
/*        - NVIDIA CORPORATION & AFFILIATES Confidential and Proprietary -
 *
 *  Copyright (C) 2010-2021, Mellanox Technologies Ltd. ALL RIGHTS RESERVED.
 *  Copyright (C) 2021-2024, NVIDIA CORPORATION & AFFILIATES. ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "LICENSE.txt".
 *
 */


/***
         *** This file was generated at "2024-09-05 17:09:31"
         *** by:
         ***    > /mswg/release/tools/a-me/a-me-1.0.96/adabe_plugins/adb2c/adb2pack.py --input adb/packets.adb --file-prefix packets --copyright=copyrights
         ***/
#include "packets_layouts.h"

void AM_ANActiveJobs_pack(const struct AM_ANActiveJobs *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1536, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->active_jobs[i]);
	}

}

void AM_ANActiveJobs_unpack(struct AM_ANActiveJobs *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1536, 1);
	ptr_struct->active_jobs[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void AM_ANActiveJobs_print(const struct AM_ANActiveJobs *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_ANActiveJobs ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 48; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_jobs_%03d     : " U32H_FMT "\n", i, ptr_struct->active_jobs[i]);
	}

}

int AM_ANActiveJobs_size(void)
{
	 return 192;
}

void AM_ANActiveJobs_dump(const struct AM_ANActiveJobs *ptr_struct, FILE* file)
{
	AM_ANActiveJobs_print(ptr_struct, file, 0);
}

void AM_ANInfo_pack(const struct AM_ANInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->endianness);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_endianness_per_job);

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reproducibility_disable);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_reproducibility_per_job);

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tree_job_default_binding);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->active_class_version);

	offset = 15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->an_sat_qp_info_supported);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->an_semaphore_info_supported);

	offset = 13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->job_key_supported);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tree_job_binding_supported);

	offset = 11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_credit_alloc_supported);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->hba_vl_counters_supported);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->hba_sl_counters_supported);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ext_perf_counters_supported);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->half_buffer_line_optimization_supported);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reproducibility_per_job_supported);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reproducibility_disable_supported);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->root_gid_group_join);

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->packet_based_credits_supported);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->endianess_per_job_supported);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->multiple_sver_active_supported);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->streaming_aggregation_supported);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_table_size);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->internal_precision_support);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_stochastic_rounding_supported);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_user_qkey_allowed);

	offset = 35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_hba_timeout_config_supported);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llt_sat_groups_size_supported);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sat_rmc_operation_supported);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_to_port_select_supported);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tree_radix);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tree_radix_used);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->sharp_version_supported_bit_mask);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->active_sharp_version_bit_mask);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->group_table_size);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gt_mode);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_group_num);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->outstanding_operation_table_size);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_aggregation_payload);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_semaphores);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->streaming_aggregation_outstanding_operation);

	offset = 264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->operation_buffer_size);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->num_of_jobs);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_num_qps);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_llt_qps);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->line_size);

	offset = 360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->worst_case_num_lines);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_lines_chunk_mode);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->perf_clu_mask);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->perf_hba_mask);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->perf_hba_split_port_mask);

	offset = 496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_perf_hba_mask);

	offset = 480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_perf_clu_mask);

	offset = 536;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data_types_supported);

	offset = 520;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mtu_support);

	offset = 560;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_llt_group_table_size);

	offset = 544;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_sat_group_table_size);

	offset = 604;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hba_timeout_config);

}

void AM_ANInfo_unpack(struct AM_ANInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->endianness = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->enable_endianness_per_job = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 29;
	ptr_struct->reproducibility_disable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->enable_reproducibility_per_job = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 27;
	ptr_struct->tree_job_default_binding = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 16;
	ptr_struct->active_class_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 15;
	ptr_struct->an_sat_qp_info_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 14;
	ptr_struct->an_semaphore_info_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 13;
	ptr_struct->job_key_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 12;
	ptr_struct->tree_job_binding_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 11;
	ptr_struct->port_credit_alloc_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 10;
	ptr_struct->hba_vl_counters_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 9;
	ptr_struct->hba_sl_counters_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->ext_perf_counters_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 7;
	ptr_struct->half_buffer_line_optimization_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 6;
	ptr_struct->reproducibility_per_job_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 5;
	ptr_struct->reproducibility_disable_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 4;
	ptr_struct->root_gid_group_join = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 3;
	ptr_struct->packet_based_credits_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 2;
	ptr_struct->endianess_per_job_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->multiple_sver_active_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->streaming_aggregation_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->tree_table_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 40;
	ptr_struct->internal_precision_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 37;
	ptr_struct->is_stochastic_rounding_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 36;
	ptr_struct->is_user_qkey_allowed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 35;
	ptr_struct->is_hba_timeout_config_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 34;
	ptr_struct->llt_sat_groups_size_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 33;
	ptr_struct->sat_rmc_operation_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->qp_to_port_select_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 88;
	ptr_struct->tree_radix = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->tree_radix_used = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->sharp_version_supported_bit_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->active_sharp_version_bit_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 136;
	ptr_struct->group_table_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 128;
	ptr_struct->gt_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->max_group_num = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 208;
	ptr_struct->outstanding_operation_table_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->max_aggregation_payload = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 248;
	ptr_struct->num_semaphores = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->streaming_aggregation_outstanding_operation = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 264;
	ptr_struct->operation_buffer_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 296;
	ptr_struct->num_of_jobs = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 336;
	ptr_struct->max_num_qps = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->max_llt_qps = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 368;
	ptr_struct->line_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 360;
	ptr_struct->worst_case_num_lines = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 352;
	ptr_struct->num_lines_chunk_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->perf_clu_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->perf_hba_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->perf_hba_split_port_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 496;
	ptr_struct->qp_perf_hba_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 480;
	ptr_struct->qp_perf_clu_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 536;
	ptr_struct->data_types_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 520;
	ptr_struct->mtu_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 560;
	ptr_struct->max_llt_group_table_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 544;
	ptr_struct->max_sat_group_table_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 604;
	ptr_struct->hba_timeout_config = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void AM_ANInfo_print(const struct AM_ANInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_ANInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "endianness           : " UH_FMT "\n", ptr_struct->endianness);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_endianness_per_job : " UH_FMT "\n", ptr_struct->enable_endianness_per_job);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reproducibility_disable : " UH_FMT "\n", ptr_struct->reproducibility_disable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_reproducibility_per_job : " UH_FMT "\n", ptr_struct->enable_reproducibility_per_job);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_job_default_binding : " UH_FMT "\n", ptr_struct->tree_job_default_binding);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_class_version : " UH_FMT "\n", ptr_struct->active_class_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_sat_qp_info_supported : " UH_FMT "\n", ptr_struct->an_sat_qp_info_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_semaphore_info_supported : " UH_FMT "\n", ptr_struct->an_semaphore_info_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_key_supported    : " UH_FMT "\n", ptr_struct->job_key_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_job_binding_supported : " UH_FMT "\n", ptr_struct->tree_job_binding_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_credit_alloc_supported : " UH_FMT "\n", ptr_struct->port_credit_alloc_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_vl_counters_supported : " UH_FMT "\n", ptr_struct->hba_vl_counters_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_sl_counters_supported : " UH_FMT "\n", ptr_struct->hba_sl_counters_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_perf_counters_supported : " UH_FMT "\n", ptr_struct->ext_perf_counters_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "half_buffer_line_optimization_supported : " UH_FMT "\n", ptr_struct->half_buffer_line_optimization_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reproducibility_per_job_supported : " UH_FMT "\n", ptr_struct->reproducibility_per_job_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reproducibility_disable_supported : " UH_FMT "\n", ptr_struct->reproducibility_disable_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "root_gid_group_join  : " UH_FMT "\n", ptr_struct->root_gid_group_join);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_based_credits_supported : " UH_FMT "\n", ptr_struct->packet_based_credits_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "endianess_per_job_supported : " UH_FMT "\n", ptr_struct->endianess_per_job_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "multiple_sver_active_supported : " UH_FMT "\n", ptr_struct->multiple_sver_active_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "streaming_aggregation_supported : " UH_FMT "\n", ptr_struct->streaming_aggregation_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_table_size      : " UH_FMT "\n", ptr_struct->tree_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "internal_precision_support : " UH_FMT "\n", ptr_struct->internal_precision_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_stochastic_rounding_supported : " UH_FMT "\n", ptr_struct->is_stochastic_rounding_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_user_qkey_allowed : " UH_FMT "\n", ptr_struct->is_user_qkey_allowed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_hba_timeout_config_supported : " UH_FMT "\n", ptr_struct->is_hba_timeout_config_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llt_sat_groups_size_supported : " UH_FMT "\n", ptr_struct->llt_sat_groups_size_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sat_rmc_operation_supported : " UH_FMT "\n", ptr_struct->sat_rmc_operation_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_to_port_select_supported : " UH_FMT "\n", ptr_struct->qp_to_port_select_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_radix           : " UH_FMT "\n", ptr_struct->tree_radix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_radix_used      : " UH_FMT "\n", ptr_struct->tree_radix_used);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sharp_version_supported_bit_mask : " UH_FMT "\n", ptr_struct->sharp_version_supported_bit_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_sharp_version_bit_mask : " UH_FMT "\n", ptr_struct->active_sharp_version_bit_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_table_size     : " UH_FMT "\n", ptr_struct->group_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gt_mode              : " UH_FMT "\n", ptr_struct->gt_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_group_num        : " U32H_FMT "\n", ptr_struct->max_group_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outstanding_operation_table_size : " UH_FMT "\n", ptr_struct->outstanding_operation_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_aggregation_payload : " UH_FMT "\n", ptr_struct->max_aggregation_payload);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_semaphores       : " UH_FMT "\n", ptr_struct->num_semaphores);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "streaming_aggregation_outstanding_operation : " UH_FMT "\n", ptr_struct->streaming_aggregation_outstanding_operation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "operation_buffer_size : " UH_FMT "\n", ptr_struct->operation_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_jobs          : " UH_FMT "\n", ptr_struct->num_of_jobs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_num_qps          : " UH_FMT "\n", ptr_struct->max_num_qps);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_llt_qps          : " UH_FMT "\n", ptr_struct->max_llt_qps);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "line_size            : " UH_FMT "\n", ptr_struct->line_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "worst_case_num_lines : " UH_FMT "\n", ptr_struct->worst_case_num_lines);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_lines_chunk_mode : " UH_FMT "\n", ptr_struct->num_lines_chunk_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "perf_clu_mask        : " U32H_FMT "\n", ptr_struct->perf_clu_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "perf_hba_mask        : " U32H_FMT "\n", ptr_struct->perf_hba_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "perf_hba_split_port_mask : " U32H_FMT "\n", ptr_struct->perf_hba_split_port_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_perf_hba_mask     : " UH_FMT "\n", ptr_struct->qp_perf_hba_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_perf_clu_mask     : " UH_FMT "\n", ptr_struct->qp_perf_clu_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_types_supported : " UH_FMT "\n", ptr_struct->data_types_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtu_support          : " UH_FMT "\n", ptr_struct->mtu_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_llt_group_table_size : " UH_FMT "\n", ptr_struct->max_llt_group_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_sat_group_table_size : " UH_FMT "\n", ptr_struct->max_sat_group_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_timeout_config   : " UH_FMT "\n", ptr_struct->hba_timeout_config);

}

int AM_ANInfo_size(void)
{
	 return 76;
}

void AM_ANInfo_dump(const struct AM_ANInfo *ptr_struct, FILE* file)
{
	AM_ANInfo_print(ptr_struct, file, 0);
}

void AM_ANSATQPInfo_pack(const struct AM_ANSATQPInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 256; i++) {
	offset = adb2c_calc_array_field_address(92, 4, i, 1152, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sat_qps_support[i]);
	}

}

void AM_ANSATQPInfo_unpack(struct AM_ANSATQPInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 256; i++) {
	offset = adb2c_calc_array_field_address(92, 4, i, 1152, 1);
	ptr_struct->sat_qps_support[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);
	}

}

void AM_ANSATQPInfo_print(const struct AM_ANSATQPInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_ANSATQPInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 256; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sat_qps_support_%03d : " UH_FMT "\n", i, ptr_struct->sat_qps_support[i]);
	}

}

int AM_ANSATQPInfo_size(void)
{
	 return 144;
}

void AM_ANSATQPInfo_dump(const struct AM_ANSATQPInfo *ptr_struct, FILE* file)
{
	AM_ANSATQPInfo_print(ptr_struct, file, 0);
}

void AM_ANSemaphoreInfo_pack(const struct AM_ANSemaphoreInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 256; i++) {
	offset = adb2c_calc_array_field_address(92, 4, i, 1152, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->semaphore_support[i]);
	}

}

void AM_ANSemaphoreInfo_unpack(struct AM_ANSemaphoreInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 256; i++) {
	offset = adb2c_calc_array_field_address(92, 4, i, 1152, 1);
	ptr_struct->semaphore_support[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);
	}

}

void AM_ANSemaphoreInfo_print(const struct AM_ANSemaphoreInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_ANSemaphoreInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 256; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "semaphore_support_%03d : " UH_FMT "\n", i, ptr_struct->semaphore_support[i]);
	}

}

int AM_ANSemaphoreInfo_size(void)
{
	 return 144;
}

void AM_ANSemaphoreInfo_dump(const struct AM_ANSemaphoreInfo *ptr_struct, FILE* file)
{
	AM_ANSemaphoreInfo_print(ptr_struct, file, 0);
}

void AM_GroupJoin_pack(const struct AM_GroupJoin *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->group_id);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

}

void AM_GroupJoin_unpack(struct AM_GroupJoin *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 4;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->group_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 104;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void AM_GroupJoin_print(const struct AM_GroupJoin *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_GroupJoin ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : " UH_FMT "\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_id             : " UH_FMT "\n", ptr_struct->group_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : " UH_FMT "\n", ptr_struct->qpn);

}

int AM_GroupJoin_size(void)
{
	 return 16;
}

void AM_GroupJoin_dump(const struct AM_GroupJoin *ptr_struct, FILE* file)
{
	AM_GroupJoin_print(ptr_struct, file, 0);
}

void AM_PortCreditResourcesAllocation_pack(const struct AM_PortCreditResourcesAllocation *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->responder_qp_packets);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->requester_qp_packets);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->packet_size);

	offset = 54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->num_flows);

	offset = 87;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->responder_buffer_cap);

	offset = 71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->requester_buffer_cap);

}

void AM_PortCreditResourcesAllocation_unpack(struct AM_PortCreditResourcesAllocation *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 23;
	ptr_struct->responder_qp_packets = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 7;
	ptr_struct->requester_qp_packets = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 60;
	ptr_struct->packet_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 54;
	ptr_struct->num_flows = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 87;
	ptr_struct->responder_buffer_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 71;
	ptr_struct->requester_buffer_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

}

void AM_PortCreditResourcesAllocation_print(const struct AM_PortCreditResourcesAllocation *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_PortCreditResourcesAllocation ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder_qp_packets : " UH_FMT "\n", ptr_struct->responder_qp_packets);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "requester_qp_packets : " UH_FMT "\n", ptr_struct->requester_qp_packets);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_size          : " UH_FMT "\n", ptr_struct->packet_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_flows            : " UH_FMT "\n", ptr_struct->num_flows);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder_buffer_cap : " UH_FMT "\n", ptr_struct->responder_buffer_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "requester_buffer_cap : " UH_FMT "\n", ptr_struct->requester_buffer_cap);

}

int AM_PortCreditResourcesAllocation_size(void)
{
	 return 12;
}

void AM_PortCreditResourcesAllocation_dump(const struct AM_PortCreditResourcesAllocation *ptr_struct, FILE* file)
{
	AM_PortCreditResourcesAllocation_print(ptr_struct, file, 0);
}

void AM_QPCConfig_pack(const struct AM_QPCConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->state);

	offset = 63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->packet_based_credit_req_en);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->packet_based_credit_resp_en);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->mtu);

	offset = 79;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->g);

	offset = 68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rlid);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->traffic_class);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(160, 32, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rgid[i]);
	}

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rq_psn);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->sq_psn);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey);

	offset = 360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port);

	offset = 392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rqpn);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->qkey);

	offset = 472;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rnr_retry_limit);

	offset = 450;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rnr_mode);

	offset = 504;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->timeout_retry_limit);

	offset = 488;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_ack_timeout);

}

void AM_QPCConfig_unpack(struct AM_QPCConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 0;
	ptr_struct->state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 63;
	ptr_struct->packet_based_credit_req_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 62;
	ptr_struct->packet_based_credit_resp_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 92;
	ptr_struct->mtu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 79;
	ptr_struct->g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 68;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 112;
	ptr_struct->rlid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 104;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 152;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 132;
	ptr_struct->traffic_class = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(160, 32, i, 512, 1);
	ptr_struct->rgid[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 296;
	ptr_struct->rq_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 328;
	ptr_struct->sq_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 368;
	ptr_struct->pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 360;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 392;
	ptr_struct->rqpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 416;
	ptr_struct->qkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 472;
	ptr_struct->rnr_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 450;
	ptr_struct->rnr_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 504;
	ptr_struct->timeout_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 488;
	ptr_struct->local_ack_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void AM_QPCConfig_print(const struct AM_QPCConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_QPCConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : " UH_FMT "\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "state                : " UH_FMT "\n", ptr_struct->state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_based_credit_req_en : " UH_FMT "\n", ptr_struct->packet_based_credit_req_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_based_credit_resp_en : " UH_FMT "\n", ptr_struct->packet_based_credit_resp_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtu                  : " UH_FMT "\n", ptr_struct->mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "g                    : " UH_FMT "\n", ptr_struct->g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : " UH_FMT "\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rlid                 : " UH_FMT "\n", ptr_struct->rlid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : " UH_FMT "\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : " UH_FMT "\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "traffic_class        : " UH_FMT "\n", ptr_struct->traffic_class);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rgid_%03d            : " U32H_FMT "\n", i, ptr_struct->rgid[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_psn               : " UH_FMT "\n", ptr_struct->rq_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_psn               : " UH_FMT "\n", ptr_struct->sq_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey                 : " UH_FMT "\n", ptr_struct->pkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : " UH_FMT "\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqpn                 : " UH_FMT "\n", ptr_struct->rqpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey                 : " U32H_FMT "\n", ptr_struct->qkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_retry_limit      : " UH_FMT "\n", ptr_struct->rnr_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_mode             : " UH_FMT "\n", ptr_struct->rnr_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timeout_retry_limit  : " UH_FMT "\n", ptr_struct->timeout_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_ack_timeout    : " UH_FMT "\n", ptr_struct->local_ack_timeout);

}

int AM_QPCConfig_size(void)
{
	 return 64;
}

void AM_QPCConfig_dump(const struct AM_QPCConfig *ptr_struct, FILE* file)
{
	AM_QPCConfig_print(ptr_struct, file, 0);
}

void AM_ResourceCleanup_pack(const struct AM_ResourceCleanup *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->group_id);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->job_id);

}

void AM_ResourceCleanup_unpack(struct AM_ResourceCleanup *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 4;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->group_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 88;
	ptr_struct->job_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void AM_ResourceCleanup_print(const struct AM_ResourceCleanup *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_ResourceCleanup ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : " UH_FMT "\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_id             : " UH_FMT "\n", ptr_struct->group_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

}

int AM_ResourceCleanup_size(void)
{
	 return 16;
}

void AM_ResourceCleanup_dump(const struct AM_ResourceCleanup *ptr_struct, FILE* file)
{
	AM_ResourceCleanup_print(ptr_struct, file, 0);
}

void AM_ResourceCleanup_V2_pack(const struct AM_ResourceCleanup_V2 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->group_num);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

}

void AM_ResourceCleanup_V2_unpack(struct AM_ResourceCleanup_V2 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 4;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->group_num = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 72;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void AM_ResourceCleanup_V2_print(const struct AM_ResourceCleanup_V2 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_ResourceCleanup_V2 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : " UH_FMT "\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_num            : " U32H_FMT "\n", ptr_struct->group_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

}

int AM_ResourceCleanup_V2_size(void)
{
	 return 16;
}

void AM_ResourceCleanup_V2_dump(const struct AM_ResourceCleanup_V2 *ptr_struct, FILE* file)
{
	AM_ResourceCleanup_V2_print(ptr_struct, file, 0);
}

void AM_TreeToJobBind_pack(const struct AM_TreeToJobBind *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->operation);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->offset);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(96, 32, i, 352, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tree_list_mask[i]);
	}

}

void AM_TreeToJobBind_unpack(struct AM_TreeToJobBind *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->operation = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 92;
	ptr_struct->offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(96, 32, i, 352, 1);
	ptr_struct->tree_list_mask[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void AM_TreeToJobBind_print(const struct AM_TreeToJobBind *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TreeToJobBind ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "operation            : " UH_FMT "\n", ptr_struct->operation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset               : " UH_FMT "\n", ptr_struct->offset);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_list_mask_%03d  : " U32H_FMT "\n", i, ptr_struct->tree_list_mask[i]);
	}

}

int AM_TreeToJobBind_size(void)
{
	 return 44;
}

void AM_TreeToJobBind_dump(const struct AM_TreeToJobBind *ptr_struct, FILE* file)
{
	AM_TreeToJobBind_print(ptr_struct, file, 0);
}

void AdjSiteLocalSubnetRecord_pack(const struct AdjSiteLocalSubnetRecord *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SubnetPrefix);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Pkey);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MasterSMLID);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->max_ar_group_id);

	offset = 35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pfrn_rtr_en);

}

void AdjSiteLocalSubnetRecord_unpack(struct AdjSiteLocalSubnetRecord *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->SubnetPrefix = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->Pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->MasterSMLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 36;
	ptr_struct->max_ar_group_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 35;
	ptr_struct->pfrn_rtr_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void AdjSiteLocalSubnetRecord_print(const struct AdjSiteLocalSubnetRecord *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AdjSiteLocalSubnetRecord ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubnetPrefix         : " UH_FMT "\n", ptr_struct->SubnetPrefix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Pkey                 : " UH_FMT "\n", ptr_struct->Pkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MasterSMLID          : " UH_FMT "\n", ptr_struct->MasterSMLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_ar_group_id      : " UH_FMT "\n", ptr_struct->max_ar_group_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pfrn_rtr_en          : " UH_FMT "\n", ptr_struct->pfrn_rtr_en);

}

int AdjSiteLocalSubnetRecord_size(void)
{
	 return 8;
}

void AdjSiteLocalSubnetRecord_dump(const struct AdjSiteLocalSubnetRecord *ptr_struct, FILE* file)
{
	AdjSiteLocalSubnetRecord_print(ptr_struct, file, 0);
}

void AdjSubnetRouterLIDRecord_pack(const struct AdjSubnetRouterLIDRecord *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->local_router_lid_start);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->subnet_prefix_id);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->local_router_lid_end);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->local_router_lid_start_cont);

}

void AdjSubnetRouterLIDRecord_unpack(struct AdjSubnetRouterLIDRecord *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->local_router_lid_start = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->subnet_prefix_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 44;
	ptr_struct->local_router_lid_end = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 32;
	ptr_struct->local_router_lid_start_cont = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void AdjSubnetRouterLIDRecord_print(const struct AdjSubnetRouterLIDRecord *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AdjSubnetRouterLIDRecord ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_router_lid_start : " UH_FMT "\n", ptr_struct->local_router_lid_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "subnet_prefix_id     : " UH_FMT "\n", ptr_struct->subnet_prefix_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_router_lid_end : " UH_FMT "\n", ptr_struct->local_router_lid_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_router_lid_start_cont : " UH_FMT "\n", ptr_struct->local_router_lid_start_cont);

}

int AdjSubnetRouterLIDRecord_size(void)
{
	 return 8;
}

void AdjSubnetRouterLIDRecord_dump(const struct AdjSubnetRouterLIDRecord *ptr_struct, FILE* file)
{
	AdjSubnetRouterLIDRecord_print(ptr_struct, file, 0);
}

void AggregationManagement_MAD_Data_Block_Element_pack(const struct AggregationManagement_MAD_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1536, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DWORD[i]);
	}

}

void AggregationManagement_MAD_Data_Block_Element_unpack(struct AggregationManagement_MAD_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1536, 1);
	ptr_struct->DWORD[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void AggregationManagement_MAD_Data_Block_Element_print(const struct AggregationManagement_MAD_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AggregationManagement_MAD_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 48; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DWORD_%03d           : " U32H_FMT "\n", i, ptr_struct->DWORD[i]);
	}

}

int AggregationManagement_MAD_Data_Block_Element_size(void)
{
	 return 192;
}

void AggregationManagement_MAD_Data_Block_Element_dump(const struct AggregationManagement_MAD_Data_Block_Element *ptr_struct, FILE* file)
{
	AggregationManagement_MAD_Data_Block_Element_print(ptr_struct, file, 0);
}

void BandwidthPerSL_pack(const struct BandwidthPerSL *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->RateLimit);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->BandwidthShare);

}

void BandwidthPerSL_unpack(struct BandwidthPerSL *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	ptr_struct->RateLimit = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 0;
	ptr_struct->BandwidthShare = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

}

void BandwidthPerSL_print(const struct BandwidthPerSL *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== BandwidthPerSL ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RateLimit            : " UH_FMT "\n", ptr_struct->RateLimit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BandwidthShare       : " UH_FMT "\n", ptr_struct->BandwidthShare);

}

int BandwidthPerSL_size(void)
{
	 return 4;
}

void BandwidthPerSL_dump(const struct BandwidthPerSL *ptr_struct, FILE* file)
{
	BandwidthPerSL_print(ptr_struct, file, 0);
}

void CACongestionEntryListElement_pack(const struct CACongestionEntryListElement *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Trigger_Threshold);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->CCTI_Increase);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CCTI_Timer);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->CCTI_Min);

}

void CACongestionEntryListElement_unpack(struct CACongestionEntryListElement *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->Trigger_Threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->CCTI_Increase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->CCTI_Timer = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->CCTI_Min = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void CACongestionEntryListElement_print(const struct CACongestionEntryListElement *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CACongestionEntryListElement ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Trigger_Threshold    : " UH_FMT "\n", ptr_struct->Trigger_Threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CCTI_Increase        : " UH_FMT "\n", ptr_struct->CCTI_Increase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CCTI_Timer           : " UH_FMT "\n", ptr_struct->CCTI_Timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CCTI_Min             : " UH_FMT "\n", ptr_struct->CCTI_Min);

}

int CACongestionEntryListElement_size(void)
{
	 return 8;
}

void CACongestionEntryListElement_dump(const struct CACongestionEntryListElement *ptr_struct, FILE* file)
{
	CACongestionEntryListElement_print(ptr_struct, file, 0);
}

void CCTI_Entry_ListElement_pack(const struct CCTI_Entry_ListElement *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 14, (u_int32_t)ptr_struct->CCT_Multiplier);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->CCT_Shift);

}

void CCTI_Entry_ListElement_unpack(struct CCTI_Entry_ListElement *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 2;
	ptr_struct->CCT_Multiplier = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 14);

	offset = 0;
	ptr_struct->CCT_Shift = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void CCTI_Entry_ListElement_print(const struct CCTI_Entry_ListElement *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CCTI_Entry_ListElement ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CCT_Multiplier       : " UH_FMT "\n", ptr_struct->CCT_Multiplier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CCT_Shift            : " UH_FMT "\n", ptr_struct->CCT_Shift);

}

int CCTI_Entry_ListElement_size(void)
{
	 return 2;
}

void CCTI_Entry_ListElement_dump(const struct CCTI_Entry_ListElement *ptr_struct, FILE* file)
{
	CCTI_Entry_ListElement_print(ptr_struct, file, 0);
}

void CC_CongestionHCAAlgoConfig_pack(const struct CC_CongestionHCAAlgoConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->counters_en);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->trace_en);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->algo_status);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->algo_en);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->encap_type);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->encap_len);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->sl_bitmask);

	for (i = 0; i < 176; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 1536, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->encapsulation[i]);
	}

}

void CC_CongestionHCAAlgoConfig_unpack(struct CC_CongestionHCAAlgoConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 3;
	ptr_struct->counters_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 2;
	ptr_struct->trace_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->algo_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->algo_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 60;
	ptr_struct->encap_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->encap_len = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->sl_bitmask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 176; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 1536, 1);
	ptr_struct->encapsulation[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->encapsulation[176] = '\0';
}

void CC_CongestionHCAAlgoConfig_print(const struct CC_CongestionHCAAlgoConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCAAlgoConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counters_en          : " UH_FMT "\n", ptr_struct->counters_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trace_en             : " UH_FMT "\n", ptr_struct->trace_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algo_status          : " UH_FMT "\n", ptr_struct->algo_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algo_en              : " UH_FMT "\n", ptr_struct->algo_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encap_type           : " UH_FMT "\n", ptr_struct->encap_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encap_len            : " UH_FMT "\n", ptr_struct->encap_len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_bitmask           : " UH_FMT "\n", ptr_struct->sl_bitmask);

	fprintf(file, "encapsulation        : \"%s\"\n", ptr_struct->encapsulation);
}

int CC_CongestionHCAAlgoConfig_size(void)
{
	 return 192;
}

void CC_CongestionHCAAlgoConfig_dump(const struct CC_CongestionHCAAlgoConfig *ptr_struct, FILE* file)
{
	CC_CongestionHCAAlgoConfig_print(ptr_struct, file, 0);
}

void CC_CongestionHCAAlgoConfigInfoElement_pack(const struct CC_CongestionHCAAlgoConfigInfoElement *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->algo_minor_version);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->algo_major_version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->algo_id);

}

void CC_CongestionHCAAlgoConfigInfoElement_unpack(struct CC_CongestionHCAAlgoConfigInfoElement *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->algo_minor_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->algo_major_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->algo_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CC_CongestionHCAAlgoConfigInfoElement_print(const struct CC_CongestionHCAAlgoConfigInfoElement *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCAAlgoConfigInfoElement ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algo_minor_version   : " UH_FMT "\n", ptr_struct->algo_minor_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algo_major_version   : " UH_FMT "\n", ptr_struct->algo_major_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algo_id              : " UH_FMT "\n", ptr_struct->algo_id);

}

int CC_CongestionHCAAlgoConfigInfoElement_size(void)
{
	 return 4;
}

void CC_CongestionHCAAlgoConfigInfoElement_dump(const struct CC_CongestionHCAAlgoConfigInfoElement *ptr_struct, FILE* file)
{
	CC_CongestionHCAAlgoConfigInfoElement_print(ptr_struct, file, 0);
}

void CC_CongestionHCAAlgoConfigParams_pack(const struct CC_CongestionHCAAlgoConfigParams *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->encap_type);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->encap_len);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->sl_bitmask);

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 1536, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->encapsulation[i]);
	}

}

void CC_CongestionHCAAlgoConfigParams_unpack(struct CC_CongestionHCAAlgoConfigParams *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 60;
	ptr_struct->encap_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->encap_len = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->sl_bitmask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 1536, 1);
	ptr_struct->encapsulation[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void CC_CongestionHCAAlgoConfigParams_print(const struct CC_CongestionHCAAlgoConfigParams *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCAAlgoConfigParams ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encap_type           : " UH_FMT "\n", ptr_struct->encap_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encap_len            : " UH_FMT "\n", ptr_struct->encap_len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_bitmask           : " UH_FMT "\n", ptr_struct->sl_bitmask);

	for (i = 0; i < 44; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encapsulation_%03d   : " U32H_FMT "\n", i, ptr_struct->encapsulation[i]);
	}

}

int CC_CongestionHCAAlgoConfigParams_size(void)
{
	 return 192;
}

void CC_CongestionHCAAlgoConfigParams_dump(const struct CC_CongestionHCAAlgoConfigParams *ptr_struct, FILE* file)
{
	CC_CongestionHCAAlgoConfigParams_print(ptr_struct, file, 0);
}

void CC_CongestionHCAAlgoCounters_pack(const struct CC_CongestionHCAAlgoCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clear);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->encap_type);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->encap_len);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->sl_bitmask);

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 1536, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->encapsulation[i]);
	}

}

void CC_CongestionHCAAlgoCounters_unpack(struct CC_CongestionHCAAlgoCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->clear = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 60;
	ptr_struct->encap_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->encap_len = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->sl_bitmask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 1536, 1);
	ptr_struct->encapsulation[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void CC_CongestionHCAAlgoCounters_print(const struct CC_CongestionHCAAlgoCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCAAlgoCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clear                : " UH_FMT "\n", ptr_struct->clear);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encap_type           : " UH_FMT "\n", ptr_struct->encap_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encap_len            : " UH_FMT "\n", ptr_struct->encap_len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_bitmask           : " UH_FMT "\n", ptr_struct->sl_bitmask);

	for (i = 0; i < 44; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encapsulation_%03d   : " U32H_FMT "\n", i, ptr_struct->encapsulation[i]);
	}

}

int CC_CongestionHCAAlgoCounters_size(void)
{
	 return 192;
}

void CC_CongestionHCAAlgoCounters_dump(const struct CC_CongestionHCAAlgoCounters *ptr_struct, FILE* file)
{
	CC_CongestionHCAAlgoCounters_print(ptr_struct, file, 0);
}

void CC_CongestionHCAGeneralSettings_pack(const struct CC_CongestionHCAGeneralSettings *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_react);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_notify);

}

void CC_CongestionHCAGeneralSettings_unpack(struct CC_CongestionHCAGeneralSettings *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	ptr_struct->en_react = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->en_notify = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void CC_CongestionHCAGeneralSettings_print(const struct CC_CongestionHCAGeneralSettings *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCAGeneralSettings ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_react             : " UH_FMT "\n", ptr_struct->en_react);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_notify            : " UH_FMT "\n", ptr_struct->en_notify);

}

int CC_CongestionHCAGeneralSettings_size(void)
{
	 return 4;
}

void CC_CongestionHCAGeneralSettings_dump(const struct CC_CongestionHCAGeneralSettings *ptr_struct, FILE* file)
{
	CC_CongestionHCAGeneralSettings_print(ptr_struct, file, 0);
}

void CC_CongestionHCANPParameters_pack(const struct CC_CongestionHCANPParameters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_time_between_cnps);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnp_sl);

	offset = 47;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cnp_sl_mode);

}

void CC_CongestionHCANPParameters_unpack(struct CC_CongestionHCANPParameters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->min_time_between_cnps = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 60;
	ptr_struct->cnp_sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 47;
	ptr_struct->cnp_sl_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void CC_CongestionHCANPParameters_print(const struct CC_CongestionHCANPParameters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCANPParameters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_time_between_cnps : " UH_FMT "\n", ptr_struct->min_time_between_cnps);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnp_sl               : " UH_FMT "\n", ptr_struct->cnp_sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnp_sl_mode          : " UH_FMT "\n", ptr_struct->cnp_sl_mode);

}

int CC_CongestionHCANPParameters_size(void)
{
	 return 16;
}

void CC_CongestionHCANPParameters_dump(const struct CC_CongestionHCANPParameters *ptr_struct, FILE* file)
{
	CC_CongestionHCANPParameters_print(ptr_struct, file, 0);
}

void CC_CongestionHCARPParameters_pack(const struct CC_CongestionHCARPParameters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clamp_tgt_rate_after_time_inc);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clamp_tgt_rate);

	offset = 47;
	adb2c_push_bits_to_buff(ptr_buff, offset, 17, (u_int32_t)ptr_struct->rpg_time_reset);

	offset = 77;
	adb2c_push_bits_to_buff(ptr_buff, offset, 19, (u_int32_t)ptr_struct->rpg_byte_reset);

	offset = 123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rpg_threshold);

	offset = 141;
	adb2c_push_bits_to_buff(ptr_buff, offset, 19, (u_int32_t)ptr_struct->rpg_max_rate);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rpg_ai_rate);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rpg_hai_rate);

	offset = 252;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rpg_gd);

	offset = 281;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->rpg_min_dec_fac);

	offset = 301;
	adb2c_push_bits_to_buff(ptr_buff, offset, 19, (u_int32_t)ptr_struct->rpg_min_rate);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rate_to_set_on_first_cnp);

	offset = 374;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->dce_tcp_g);

	offset = 399;
	adb2c_push_bits_to_buff(ptr_buff, offset, 17, (u_int32_t)ptr_struct->dce_tcp_rtt);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rate_reduce_mionitor_period);

	offset = 470;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->initial_alpha_value);

}

void CC_CongestionHCARPParameters_unpack(struct CC_CongestionHCARPParameters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	ptr_struct->clamp_tgt_rate_after_time_inc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->clamp_tgt_rate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 47;
	ptr_struct->rpg_time_reset = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 17);

	offset = 77;
	ptr_struct->rpg_byte_reset = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 19);

	offset = 123;
	ptr_struct->rpg_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 141;
	ptr_struct->rpg_max_rate = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 19);

	offset = 176;
	ptr_struct->rpg_ai_rate = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->rpg_hai_rate = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 252;
	ptr_struct->rpg_gd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 281;
	ptr_struct->rpg_min_dec_fac = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 301;
	ptr_struct->rpg_min_rate = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 19);

	offset = 320;
	ptr_struct->rate_to_set_on_first_cnp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 374;
	ptr_struct->dce_tcp_g = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 399;
	ptr_struct->dce_tcp_rtt = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 17);

	offset = 416;
	ptr_struct->rate_reduce_mionitor_period = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 470;
	ptr_struct->initial_alpha_value = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void CC_CongestionHCARPParameters_print(const struct CC_CongestionHCARPParameters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCARPParameters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clamp_tgt_rate_after_time_inc : " UH_FMT "\n", ptr_struct->clamp_tgt_rate_after_time_inc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clamp_tgt_rate       : " UH_FMT "\n", ptr_struct->clamp_tgt_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_time_reset       : " UH_FMT "\n", ptr_struct->rpg_time_reset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_byte_reset       : " UH_FMT "\n", ptr_struct->rpg_byte_reset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_threshold        : " UH_FMT "\n", ptr_struct->rpg_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_max_rate         : " UH_FMT "\n", ptr_struct->rpg_max_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_ai_rate          : " UH_FMT "\n", ptr_struct->rpg_ai_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_hai_rate         : " UH_FMT "\n", ptr_struct->rpg_hai_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_gd               : " UH_FMT "\n", ptr_struct->rpg_gd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_min_dec_fac      : " UH_FMT "\n", ptr_struct->rpg_min_dec_fac);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpg_min_rate         : " UH_FMT "\n", ptr_struct->rpg_min_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rate_to_set_on_first_cnp : " U32H_FMT "\n", ptr_struct->rate_to_set_on_first_cnp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dce_tcp_g            : " UH_FMT "\n", ptr_struct->dce_tcp_g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dce_tcp_rtt          : " UH_FMT "\n", ptr_struct->dce_tcp_rtt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rate_reduce_mionitor_period : " U32H_FMT "\n", ptr_struct->rate_reduce_mionitor_period);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_alpha_value  : " UH_FMT "\n", ptr_struct->initial_alpha_value);

}

int CC_CongestionHCARPParameters_size(void)
{
	 return 64;
}

void CC_CongestionHCARPParameters_dump(const struct CC_CongestionHCARPParameters *ptr_struct, FILE* file)
{
	CC_CongestionHCARPParameters_print(ptr_struct, file, 0);
}

void CC_CongestionInfo_pack(const struct CC_CongestionInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ControlTableCap);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CongestionInfo);

}

void CC_CongestionInfo_unpack(struct CC_CongestionInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->ControlTableCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->CongestionInfo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CC_CongestionInfo_print(const struct CC_CongestionInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ControlTableCap      : " UH_FMT "\n", ptr_struct->ControlTableCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CongestionInfo       : " UH_FMT "\n", ptr_struct->CongestionInfo);

}

int CC_CongestionInfo_size(void)
{
	 return 4;
}

void CC_CongestionInfo_dump(const struct CC_CongestionInfo *ptr_struct, FILE* file)
{
	CC_CongestionInfo_print(ptr_struct, file, 0);
}

void CC_CongestionPortProfileSettings_pack(const struct CC_CongestionPortProfileSettings *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vl_mask);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->granularity);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mode);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->profile1_min);

	offset = 76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->profile1_max);

	offset = 65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->profile1_percent);

	offset = 108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->profile2_min);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->profile2_max);

	offset = 129;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->profile2_percent);

	offset = 172;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->profile3_min);

	offset = 204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->profile3_max);

	offset = 193;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->profile3_percent);

}

void CC_CongestionPortProfileSettings_unpack(struct CC_CongestionPortProfileSettings *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->vl_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->granularity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 44;
	ptr_struct->profile1_min = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 76;
	ptr_struct->profile1_max = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 65;
	ptr_struct->profile1_percent = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 108;
	ptr_struct->profile2_min = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 140;
	ptr_struct->profile2_max = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 129;
	ptr_struct->profile2_percent = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 172;
	ptr_struct->profile3_min = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 204;
	ptr_struct->profile3_max = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 193;
	ptr_struct->profile3_percent = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

}

void CC_CongestionPortProfileSettings_print(const struct CC_CongestionPortProfileSettings *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionPortProfileSettings ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_mask              : " UH_FMT "\n", ptr_struct->vl_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "granularity          : " UH_FMT "\n", ptr_struct->granularity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mode                 : " UH_FMT "\n", ptr_struct->mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile1_min         : " UH_FMT "\n", ptr_struct->profile1_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile1_max         : " UH_FMT "\n", ptr_struct->profile1_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile1_percent     : " UH_FMT "\n", ptr_struct->profile1_percent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile2_min         : " UH_FMT "\n", ptr_struct->profile2_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile2_max         : " UH_FMT "\n", ptr_struct->profile2_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile2_percent     : " UH_FMT "\n", ptr_struct->profile2_percent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile3_min         : " UH_FMT "\n", ptr_struct->profile3_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile3_max         : " UH_FMT "\n", ptr_struct->profile3_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile3_percent     : " UH_FMT "\n", ptr_struct->profile3_percent);

}

int CC_CongestionPortProfileSettings_size(void)
{
	 return 32;
}

void CC_CongestionPortProfileSettings_dump(const struct CC_CongestionPortProfileSettings *ptr_struct, FILE* file)
{
	CC_CongestionPortProfileSettings_print(ptr_struct, file, 0);
}

void CC_CongestionSLMappingSettings_pack(const struct CC_CongestionSLMappingSettings *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_15);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_14);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_13);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_12);

	offset = 22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_11);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_10);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_9);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_8);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_7);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_6);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_5);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_4);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_3);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_2);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_1);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl_profile_0);

}

void CC_CongestionSLMappingSettings_unpack(struct CC_CongestionSLMappingSettings *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->sl_profile_15 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 28;
	ptr_struct->sl_profile_14 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 26;
	ptr_struct->sl_profile_13 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 24;
	ptr_struct->sl_profile_12 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 22;
	ptr_struct->sl_profile_11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 20;
	ptr_struct->sl_profile_10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 18;
	ptr_struct->sl_profile_9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->sl_profile_8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 14;
	ptr_struct->sl_profile_7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 12;
	ptr_struct->sl_profile_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 10;
	ptr_struct->sl_profile_5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->sl_profile_4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 6;
	ptr_struct->sl_profile_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 4;
	ptr_struct->sl_profile_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 2;
	ptr_struct->sl_profile_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->sl_profile_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void CC_CongestionSLMappingSettings_print(const struct CC_CongestionSLMappingSettings *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionSLMappingSettings ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_15        : " UH_FMT "\n", ptr_struct->sl_profile_15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_14        : " UH_FMT "\n", ptr_struct->sl_profile_14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_13        : " UH_FMT "\n", ptr_struct->sl_profile_13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_12        : " UH_FMT "\n", ptr_struct->sl_profile_12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_11        : " UH_FMT "\n", ptr_struct->sl_profile_11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_10        : " UH_FMT "\n", ptr_struct->sl_profile_10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_9         : " UH_FMT "\n", ptr_struct->sl_profile_9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_8         : " UH_FMT "\n", ptr_struct->sl_profile_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_7         : " UH_FMT "\n", ptr_struct->sl_profile_7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_6         : " UH_FMT "\n", ptr_struct->sl_profile_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_5         : " UH_FMT "\n", ptr_struct->sl_profile_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_4         : " UH_FMT "\n", ptr_struct->sl_profile_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_3         : " UH_FMT "\n", ptr_struct->sl_profile_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_2         : " UH_FMT "\n", ptr_struct->sl_profile_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_1         : " UH_FMT "\n", ptr_struct->sl_profile_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_profile_0         : " UH_FMT "\n", ptr_struct->sl_profile_0);

}

int CC_CongestionSLMappingSettings_size(void)
{
	 return 4;
}

void CC_CongestionSLMappingSettings_dump(const struct CC_CongestionSLMappingSettings *ptr_struct, FILE* file)
{
	CC_CongestionSLMappingSettings_print(ptr_struct, file, 0);
}

void CC_CongestionSwitchGeneralSettings_pack(const struct CC_CongestionSwitchGeneralSettings *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->aqs_time);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->aqs_weight);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cap_total_buffer_size);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cap_cc_profile_step_size);

}

void CC_CongestionSwitchGeneralSettings_unpack(struct CC_CongestionSwitchGeneralSettings *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->aqs_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 20;
	ptr_struct->aqs_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 7;
	ptr_struct->en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->cap_total_buffer_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->cap_cc_profile_step_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void CC_CongestionSwitchGeneralSettings_print(const struct CC_CongestionSwitchGeneralSettings *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionSwitchGeneralSettings ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aqs_time             : " UH_FMT "\n", ptr_struct->aqs_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aqs_weight           : " UH_FMT "\n", ptr_struct->aqs_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en                   : " UH_FMT "\n", ptr_struct->en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_total_buffer_size : " U32H_FMT "\n", ptr_struct->cap_total_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_cc_profile_step_size : " UH_FMT "\n", ptr_struct->cap_cc_profile_step_size);

}

int CC_CongestionSwitchGeneralSettings_size(void)
{
	 return 16;
}

void CC_CongestionSwitchGeneralSettings_dump(const struct CC_CongestionSwitchGeneralSettings *ptr_struct, FILE* file)
{
	CC_CongestionSwitchGeneralSettings_print(ptr_struct, file, 0);
}

void CC_Log_Data_Block_Element_pack(const struct CC_Log_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 256, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DWORD[i]);
	}

}

void CC_Log_Data_Block_Element_unpack(struct CC_Log_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 256, 1);
	ptr_struct->DWORD[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void CC_Log_Data_Block_Element_print(const struct CC_Log_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_Log_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DWORD_%03d           : " U32H_FMT "\n", i, ptr_struct->DWORD[i]);
	}

}

int CC_Log_Data_Block_Element_size(void)
{
	 return 32;
}

void CC_Log_Data_Block_Element_dump(const struct CC_Log_Data_Block_Element *ptr_struct, FILE* file)
{
	CC_Log_Data_Block_Element_print(ptr_struct, file, 0);
}

void CC_Mgt_Data_Block_Element_pack(const struct CC_Mgt_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1536, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DWORD[i]);
	}

}

void CC_Mgt_Data_Block_Element_unpack(struct CC_Mgt_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1536, 1);
	ptr_struct->DWORD[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void CC_Mgt_Data_Block_Element_print(const struct CC_Mgt_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_Mgt_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 48; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DWORD_%03d           : " U32H_FMT "\n", i, ptr_struct->DWORD[i]);
	}

}

int CC_Mgt_Data_Block_Element_size(void)
{
	 return 192;
}

void CC_Mgt_Data_Block_Element_dump(const struct CC_Mgt_Data_Block_Element *ptr_struct, FILE* file)
{
	CC_Mgt_Data_Block_Element_print(ptr_struct, file, 0);
}

void CC_SwitchCongestionSetting_Control_Map_pack(const struct CC_SwitchCongestionSetting_Control_Map *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Marking_RateIsValid);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->CS_ThresholdAndCS_ReturnDelayIsValid);

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ThresholdAndPacket_SizeIsValid);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Credit_MaskIsValid);

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Victim_MaskIsValid);

}

void CC_SwitchCongestionSetting_Control_Map_unpack(struct CC_SwitchCongestionSetting_Control_Map *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->Marking_RateIsValid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->CS_ThresholdAndCS_ReturnDelayIsValid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 29;
	ptr_struct->ThresholdAndPacket_SizeIsValid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->Credit_MaskIsValid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 27;
	ptr_struct->Victim_MaskIsValid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void CC_SwitchCongestionSetting_Control_Map_print(const struct CC_SwitchCongestionSetting_Control_Map *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_SwitchCongestionSetting_Control_Map ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Marking_RateIsValid  : " UH_FMT "\n", ptr_struct->Marking_RateIsValid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CS_ThresholdAndCS_ReturnDelayIsValid : " UH_FMT "\n", ptr_struct->CS_ThresholdAndCS_ReturnDelayIsValid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ThresholdAndPacket_SizeIsValid : " UH_FMT "\n", ptr_struct->ThresholdAndPacket_SizeIsValid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Credit_MaskIsValid   : " UH_FMT "\n", ptr_struct->Credit_MaskIsValid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Victim_MaskIsValid   : " UH_FMT "\n", ptr_struct->Victim_MaskIsValid);

}

int CC_SwitchCongestionSetting_Control_Map_size(void)
{
	 return 4;
}

void CC_SwitchCongestionSetting_Control_Map_dump(const struct CC_SwitchCongestionSetting_Control_Map *ptr_struct, FILE* file)
{
	CC_SwitchCongestionSetting_Control_Map_print(ptr_struct, file, 0);
}

void CC_TimeStamp_pack(const struct CC_TimeStamp *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TimeStamp);

}

void CC_TimeStamp_unpack(struct CC_TimeStamp *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->TimeStamp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void CC_TimeStamp_print(const struct CC_TimeStamp *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_TimeStamp ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TimeStamp            : " U32H_FMT "\n", ptr_struct->TimeStamp);

}

int CC_TimeStamp_size(void)
{
	 return 4;
}

void CC_TimeStamp_dump(const struct CC_TimeStamp *ptr_struct, FILE* file)
{
	CC_TimeStamp_print(ptr_struct, file, 0);
}

void CDInfo_Block_pack(const struct CDInfo_Block *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ingress_port_state2);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->egress_port_state2);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ingress_port_state1);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->egress_port_state1);

}

void CDInfo_Block_unpack(struct CDInfo_Block *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 6;
	ptr_struct->ingress_port_state2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 4;
	ptr_struct->egress_port_state2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 2;
	ptr_struct->ingress_port_state1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->egress_port_state1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void CDInfo_Block_print(const struct CDInfo_Block *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CDInfo_Block ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_port_state2  : " UH_FMT "\n", ptr_struct->ingress_port_state2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_port_state2   : " UH_FMT "\n", ptr_struct->egress_port_state2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_port_state1  : " UH_FMT "\n", ptr_struct->ingress_port_state1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_port_state1   : " UH_FMT "\n", ptr_struct->egress_port_state1);

}

int CDInfo_Block_size(void)
{
	 return 1;
}

void CDInfo_Block_dump(const struct CDInfo_Block *ptr_struct, FILE* file)
{
	CDInfo_Block_print(ptr_struct, file, 0);
}

void CDPortState_Block_pack(const struct CDPortState_Block *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ingress_port_state2);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->egress_port_state2);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ingress_port_state1);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->egress_port_state1);

}

void CDPortState_Block_unpack(struct CDPortState_Block *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 6;
	ptr_struct->ingress_port_state2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 4;
	ptr_struct->egress_port_state2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 2;
	ptr_struct->ingress_port_state1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->egress_port_state1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void CDPortState_Block_print(const struct CDPortState_Block *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CDPortState_Block ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_port_state2  : " UH_FMT "\n", ptr_struct->ingress_port_state2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_port_state2   : " UH_FMT "\n", ptr_struct->egress_port_state2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_port_state1  : " UH_FMT "\n", ptr_struct->ingress_port_state1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_port_state1   : " UH_FMT "\n", ptr_struct->egress_port_state1);

}

int CDPortState_Block_size(void)
{
	 return 1;
}

void CDPortState_Block_dump(const struct CDPortState_Block *ptr_struct, FILE* file)
{
	CDPortState_Block_print(ptr_struct, file, 0);
}

void Class_C_Data_Block_Element_pack(const struct Class_C_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1792, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Data[i]);
	}

}

void Class_C_Data_Block_Element_unpack(struct Class_C_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1792, 1);
	ptr_struct->Data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void Class_C_Data_Block_Element_print(const struct Class_C_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== Class_C_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 56; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data_%03d            : " U32H_FMT "\n", i, ptr_struct->Data[i]);
	}

}

int Class_C_Data_Block_Element_size(void)
{
	 return 224;
}

void Class_C_Data_Block_Element_dump(const struct Class_C_Data_Block_Element *ptr_struct, FILE* file)
{
	Class_C_Data_Block_Element_print(ptr_struct, file, 0);
}

void Class_RDM_Data_Block_Element_pack(const struct Class_RDM_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1792, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Data[i]);
	}

}

void Class_RDM_Data_Block_Element_unpack(struct Class_RDM_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1792, 1);
	ptr_struct->Data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void Class_RDM_Data_Block_Element_print(const struct Class_RDM_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== Class_RDM_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 56; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data_%03d            : " U32H_FMT "\n", i, ptr_struct->Data[i]);
	}

}

int Class_RDM_Data_Block_Element_size(void)
{
	 return 224;
}

void Class_RDM_Data_Block_Element_dump(const struct Class_RDM_Data_Block_Element *ptr_struct, FILE* file)
{
	Class_RDM_Data_Block_Element_print(ptr_struct, file, 0);
}

void CongestionEntryListSwitchElement_pack(const struct CongestionEntryListSwitchElement *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DLID);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SLID);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Timestamp);

}

void CongestionEntryListSwitchElement_unpack(struct CongestionEntryListSwitchElement *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->DLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->SLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->SL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->Timestamp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void CongestionEntryListSwitchElement_print(const struct CongestionEntryListSwitchElement *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CongestionEntryListSwitchElement ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DLID                 : " UH_FMT "\n", ptr_struct->DLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SLID                 : " UH_FMT "\n", ptr_struct->SLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL                   : " UH_FMT "\n", ptr_struct->SL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Timestamp            : " U32H_FMT "\n", ptr_struct->Timestamp);

}

int CongestionEntryListSwitchElement_size(void)
{
	 return 12;
}

void CongestionEntryListSwitchElement_dump(const struct CongestionEntryListSwitchElement *ptr_struct, FILE* file)
{
	CongestionEntryListSwitchElement_print(ptr_struct, file, 0);
}

void CongestionLogEventListCAElement_pack(const struct CongestionLogEventListCAElement *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->Local_QP_CN_Entry);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Service_Type_CN_Entry);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL_CN_Entry);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->Remote_QP_Number_CN_Entry);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Remote_LID_CN_Entry);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Timestamp);

}

void CongestionLogEventListCAElement_unpack(struct CongestionLogEventListCAElement *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->Local_QP_CN_Entry = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 60;
	ptr_struct->Service_Type_CN_Entry = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->SL_CN_Entry = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->Remote_QP_Number_CN_Entry = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 64;
	ptr_struct->Remote_LID_CN_Entry = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->Timestamp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void CongestionLogEventListCAElement_print(const struct CongestionLogEventListCAElement *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CongestionLogEventListCAElement ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Local_QP_CN_Entry    : " UH_FMT "\n", ptr_struct->Local_QP_CN_Entry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Service_Type_CN_Entry : " UH_FMT "\n", ptr_struct->Service_Type_CN_Entry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL_CN_Entry          : " UH_FMT "\n", ptr_struct->SL_CN_Entry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Remote_QP_Number_CN_Entry : " UH_FMT "\n", ptr_struct->Remote_QP_Number_CN_Entry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Remote_LID_CN_Entry  : " UH_FMT "\n", ptr_struct->Remote_LID_CN_Entry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Timestamp            : " U32H_FMT "\n", ptr_struct->Timestamp);

}

int CongestionLogEventListCAElement_size(void)
{
	 return 16;
}

void CongestionLogEventListCAElement_dump(const struct CongestionLogEventListCAElement *ptr_struct, FILE* file)
{
	CongestionLogEventListCAElement_print(ptr_struct, file, 0);
}

void DataBuffer_pack(const struct DataBuffer *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 216; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1728, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void DataBuffer_unpack(struct DataBuffer *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 216; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1728, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void DataBuffer_print(const struct DataBuffer *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DataBuffer ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 216; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int DataBuffer_size(void)
{
	 return 216;
}

void DataBuffer_dump(const struct DataBuffer *ptr_struct, FILE* file)
{
	DataBuffer_print(ptr_struct, file, 0);
}

void DirRPath_Block_Element_pack(const struct DirRPath_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->BYTE[i]);
	}

}

void DirRPath_Block_Element_unpack(struct DirRPath_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	ptr_struct->BYTE[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void DirRPath_Block_Element_print(const struct DirRPath_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DirRPath_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BYTE_%03d            : " UH_FMT "\n", i, ptr_struct->BYTE[i]);
	}

}

int DirRPath_Block_Element_size(void)
{
	 return 64;
}

void DirRPath_Block_Element_dump(const struct DirRPath_Block_Element *ptr_struct, FILE* file)
{
	DirRPath_Block_Element_print(ptr_struct, file, 0);
}

void GID_Block_Element_pack(const struct GID_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 128, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DWord[i]);
	}

}

void GID_Block_Element_unpack(struct GID_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 128, 1);
	ptr_struct->DWord[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void GID_Block_Element_print(const struct GID_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== GID_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DWord_%03d           : " U32H_FMT "\n", i, ptr_struct->DWord[i]);
	}

}

int GID_Block_Element_size(void)
{
	 return 16;
}

void GID_Block_Element_dump(const struct GID_Block_Element *ptr_struct, FILE* file)
{
	GID_Block_Element_print(ptr_struct, file, 0);
}

void GeneralInfoCapabilityMask_pack(const struct GeneralInfoCapabilityMask *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capability0);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capability1);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capability2);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capability3);

}

void GeneralInfoCapabilityMask_unpack(struct GeneralInfoCapabilityMask *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->capability0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->capability1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->capability2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->capability3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void GeneralInfoCapabilityMask_print(const struct GeneralInfoCapabilityMask *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== GeneralInfoCapabilityMask ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability0          : " U32H_FMT "\n", ptr_struct->capability0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability1          : " U32H_FMT "\n", ptr_struct->capability1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability2          : " U32H_FMT "\n", ptr_struct->capability2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability3          : " U32H_FMT "\n", ptr_struct->capability3);

}

int GeneralInfoCapabilityMask_size(void)
{
	 return 16;
}

void GeneralInfoCapabilityMask_dump(const struct GeneralInfoCapabilityMask *ptr_struct, FILE* file)
{
	GeneralInfoCapabilityMask_print(ptr_struct, file, 0);
}

void HWInfo_Block_Element_pack(const struct HWInfo_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DeviceID);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DeviceHWRevision);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->pvs);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->technology);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_ports);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->hw_dev_id);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->manufacturing_base_mac_32_47);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->manufacturing_base_mac_0_31);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->UpTime);

}

void HWInfo_Block_Element_unpack(struct HWInfo_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->DeviceID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->DeviceHWRevision = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 59;
	ptr_struct->pvs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 48;
	ptr_struct->technology = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 40;
	ptr_struct->num_ports = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->hw_dev_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->manufacturing_base_mac_32_47 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->manufacturing_base_mac_0_31 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->UpTime = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void HWInfo_Block_Element_print(const struct HWInfo_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== HWInfo_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DeviceID             : " UH_FMT "\n", ptr_struct->DeviceID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DeviceHWRevision     : " UH_FMT "\n", ptr_struct->DeviceHWRevision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pvs                  : " UH_FMT "\n", ptr_struct->pvs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "technology           : " UH_FMT "\n", ptr_struct->technology);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_ports            : " UH_FMT "\n", ptr_struct->num_ports);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_dev_id            : " UH_FMT "\n", ptr_struct->hw_dev_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "manufacturing_base_mac_32_47 : " UH_FMT "\n", ptr_struct->manufacturing_base_mac_32_47);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "manufacturing_base_mac_0_31 : " U32H_FMT "\n", ptr_struct->manufacturing_base_mac_0_31);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "UpTime               : " U32H_FMT "\n", ptr_struct->UpTime);

}

int HWInfo_Block_Element_size(void)
{
	 return 32;
}

void HWInfo_Block_Element_dump(const struct HWInfo_Block_Element *ptr_struct, FILE* file)
{
	HWInfo_Block_Element_print(ptr_struct, file, 0);
}

void IB_AETH_pack(const struct IB_AETH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->MSN);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Syndrome);

}

void IB_AETH_unpack(struct IB_AETH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->MSN = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 0;
	ptr_struct->Syndrome = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void IB_AETH_print(const struct IB_AETH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_AETH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MSN                  : " UH_FMT "\n", ptr_struct->MSN);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Syndrome             : " UH_FMT "\n", ptr_struct->Syndrome);

}

int IB_AETH_size(void)
{
	 return 4;
}

void IB_AETH_dump(const struct IB_AETH *ptr_struct, FILE* file)
{
	IB_AETH_print(ptr_struct, file, 0);
}

void IB_DETH_pack(const struct IB_DETH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Q_Key);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->SrcQP);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Rsv8);

}

void IB_DETH_unpack(struct IB_DETH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->Q_Key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->SrcQP = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 32;
	ptr_struct->Rsv8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void IB_DETH_print(const struct IB_DETH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_DETH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Q_Key                : " U32H_FMT "\n", ptr_struct->Q_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SrcQP                : " UH_FMT "\n", ptr_struct->SrcQP);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsv8                 : " UH_FMT "\n", ptr_struct->Rsv8);

}

int IB_DETH_size(void)
{
	 return 8;
}

void IB_DETH_dump(const struct IB_DETH *ptr_struct, FILE* file)
{
	IB_DETH_print(ptr_struct, file, 0);
}

void IB_IETH_pack(const struct IB_IETH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->R_Key);

}

void IB_IETH_unpack(struct IB_IETH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->R_Key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void IB_IETH_print(const struct IB_IETH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_IETH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "R_Key                : " U32H_FMT "\n", ptr_struct->R_Key);

}

int IB_IETH_size(void)
{
	 return 4;
}

void IB_IETH_dump(const struct IB_IETH *ptr_struct, FILE* file)
{
	IB_IETH_print(ptr_struct, file, 0);
}

void IB_ImmDt_pack(const struct IB_ImmDt *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Immediate_Data);

}

void IB_ImmDt_unpack(struct IB_ImmDt *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->Immediate_Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void IB_ImmDt_print(const struct IB_ImmDt *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_ImmDt ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Immediate_Data       : " U32H_FMT "\n", ptr_struct->Immediate_Data);

}

int IB_ImmDt_size(void)
{
	 return 4;
}

void IB_ImmDt_dump(const struct IB_ImmDt *ptr_struct, FILE* file)
{
	IB_ImmDt_print(ptr_struct, file, 0);
}

void IB_LRH_pack(const struct IB_LRH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DLID);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->LNH);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->Rsv2);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Sl);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LVer);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Vl);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SLID);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->PktLen);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->Rsv5);

}

void IB_LRH_unpack(struct IB_LRH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->DLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 14;
	ptr_struct->LNH = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 12;
	ptr_struct->Rsv2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->Sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 4;
	ptr_struct->LVer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->Vl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->SLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 37;
	ptr_struct->PktLen = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 32;
	ptr_struct->Rsv5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void IB_LRH_print(const struct IB_LRH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_LRH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DLID                 : " UH_FMT "\n", ptr_struct->DLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LNH                  : " UH_FMT "\n", ptr_struct->LNH);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsv2                 : " UH_FMT "\n", ptr_struct->Rsv2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Sl                   : " UH_FMT "\n", ptr_struct->Sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LVer                 : " UH_FMT "\n", ptr_struct->LVer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Vl                   : " UH_FMT "\n", ptr_struct->Vl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SLID                 : " UH_FMT "\n", ptr_struct->SLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PktLen               : " UH_FMT "\n", ptr_struct->PktLen);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsv5                 : " UH_FMT "\n", ptr_struct->Rsv5);

}

int IB_LRH_size(void)
{
	 return 8;
}

void IB_LRH_dump(const struct IB_LRH *ptr_struct, FILE* file)
{
	IB_LRH_print(ptr_struct, file, 0);
}

void IB_RDETH_pack(const struct IB_RDETH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->EECnxt);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Rsv8);

}

void IB_RDETH_unpack(struct IB_RDETH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->EECnxt = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 0;
	ptr_struct->Rsv8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void IB_RDETH_print(const struct IB_RDETH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_RDETH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EECnxt               : " UH_FMT "\n", ptr_struct->EECnxt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsv8                 : " UH_FMT "\n", ptr_struct->Rsv8);

}

int IB_RDETH_size(void)
{
	 return 4;
}

void IB_RDETH_dump(const struct IB_RDETH *ptr_struct, FILE* file)
{
	IB_RDETH_print(ptr_struct, file, 0);
}

void IB_RWH_pack(const struct IB_RWH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->EtherType);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HW_Reserved);

}

void IB_RWH_unpack(struct IB_RWH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->EtherType = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->HW_Reserved = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void IB_RWH_print(const struct IB_RWH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_RWH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EtherType            : " UH_FMT "\n", ptr_struct->EtherType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HW_Reserved          : " UH_FMT "\n", ptr_struct->HW_Reserved);

}

int IB_RWH_size(void)
{
	 return 4;
}

void IB_RWH_dump(const struct IB_RWH *ptr_struct, FILE* file)
{
	IB_RWH_print(ptr_struct, file, 0);
}

void ICRC_pack(const struct ICRC *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ICRC);

}

void ICRC_unpack(struct ICRC *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->ICRC = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void ICRC_print(const struct ICRC *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ICRC ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ICRC                 : " U32H_FMT "\n", ptr_struct->ICRC);

}

int ICRC_size(void)
{
	 return 4;
}

void ICRC_dump(const struct ICRC *ptr_struct, FILE* file)
{
	ICRC_print(ptr_struct, file, 0);
}

void LID_Port_Block_Element_pack(const struct LID_Port_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LID);

	offset = 15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Valid);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->LMC);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Port);

}

void LID_Port_Block_Element_unpack(struct LID_Port_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->LID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 15;
	ptr_struct->Valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 12;
	ptr_struct->LMC = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 8;
	ptr_struct->Reserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->Port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void LID_Port_Block_Element_print(const struct LID_Port_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== LID_Port_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LID                  : " UH_FMT "\n", ptr_struct->LID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Valid                : " UH_FMT "\n", ptr_struct->Valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LMC                  : " UH_FMT "\n", ptr_struct->LMC);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Port                 : " UH_FMT "\n", ptr_struct->Port);

}

int LID_Port_Block_Element_size(void)
{
	 return 4;
}

void LID_Port_Block_Element_dump(const struct LID_Port_Block_Element *ptr_struct, FILE* file)
{
	LID_Port_Block_Element_print(ptr_struct, file, 0);
}

void NVLPenaltyBoxConfig_pack(const struct NVLPenaltyBoxConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 896; i++) {
	offset = adb2c_calc_array_field_address(30, 2, i, 1792, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->mlid[i]);
	}

}

void NVLPenaltyBoxConfig_unpack(struct NVLPenaltyBoxConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 896; i++) {
	offset = adb2c_calc_array_field_address(30, 2, i, 1792, 1);
	ptr_struct->mlid[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);
	}

}

void NVLPenaltyBoxConfig_print(const struct NVLPenaltyBoxConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NVLPenaltyBoxConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 896; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlid_%03d            : " UH_FMT "\n", i, ptr_struct->mlid[i]);
	}

}

int NVLPenaltyBoxConfig_size(void)
{
	 return 224;
}

void NVLPenaltyBoxConfig_dump(const struct NVLPenaltyBoxConfig *ptr_struct, FILE* file)
{
	NVLPenaltyBoxConfig_print(ptr_struct, file, 0);
}

void NVLReductionConfigureMLIDMonitors_pack(const struct NVLReductionConfigureMLIDMonitors *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 160, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mlid[i]);
	}

	offset = 159;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reset_aggregate_counters);

	offset = 158;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reset_hw_auto_counters);

}

void NVLReductionConfigureMLIDMonitors_unpack(struct NVLReductionConfigureMLIDMonitors *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 160, 1);
	ptr_struct->mlid[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	offset = 159;
	ptr_struct->reset_aggregate_counters = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 158;
	ptr_struct->reset_hw_auto_counters = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void NVLReductionConfigureMLIDMonitors_print(const struct NVLReductionConfigureMLIDMonitors *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NVLReductionConfigureMLIDMonitors ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlid_%03d            : " UH_FMT "\n", i, ptr_struct->mlid[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_aggregate_counters : " UH_FMT "\n", ptr_struct->reset_aggregate_counters);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_hw_auto_counters : " UH_FMT "\n", ptr_struct->reset_hw_auto_counters);

}

int NVLReductionConfigureMLIDMonitors_size(void)
{
	 return 20;
}

void NVLReductionConfigureMLIDMonitors_dump(const struct NVLReductionConfigureMLIDMonitors *ptr_struct, FILE* file)
{
	NVLReductionConfigureMLIDMonitors_print(ptr_struct, file, 0);
}

void NVLReductionForwardingTable_pack(const struct NVLReductionForwardingTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 112; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 1792, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->hbf_group_id[i]);
	}

}

void NVLReductionForwardingTable_unpack(struct NVLReductionForwardingTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 112; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 1792, 1);
	ptr_struct->hbf_group_id[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

}

void NVLReductionForwardingTable_print(const struct NVLReductionForwardingTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NVLReductionForwardingTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 112; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hbf_group_id_%03d    : " UH_FMT "\n", i, ptr_struct->hbf_group_id[i]);
	}

}

int NVLReductionForwardingTable_size(void)
{
	 return 224;
}

void NVLReductionForwardingTable_dump(const struct NVLReductionForwardingTable *ptr_struct, FILE* file)
{
	NVLReductionForwardingTable_print(ptr_struct, file, 0);
}

void NVLReductionInfo_pack(const struct NVLReductionInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capability_mask);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->hbf_group_cap);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->reduction_fdb_cap);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->reduction_fdb_top);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_up_ports);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_down_ports);

	offset = 155;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mcto_timer);

	offset = 151;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->penalty_box_change_trap_disable);

}

void NVLReductionInfo_unpack(struct NVLReductionInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->capability_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->hbf_group_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->reduction_fdb_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->reduction_fdb_top = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->num_of_up_ports = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->num_of_down_ports = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 155;
	ptr_struct->mcto_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 151;
	ptr_struct->penalty_box_change_trap_disable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void NVLReductionInfo_print(const struct NVLReductionInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NVLReductionInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability_mask      : " U32H_FMT "\n", ptr_struct->capability_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hbf_group_cap        : " UH_FMT "\n", ptr_struct->hbf_group_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reduction_fdb_cap    : " UH_FMT "\n", ptr_struct->reduction_fdb_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reduction_fdb_top    : " UH_FMT "\n", ptr_struct->reduction_fdb_top);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_up_ports      : " UH_FMT "\n", ptr_struct->num_of_up_ports);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_down_ports    : " UH_FMT "\n", ptr_struct->num_of_down_ports);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mcto_timer           : " UH_FMT "\n", ptr_struct->mcto_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "penalty_box_change_trap_disable : " UH_FMT "\n", ptr_struct->penalty_box_change_trap_disable);

}

int NVLReductionInfo_size(void)
{
	 return 224;
}

void NVLReductionInfo_dump(const struct NVLReductionInfo *ptr_struct, FILE* file)
{
	NVLReductionInfo_print(ptr_struct, file, 0);
}

void NVLReductionPortInfo_pack(const struct NVLReductionPortInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capability_mask);

	offset = 63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->exclude_include_self);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_direction_is_up);

}

void NVLReductionPortInfo_unpack(struct NVLReductionPortInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->capability_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 63;
	ptr_struct->exclude_include_self = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 62;
	ptr_struct->port_direction_is_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void NVLReductionPortInfo_print(const struct NVLReductionPortInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NVLReductionPortInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability_mask      : " U32H_FMT "\n", ptr_struct->capability_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "exclude_include_self : " UH_FMT "\n", ptr_struct->exclude_include_self);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_direction_is_up : " UH_FMT "\n", ptr_struct->port_direction_is_up);

}

int NVLReductionPortInfo_size(void)
{
	 return 224;
}

void NVLReductionPortInfo_dump(const struct NVLReductionPortInfo *ptr_struct, FILE* file)
{
	NVLReductionPortInfo_print(ptr_struct, file, 0);
}

void NVLReductionProfilesConfig_pack(const struct NVLReductionProfilesConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 448; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 1792, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_profile[i]);
	}

}

void NVLReductionProfilesConfig_unpack(struct NVLReductionProfilesConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 448; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 1792, 1);
	ptr_struct->port_profile[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);
	}

}

void NVLReductionProfilesConfig_print(const struct NVLReductionProfilesConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NVLReductionProfilesConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 448; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_profile_%03d    : " UH_FMT "\n", i, ptr_struct->port_profile[i]);
	}

}

int NVLReductionProfilesConfig_size(void)
{
	 return 224;
}

void NVLReductionProfilesConfig_dump(const struct NVLReductionProfilesConfig *ptr_struct, FILE* file)
{
	NVLReductionProfilesConfig_print(ptr_struct, file, 0);
}

void NVLReductionRoundingMode_pack(const struct NVLReductionRoundingMode *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->native_8_bit);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mixed_8_bit);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->native_16_bit);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mixed_16_bit);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->deterministic_mode);

}

void NVLReductionRoundingMode_unpack(struct NVLReductionRoundingMode *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 11;
	ptr_struct->native_8_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 10;
	ptr_struct->mixed_8_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 9;
	ptr_struct->native_16_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->mixed_16_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->deterministic_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void NVLReductionRoundingMode_print(const struct NVLReductionRoundingMode *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NVLReductionRoundingMode ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "native_8_bit         : " UH_FMT "\n", ptr_struct->native_8_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixed_8_bit          : " UH_FMT "\n", ptr_struct->mixed_8_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "native_16_bit        : " UH_FMT "\n", ptr_struct->native_16_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixed_16_bit         : " UH_FMT "\n", ptr_struct->mixed_16_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "deterministic_mode   : " UH_FMT "\n", ptr_struct->deterministic_mode);

}

int NVLReductionRoundingMode_size(void)
{
	 return 4;
}

void NVLReductionRoundingMode_dump(const struct NVLReductionRoundingMode *ptr_struct, FILE* file)
{
	NVLReductionRoundingMode_print(ptr_struct, file, 0);
}

void PM_PortSamplesResult_pack(const struct PM_PortSamplesResult *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->SampleStatus);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Tag);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter0);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter1);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter2);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter3);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter4);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter5);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter6);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter7);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter8);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter9);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter10);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter11);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter12);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter13);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Counter14);

}

void PM_PortSamplesResult_unpack(struct PM_PortSamplesResult *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->SampleStatus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->Tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->Counter0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->Counter1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->Counter2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->Counter3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->Counter4 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->Counter5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->Counter6 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->Counter7 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->Counter8 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->Counter9 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->Counter10 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->Counter11 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->Counter12 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->Counter13 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->Counter14 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void PM_PortSamplesResult_print(const struct PM_PortSamplesResult *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortSamplesResult ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SampleStatus         : " UH_FMT "\n", ptr_struct->SampleStatus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Tag                  : " UH_FMT "\n", ptr_struct->Tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter0             : " U32H_FMT "\n", ptr_struct->Counter0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter1             : " U32H_FMT "\n", ptr_struct->Counter1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter2             : " U32H_FMT "\n", ptr_struct->Counter2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter3             : " U32H_FMT "\n", ptr_struct->Counter3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter4             : " U32H_FMT "\n", ptr_struct->Counter4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter5             : " U32H_FMT "\n", ptr_struct->Counter5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter6             : " U32H_FMT "\n", ptr_struct->Counter6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter7             : " U32H_FMT "\n", ptr_struct->Counter7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter8             : " U32H_FMT "\n", ptr_struct->Counter8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter9             : " U32H_FMT "\n", ptr_struct->Counter9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter10            : " U32H_FMT "\n", ptr_struct->Counter10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter11            : " U32H_FMT "\n", ptr_struct->Counter11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter12            : " U32H_FMT "\n", ptr_struct->Counter12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter13            : " U32H_FMT "\n", ptr_struct->Counter13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Counter14            : " U32H_FMT "\n", ptr_struct->Counter14);

}

int PM_PortSamplesResult_size(void)
{
	 return 192;
}

void PM_PortSamplesResult_dump(const struct PM_PortSamplesResult *ptr_struct, FILE* file)
{
	PM_PortSamplesResult_print(ptr_struct, file, 0);
}

void PM_PortVLXmitFlowCtlUpdateErrors_pack(const struct PM_PortVLXmitFlowCtlUpdateErrors *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CounterSelect);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors0);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors1);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors2);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors3);

	offset = 54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors4);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors5);

	offset = 50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors6);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors7);

	offset = 46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors8);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors9);

	offset = 42;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors10);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors11);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors12);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors13);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors14);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortVLXmitFlowCtlUpdateErrors15);

}

void PM_PortVLXmitFlowCtlUpdateErrors_unpack(struct PM_PortVLXmitFlowCtlUpdateErrors *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->Reserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->CounterSelect = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 62;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 60;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 58;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 56;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 54;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 52;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 50;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 48;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 46;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 44;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 42;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 40;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 38;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors12 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 36;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors13 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 34;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors14 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 32;
	ptr_struct->PortVLXmitFlowCtlUpdateErrors15 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void PM_PortVLXmitFlowCtlUpdateErrors_print(const struct PM_PortVLXmitFlowCtlUpdateErrors *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortVLXmitFlowCtlUpdateErrors ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect        : " UH_FMT "\n", ptr_struct->CounterSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors0 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors1 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors2 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors3 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors4 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors5 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors6 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors7 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors8 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors9 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors10 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors11 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors12 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors13 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors14 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitFlowCtlUpdateErrors15 : " UH_FMT "\n", ptr_struct->PortVLXmitFlowCtlUpdateErrors15);

}

int PM_PortVLXmitFlowCtlUpdateErrors_size(void)
{
	 return 64;
}

void PM_PortVLXmitFlowCtlUpdateErrors_dump(const struct PM_PortVLXmitFlowCtlUpdateErrors *ptr_struct, FILE* file)
{
	PM_PortVLXmitFlowCtlUpdateErrors_print(ptr_struct, file, 0);
}

void PSID_Block_Element_pack(const struct PSID_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 128, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PSID[i]);
	}

}

void PSID_Block_Element_unpack(struct PSID_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 128, 1);
	ptr_struct->PSID[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void PSID_Block_Element_print(const struct PSID_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PSID_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PSID_%03d            : " UH_FMT "\n", i, ptr_struct->PSID[i]);
	}

}

int PSID_Block_Element_size(void)
{
	 return 16;
}

void PSID_Block_Element_dump(const struct PSID_Block_Element *ptr_struct, FILE* file)
{
	PSID_Block_Element_print(ptr_struct, file, 0);
}

void P_Key_Block_Element_pack(const struct P_Key_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->P_KeyBase);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Membership_Type);

}

void P_Key_Block_Element_unpack(struct P_Key_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	ptr_struct->P_KeyBase = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->Membership_Type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void P_Key_Block_Element_print(const struct P_Key_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== P_Key_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "P_KeyBase            : " UH_FMT "\n", ptr_struct->P_KeyBase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Membership_Type      : " UH_FMT "\n", ptr_struct->Membership_Type);

}

int P_Key_Block_Element_size(void)
{
	 return 2;
}

void P_Key_Block_Element_dump(const struct P_Key_Block_Element *ptr_struct, FILE* file)
{
	P_Key_Block_Element_print(ptr_struct, file, 0);
}

void PenaltyBoxChangeTrap_pack(const struct PenaltyBoxChangeTrap *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid_addr);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->port_no);

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(88, 8, i, 448, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->block_id_mask[i]);
	}

}

void PenaltyBoxChangeTrap_unpack(struct PenaltyBoxChangeTrap *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->lid_addr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->port_no = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(88, 8, i, 448, 1);
	ptr_struct->block_id_mask[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void PenaltyBoxChangeTrap_print(const struct PenaltyBoxChangeTrap *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PenaltyBoxChangeTrap ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid_addr             : " UH_FMT "\n", ptr_struct->lid_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_no              : " UH_FMT "\n", ptr_struct->port_no);

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "block_id_mask_%03d   : " UH_FMT "\n", i, ptr_struct->block_id_mask[i]);
	}

}

int PenaltyBoxChangeTrap_size(void)
{
	 return 56;
}

void PenaltyBoxChangeTrap_dump(const struct PenaltyBoxChangeTrap *ptr_struct, FILE* file)
{
	PenaltyBoxChangeTrap_print(ptr_struct, file, 0);
}

void PerfManagement_MAD_Data_Block_Element_pack(const struct PerfManagement_MAD_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1536, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DWORD[i]);
	}

}

void PerfManagement_MAD_Data_Block_Element_unpack(struct PerfManagement_MAD_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1536, 1);
	ptr_struct->DWORD[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void PerfManagement_MAD_Data_Block_Element_print(const struct PerfManagement_MAD_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PerfManagement_MAD_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 48; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DWORD_%03d           : " U32H_FMT "\n", i, ptr_struct->DWORD[i]);
	}

}

int PerfManagement_MAD_Data_Block_Element_size(void)
{
	 return 192;
}

void PerfManagement_MAD_Data_Block_Element_dump(const struct PerfManagement_MAD_Data_Block_Element *ptr_struct, FILE* file)
{
	PerfManagement_MAD_Data_Block_Element_print(ptr_struct, file, 0);
}

void PortCountersExtended_Mask_Block_Element_pack(const struct PortCountersExtended_Mask_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortXmitData);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortRcvData);

	offset = 13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortXmitPkts);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortRcvPkts);

	offset = 11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortUnicastXmitPkts);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortUnicastRcvPkts);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortMulticastXmitPkts);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortMulticastRcvPkts);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved);

}

void PortCountersExtended_Mask_Block_Element_unpack(struct PortCountersExtended_Mask_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 15;
	ptr_struct->SetPortXmitData = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 14;
	ptr_struct->SetPortRcvData = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 13;
	ptr_struct->SetPortXmitPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 12;
	ptr_struct->SetPortRcvPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 11;
	ptr_struct->SetPortUnicastXmitPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 10;
	ptr_struct->SetPortUnicastRcvPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 9;
	ptr_struct->SetPortMulticastXmitPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->SetPortMulticastRcvPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->Reserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void PortCountersExtended_Mask_Block_Element_print(const struct PortCountersExtended_Mask_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PortCountersExtended_Mask_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortXmitData      : " UH_FMT "\n", ptr_struct->SetPortXmitData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortRcvData       : " UH_FMT "\n", ptr_struct->SetPortRcvData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortXmitPkts      : " UH_FMT "\n", ptr_struct->SetPortXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortRcvPkts       : " UH_FMT "\n", ptr_struct->SetPortRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortUnicastXmitPkts : " UH_FMT "\n", ptr_struct->SetPortUnicastXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortUnicastRcvPkts : " UH_FMT "\n", ptr_struct->SetPortUnicastRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortMulticastXmitPkts : " UH_FMT "\n", ptr_struct->SetPortMulticastXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortMulticastRcvPkts : " UH_FMT "\n", ptr_struct->SetPortMulticastRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

}

int PortCountersExtended_Mask_Block_Element_size(void)
{
	 return 2;
}

void PortCountersExtended_Mask_Block_Element_dump(const struct PortCountersExtended_Mask_Block_Element *ptr_struct, FILE* file)
{
	PortCountersExtended_Mask_Block_Element_print(ptr_struct, file, 0);
}

void PortCounters_Mask2_Block_Element_pack(const struct PortCounters_Mask2_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortXmitWait);

}

void PortCounters_Mask2_Block_Element_unpack(struct PortCounters_Mask2_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 7;
	ptr_struct->SetPortXmitWait = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void PortCounters_Mask2_Block_Element_print(const struct PortCounters_Mask2_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PortCounters_Mask2_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortXmitWait      : " UH_FMT "\n", ptr_struct->SetPortXmitWait);

}

int PortCounters_Mask2_Block_Element_size(void)
{
	 return 1;
}

void PortCounters_Mask2_Block_Element_dump(const struct PortCounters_Mask2_Block_Element *ptr_struct, FILE* file)
{
	PortCounters_Mask2_Block_Element_print(ptr_struct, file, 0);
}

void PortCounters_Mask_Block_Element_pack(const struct PortCounters_Mask_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetSymbolErrorCounter);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetLinkErrorRecoveryCounter);

	offset = 13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetLinkDownedCounter);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortRcvErrors);

	offset = 11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortRcvRemotePhysicalErrors);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortRcvSwitchRelayErrors);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortXmitDiscards);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortXmitConstraintErrors);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortRcvConstraintErrors);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetLocalLinkIntegrityErrors);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetExcessiveBufferOverrunErrors);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetVL15Dropped);

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortXmitData);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortRcvData);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortXmitPkts);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortRcvPkts);

}

void PortCounters_Mask_Block_Element_unpack(struct PortCounters_Mask_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 15;
	ptr_struct->SetSymbolErrorCounter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 14;
	ptr_struct->SetLinkErrorRecoveryCounter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 13;
	ptr_struct->SetLinkDownedCounter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 12;
	ptr_struct->SetPortRcvErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 11;
	ptr_struct->SetPortRcvRemotePhysicalErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 10;
	ptr_struct->SetPortRcvSwitchRelayErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 9;
	ptr_struct->SetPortXmitDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->SetPortXmitConstraintErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 7;
	ptr_struct->SetPortRcvConstraintErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 6;
	ptr_struct->SetLocalLinkIntegrityErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 5;
	ptr_struct->SetExcessiveBufferOverrunErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 4;
	ptr_struct->SetVL15Dropped = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 3;
	ptr_struct->SetPortXmitData = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 2;
	ptr_struct->SetPortRcvData = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->SetPortXmitPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->SetPortRcvPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void PortCounters_Mask_Block_Element_print(const struct PortCounters_Mask_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PortCounters_Mask_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetSymbolErrorCounter : " UH_FMT "\n", ptr_struct->SetSymbolErrorCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetLinkErrorRecoveryCounter : " UH_FMT "\n", ptr_struct->SetLinkErrorRecoveryCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetLinkDownedCounter : " UH_FMT "\n", ptr_struct->SetLinkDownedCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortRcvErrors     : " UH_FMT "\n", ptr_struct->SetPortRcvErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortRcvRemotePhysicalErrors : " UH_FMT "\n", ptr_struct->SetPortRcvRemotePhysicalErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortRcvSwitchRelayErrors : " UH_FMT "\n", ptr_struct->SetPortRcvSwitchRelayErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortXmitDiscards  : " UH_FMT "\n", ptr_struct->SetPortXmitDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortXmitConstraintErrors : " UH_FMT "\n", ptr_struct->SetPortXmitConstraintErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortRcvConstraintErrors : " UH_FMT "\n", ptr_struct->SetPortRcvConstraintErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetLocalLinkIntegrityErrors : " UH_FMT "\n", ptr_struct->SetLocalLinkIntegrityErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetExcessiveBufferOverrunErrors : " UH_FMT "\n", ptr_struct->SetExcessiveBufferOverrunErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetVL15Dropped       : " UH_FMT "\n", ptr_struct->SetVL15Dropped);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortXmitData      : " UH_FMT "\n", ptr_struct->SetPortXmitData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortRcvData       : " UH_FMT "\n", ptr_struct->SetPortRcvData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortXmitPkts      : " UH_FMT "\n", ptr_struct->SetPortXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortRcvPkts       : " UH_FMT "\n", ptr_struct->SetPortRcvPkts);

}

int PortCounters_Mask_Block_Element_size(void)
{
	 return 2;
}

void PortCounters_Mask_Block_Element_dump(const struct PortCounters_Mask_Block_Element *ptr_struct, FILE* file)
{
	PortCounters_Mask_Block_Element_print(ptr_struct, file, 0);
}

void PortRcvErrorDetails_Mask_Block_Element_pack(const struct PortRcvErrorDetails_Mask_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortLocalPhysicalErrors);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortMalformedPacketErrors);

	offset = 13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortBufferOverrunErrors);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortDLIDMappingErrors);

	offset = 11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortVLMappingErrors);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortLoopingErrors);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->Reserved);

}

void PortRcvErrorDetails_Mask_Block_Element_unpack(struct PortRcvErrorDetails_Mask_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 15;
	ptr_struct->SetPortLocalPhysicalErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 14;
	ptr_struct->SetPortMalformedPacketErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 13;
	ptr_struct->SetPortBufferOverrunErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 12;
	ptr_struct->SetPortDLIDMappingErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 11;
	ptr_struct->SetPortVLMappingErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 10;
	ptr_struct->SetPortLoopingErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->Reserved = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void PortRcvErrorDetails_Mask_Block_Element_print(const struct PortRcvErrorDetails_Mask_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PortRcvErrorDetails_Mask_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortLocalPhysicalErrors : " UH_FMT "\n", ptr_struct->SetPortLocalPhysicalErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortMalformedPacketErrors : " UH_FMT "\n", ptr_struct->SetPortMalformedPacketErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortBufferOverrunErrors : " UH_FMT "\n", ptr_struct->SetPortBufferOverrunErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortDLIDMappingErrors : " UH_FMT "\n", ptr_struct->SetPortDLIDMappingErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortVLMappingErrors : " UH_FMT "\n", ptr_struct->SetPortVLMappingErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortLoopingErrors : " UH_FMT "\n", ptr_struct->SetPortLoopingErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

}

int PortRcvErrorDetails_Mask_Block_Element_size(void)
{
	 return 2;
}

void PortRcvErrorDetails_Mask_Block_Element_dump(const struct PortRcvErrorDetails_Mask_Block_Element *ptr_struct, FILE* file)
{
	PortRcvErrorDetails_Mask_Block_Element_print(ptr_struct, file, 0);
}

void PortSampleControlOptionMask_pack(const struct PortSampleControlOptionMask *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PlaceHolder);

	offset = 15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SwPortVLCongestion_SWPortVLCongestion_n);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvConCtrl_PortPktRcvFECN);

	offset = 13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvConCtrl_PortPktRcvBECN);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortSLRcvFECN_PortSLRcvFECN_n);

	offset = 11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortSLRcvBECN_PortSLRcvBECN_n);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitConCtrl_PortXmitTimeCong);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortVLXmitTimeCong_PortVLXmitTimeCong_n);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitDataSL_n);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvDataSL_n);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitDataSLExt_n);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvDataSLExt_n);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitQueue_n);

	offset = 61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitDataVl_n);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvDataVl_n);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitPktVl_n);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvPktVl_n);

	offset = 57;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvErrorDetails_PortLocalPhysicalErrors);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvErrorDetails_PortMalformedPacketErrors);

	offset = 55;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvErrorDetails_PortBufferOverrunErrors);

	offset = 54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvErrorDetails_PortDLIDMappingErrors);

	offset = 53;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvErrorDetails_PortVlMappingErrors);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortRcvErrorDetails_PortLoopingErrors);

	offset = 51;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitDiscardDetails_PortInactiveDiscards);

	offset = 50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitDiscardDetails_PortNeighborMTUDiscards);

	offset = 49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitDiscardDetails_PortSwLifetimeLimitDiscards);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortXmitDiscardDetails_PortSwHOQLifeLimitDiscards);

	offset = 47;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortOpRcvCounters_PortOpRcvPkts);

	offset = 46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortOpRcvCounters_PortOpRcvData);

	offset = 45;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortFlowCtlCounters_PortXmitFlowPkts);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortFlowCtlCounters_PortRcvFlowPkts);

	offset = 43;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortVLOpPackets_PortVLOpPackets_n);

	offset = 42;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortVLOpData_PortVLOpData_n);

	offset = 41;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortVlXmitFlowCtlUpdateErrors_PortVLXmitCtlUpdateErrors_n);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortVLXmitWaitCounters_PortVLXmitWait_n);

	offset = 39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortUnicastXmitPkts);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortUnicastRcvPkts);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortMulticastXmitPkts);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortMulticastRcvPkts);

	offset = 35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortExtendedSpeedsCounter);

}

void PortSampleControlOptionMask_unpack(struct PortSampleControlOptionMask *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->PlaceHolder = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 15;
	ptr_struct->SwPortVLCongestion_SWPortVLCongestion_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 14;
	ptr_struct->PortRcvConCtrl_PortPktRcvFECN = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 13;
	ptr_struct->PortRcvConCtrl_PortPktRcvBECN = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 12;
	ptr_struct->PortSLRcvFECN_PortSLRcvFECN_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 11;
	ptr_struct->PortSLRcvBECN_PortSLRcvBECN_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 10;
	ptr_struct->PortXmitConCtrl_PortXmitTimeCong = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 9;
	ptr_struct->PortVLXmitTimeCong_PortVLXmitTimeCong_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->PortXmitDataSL_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 7;
	ptr_struct->PortRcvDataSL_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 6;
	ptr_struct->PortXmitDataSLExt_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 5;
	ptr_struct->PortRcvDataSLExt_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 62;
	ptr_struct->PortXmitQueue_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 61;
	ptr_struct->PortXmitDataVl_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 60;
	ptr_struct->PortRcvDataVl_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 59;
	ptr_struct->PortXmitPktVl_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 58;
	ptr_struct->PortRcvPktVl_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 57;
	ptr_struct->PortRcvErrorDetails_PortLocalPhysicalErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->PortRcvErrorDetails_PortMalformedPacketErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 55;
	ptr_struct->PortRcvErrorDetails_PortBufferOverrunErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 54;
	ptr_struct->PortRcvErrorDetails_PortDLIDMappingErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 53;
	ptr_struct->PortRcvErrorDetails_PortVlMappingErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 52;
	ptr_struct->PortRcvErrorDetails_PortLoopingErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 51;
	ptr_struct->PortXmitDiscardDetails_PortInactiveDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 50;
	ptr_struct->PortXmitDiscardDetails_PortNeighborMTUDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 49;
	ptr_struct->PortXmitDiscardDetails_PortSwLifetimeLimitDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->PortXmitDiscardDetails_PortSwHOQLifeLimitDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 47;
	ptr_struct->PortOpRcvCounters_PortOpRcvPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 46;
	ptr_struct->PortOpRcvCounters_PortOpRcvData = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 45;
	ptr_struct->PortFlowCtlCounters_PortXmitFlowPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 44;
	ptr_struct->PortFlowCtlCounters_PortRcvFlowPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 43;
	ptr_struct->PortVLOpPackets_PortVLOpPackets_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 42;
	ptr_struct->PortVLOpData_PortVLOpData_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 41;
	ptr_struct->PortVlXmitFlowCtlUpdateErrors_PortVLXmitCtlUpdateErrors_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 40;
	ptr_struct->PortVLXmitWaitCounters_PortVLXmitWait_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 39;
	ptr_struct->PortUnicastXmitPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 38;
	ptr_struct->PortUnicastRcvPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 37;
	ptr_struct->PortMulticastXmitPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 36;
	ptr_struct->PortMulticastRcvPkts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 35;
	ptr_struct->PortExtendedSpeedsCounter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void PortSampleControlOptionMask_print(const struct PortSampleControlOptionMask *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PortSampleControlOptionMask ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PlaceHolder          : " UH_FMT "\n", ptr_struct->PlaceHolder);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SwPortVLCongestion_SWPortVLCongestion_n : " UH_FMT "\n", ptr_struct->SwPortVLCongestion_SWPortVLCongestion_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvConCtrl_PortPktRcvFECN : " UH_FMT "\n", ptr_struct->PortRcvConCtrl_PortPktRcvFECN);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvConCtrl_PortPktRcvBECN : " UH_FMT "\n", ptr_struct->PortRcvConCtrl_PortPktRcvBECN);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSLRcvFECN_PortSLRcvFECN_n : " UH_FMT "\n", ptr_struct->PortSLRcvFECN_PortSLRcvFECN_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSLRcvBECN_PortSLRcvBECN_n : " UH_FMT "\n", ptr_struct->PortSLRcvBECN_PortSLRcvBECN_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitConCtrl_PortXmitTimeCong : " UH_FMT "\n", ptr_struct->PortXmitConCtrl_PortXmitTimeCong);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitTimeCong_PortVLXmitTimeCong_n : " UH_FMT "\n", ptr_struct->PortVLXmitTimeCong_PortVLXmitTimeCong_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDataSL_n     : " UH_FMT "\n", ptr_struct->PortXmitDataSL_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvDataSL_n      : " UH_FMT "\n", ptr_struct->PortRcvDataSL_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDataSLExt_n  : " UH_FMT "\n", ptr_struct->PortXmitDataSLExt_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvDataSLExt_n   : " UH_FMT "\n", ptr_struct->PortRcvDataSLExt_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitQueue_n      : " UH_FMT "\n", ptr_struct->PortXmitQueue_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDataVl_n     : " UH_FMT "\n", ptr_struct->PortXmitDataVl_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvDataVl_n      : " UH_FMT "\n", ptr_struct->PortRcvDataVl_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitPktVl_n      : " UH_FMT "\n", ptr_struct->PortXmitPktVl_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvPktVl_n       : " UH_FMT "\n", ptr_struct->PortRcvPktVl_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvErrorDetails_PortLocalPhysicalErrors : " UH_FMT "\n", ptr_struct->PortRcvErrorDetails_PortLocalPhysicalErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvErrorDetails_PortMalformedPacketErrors : " UH_FMT "\n", ptr_struct->PortRcvErrorDetails_PortMalformedPacketErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvErrorDetails_PortBufferOverrunErrors : " UH_FMT "\n", ptr_struct->PortRcvErrorDetails_PortBufferOverrunErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvErrorDetails_PortDLIDMappingErrors : " UH_FMT "\n", ptr_struct->PortRcvErrorDetails_PortDLIDMappingErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvErrorDetails_PortVlMappingErrors : " UH_FMT "\n", ptr_struct->PortRcvErrorDetails_PortVlMappingErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvErrorDetails_PortLoopingErrors : " UH_FMT "\n", ptr_struct->PortRcvErrorDetails_PortLoopingErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDiscardDetails_PortInactiveDiscards : " UH_FMT "\n", ptr_struct->PortXmitDiscardDetails_PortInactiveDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDiscardDetails_PortNeighborMTUDiscards : " UH_FMT "\n", ptr_struct->PortXmitDiscardDetails_PortNeighborMTUDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDiscardDetails_PortSwLifetimeLimitDiscards : " UH_FMT "\n", ptr_struct->PortXmitDiscardDetails_PortSwLifetimeLimitDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDiscardDetails_PortSwHOQLifeLimitDiscards : " UH_FMT "\n", ptr_struct->PortXmitDiscardDetails_PortSwHOQLifeLimitDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortOpRcvCounters_PortOpRcvPkts : " UH_FMT "\n", ptr_struct->PortOpRcvCounters_PortOpRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortOpRcvCounters_PortOpRcvData : " UH_FMT "\n", ptr_struct->PortOpRcvCounters_PortOpRcvData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortFlowCtlCounters_PortXmitFlowPkts : " UH_FMT "\n", ptr_struct->PortFlowCtlCounters_PortXmitFlowPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortFlowCtlCounters_PortRcvFlowPkts : " UH_FMT "\n", ptr_struct->PortFlowCtlCounters_PortRcvFlowPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLOpPackets_PortVLOpPackets_n : " UH_FMT "\n", ptr_struct->PortVLOpPackets_PortVLOpPackets_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLOpData_PortVLOpData_n : " UH_FMT "\n", ptr_struct->PortVLOpData_PortVLOpData_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVlXmitFlowCtlUpdateErrors_PortVLXmitCtlUpdateErrors_n : " UH_FMT "\n", ptr_struct->PortVlXmitFlowCtlUpdateErrors_PortVLXmitCtlUpdateErrors_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLXmitWaitCounters_PortVLXmitWait_n : " UH_FMT "\n", ptr_struct->PortVLXmitWaitCounters_PortVLXmitWait_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortUnicastXmitPkts  : " UH_FMT "\n", ptr_struct->PortUnicastXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortUnicastRcvPkts   : " UH_FMT "\n", ptr_struct->PortUnicastRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMulticastXmitPkts : " UH_FMT "\n", ptr_struct->PortMulticastXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMulticastRcvPkts : " UH_FMT "\n", ptr_struct->PortMulticastRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortExtendedSpeedsCounter : " UH_FMT "\n", ptr_struct->PortExtendedSpeedsCounter);

}

int PortSampleControlOptionMask_size(void)
{
	 return 8;
}

void PortSampleControlOptionMask_dump(const struct PortSampleControlOptionMask *ptr_struct, FILE* file)
{
	PortSampleControlOptionMask_print(ptr_struct, file, 0);
}

void PortXmitDiscardDetails_Mask_Block_Element_pack(const struct PortXmitDiscardDetails_Mask_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortInactiveDiscards);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortNeighborMTUDiscards);

	offset = 13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortSwLifetimeLimitDiscards);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SetPortSwHOQLifetimeLimitDiscards);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->Reserved);

}

void PortXmitDiscardDetails_Mask_Block_Element_unpack(struct PortXmitDiscardDetails_Mask_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 15;
	ptr_struct->SetPortInactiveDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 14;
	ptr_struct->SetPortNeighborMTUDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 13;
	ptr_struct->SetPortSwLifetimeLimitDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 12;
	ptr_struct->SetPortSwHOQLifetimeLimitDiscards = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->Reserved = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

}

void PortXmitDiscardDetails_Mask_Block_Element_print(const struct PortXmitDiscardDetails_Mask_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PortXmitDiscardDetails_Mask_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortInactiveDiscards : " UH_FMT "\n", ptr_struct->SetPortInactiveDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortNeighborMTUDiscards : " UH_FMT "\n", ptr_struct->SetPortNeighborMTUDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortSwLifetimeLimitDiscards : " UH_FMT "\n", ptr_struct->SetPortSwLifetimeLimitDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SetPortSwHOQLifetimeLimitDiscards : " UH_FMT "\n", ptr_struct->SetPortSwHOQLifetimeLimitDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

}

int PortXmitDiscardDetails_Mask_Block_Element_size(void)
{
	 return 2;
}

void PortXmitDiscardDetails_Mask_Block_Element_dump(const struct PortXmitDiscardDetails_Mask_Block_Element *ptr_struct, FILE* file)
{
	PortXmitDiscardDetails_Mask_Block_Element_print(ptr_struct, file, 0);
}

void RDMRawNoticeDataDetails_pack(const struct RDMRawNoticeDataDetails *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 448, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void RDMRawNoticeDataDetails_unpack(struct RDMRawNoticeDataDetails *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 448, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void RDMRawNoticeDataDetails_print(const struct RDMRawNoticeDataDetails *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RDMRawNoticeDataDetails ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 56; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int RDMRawNoticeDataDetails_size(void)
{
	 return 56;
}

void RDMRawNoticeDataDetails_dump(const struct RDMRawNoticeDataDetails *ptr_struct, FILE* file)
{
	RDMRawNoticeDataDetails_print(ptr_struct, file, 0);
}

void RawData_PM_PortRcvXmitCntrsSlVl_pack(const struct RawData_PM_PortRcvXmitCntrsSlVl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 132; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1056, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void RawData_PM_PortRcvXmitCntrsSlVl_unpack(struct RawData_PM_PortRcvXmitCntrsSlVl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 132; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1056, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void RawData_PM_PortRcvXmitCntrsSlVl_print(const struct RawData_PM_PortRcvXmitCntrsSlVl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RawData_PM_PortRcvXmitCntrsSlVl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 132; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int RawData_PM_PortRcvXmitCntrsSlVl_size(void)
{
	 return 132;
}

void RawData_PM_PortRcvXmitCntrsSlVl_dump(const struct RawData_PM_PortRcvXmitCntrsSlVl *ptr_struct, FILE* file)
{
	RawData_PM_PortRcvXmitCntrsSlVl_print(ptr_struct, file, 0);
}

void RawData_PM_PortRcvXmitCntrsSlVl16_pack(const struct RawData_PM_PortRcvXmitCntrsSlVl16 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 256, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DataVLSL16[i]);
	}

}

void RawData_PM_PortRcvXmitCntrsSlVl16_unpack(struct RawData_PM_PortRcvXmitCntrsSlVl16 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 256, 1);
	ptr_struct->DataVLSL16[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

}

void RawData_PM_PortRcvXmitCntrsSlVl16_print(const struct RawData_PM_PortRcvXmitCntrsSlVl16 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RawData_PM_PortRcvXmitCntrsSlVl16 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DataVLSL16_%03d      : " UH_FMT "\n", i, ptr_struct->DataVLSL16[i]);
	}

}

int RawData_PM_PortRcvXmitCntrsSlVl16_size(void)
{
	 return 32;
}

void RawData_PM_PortRcvXmitCntrsSlVl16_dump(const struct RawData_PM_PortRcvXmitCntrsSlVl16 *ptr_struct, FILE* file)
{
	RawData_PM_PortRcvXmitCntrsSlVl16_print(ptr_struct, file, 0);
}

void RawData_PM_PortRcvXmitCntrsSlVl32_pack(const struct RawData_PM_PortRcvXmitCntrsSlVl32 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DataVLSL32[i]);
	}

}

void RawData_PM_PortRcvXmitCntrsSlVl32_unpack(struct RawData_PM_PortRcvXmitCntrsSlVl32 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ptr_struct->DataVLSL32[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void RawData_PM_PortRcvXmitCntrsSlVl32_print(const struct RawData_PM_PortRcvXmitCntrsSlVl32 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RawData_PM_PortRcvXmitCntrsSlVl32 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DataVLSL32_%03d      : " U32H_FMT "\n", i, ptr_struct->DataVLSL32[i]);
	}

}

int RawData_PM_PortRcvXmitCntrsSlVl32_size(void)
{
	 return 64;
}

void RawData_PM_PortRcvXmitCntrsSlVl32_dump(const struct RawData_PM_PortRcvXmitCntrsSlVl32 *ptr_struct, FILE* file)
{
	RawData_PM_PortRcvXmitCntrsSlVl32_print(ptr_struct, file, 0);
}

void RawNoticeDataDetails_pack(const struct RawNoticeDataDetails *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 448, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void RawNoticeDataDetails_unpack(struct RawNoticeDataDetails *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 448, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void RawNoticeDataDetails_print(const struct RawNoticeDataDetails *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RawNoticeDataDetails ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 56; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int RawNoticeDataDetails_size(void)
{
	 return 56;
}

void RawNoticeDataDetails_dump(const struct RawNoticeDataDetails *ptr_struct, FILE* file)
{
	RawNoticeDataDetails_print(ptr_struct, file, 0);
}

void SMP_ARGroupToRouterLIDTable_pack(const struct SMP_ARGroupToRouterLIDTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->router_lid[i]);
	}

}

void SMP_ARGroupToRouterLIDTable_unpack(struct SMP_ARGroupToRouterLIDTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	ptr_struct->router_lid[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

}

void SMP_ARGroupToRouterLIDTable_print(const struct SMP_ARGroupToRouterLIDTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ARGroupToRouterLIDTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "router_lid_%03d      : " UH_FMT "\n", i, ptr_struct->router_lid[i]);
	}

}

int SMP_ARGroupToRouterLIDTable_size(void)
{
	 return 64;
}

void SMP_ARGroupToRouterLIDTable_dump(const struct SMP_ARGroupToRouterLIDTable *ptr_struct, FILE* file)
{
	SMP_ARGroupToRouterLIDTable_print(ptr_struct, file, 0);
}

void SMP_BERConfig_pack(const struct SMP_BERConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->en_thr);

	offset = 90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->error_thr_action);

	offset = 66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_normal_trap);

	offset = 65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_warning_trap);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_error_trap);

	offset = 116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->error_thr);

	offset = 148;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->warning_thr);

	offset = 180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->normal_thr);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->time_window);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sampling_rate);

}

void SMP_BERConfig_unpack(struct SMP_BERConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 94;
	ptr_struct->en_thr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 90;
	ptr_struct->error_thr_action = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 66;
	ptr_struct->en_normal_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 65;
	ptr_struct->en_warning_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->en_error_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 116;
	ptr_struct->error_thr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 148;
	ptr_struct->warning_thr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 180;
	ptr_struct->normal_thr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 200;
	ptr_struct->time_window = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 248;
	ptr_struct->sampling_rate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void SMP_BERConfig_print(const struct SMP_BERConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_BERConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_thr               : " UH_FMT "\n", ptr_struct->en_thr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_thr_action     : " UH_FMT "\n", ptr_struct->error_thr_action);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_normal_trap       : " UH_FMT "\n", ptr_struct->en_normal_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_warning_trap      : " UH_FMT "\n", ptr_struct->en_warning_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_error_trap        : " UH_FMT "\n", ptr_struct->en_error_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_thr            : " UH_FMT "\n", ptr_struct->error_thr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "warning_thr          : " UH_FMT "\n", ptr_struct->warning_thr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "normal_thr           : " UH_FMT "\n", ptr_struct->normal_thr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_window          : " UH_FMT "\n", ptr_struct->time_window);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sampling_rate        : " UH_FMT "\n", ptr_struct->sampling_rate);

}

int SMP_BERConfig_size(void)
{
	 return 64;
}

void SMP_BERConfig_dump(const struct SMP_BERConfig *ptr_struct, FILE* file)
{
	SMP_BERConfig_print(ptr_struct, file, 0);
}

void SMP_ChassisInfo_pack(const struct SMP_ChassisInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(56, 8, i, 288, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->chassis_id[i]);
	}

}

void SMP_ChassisInfo_unpack(struct SMP_ChassisInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(56, 8, i, 288, 1);
	ptr_struct->chassis_id[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->chassis_id[16] = '\0';
}

void SMP_ChassisInfo_print(const struct SMP_ChassisInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ChassisInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "chassis_id           : \"%s\"\n", ptr_struct->chassis_id);
}

int SMP_ChassisInfo_size(void)
{
	 return 36;
}

void SMP_ChassisInfo_dump(const struct SMP_ChassisInfo *ptr_struct, FILE* file)
{
	SMP_ChassisInfo_print(ptr_struct, file, 0);
}

void SMP_CreditWatchdogConfig_pack(const struct SMP_CreditWatchdogConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->en_thr);

	offset = 90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->error_thr_action);

	offset = 66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_normal_trap);

	offset = 65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_warning_trap);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_error_trap);

	offset = 123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->error_thr);

	offset = 155;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->warning_thr);

	offset = 187;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->normal_thr);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->time_window);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sampling_rate);

}

void SMP_CreditWatchdogConfig_unpack(struct SMP_CreditWatchdogConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 94;
	ptr_struct->en_thr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 90;
	ptr_struct->error_thr_action = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 66;
	ptr_struct->en_normal_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 65;
	ptr_struct->en_warning_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->en_error_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 123;
	ptr_struct->error_thr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 155;
	ptr_struct->warning_thr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 187;
	ptr_struct->normal_thr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 216;
	ptr_struct->time_window = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 248;
	ptr_struct->sampling_rate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void SMP_CreditWatchdogConfig_print(const struct SMP_CreditWatchdogConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_CreditWatchdogConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_thr               : " UH_FMT "\n", ptr_struct->en_thr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_thr_action     : " UH_FMT "\n", ptr_struct->error_thr_action);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_normal_trap       : " UH_FMT "\n", ptr_struct->en_normal_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_warning_trap      : " UH_FMT "\n", ptr_struct->en_warning_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_error_trap        : " UH_FMT "\n", ptr_struct->en_error_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_thr            : " UH_FMT "\n", ptr_struct->error_thr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "warning_thr          : " UH_FMT "\n", ptr_struct->warning_thr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "normal_thr           : " UH_FMT "\n", ptr_struct->normal_thr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_window          : " UH_FMT "\n", ptr_struct->time_window);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sampling_rate        : " UH_FMT "\n", ptr_struct->sampling_rate);

}

int SMP_CreditWatchdogConfig_size(void)
{
	 return 64;
}

void SMP_CreditWatchdogConfig_dump(const struct SMP_CreditWatchdogConfig *ptr_struct, FILE* file)
{
	SMP_CreditWatchdogConfig_print(ptr_struct, file, 0);
}

void SMP_ExtendedSwitchInfo_pack(const struct SMP_ExtendedSwitchInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->turbo_path_enable);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->turbo_path_cap);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->request_issu);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->end_to_end_timescale);

	offset = 54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->req_delay);

	offset = 39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->req_trig_window_cap);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rst_trig_th_cap);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->set_trig_th_cap);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->req_delay_cap);

	offset = 86;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->rst_trig_th);

	offset = 70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->set_trig_th);

	offset = 118;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->req_trig_window);

}

void SMP_ExtendedSwitchInfo_unpack(struct SMP_ExtendedSwitchInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->turbo_path_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 28;
	ptr_struct->turbo_path_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 26;
	ptr_struct->request_issu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->end_to_end_timescale = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 54;
	ptr_struct->req_delay = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 39;
	ptr_struct->req_trig_window_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 38;
	ptr_struct->rst_trig_th_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 37;
	ptr_struct->set_trig_th_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 36;
	ptr_struct->req_delay_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 86;
	ptr_struct->rst_trig_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 70;
	ptr_struct->set_trig_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 118;
	ptr_struct->req_trig_window = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void SMP_ExtendedSwitchInfo_print(const struct SMP_ExtendedSwitchInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ExtendedSwitchInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "turbo_path_enable    : " UH_FMT "\n", ptr_struct->turbo_path_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "turbo_path_cap       : " UH_FMT "\n", ptr_struct->turbo_path_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "request_issu         : " UH_FMT "\n", ptr_struct->request_issu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "end_to_end_timescale : " UH_FMT "\n", ptr_struct->end_to_end_timescale);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "req_delay            : " UH_FMT "\n", ptr_struct->req_delay);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "req_trig_window_cap  : " UH_FMT "\n", ptr_struct->req_trig_window_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rst_trig_th_cap      : " UH_FMT "\n", ptr_struct->rst_trig_th_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_trig_th_cap      : " UH_FMT "\n", ptr_struct->set_trig_th_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "req_delay_cap        : " UH_FMT "\n", ptr_struct->req_delay_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rst_trig_th          : " UH_FMT "\n", ptr_struct->rst_trig_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_trig_th          : " UH_FMT "\n", ptr_struct->set_trig_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "req_trig_window      : " UH_FMT "\n", ptr_struct->req_trig_window);

}

int SMP_ExtendedSwitchInfo_size(void)
{
	 return 16;
}

void SMP_ExtendedSwitchInfo_dump(const struct SMP_ExtendedSwitchInfo *ptr_struct, FILE* file)
{
	SMP_ExtendedSwitchInfo_print(ptr_struct, file, 0);
}

void SMP_LedInfo_pack(const struct SMP_LedInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->LedMask);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 31, (u_int32_t)ptr_struct->Reserved);

}

void SMP_LedInfo_unpack(struct SMP_LedInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->LedMask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->Reserved = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 31);

}

void SMP_LedInfo_print(const struct SMP_LedInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_LedInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LedMask              : " UH_FMT "\n", ptr_struct->LedMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

}

int SMP_LedInfo_size(void)
{
	 return 4;
}

void SMP_LedInfo_dump(const struct SMP_LedInfo *ptr_struct, FILE* file)
{
	SMP_LedInfo_print(ptr_struct, file, 0);
}

void SMP_LinearForwardingTable_pack(const struct SMP_LinearForwardingTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Port[i]);
	}

}

void SMP_LinearForwardingTable_unpack(struct SMP_LinearForwardingTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	ptr_struct->Port[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void SMP_LinearForwardingTable_print(const struct SMP_LinearForwardingTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_LinearForwardingTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Port_%03d            : " UH_FMT "\n", i, ptr_struct->Port[i]);
	}

}

int SMP_LinearForwardingTable_size(void)
{
	 return 64;
}

void SMP_LinearForwardingTable_dump(const struct SMP_LinearForwardingTable *ptr_struct, FILE* file)
{
	SMP_LinearForwardingTable_print(ptr_struct, file, 0);
}

void SMP_LinearForwardingTableSplit_pack(const struct SMP_LinearForwardingTableSplit *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->global_lid_range_start);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->global_lid_range_cap);

	offset = 76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->global_lid_range_top);

	offset = 108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->alid_range_start);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->alid_range_cap);

	offset = 172;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->alid_range_top);

	offset = 204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->local_plane_lid_range_start);

	offset = 236;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->local_plane_lid_range_cap);

	offset = 268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->Local_plane_lid_range_top);

}

void SMP_LinearForwardingTableSplit_unpack(struct SMP_LinearForwardingTableSplit *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	ptr_struct->global_lid_range_start = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 44;
	ptr_struct->global_lid_range_cap = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 76;
	ptr_struct->global_lid_range_top = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 108;
	ptr_struct->alid_range_start = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 140;
	ptr_struct->alid_range_cap = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 172;
	ptr_struct->alid_range_top = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 204;
	ptr_struct->local_plane_lid_range_start = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 236;
	ptr_struct->local_plane_lid_range_cap = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 268;
	ptr_struct->Local_plane_lid_range_top = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

}

void SMP_LinearForwardingTableSplit_print(const struct SMP_LinearForwardingTableSplit *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_LinearForwardingTableSplit ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global_lid_range_start : " UH_FMT "\n", ptr_struct->global_lid_range_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global_lid_range_cap : " UH_FMT "\n", ptr_struct->global_lid_range_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global_lid_range_top : " UH_FMT "\n", ptr_struct->global_lid_range_top);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alid_range_start     : " UH_FMT "\n", ptr_struct->alid_range_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alid_range_cap       : " UH_FMT "\n", ptr_struct->alid_range_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alid_range_top       : " UH_FMT "\n", ptr_struct->alid_range_top);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_plane_lid_range_start : " UH_FMT "\n", ptr_struct->local_plane_lid_range_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_plane_lid_range_cap : " UH_FMT "\n", ptr_struct->local_plane_lid_range_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Local_plane_lid_range_top : " UH_FMT "\n", ptr_struct->Local_plane_lid_range_top);

}

int SMP_LinearForwardingTableSplit_size(void)
{
	 return 64;
}

void SMP_LinearForwardingTableSplit_dump(const struct SMP_LinearForwardingTableSplit *ptr_struct, FILE* file)
{
	SMP_LinearForwardingTableSplit_print(ptr_struct, file, 0);
}

void SMP_MAD_Data_Block_Element_pack(const struct SMP_MAD_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DWORD[i]);
	}

}

void SMP_MAD_Data_Block_Element_unpack(struct SMP_MAD_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ptr_struct->DWORD[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void SMP_MAD_Data_Block_Element_print(const struct SMP_MAD_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_MAD_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DWORD_%03d           : " U32H_FMT "\n", i, ptr_struct->DWORD[i]);
	}

}

int SMP_MAD_Data_Block_Element_size(void)
{
	 return 64;
}

void SMP_MAD_Data_Block_Element_dump(const struct SMP_MAD_Data_Block_Element *ptr_struct, FILE* file)
{
	SMP_MAD_Data_Block_Element_print(ptr_struct, file, 0);
}

void SMP_MlnxExtPortInfo_pack(const struct SMP_MlnxExtPortInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->StateChangeEnable);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->RouterLIDEn);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SHArPANEn);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->AME);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkSpeedSupported);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->unhealthy_reason);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->bw_utilization);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bw_util_en);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkSpeedEnabled);

	offset = 81;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->min_bw_utilization);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkSpeedActive);

	offset = 108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->ActiveRSFECParity);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->ActiveRSFECData);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CapabilityMask);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->FECModeActive);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->RetransMode);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->FDR10FECModeSupported);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->FDR10FECModeEnabled);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->FDRFECModeSupported);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->FDRFECModeEnabled);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->EDR20FECModeSupported);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->EDR20FECModeEnabled);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->EDRFECModeSupported);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->EDRFECModeEnabled);

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->FDR10RetranSupported);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->FDR10RetranEnabled);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->FDRRetranSupported);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->FDRRetranEnabled);

	offset = 344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->EDR20RetranSupported);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->EDR20RetranEnabled);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->EDRRetranSupported);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->EDRRetranEnabled);

	offset = 380;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SpecialPortType);

	offset = 376;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->IsSpecialPort);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecialPortCapabilityMask);

	offset = 355;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->access_trunk);

	offset = 353;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mission_port_configured_as_fnm);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->IsFNMPort);

	offset = 400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HDRFECModeSupported);

	offset = 384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HDRFECModeEnabled);

	offset = 432;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->OOOSLMask);

	offset = 416;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->AdaptiveTimeoutSLMask);

	offset = 464;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->NDRFECModeSupported);

	offset = 448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->NDRFECModeEnabled);

	offset = 496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->XDRFECModeSupported);

	offset = 480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->XDRFECModeEnabled);

}

void SMP_MlnxExtPortInfo_unpack(struct SMP_MlnxExtPortInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->StateChangeEnable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 2;
	ptr_struct->RouterLIDEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->SHArPANEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->AME = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->LinkSpeedSupported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->unhealthy_reason = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 38;
	ptr_struct->bw_utilization = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 37;
	ptr_struct->bw_util_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 88;
	ptr_struct->LinkSpeedEnabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 81;
	ptr_struct->min_bw_utilization = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 120;
	ptr_struct->LinkSpeedActive = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 108;
	ptr_struct->ActiveRSFECParity = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 96;
	ptr_struct->ActiveRSFECData = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 144;
	ptr_struct->CapabilityMask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 136;
	ptr_struct->FECModeActive = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->RetransMode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->FDR10FECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->FDR10FECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->FDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->FDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->EDR20FECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->EDR20FECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 272;
	ptr_struct->EDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->EDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 312;
	ptr_struct->FDR10RetranSupported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 304;
	ptr_struct->FDR10RetranEnabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 296;
	ptr_struct->FDRRetranSupported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->FDRRetranEnabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 344;
	ptr_struct->EDR20RetranSupported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 336;
	ptr_struct->EDR20RetranEnabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 328;
	ptr_struct->EDRRetranSupported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->EDRRetranEnabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 380;
	ptr_struct->SpecialPortType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 376;
	ptr_struct->IsSpecialPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 368;
	ptr_struct->SpecialPortCapabilityMask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 355;
	ptr_struct->access_trunk = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 353;
	ptr_struct->mission_port_configured_as_fnm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 352;
	ptr_struct->IsFNMPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 400;
	ptr_struct->HDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 384;
	ptr_struct->HDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 432;
	ptr_struct->OOOSLMask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 416;
	ptr_struct->AdaptiveTimeoutSLMask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 464;
	ptr_struct->NDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 448;
	ptr_struct->NDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 496;
	ptr_struct->XDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 480;
	ptr_struct->XDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void SMP_MlnxExtPortInfo_print(const struct SMP_MlnxExtPortInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_MlnxExtPortInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "StateChangeEnable    : " UH_FMT "\n", ptr_struct->StateChangeEnable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RouterLIDEn          : " UH_FMT "\n", ptr_struct->RouterLIDEn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SHArPANEn            : " UH_FMT "\n", ptr_struct->SHArPANEn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AME                  : " UH_FMT "\n", ptr_struct->AME);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedSupported   : " UH_FMT "\n", ptr_struct->LinkSpeedSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unhealthy_reason     : " UH_FMT "\n", ptr_struct->unhealthy_reason);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bw_utilization       : " UH_FMT "\n", ptr_struct->bw_utilization);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bw_util_en           : " UH_FMT "\n", ptr_struct->bw_util_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedEnabled     : " UH_FMT "\n", ptr_struct->LinkSpeedEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_bw_utilization   : " UH_FMT "\n", ptr_struct->min_bw_utilization);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedActive      : " UH_FMT "\n", ptr_struct->LinkSpeedActive);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ActiveRSFECParity    : " UH_FMT "\n", ptr_struct->ActiveRSFECParity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ActiveRSFECData      : " UH_FMT "\n", ptr_struct->ActiveRSFECData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CapabilityMask       : " UH_FMT "\n", ptr_struct->CapabilityMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FECModeActive        : " UH_FMT "\n", ptr_struct->FECModeActive);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RetransMode          : " UH_FMT "\n", ptr_struct->RetransMode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDR10FECModeSupported : " UH_FMT "\n", ptr_struct->FDR10FECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDR10FECModeEnabled  : " UH_FMT "\n", ptr_struct->FDR10FECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDRFECModeSupported  : " UH_FMT "\n", ptr_struct->FDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->FDRFECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDR20FECModeSupported : " UH_FMT "\n", ptr_struct->EDR20FECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDR20FECModeEnabled  : " UH_FMT "\n", ptr_struct->EDR20FECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDRFECModeSupported  : " UH_FMT "\n", ptr_struct->EDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->EDRFECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDR10RetranSupported : " UH_FMT "\n", ptr_struct->FDR10RetranSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDR10RetranEnabled   : " UH_FMT "\n", ptr_struct->FDR10RetranEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDRRetranSupported   : " UH_FMT "\n", ptr_struct->FDRRetranSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDRRetranEnabled     : " UH_FMT "\n", ptr_struct->FDRRetranEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDR20RetranSupported : " UH_FMT "\n", ptr_struct->EDR20RetranSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDR20RetranEnabled   : " UH_FMT "\n", ptr_struct->EDR20RetranEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDRRetranSupported   : " UH_FMT "\n", ptr_struct->EDRRetranSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDRRetranEnabled     : " UH_FMT "\n", ptr_struct->EDRRetranEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecialPortType      : " UH_FMT "\n", ptr_struct->SpecialPortType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IsSpecialPort        : " UH_FMT "\n", ptr_struct->IsSpecialPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecialPortCapabilityMask : " UH_FMT "\n", ptr_struct->SpecialPortCapabilityMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_trunk         : " UH_FMT "\n", ptr_struct->access_trunk);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mission_port_configured_as_fnm : " UH_FMT "\n", ptr_struct->mission_port_configured_as_fnm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IsFNMPort            : " UH_FMT "\n", ptr_struct->IsFNMPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HDRFECModeSupported  : " UH_FMT "\n", ptr_struct->HDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->HDRFECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OOOSLMask            : " UH_FMT "\n", ptr_struct->OOOSLMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdaptiveTimeoutSLMask : " UH_FMT "\n", ptr_struct->AdaptiveTimeoutSLMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NDRFECModeSupported  : " UH_FMT "\n", ptr_struct->NDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->NDRFECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "XDRFECModeSupported  : " UH_FMT "\n", ptr_struct->XDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "XDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->XDRFECModeEnabled);

}

int SMP_MlnxExtPortInfo_size(void)
{
	 return 64;
}

void SMP_MlnxExtPortInfo_dump(const struct SMP_MlnxExtPortInfo *ptr_struct, FILE* file)
{
	SMP_MlnxExtPortInfo_print(ptr_struct, file, 0);
}

void SMP_MulticastForwardingTable_pack(const struct SMP_MulticastForwardingTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortMask[i]);
	}

}

void SMP_MulticastForwardingTable_unpack(struct SMP_MulticastForwardingTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	ptr_struct->PortMask[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

}

void SMP_MulticastForwardingTable_print(const struct SMP_MulticastForwardingTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_MulticastForwardingTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMask_%03d        : " UH_FMT "\n", i, ptr_struct->PortMask[i]);
	}

}

int SMP_MulticastForwardingTable_size(void)
{
	 return 64;
}

void SMP_MulticastForwardingTable_dump(const struct SMP_MulticastForwardingTable *ptr_struct, FILE* file)
{
	SMP_MulticastForwardingTable_print(ptr_struct, file, 0);
}

void SMP_NodeDesc_pack(const struct SMP_NodeDesc *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Byte[i]);
	}

}

void SMP_NodeDesc_unpack(struct SMP_NodeDesc *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	ptr_struct->Byte[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->Byte[64] = '\0';
}

void SMP_NodeDesc_print(const struct SMP_NodeDesc *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_NodeDesc ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "Byte                 : \"%s\"\n", ptr_struct->Byte);
}

int SMP_NodeDesc_size(void)
{
	 return 64;
}

void SMP_NodeDesc_dump(const struct SMP_NodeDesc *ptr_struct, FILE* file)
{
	SMP_NodeDesc_print(ptr_struct, file, 0);
}

void SMP_PortInfoExtended_pack(const struct SMP_PortInfoExtended *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->CapMsk);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->FDRFECModeSupported);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->FECModeActive);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->EDRFECModeSupported);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->FDRFECModeEnabled);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HDRFECModeSupported);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->EDRFECModeEnabled);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->NDRFECModeSupported);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HDRFECModeEnabled);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PartitionTop);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->NDRFECModeEnabled);

}

void SMP_PortInfoExtended_unpack(struct SMP_PortInfoExtended *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->CapMsk = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->FDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->FECModeActive = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->EDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->FDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->HDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->EDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->NDRFECModeSupported = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->HDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->PartitionTop = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->NDRFECModeEnabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void SMP_PortInfoExtended_print(const struct SMP_PortInfoExtended *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_PortInfoExtended ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CapMsk               : " U32H_FMT "\n", ptr_struct->CapMsk);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDRFECModeSupported  : " UH_FMT "\n", ptr_struct->FDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FECModeActive        : " UH_FMT "\n", ptr_struct->FECModeActive);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDRFECModeSupported  : " UH_FMT "\n", ptr_struct->EDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->FDRFECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HDRFECModeSupported  : " UH_FMT "\n", ptr_struct->HDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->EDRFECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NDRFECModeSupported  : " UH_FMT "\n", ptr_struct->NDRFECModeSupported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->HDRFECModeEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PartitionTop         : " UH_FMT "\n", ptr_struct->PartitionTop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NDRFECModeEnabled    : " UH_FMT "\n", ptr_struct->NDRFECModeEnabled);

}

int SMP_PortInfoExtended_size(void)
{
	 return 24;
}

void SMP_PortInfoExtended_dump(const struct SMP_PortInfoExtended *ptr_struct, FILE* file)
{
	SMP_PortInfoExtended_print(ptr_struct, file, 0);
}

void SMP_ProfilesConfig_pack(const struct SMP_ProfilesConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_profile[i]);
	}

}

void SMP_ProfilesConfig_unpack(struct SMP_ProfilesConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 512, 1);
	ptr_struct->port_profile[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);
	}

}

void SMP_ProfilesConfig_print(const struct SMP_ProfilesConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ProfilesConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_profile_%03d    : " UH_FMT "\n", i, ptr_struct->port_profile[i]);
	}

}

int SMP_ProfilesConfig_size(void)
{
	 return 64;
}

void SMP_ProfilesConfig_dump(const struct SMP_ProfilesConfig *ptr_struct, FILE* file)
{
	SMP_ProfilesConfig_print(ptr_struct, file, 0);
}

void SMP_RouterInfo_pack(const struct SMP_RouterInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->CapabilityMask);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->NextHopTableCap);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->NextHopTableTop);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AdjacentSiteLocalSubnetsTableCap);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AdjacentSiteLocalSubnetsTableTop);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->table_changes_bitmask);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ar_group_to_router_lid_table_cap);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cap_supported_subnets);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_router_lid);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AdjacentSubnetsRouterLIDInfo);

	offset = 167;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pfrn_rtr_en);

	offset = 204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->global_router_lid_base);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->max_ar_group_id);

	offset = 236;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->global_router_lid_top);

	offset = 268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->local_router_lid_base);

	offset = 300;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->local_router_lid_top);

}

void SMP_RouterInfo_unpack(struct SMP_RouterInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->CapabilityMask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->NextHopTableCap = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->NextHopTableTop = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 120;
	ptr_struct->AdjacentSiteLocalSubnetsTableCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->AdjacentSiteLocalSubnetsTableTop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->table_changes_bitmask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->ar_group_to_router_lid_table_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->cap_supported_subnets = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->cap_router_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 168;
	ptr_struct->AdjacentSubnetsRouterLIDInfo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 167;
	ptr_struct->pfrn_rtr_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 204;
	ptr_struct->global_router_lid_base = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 192;
	ptr_struct->max_ar_group_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 236;
	ptr_struct->global_router_lid_top = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 268;
	ptr_struct->local_router_lid_base = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 300;
	ptr_struct->local_router_lid_top = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

}

void SMP_RouterInfo_print(const struct SMP_RouterInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_RouterInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CapabilityMask       : " U32H_FMT "\n", ptr_struct->CapabilityMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NextHopTableCap      : " U32H_FMT "\n", ptr_struct->NextHopTableCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NextHopTableTop      : " U32H_FMT "\n", ptr_struct->NextHopTableTop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdjacentSiteLocalSubnetsTableCap : " UH_FMT "\n", ptr_struct->AdjacentSiteLocalSubnetsTableCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdjacentSiteLocalSubnetsTableTop : " UH_FMT "\n", ptr_struct->AdjacentSiteLocalSubnetsTableTop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_changes_bitmask : " UH_FMT "\n", ptr_struct->table_changes_bitmask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar_group_to_router_lid_table_cap : " UH_FMT "\n", ptr_struct->ar_group_to_router_lid_table_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_supported_subnets : " UH_FMT "\n", ptr_struct->cap_supported_subnets);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_router_lid       : " UH_FMT "\n", ptr_struct->cap_router_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdjacentSubnetsRouterLIDInfo : " UH_FMT "\n", ptr_struct->AdjacentSubnetsRouterLIDInfo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pfrn_rtr_en          : " UH_FMT "\n", ptr_struct->pfrn_rtr_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global_router_lid_base : " UH_FMT "\n", ptr_struct->global_router_lid_base);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_ar_group_id      : " UH_FMT "\n", ptr_struct->max_ar_group_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global_router_lid_top : " UH_FMT "\n", ptr_struct->global_router_lid_top);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_router_lid_base : " UH_FMT "\n", ptr_struct->local_router_lid_base);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_router_lid_top : " UH_FMT "\n", ptr_struct->local_router_lid_top);

}

int SMP_RouterInfo_size(void)
{
	 return 64;
}

void SMP_RouterInfo_dump(const struct SMP_RouterInfo *ptr_struct, FILE* file)
{
	SMP_RouterInfo_print(ptr_struct, file, 0);
}

void SMP_RouterLIDTable_pack(const struct SMP_RouterLIDTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 512; i++) {
	offset = adb2c_calc_array_field_address(31, 1, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->V[i]);
	}

}

void SMP_RouterLIDTable_unpack(struct SMP_RouterLIDTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 512; i++) {
	offset = adb2c_calc_array_field_address(31, 1, i, 512, 1);
	ptr_struct->V[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);
	}

}

void SMP_RouterLIDTable_print(const struct SMP_RouterLIDTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_RouterLIDTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 512; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "V_%03d               : " UH_FMT "\n", i, ptr_struct->V[i]);
	}

}

int SMP_RouterLIDTable_size(void)
{
	 return 64;
}

void SMP_RouterLIDTable_dump(const struct SMP_RouterLIDTable *ptr_struct, FILE* file)
{
	SMP_RouterLIDTable_print(ptr_struct, file, 0);
}

void SMP_SLToVLMappingTable_pack(const struct SMP_SLToVLMappingTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL7ToVL);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL6ToVL);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL5ToVL);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL4ToVL);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL3ToVL);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL2ToVL);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL1ToVL);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL0ToVL);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL15ToVL);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL14ToVL);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL13ToVL);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL12ToVL);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL11ToVL);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL10ToVL);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL9ToVL);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL8ToVL);

}

void SMP_SLToVLMappingTable_unpack(struct SMP_SLToVLMappingTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->SL7ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 24;
	ptr_struct->SL6ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->SL5ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->SL4ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 12;
	ptr_struct->SL3ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->SL2ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 4;
	ptr_struct->SL1ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->SL0ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 60;
	ptr_struct->SL15ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->SL14ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 52;
	ptr_struct->SL13ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->SL12ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 44;
	ptr_struct->SL11ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->SL10ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 36;
	ptr_struct->SL9ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->SL8ToVL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void SMP_SLToVLMappingTable_print(const struct SMP_SLToVLMappingTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_SLToVLMappingTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL7ToVL              : " UH_FMT "\n", ptr_struct->SL7ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL6ToVL              : " UH_FMT "\n", ptr_struct->SL6ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL5ToVL              : " UH_FMT "\n", ptr_struct->SL5ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL4ToVL              : " UH_FMT "\n", ptr_struct->SL4ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL3ToVL              : " UH_FMT "\n", ptr_struct->SL3ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL2ToVL              : " UH_FMT "\n", ptr_struct->SL2ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL1ToVL              : " UH_FMT "\n", ptr_struct->SL1ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL0ToVL              : " UH_FMT "\n", ptr_struct->SL0ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL15ToVL             : " UH_FMT "\n", ptr_struct->SL15ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL14ToVL             : " UH_FMT "\n", ptr_struct->SL14ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL13ToVL             : " UH_FMT "\n", ptr_struct->SL13ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL12ToVL             : " UH_FMT "\n", ptr_struct->SL12ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL11ToVL             : " UH_FMT "\n", ptr_struct->SL11ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL10ToVL             : " UH_FMT "\n", ptr_struct->SL10ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL9ToVL              : " UH_FMT "\n", ptr_struct->SL9ToVL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL8ToVL              : " UH_FMT "\n", ptr_struct->SL8ToVL);

}

int SMP_SLToVLMappingTable_size(void)
{
	 return 8;
}

void SMP_SLToVLMappingTable_dump(const struct SMP_SLToVLMappingTable *ptr_struct, FILE* file)
{
	SMP_SLToVLMappingTable_print(ptr_struct, file, 0);
}

void SMP_SwitchInfo_pack(const struct SMP_SwitchInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->RandomFDBCap);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LinearFDBCap);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LinearFDBTop);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MCastFDBCap);

	offset = 94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->OptimizedSLVLMapping);

	offset = 93;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PortStateChange);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->LifeTimeValue);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DefMCastNotPriPort);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DefMCastPriPort);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DefPort);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PartEnfCap);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LidsPerPort);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MCastFDBTop);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ENP0);

	offset = 131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->FilterRawOutbCap);

	offset = 130;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->FilterRawInbCap);

	offset = 129;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->OutbEnfCap);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->InbEnfCap);

}

void SMP_SwitchInfo_unpack(struct SMP_SwitchInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->RandomFDBCap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->LinearFDBCap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->LinearFDBTop = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->MCastFDBCap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 94;
	ptr_struct->OptimizedSLVLMapping = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 93;
	ptr_struct->PortStateChange = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 88;
	ptr_struct->LifeTimeValue = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 80;
	ptr_struct->DefMCastNotPriPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->DefMCastPriPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->DefPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->PartEnfCap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->LidsPerPort = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->MCastFDBTop = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 132;
	ptr_struct->ENP0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 131;
	ptr_struct->FilterRawOutbCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 130;
	ptr_struct->FilterRawInbCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 129;
	ptr_struct->OutbEnfCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 128;
	ptr_struct->InbEnfCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void SMP_SwitchInfo_print(const struct SMP_SwitchInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_SwitchInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RandomFDBCap         : " UH_FMT "\n", ptr_struct->RandomFDBCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinearFDBCap         : " UH_FMT "\n", ptr_struct->LinearFDBCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinearFDBTop         : " UH_FMT "\n", ptr_struct->LinearFDBTop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MCastFDBCap          : " UH_FMT "\n", ptr_struct->MCastFDBCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OptimizedSLVLMapping : " UH_FMT "\n", ptr_struct->OptimizedSLVLMapping);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortStateChange      : " UH_FMT "\n", ptr_struct->PortStateChange);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LifeTimeValue        : " UH_FMT "\n", ptr_struct->LifeTimeValue);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DefMCastNotPriPort   : " UH_FMT "\n", ptr_struct->DefMCastNotPriPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DefMCastPriPort      : " UH_FMT "\n", ptr_struct->DefMCastPriPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DefPort              : " UH_FMT "\n", ptr_struct->DefPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PartEnfCap           : " UH_FMT "\n", ptr_struct->PartEnfCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidsPerPort          : " UH_FMT "\n", ptr_struct->LidsPerPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MCastFDBTop          : " UH_FMT "\n", ptr_struct->MCastFDBTop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ENP0                 : " UH_FMT "\n", ptr_struct->ENP0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FilterRawOutbCap     : " UH_FMT "\n", ptr_struct->FilterRawOutbCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FilterRawInbCap      : " UH_FMT "\n", ptr_struct->FilterRawInbCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutbEnfCap           : " UH_FMT "\n", ptr_struct->OutbEnfCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "InbEnfCap            : " UH_FMT "\n", ptr_struct->InbEnfCap);

}

int SMP_SwitchInfo_size(void)
{
	 return 64;
}

void SMP_SwitchInfo_dump(const struct SMP_SwitchInfo *ptr_struct, FILE* file)
{
	SMP_SwitchInfo_print(ptr_struct, file, 0);
}

void SMP_SwitchPortStateTable_pack(const struct SMP_SwitchPortStateTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortStateBlock[i]);
	}

}

void SMP_SwitchPortStateTable_unpack(struct SMP_SwitchPortStateTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 512, 1);
	ptr_struct->PortStateBlock[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);
	}

}

void SMP_SwitchPortStateTable_print(const struct SMP_SwitchPortStateTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_SwitchPortStateTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortStateBlock_%03d  : " UH_FMT "\n", i, ptr_struct->PortStateBlock[i]);
	}

}

int SMP_SwitchPortStateTable_size(void)
{
	 return 64;
}

void SMP_SwitchPortStateTable_dump(const struct SMP_SwitchPortStateTable *ptr_struct, FILE* file)
{
	SMP_SwitchPortStateTable_print(ptr_struct, file, 0);
}

void SMP_TempSensing_pack(const struct SMP_TempSensing *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tss);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->stgs);

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->stge);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtts);

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtte);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtgs);

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtge);

	offset = 53;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->current_temp);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->max_temp);

	offset = 85;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->overtemp_warning_threshold_hi);

	offset = 69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->overtemp_warning_threshold_lo);

	offset = 127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wts);

	offset = 126;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtga);

	offset = 125;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtgp);

	offset = 123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->wtgm);

}

void SMP_TempSensing_unpack(struct SMP_TempSensing *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->tss = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->stgs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 29;
	ptr_struct->stge = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->wtts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 27;
	ptr_struct->wtte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 26;
	ptr_struct->wtgs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 25;
	ptr_struct->wtge = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 53;
	ptr_struct->current_temp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 37;
	ptr_struct->max_temp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 85;
	ptr_struct->overtemp_warning_threshold_hi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 69;
	ptr_struct->overtemp_warning_threshold_lo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 127;
	ptr_struct->wts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 126;
	ptr_struct->wtga = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 125;
	ptr_struct->wtgp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 123;
	ptr_struct->wtgm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void SMP_TempSensing_print(const struct SMP_TempSensing *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_TempSensing ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tss                  : " UH_FMT "\n", ptr_struct->tss);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stgs                 : " UH_FMT "\n", ptr_struct->stgs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stge                 : " UH_FMT "\n", ptr_struct->stge);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtts                 : " UH_FMT "\n", ptr_struct->wtts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtte                 : " UH_FMT "\n", ptr_struct->wtte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtgs                 : " UH_FMT "\n", ptr_struct->wtgs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtge                 : " UH_FMT "\n", ptr_struct->wtge);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "current_temp         : " UH_FMT "\n", ptr_struct->current_temp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp             : " UH_FMT "\n", ptr_struct->max_temp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "overtemp_warning_threshold_hi : " UH_FMT "\n", ptr_struct->overtemp_warning_threshold_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "overtemp_warning_threshold_lo : " UH_FMT "\n", ptr_struct->overtemp_warning_threshold_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wts                  : " UH_FMT "\n", ptr_struct->wts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtga                 : " UH_FMT "\n", ptr_struct->wtga);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtgp                 : " UH_FMT "\n", ptr_struct->wtgp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtgm                 : " UH_FMT "\n", ptr_struct->wtgm);

}

int SMP_TempSensing_size(void)
{
	 return 16;
}

void SMP_TempSensing_dump(const struct SMP_TempSensing *ptr_struct, FILE* file)
{
	SMP_TempSensing_print(ptr_struct, file, 0);
}

void SMP_VPortState_pack(const struct SMP_VPortState *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vport_state[i]);
	}

}

void SMP_VPortState_unpack(struct SMP_VPortState *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 512, 1);
	ptr_struct->vport_state[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);
	}

}

void SMP_VPortState_print(const struct SMP_VPortState *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_VPortState ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_state_%03d     : " UH_FMT "\n", i, ptr_struct->vport_state[i]);
	}

}

int SMP_VPortState_size(void)
{
	 return 64;
}

void SMP_VPortState_dump(const struct SMP_VPortState *ptr_struct, FILE* file)
{
	SMP_VPortState_print(ptr_struct, file, 0);
}

void SMP_VirtualizationInfo_pack(const struct SMP_VirtualizationInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vport_index_top);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vport_cap);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->capability_mask);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->virtualization_revision);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vportstate_change);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vclient_reregister);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->virtualization_enable);

}

void SMP_VirtualizationInfo_unpack(struct SMP_VirtualizationInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->vport_index_top = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->vport_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 56;
	ptr_struct->capability_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->virtualization_revision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 34;
	ptr_struct->vportstate_change = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 33;
	ptr_struct->vclient_reregister = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->virtualization_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void SMP_VirtualizationInfo_print(const struct SMP_VirtualizationInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_VirtualizationInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_index_top      : " UH_FMT "\n", ptr_struct->vport_index_top);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_cap            : " UH_FMT "\n", ptr_struct->vport_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability_mask      : " UH_FMT "\n", ptr_struct->capability_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "virtualization_revision : " UH_FMT "\n", ptr_struct->virtualization_revision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vportstate_change    : " UH_FMT "\n", ptr_struct->vportstate_change);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vclient_reregister   : " UH_FMT "\n", ptr_struct->vclient_reregister);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "virtualization_enable : " UH_FMT "\n", ptr_struct->virtualization_enable);

}

int SMP_VirtualizationInfo_size(void)
{
	 return 64;
}

void SMP_VirtualizationInfo_dump(const struct SMP_VirtualizationInfo *ptr_struct, FILE* file)
{
	SMP_VirtualizationInfo_print(ptr_struct, file, 0);
}

void SMP_pFRNConfig_pack(const struct SMP_pFRNConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset = 118;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->mask_clear_timeout);

	offset = 102;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->mask_force_clear_timeout);

}

void SMP_pFRNConfig_unpack(struct SMP_pFRNConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 64;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 118;
	ptr_struct->mask_clear_timeout = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 102;
	ptr_struct->mask_force_clear_timeout = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void SMP_pFRNConfig_print(const struct SMP_pFRNConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_pFRNConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : " UH_FMT "\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mask_clear_timeout   : " UH_FMT "\n", ptr_struct->mask_clear_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mask_force_clear_timeout : " UH_FMT "\n", ptr_struct->mask_force_clear_timeout);

}

int SMP_pFRNConfig_size(void)
{
	 return 64;
}

void SMP_pFRNConfig_dump(const struct SMP_pFRNConfig *ptr_struct, FILE* file)
{
	SMP_pFRNConfig_print(ptr_struct, file, 0);
}

void SWInfo_Block_Element_pack(const struct SWInfo_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SubMinor);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Minor);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Major);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved8);

	for (i = 0; i < 7; i++) {
	offset = adb2c_calc_array_field_address(32, 32, i, 256, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved_Dword[i]);
	}

}

void SWInfo_Block_Element_unpack(struct SWInfo_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->SubMinor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->Minor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->Major = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->Reserved8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 7; i++) {
	offset = adb2c_calc_array_field_address(32, 32, i, 256, 1);
	ptr_struct->Reserved_Dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void SWInfo_Block_Element_print(const struct SWInfo_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SWInfo_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubMinor             : " UH_FMT "\n", ptr_struct->SubMinor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Minor                : " UH_FMT "\n", ptr_struct->Minor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Major                : " UH_FMT "\n", ptr_struct->Major);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved8            : " UH_FMT "\n", ptr_struct->Reserved8);

	for (i = 0; i < 7; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved_Dword_%03d  : " U32H_FMT "\n", i, ptr_struct->Reserved_Dword[i]);
	}

}

int SWInfo_Block_Element_size(void)
{
	 return 32;
}

void SWInfo_Block_Element_dump(const struct SWInfo_Block_Element *ptr_struct, FILE* file)
{
	SWInfo_Block_Element_print(ptr_struct, file, 0);
}

void SubnetAdministartion_MAD_Data_Block_Element_pack(const struct SubnetAdministartion_MAD_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 50; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1600, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DWORD[i]);
	}

}

void SubnetAdministartion_MAD_Data_Block_Element_unpack(struct SubnetAdministartion_MAD_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 50; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1600, 1);
	ptr_struct->DWORD[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void SubnetAdministartion_MAD_Data_Block_Element_print(const struct SubnetAdministartion_MAD_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SubnetAdministartion_MAD_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 50; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DWORD_%03d           : " U32H_FMT "\n", i, ptr_struct->DWORD[i]);
	}

}

int SubnetAdministartion_MAD_Data_Block_Element_size(void)
{
	 return 200;
}

void SubnetAdministartion_MAD_Data_Block_Element_dump(const struct SubnetAdministartion_MAD_Data_Block_Element *ptr_struct, FILE* file)
{
	SubnetAdministartion_MAD_Data_Block_Element_print(ptr_struct, file, 0);
}

void SwitchPortCongestionSettingElement_pack(const struct SwitchPortCongestionSettingElement *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Cong_Parm);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Packet_Size);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Threshold);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Control_Type);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Valid);

}

void SwitchPortCongestionSettingElement_unpack(struct SwitchPortCongestionSettingElement *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->Cong_Parm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->Packet_Size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->Threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1;
	ptr_struct->Control_Type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->Valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void SwitchPortCongestionSettingElement_print(const struct SwitchPortCongestionSettingElement *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SwitchPortCongestionSettingElement ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Cong_Parm            : " UH_FMT "\n", ptr_struct->Cong_Parm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Packet_Size          : " UH_FMT "\n", ptr_struct->Packet_Size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Threshold            : " UH_FMT "\n", ptr_struct->Threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Control_Type         : " UH_FMT "\n", ptr_struct->Control_Type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Valid                : " UH_FMT "\n", ptr_struct->Valid);

}

int SwitchPortCongestionSettingElement_size(void)
{
	 return 4;
}

void SwitchPortCongestionSettingElement_dump(const struct SwitchPortCongestionSettingElement *ptr_struct, FILE* file)
{
	SwitchPortCongestionSettingElement_print(ptr_struct, file, 0);
}

void TID_Block_Element_pack(const struct TID_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->High);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Low);

}

void TID_Block_Element_unpack(struct TID_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->High = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->Low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void TID_Block_Element_print(const struct TID_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== TID_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "High                 : " U32H_FMT "\n", ptr_struct->High);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Low                  : " U32H_FMT "\n", ptr_struct->Low);

}

int TID_Block_Element_size(void)
{
	 return 8;
}

void TID_Block_Element_dump(const struct TID_Block_Element *ptr_struct, FILE* file)
{
	TID_Block_Element_print(ptr_struct, file, 0);
}

void UINT256_pack(const struct UINT256 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Mask_255_224);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Mask_223_192);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Mask_191_160);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Mask_159_128);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Mask_127_96);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Mask_95_64);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Mask_63_32);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Mask_31_0);

}

void UINT256_unpack(struct UINT256 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->Mask_255_224 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->Mask_223_192 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->Mask_191_160 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->Mask_159_128 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->Mask_127_96 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->Mask_95_64 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->Mask_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->Mask_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void UINT256_print(const struct UINT256 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== UINT256 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mask_255_224         : " U32H_FMT "\n", ptr_struct->Mask_255_224);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mask_223_192         : " U32H_FMT "\n", ptr_struct->Mask_223_192);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mask_191_160         : " U32H_FMT "\n", ptr_struct->Mask_191_160);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mask_159_128         : " U32H_FMT "\n", ptr_struct->Mask_159_128);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mask_127_96          : " U32H_FMT "\n", ptr_struct->Mask_127_96);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mask_95_64           : " U32H_FMT "\n", ptr_struct->Mask_95_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mask_63_32           : " U32H_FMT "\n", ptr_struct->Mask_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mask_31_0            : " U32H_FMT "\n", ptr_struct->Mask_31_0);

}

int UINT256_size(void)
{
	 return 32;
}

void UINT256_dump(const struct UINT256 *ptr_struct, FILE* file)
{
	UINT256_print(ptr_struct, file, 0);
}

void VCRC_pack(const struct VCRC *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->VCRC);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Rsrvd);

}

void VCRC_unpack(struct VCRC *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->VCRC = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->Rsrvd = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void VCRC_print(const struct VCRC *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VCRC ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VCRC                 : " UH_FMT "\n", ptr_struct->VCRC);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsrvd                : " UH_FMT "\n", ptr_struct->Rsrvd);

}

int VCRC_size(void)
{
	 return 4;
}

void VCRC_dump(const struct VCRC *ptr_struct, FILE* file)
{
	VCRC_print(ptr_struct, file, 0);
}

void VLConfigBlock_pack(const struct VLConfigBlock *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->disable_hoq_life);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_type_bitmask);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vl_buffer_weight);

}

void VLConfigBlock_unpack(struct VLConfigBlock *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->disable_hoq_life = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->data_type_bitmask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->vl_buffer_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void VLConfigBlock_print(const struct VLConfigBlock *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VLConfigBlock ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disable_hoq_life     : " UH_FMT "\n", ptr_struct->disable_hoq_life);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_type_bitmask    : " UH_FMT "\n", ptr_struct->data_type_bitmask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_buffer_weight     : " UH_FMT "\n", ptr_struct->vl_buffer_weight);

}

int VLConfigBlock_size(void)
{
	 return 4;
}

void VLConfigBlock_dump(const struct VLConfigBlock *ptr_struct, FILE* file)
{
	VLConfigBlock_print(ptr_struct, file, 0);
}

void VL_Weight_Block_Element_pack(const struct VL_Weight_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Weight);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved);

}

void VL_Weight_Block_Element_unpack(struct VL_Weight_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->Weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->VL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->Reserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void VL_Weight_Block_Element_print(const struct VL_Weight_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VL_Weight_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Weight               : " UH_FMT "\n", ptr_struct->Weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL                   : " UH_FMT "\n", ptr_struct->VL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

}

int VL_Weight_Block_Element_size(void)
{
	 return 2;
}

void VL_Weight_Block_Element_dump(const struct VL_Weight_Block_Element *ptr_struct, FILE* file)
{
	VL_Weight_Block_Element_print(ptr_struct, file, 0);
}

void VS_CongestionMirroring_pack(const struct VS_CongestionMirroring *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->en_vl_bitmap);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->mirror_agent_ptr);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->probability_rate);

	offset = 118;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->thr_high);

	offset = 150;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->thr_low);

}

void VS_CongestionMirroring_unpack(struct VS_CongestionMirroring *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->en_vl_bitmap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 60;
	ptr_struct->mirror_agent_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->probability_rate = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 118;
	ptr_struct->thr_high = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 150;
	ptr_struct->thr_low = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void VS_CongestionMirroring_print(const struct VS_CongestionMirroring *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_CongestionMirroring ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_vl_bitmap         : " UH_FMT "\n", ptr_struct->en_vl_bitmap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mirror_agent_ptr     : " UH_FMT "\n", ptr_struct->mirror_agent_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "probability_rate     : " U32H_FMT "\n", ptr_struct->probability_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thr_high             : " UH_FMT "\n", ptr_struct->thr_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thr_low              : " UH_FMT "\n", ptr_struct->thr_low);

}

int VS_CongestionMirroring_size(void)
{
	 return 20;
}

void VS_CongestionMirroring_dump(const struct VS_CongestionMirroring *ptr_struct, FILE* file)
{
	VS_CongestionMirroring_print(ptr_struct, file, 0);
}

void VS_DC_Page1LatestVersion_pack(const struct VS_DC_Page1LatestVersion *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_sig_err);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_sig_err);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_cnak);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_reconnect);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_reconnect_ack);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_open_gb);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_no_dcrs);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_cnak_sent);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_reconnect_ack_bad);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_open_gb_cnak);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_gb_trap_cnak);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_not_gb_connect);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_not_gb_reconnect);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_curr_gb_connect);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_curr_gb_reconnect);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_close_non_gb_gc);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_dcr_inhale_events);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_state_active_gb);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_state_avail_dcrs);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_state_dcr_lifo_size);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_cnak_drop);

	offset = 672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->minimum_dcrs);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->maximum_dcrs);

	offset = 736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_cnak_fifo_size);

	offset = 768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_dc_cacks);

	offset = 800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_dc_cacks);

	offset = 832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_rsp_ooo_packet);

	offset = 864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_req_ooo_packet);

	offset = 896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_reached_max_outstanding_psn);

	offset = 928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_pause_on_strong_ordering);

	offset = 960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_fault_discard_eq_overrun);

	offset = 992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_fault_discard_other);

	offset = 1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_event_posted);

	offset = 1056;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_event_last_posted);

	offset = 1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_resume_received);

	offset = 1120;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_resume_error_received);

	offset = 1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_tx_req);

	offset = 1184;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_rx_res);

	offset = 1216;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_tx_res);

	offset = 1248;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->odp_rx_req);

}

void VS_DC_Page1LatestVersion_unpack(struct VS_DC_Page1LatestVersion *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->rq_num_sig_err = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->sq_num_sig_err = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->sq_num_cnak = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->sq_reconnect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->sq_reconnect_ack = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->rq_open_gb = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->rq_num_no_dcrs = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->rq_num_cnak_sent = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->sq_reconnect_ack_bad = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->rq_open_gb_cnak = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->rq_gb_trap_cnak = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->rq_not_gb_connect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->rq_not_gb_reconnect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->rq_curr_gb_connect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->rq_curr_gb_reconnect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->rq_close_non_gb_gc = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->rq_dcr_inhale_events = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->rq_state_active_gb = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 576;
	ptr_struct->rq_state_avail_dcrs = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 608;
	ptr_struct->rq_state_dcr_lifo_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 640;
	ptr_struct->sq_cnak_drop = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 672;
	ptr_struct->minimum_dcrs = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 704;
	ptr_struct->maximum_dcrs = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 736;
	ptr_struct->max_cnak_fifo_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 768;
	ptr_struct->rq_num_dc_cacks = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 800;
	ptr_struct->sq_num_dc_cacks = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 832;
	ptr_struct->rx_rsp_ooo_packet = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 864;
	ptr_struct->rx_req_ooo_packet = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 896;
	ptr_struct->tx_reached_max_outstanding_psn = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 928;
	ptr_struct->tx_pause_on_strong_ordering = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 960;
	ptr_struct->odp_fault_discard_eq_overrun = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 992;
	ptr_struct->odp_fault_discard_other = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1024;
	ptr_struct->odp_event_posted = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1056;
	ptr_struct->odp_event_last_posted = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1088;
	ptr_struct->odp_resume_received = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1120;
	ptr_struct->odp_resume_error_received = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1152;
	ptr_struct->odp_tx_req = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1184;
	ptr_struct->odp_rx_res = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1216;
	ptr_struct->odp_tx_res = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1248;
	ptr_struct->odp_rx_req = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void VS_DC_Page1LatestVersion_print(const struct VS_DC_Page1LatestVersion *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_DC_Page1LatestVersion ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_sig_err       : " U32H_FMT "\n", ptr_struct->rq_num_sig_err);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_sig_err       : " U32H_FMT "\n", ptr_struct->sq_num_sig_err);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_cnak          : " U32H_FMT "\n", ptr_struct->sq_num_cnak);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_reconnect         : " U32H_FMT "\n", ptr_struct->sq_reconnect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_reconnect_ack     : " U32H_FMT "\n", ptr_struct->sq_reconnect_ack);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_open_gb           : " U32H_FMT "\n", ptr_struct->rq_open_gb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_no_dcrs       : " U32H_FMT "\n", ptr_struct->rq_num_no_dcrs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_cnak_sent     : " U32H_FMT "\n", ptr_struct->rq_num_cnak_sent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_reconnect_ack_bad : " U32H_FMT "\n", ptr_struct->sq_reconnect_ack_bad);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_open_gb_cnak      : " U32H_FMT "\n", ptr_struct->rq_open_gb_cnak);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_gb_trap_cnak      : " U32H_FMT "\n", ptr_struct->rq_gb_trap_cnak);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_not_gb_connect    : " U32H_FMT "\n", ptr_struct->rq_not_gb_connect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_not_gb_reconnect  : " U32H_FMT "\n", ptr_struct->rq_not_gb_reconnect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_curr_gb_connect   : " U32H_FMT "\n", ptr_struct->rq_curr_gb_connect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_curr_gb_reconnect : " U32H_FMT "\n", ptr_struct->rq_curr_gb_reconnect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_close_non_gb_gc   : " U32H_FMT "\n", ptr_struct->rq_close_non_gb_gc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_dcr_inhale_events : " U32H_FMT "\n", ptr_struct->rq_dcr_inhale_events);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_state_active_gb   : " U32H_FMT "\n", ptr_struct->rq_state_active_gb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_state_avail_dcrs  : " U32H_FMT "\n", ptr_struct->rq_state_avail_dcrs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_state_dcr_lifo_size : " U32H_FMT "\n", ptr_struct->rq_state_dcr_lifo_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_cnak_drop         : " U32H_FMT "\n", ptr_struct->sq_cnak_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "minimum_dcrs         : " U32H_FMT "\n", ptr_struct->minimum_dcrs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "maximum_dcrs         : " U32H_FMT "\n", ptr_struct->maximum_dcrs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_cnak_fifo_size   : " U32H_FMT "\n", ptr_struct->max_cnak_fifo_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_dc_cacks      : " U32H_FMT "\n", ptr_struct->rq_num_dc_cacks);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_dc_cacks      : " U32H_FMT "\n", ptr_struct->sq_num_dc_cacks);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_rsp_ooo_packet    : " U32H_FMT "\n", ptr_struct->rx_rsp_ooo_packet);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_req_ooo_packet    : " U32H_FMT "\n", ptr_struct->rx_req_ooo_packet);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_reached_max_outstanding_psn : " U32H_FMT "\n", ptr_struct->tx_reached_max_outstanding_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_pause_on_strong_ordering : " U32H_FMT "\n", ptr_struct->tx_pause_on_strong_ordering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_fault_discard_eq_overrun : " U32H_FMT "\n", ptr_struct->odp_fault_discard_eq_overrun);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_fault_discard_other : " U32H_FMT "\n", ptr_struct->odp_fault_discard_other);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_event_posted     : " U32H_FMT "\n", ptr_struct->odp_event_posted);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_event_last_posted : " U32H_FMT "\n", ptr_struct->odp_event_last_posted);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_resume_received  : " U32H_FMT "\n", ptr_struct->odp_resume_received);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_resume_error_received : " U32H_FMT "\n", ptr_struct->odp_resume_error_received);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_tx_req           : " U32H_FMT "\n", ptr_struct->odp_tx_req);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_rx_res           : " U32H_FMT "\n", ptr_struct->odp_rx_res);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_tx_res           : " U32H_FMT "\n", ptr_struct->odp_tx_res);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "odp_rx_req           : " U32H_FMT "\n", ptr_struct->odp_rx_req);

}

int VS_DC_Page1LatestVersion_size(void)
{
	 return 160;
}

void VS_DC_Page1LatestVersion_dump(const struct VS_DC_Page1LatestVersion *ptr_struct, FILE* file)
{
	VS_DC_Page1LatestVersion_print(ptr_struct, file, 0);
}

void VS_DC_Page255LatestVersion_pack(const struct VS_DC_Page255LatestVersion *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_cqovf);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_eqovf);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_ds_ex_pi_retry);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_next_gb_connect);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_next_gb_reconnect);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_psn_close_gb);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_psn_close_gb_cwc);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_close_gb_gc);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_cwc_ghost_discard_connect);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_cwc_ghost_discard_reconnect);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_cwc_reconnect_stale_connection);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_cwc_reconnect_probable_current_connection);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_cwc_uncertainty_discard);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_dc_cacks_full_hash);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_dc_cacks_collision);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dc_hash_curr_used_lines);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dc_has_max_used_entries_in_line);

}

void VS_DC_Page255LatestVersion_unpack(struct VS_DC_Page255LatestVersion *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->num_cqovf = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->num_eqovf = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->sq_num_ds_ex_pi_retry = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->rq_next_gb_connect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->rq_next_gb_reconnect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->rq_psn_close_gb = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->rq_psn_close_gb_cwc = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->rq_close_gb_gc = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->rq_cwc_ghost_discard_connect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->rq_cwc_ghost_discard_reconnect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->rq_cwc_reconnect_stale_connection = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->rq_cwc_reconnect_probable_current_connection = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->rq_cwc_uncertainty_discard = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->rq_num_dc_cacks_full_hash = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->rq_num_dc_cacks_collision = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->dc_hash_curr_used_lines = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->dc_has_max_used_entries_in_line = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void VS_DC_Page255LatestVersion_print(const struct VS_DC_Page255LatestVersion *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_DC_Page255LatestVersion ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_cqovf            : " U32H_FMT "\n", ptr_struct->num_cqovf);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_eqovf            : " U32H_FMT "\n", ptr_struct->num_eqovf);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_ds_ex_pi_retry : " U32H_FMT "\n", ptr_struct->sq_num_ds_ex_pi_retry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_next_gb_connect   : " U32H_FMT "\n", ptr_struct->rq_next_gb_connect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_next_gb_reconnect : " U32H_FMT "\n", ptr_struct->rq_next_gb_reconnect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_psn_close_gb      : " U32H_FMT "\n", ptr_struct->rq_psn_close_gb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_psn_close_gb_cwc  : " U32H_FMT "\n", ptr_struct->rq_psn_close_gb_cwc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_close_gb_gc       : " U32H_FMT "\n", ptr_struct->rq_close_gb_gc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_cwc_ghost_discard_connect : " U32H_FMT "\n", ptr_struct->rq_cwc_ghost_discard_connect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_cwc_ghost_discard_reconnect : " U32H_FMT "\n", ptr_struct->rq_cwc_ghost_discard_reconnect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_cwc_reconnect_stale_connection : " U32H_FMT "\n", ptr_struct->rq_cwc_reconnect_stale_connection);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_cwc_reconnect_probable_current_connection : " U32H_FMT "\n", ptr_struct->rq_cwc_reconnect_probable_current_connection);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_cwc_uncertainty_discard : " U32H_FMT "\n", ptr_struct->rq_cwc_uncertainty_discard);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_dc_cacks_full_hash : " U32H_FMT "\n", ptr_struct->rq_num_dc_cacks_full_hash);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_dc_cacks_collision : " U32H_FMT "\n", ptr_struct->rq_num_dc_cacks_collision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_hash_curr_used_lines : " U32H_FMT "\n", ptr_struct->dc_hash_curr_used_lines);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_has_max_used_entries_in_line : " U32H_FMT "\n", ptr_struct->dc_has_max_used_entries_in_line);

}

int VS_DC_Page255LatestVersion_size(void)
{
	 return 68;
}

void VS_DC_Page255LatestVersion_dump(const struct VS_DC_Page255LatestVersion *ptr_struct, FILE* file)
{
	VS_DC_Page255LatestVersion_print(ptr_struct, file, 0);
}

void VS_DC_TransportErrorsAndFlowsV2_pack(const struct VS_DC_TransportErrorsAndFlowsV2 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_lle);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_lle);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_lqpoe);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_lqpoe);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_leeoe);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_leeoe);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_lpe);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_lpe);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_wrfe);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_wrfe);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_mwbe);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_bre);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_lae);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_rire);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_rire);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_rae);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_rae);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_roe);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_roe);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_rnr);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_oos);

	offset = 672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_oos);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_dup);

	offset = 736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_to);

	offset = 768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_tree);

	offset = 800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_rree);

	offset = 832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_rabrte);

	offset = 864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_mce);

	offset = 896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_num_retrans_rsync);

	offset = 928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_retrans_rsync);

	offset = 960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sq_num_ldb_drops);

}

void VS_DC_TransportErrorsAndFlowsV2_unpack(struct VS_DC_TransportErrorsAndFlowsV2 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->rq_num_lle = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->sq_num_lle = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->rq_num_lqpoe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->sq_num_lqpoe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->rq_num_leeoe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->sq_num_leeoe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->rq_num_lpe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->sq_num_lpe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->rq_num_wrfe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->sq_num_wrfe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->sq_num_mwbe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->sq_num_bre = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->rq_num_lae = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->rq_num_rire = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->sq_num_rire = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->rq_num_rae = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->sq_num_rae = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->rq_num_roe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 576;
	ptr_struct->sq_num_roe = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 608;
	ptr_struct->sq_num_rnr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 640;
	ptr_struct->rq_num_oos = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 672;
	ptr_struct->sq_num_oos = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 704;
	ptr_struct->rq_num_dup = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 736;
	ptr_struct->sq_num_to = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 768;
	ptr_struct->sq_num_tree = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 800;
	ptr_struct->sq_num_rree = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 832;
	ptr_struct->sq_num_rabrte = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 864;
	ptr_struct->rq_num_mce = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 896;
	ptr_struct->rq_num_retrans_rsync = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 928;
	ptr_struct->sq_num_retrans_rsync = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 960;
	ptr_struct->sq_num_ldb_drops = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void VS_DC_TransportErrorsAndFlowsV2_print(const struct VS_DC_TransportErrorsAndFlowsV2 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_DC_TransportErrorsAndFlowsV2 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_lle           : " U32H_FMT "\n", ptr_struct->rq_num_lle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_lle           : " U32H_FMT "\n", ptr_struct->sq_num_lle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_lqpoe         : " U32H_FMT "\n", ptr_struct->rq_num_lqpoe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_lqpoe         : " U32H_FMT "\n", ptr_struct->sq_num_lqpoe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_leeoe         : " U32H_FMT "\n", ptr_struct->rq_num_leeoe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_leeoe         : " U32H_FMT "\n", ptr_struct->sq_num_leeoe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_lpe           : " U32H_FMT "\n", ptr_struct->rq_num_lpe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_lpe           : " U32H_FMT "\n", ptr_struct->sq_num_lpe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_wrfe          : " U32H_FMT "\n", ptr_struct->rq_num_wrfe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_wrfe          : " U32H_FMT "\n", ptr_struct->sq_num_wrfe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_mwbe          : " U32H_FMT "\n", ptr_struct->sq_num_mwbe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_bre           : " U32H_FMT "\n", ptr_struct->sq_num_bre);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_lae           : " U32H_FMT "\n", ptr_struct->rq_num_lae);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_rire          : " U32H_FMT "\n", ptr_struct->rq_num_rire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_rire          : " U32H_FMT "\n", ptr_struct->sq_num_rire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_rae           : " U32H_FMT "\n", ptr_struct->rq_num_rae);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_rae           : " U32H_FMT "\n", ptr_struct->sq_num_rae);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_roe           : " U32H_FMT "\n", ptr_struct->rq_num_roe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_roe           : " U32H_FMT "\n", ptr_struct->sq_num_roe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_rnr           : " U32H_FMT "\n", ptr_struct->sq_num_rnr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_oos           : " U32H_FMT "\n", ptr_struct->rq_num_oos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_oos           : " U32H_FMT "\n", ptr_struct->sq_num_oos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_dup           : " U32H_FMT "\n", ptr_struct->rq_num_dup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_to            : " U32H_FMT "\n", ptr_struct->sq_num_to);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_tree          : " U32H_FMT "\n", ptr_struct->sq_num_tree);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_rree          : " U32H_FMT "\n", ptr_struct->sq_num_rree);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_rabrte        : " U32H_FMT "\n", ptr_struct->sq_num_rabrte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_mce           : " U32H_FMT "\n", ptr_struct->rq_num_mce);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_num_retrans_rsync : " U32H_FMT "\n", ptr_struct->rq_num_retrans_rsync);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_retrans_rsync : " U32H_FMT "\n", ptr_struct->sq_num_retrans_rsync);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_num_ldb_drops     : " U32H_FMT "\n", ptr_struct->sq_num_ldb_drops);

}

int VS_DC_TransportErrorsAndFlowsV2_size(void)
{
	 return 124;
}

void VS_DC_TransportErrorsAndFlowsV2_dump(const struct VS_DC_TransportErrorsAndFlowsV2 *ptr_struct, FILE* file)
{
	VS_DC_TransportErrorsAndFlowsV2_print(ptr_struct, file, 0);
}

void VS_Encapsulation_LocalSPAN_pack(const struct VS_Encapsulation_LocalSPAN *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 124;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl);

}

void VS_Encapsulation_LocalSPAN_unpack(struct VS_Encapsulation_LocalSPAN *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 124;
	ptr_struct->vl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void VS_Encapsulation_LocalSPAN_print(const struct VS_Encapsulation_LocalSPAN *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_Encapsulation_LocalSPAN ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl                   : " UH_FMT "\n", ptr_struct->vl);

}

int VS_Encapsulation_LocalSPAN_size(void)
{
	 return 80;
}

void VS_Encapsulation_LocalSPAN_dump(const struct VS_Encapsulation_LocalSPAN *ptr_struct, FILE* file)
{
	VS_Encapsulation_LocalSPAN_print(ptr_struct, file, 0);
}

void VS_Encapsulation_RawData_pack(const struct VS_Encapsulation_RawData *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 80; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 640, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void VS_Encapsulation_RawData_unpack(struct VS_Encapsulation_RawData *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 80; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 640, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void VS_Encapsulation_RawData_print(const struct VS_Encapsulation_RawData *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_Encapsulation_RawData ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 80; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int VS_Encapsulation_RawData_size(void)
{
	 return 80;
}

void VS_Encapsulation_RawData_dump(const struct VS_Encapsulation_RawData *ptr_struct, FILE* file)
{
	VS_Encapsulation_RawData_print(ptr_struct, file, 0);
}

void VS_Encapsulation_RemoteSPANLocalUD_pack(const struct VS_Encapsulation_RemoteSPANLocalUD *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dlid);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dpa);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->slid);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->swid);

	offset = 124;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl);

	offset = 464;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey);

	offset = 457;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m);

	offset = 456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->se);

	offset = 488;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->dest_qp);

	offset = 520;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->psn_init_val);

	offset = 513;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ar);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->qkey);

	offset = 584;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->src_qp);

}

void VS_Encapsulation_RemoteSPANLocalUD_unpack(struct VS_Encapsulation_RemoteSPANLocalUD *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->dlid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 14;
	ptr_struct->dpa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->slid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 40;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->swid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 124;
	ptr_struct->vl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 464;
	ptr_struct->pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 457;
	ptr_struct->m = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 456;
	ptr_struct->se = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 488;
	ptr_struct->dest_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 520;
	ptr_struct->psn_init_val = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 513;
	ptr_struct->ar = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 544;
	ptr_struct->qkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 584;
	ptr_struct->src_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void VS_Encapsulation_RemoteSPANLocalUD_print(const struct VS_Encapsulation_RemoteSPANLocalUD *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_Encapsulation_RemoteSPANLocalUD ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dlid                 : " UH_FMT "\n", ptr_struct->dlid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dpa                  : " UH_FMT "\n", ptr_struct->dpa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : " UH_FMT "\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slid                 : " UH_FMT "\n", ptr_struct->slid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swid                 : " UH_FMT "\n", ptr_struct->swid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl                   : " UH_FMT "\n", ptr_struct->vl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey                 : " UH_FMT "\n", ptr_struct->pkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m                    : " UH_FMT "\n", ptr_struct->m);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "se                   : " UH_FMT "\n", ptr_struct->se);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dest_qp              : " UH_FMT "\n", ptr_struct->dest_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psn_init_val         : " UH_FMT "\n", ptr_struct->psn_init_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar                   : " UH_FMT "\n", ptr_struct->ar);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey                 : " U32H_FMT "\n", ptr_struct->qkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "src_qp               : " UH_FMT "\n", ptr_struct->src_qp);

}

int VS_Encapsulation_RemoteSPANLocalUD_size(void)
{
	 return 80;
}

void VS_Encapsulation_RemoteSPANLocalUD_dump(const struct VS_Encapsulation_RemoteSPANLocalUD *ptr_struct, FILE* file)
{
	VS_Encapsulation_RemoteSPANLocalUD_print(ptr_struct, file, 0);
}

void VS_FastRecoveryCounters_pack(const struct VS_FastRecoveryCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->FieldSelect);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->trigger);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->counter_overflow);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_errors);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_warnings);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_normals);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->min_value);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_value);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->consecutive_normal);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->last_value_0);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->last_value_1);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->last_value_2);

}

void VS_FastRecoveryCounters_unpack(struct VS_FastRecoveryCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->FieldSelect = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->counter_overflow = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->num_errors = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->num_warnings = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->num_normals = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->min_value = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->max_value = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->consecutive_normal = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->last_value_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->last_value_1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->last_value_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void VS_FastRecoveryCounters_print(const struct VS_FastRecoveryCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_FastRecoveryCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FieldSelect          : " UH_FMT "\n", ptr_struct->FieldSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trigger              : " UH_FMT "\n", ptr_struct->trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_overflow     : " UH_FMT "\n", ptr_struct->counter_overflow);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_errors           : " U32H_FMT "\n", ptr_struct->num_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_warnings         : " U32H_FMT "\n", ptr_struct->num_warnings);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_normals          : " U32H_FMT "\n", ptr_struct->num_normals);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_value            : " U32H_FMT "\n", ptr_struct->min_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_value            : " U32H_FMT "\n", ptr_struct->max_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "consecutive_normal   : " U32H_FMT "\n", ptr_struct->consecutive_normal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_value_0         : " U32H_FMT "\n", ptr_struct->last_value_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_value_1         : " U32H_FMT "\n", ptr_struct->last_value_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_value_2         : " U32H_FMT "\n", ptr_struct->last_value_2);

}

int VS_FastRecoveryCounters_size(void)
{
	 return 48;
}

void VS_FastRecoveryCounters_dump(const struct VS_FastRecoveryCounters *ptr_struct, FILE* file)
{
	VS_FastRecoveryCounters_print(ptr_struct, file, 0);
}

void VS_MirroringGlobalTrigger_pack(const struct VS_MirroringGlobalTrigger *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->mirror_agent_ptr);

	offset = 35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->err_notifications);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->warning_notifications);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->noraml_notifications);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->probability_rate);

}

void VS_MirroringGlobalTrigger_unpack(struct VS_MirroringGlobalTrigger *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 60;
	ptr_struct->mirror_agent_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 35;
	ptr_struct->err_notifications = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 34;
	ptr_struct->warning_notifications = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 33;
	ptr_struct->noraml_notifications = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->probability_rate = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void VS_MirroringGlobalTrigger_print(const struct VS_MirroringGlobalTrigger *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_MirroringGlobalTrigger ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mirror_agent_ptr     : " UH_FMT "\n", ptr_struct->mirror_agent_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "err_notifications    : " UH_FMT "\n", ptr_struct->err_notifications);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "warning_notifications : " UH_FMT "\n", ptr_struct->warning_notifications);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "noraml_notifications : " UH_FMT "\n", ptr_struct->noraml_notifications);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable               : " UH_FMT "\n", ptr_struct->enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "probability_rate     : " U32H_FMT "\n", ptr_struct->probability_rate);

}

int VS_MirroringGlobalTrigger_size(void)
{
	 return 12;
}

void VS_MirroringGlobalTrigger_dump(const struct VS_MirroringGlobalTrigger *ptr_struct, FILE* file)
{
	VS_MirroringGlobalTrigger_print(ptr_struct, file, 0);
}

void VS_MirroringInfo_pack(const struct VS_MirroringInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cap_rspan_mirror_agents);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cap_mirror_agents);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cap_cbm_filter);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cap_cb_set);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_recovery_supported);

}

void VS_MirroringInfo_unpack(struct VS_MirroringInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->cap_rspan_mirror_agents = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->cap_mirror_agents = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 60;
	ptr_struct->cap_cbm_filter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 52;
	ptr_struct->cap_cb_set = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->fast_recovery_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void VS_MirroringInfo_print(const struct VS_MirroringInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_MirroringInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_rspan_mirror_agents : " UH_FMT "\n", ptr_struct->cap_rspan_mirror_agents);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_mirror_agents    : " UH_FMT "\n", ptr_struct->cap_mirror_agents);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_cbm_filter       : " UH_FMT "\n", ptr_struct->cap_cbm_filter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_cb_set           : " UH_FMT "\n", ptr_struct->cap_cb_set);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_recovery_supported : " UH_FMT "\n", ptr_struct->fast_recovery_supported);

}

int VS_MirroringInfo_size(void)
{
	 return 12;
}

void VS_MirroringInfo_dump(const struct VS_MirroringInfo *ptr_struct, FILE* file)
{
	VS_MirroringInfo_print(ptr_struct, file, 0);
}

void VS_PerformanceHistogramBufferControl_pack(const struct VS_PerformanceHistogramBufferControl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 93;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mode);

	offset = 82;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->sample_time);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->histogram_type);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hist_min_value);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->bin_size);

}

void VS_PerformanceHistogramBufferControl_unpack(struct VS_PerformanceHistogramBufferControl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 93;
	ptr_struct->mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 82;
	ptr_struct->sample_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 64;
	ptr_struct->histogram_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 96;
	ptr_struct->hist_min_value = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->bin_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void VS_PerformanceHistogramBufferControl_print(const struct VS_PerformanceHistogramBufferControl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_PerformanceHistogramBufferControl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mode                 : " UH_FMT "\n", ptr_struct->mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sample_time          : " UH_FMT "\n", ptr_struct->sample_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "histogram_type       : " UH_FMT "\n", ptr_struct->histogram_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hist_min_value       : " U32H_FMT "\n", ptr_struct->hist_min_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bin_size             : " U32H_FMT "\n", ptr_struct->bin_size);

}

int VS_PerformanceHistogramBufferControl_size(void)
{
	 return 20;
}

void VS_PerformanceHistogramBufferControl_dump(const struct VS_PerformanceHistogramBufferControl *ptr_struct, FILE* file)
{
	VS_PerformanceHistogramBufferControl_print(ptr_struct, file, 0);
}

void VS_PerformanceHistogramInfo_pack(const struct VS_PerformanceHistogramInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->cap_max_sample_time);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cap_max_port_hist_id);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cap_hist_bin_size);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_cell_size);

}

void VS_PerformanceHistogramInfo_unpack(struct VS_PerformanceHistogramInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 90;
	ptr_struct->cap_max_sample_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 80;
	ptr_struct->cap_max_port_hist_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->cap_hist_bin_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->cap_cell_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void VS_PerformanceHistogramInfo_print(const struct VS_PerformanceHistogramInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_PerformanceHistogramInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_max_sample_time  : " UH_FMT "\n", ptr_struct->cap_max_sample_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_max_port_hist_id : " UH_FMT "\n", ptr_struct->cap_max_port_hist_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_hist_bin_size    : " UH_FMT "\n", ptr_struct->cap_hist_bin_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_cell_size        : " UH_FMT "\n", ptr_struct->cap_cell_size);

}

int VS_PerformanceHistogramInfo_size(void)
{
	 return 16;
}

void VS_PerformanceHistogramInfo_dump(const struct VS_PerformanceHistogramInfo *ptr_struct, FILE* file)
{
	VS_PerformanceHistogramInfo_print(ptr_struct, file, 0);
}

void VS_PerformanceHistogramPortsControl_pack(const struct VS_PerformanceHistogramPortsControl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mode);

	offset = 50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->sample_time);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->histogram_type);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hist_min_value);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->bin_size);

}

void VS_PerformanceHistogramPortsControl_unpack(struct VS_PerformanceHistogramPortsControl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 61;
	ptr_struct->mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 50;
	ptr_struct->sample_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 32;
	ptr_struct->histogram_type = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->hist_min_value = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->bin_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void VS_PerformanceHistogramPortsControl_print(const struct VS_PerformanceHistogramPortsControl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_PerformanceHistogramPortsControl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mode                 : " UH_FMT "\n", ptr_struct->mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sample_time          : " UH_FMT "\n", ptr_struct->sample_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "histogram_type       : " UH_FMT "\n", ptr_struct->histogram_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hist_min_value       : " U32H_FMT "\n", ptr_struct->hist_min_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bin_size             : " U32H_FMT "\n", ptr_struct->bin_size);

}

int VS_PerformanceHistogramPortsControl_size(void)
{
	 return 16;
}

void VS_PerformanceHistogramPortsControl_dump(const struct VS_PerformanceHistogramPortsControl *ptr_struct, FILE* file)
{
	VS_PerformanceHistogramPortsControl_print(ptr_struct, file, 0);
}

void VendorSpecific_MAD_Data_Block_Element_pack(const struct VendorSpecific_MAD_Data_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1792, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DWORD[i]);
	}

}

void VendorSpecific_MAD_Data_Block_Element_unpack(struct VendorSpecific_MAD_Data_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 56; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1792, 1);
	ptr_struct->DWORD[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void VendorSpecific_MAD_Data_Block_Element_print(const struct VendorSpecific_MAD_Data_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VendorSpecific_MAD_Data_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 56; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DWORD_%03d           : " U32H_FMT "\n", i, ptr_struct->DWORD[i]);
	}

}

int VendorSpecific_MAD_Data_Block_Element_size(void)
{
	 return 224;
}

void VendorSpecific_MAD_Data_Block_Element_dump(const struct VendorSpecific_MAD_Data_Block_Element *ptr_struct, FILE* file)
{
	VendorSpecific_MAD_Data_Block_Element_print(ptr_struct, file, 0);
}

void acc_register_pack(const struct acc_register *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void acc_register_unpack(struct acc_register *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 352, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void acc_register_print(const struct acc_register *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== acc_register ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 44; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int acc_register_size(void)
{
	 return 44;
}

void acc_register_dump(const struct acc_register *ptr_struct, FILE* file)
{
	acc_register_print(ptr_struct, file, 0);
}

void acc_register_gmp_pack(const struct acc_register_gmp *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 220; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1760, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void acc_register_gmp_unpack(struct acc_register_gmp *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 220; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1760, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void acc_register_gmp_print(const struct acc_register_gmp *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== acc_register_gmp ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 220; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int acc_register_gmp_size(void)
{
	 return 220;
}

void acc_register_gmp_dump(const struct acc_register_gmp *ptr_struct, FILE* file)
{
	acc_register_gmp_print(ptr_struct, file, 0);
}

void adaptive_routing_group_table_copy_element_pack(const struct adaptive_routing_group_table_copy_element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->copy_from_index);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->copy_to_index);

}

void adaptive_routing_group_table_copy_element_unpack(struct adaptive_routing_group_table_copy_element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->copy_from_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 4;
	ptr_struct->copy_to_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

}

void adaptive_routing_group_table_copy_element_print(const struct adaptive_routing_group_table_copy_element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== adaptive_routing_group_table_copy_element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "copy_from_index      : " UH_FMT "\n", ptr_struct->copy_from_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "copy_to_index        : " UH_FMT "\n", ptr_struct->copy_to_index);

}

int adaptive_routing_group_table_copy_element_size(void)
{
	 return 4;
}

void adaptive_routing_group_table_copy_element_dump(const struct adaptive_routing_group_table_copy_element *ptr_struct, FILE* file)
{
	adaptive_routing_group_table_copy_element_print(ptr_struct, file, 0);
}

void adaptive_routing_info_pack(const struct adaptive_routing_info *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_arn_sup);

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_frn_sup);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_fr_sup);

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fr_enabled);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rn_xmit_enabled);

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_ar_trials_supported);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sub_grps_active);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->group_table_copy_sup);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->direction_num_sup);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_fallback);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is4_mode);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->glb_groups);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->by_sl_cap);

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->by_sl_en);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->by_transp_cap);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dyn_cap_calc_sup);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->group_cap);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->group_top);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->group_table_cap);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->string_width_cap);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ar_version_cap);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rn_version_cap);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sub_grps_supported);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->enable_by_sl_mask);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->by_transport_disable);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ageing_time_value);

	offset = 179;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pfrn_enabled);

	offset = 178;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->by_vl_en);

	offset = 177;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->whbf_en);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->by_sl_hbf_en);

	offset = 166;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_pfrn_supported);

	offset = 165;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->by_vl_cap);

	offset = 164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_bth_dqp_hash_supported);

	offset = 163;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_dceth_hash_supported);

	offset = 162;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_symmetric_hash_supported);

	offset = 161;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_whbf_supported);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_hbf_supported);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->enable_by_sl_mask_hbf);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->whbf_granularity);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->enable_by_vl_mask);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl_vl_mode);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->enable_by_vl_mask_hbf);

}

void adaptive_routing_info_unpack(struct adaptive_routing_info *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->e = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->is_arn_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 29;
	ptr_struct->is_frn_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->is_fr_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 27;
	ptr_struct->fr_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 26;
	ptr_struct->rn_xmit_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 25;
	ptr_struct->is_ar_trials_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 20;
	ptr_struct->sub_grps_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->group_table_copy_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->direction_num_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 7;
	ptr_struct->no_fallback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 6;
	ptr_struct->is4_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 5;
	ptr_struct->glb_groups = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 4;
	ptr_struct->by_sl_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 3;
	ptr_struct->by_sl_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 2;
	ptr_struct->by_transp_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->dyn_cap_calc_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 52;
	ptr_struct->group_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 40;
	ptr_struct->group_top = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 36;
	ptr_struct->group_table_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->string_width_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 92;
	ptr_struct->ar_version_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->rn_version_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->sub_grps_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->enable_by_sl_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 120;
	ptr_struct->by_transport_disable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->ageing_time_value = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 179;
	ptr_struct->pfrn_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 178;
	ptr_struct->by_vl_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 177;
	ptr_struct->whbf_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 176;
	ptr_struct->by_sl_hbf_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 166;
	ptr_struct->is_pfrn_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 165;
	ptr_struct->by_vl_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 164;
	ptr_struct->is_bth_dqp_hash_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 163;
	ptr_struct->is_dceth_hash_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 162;
	ptr_struct->is_symmetric_hash_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 161;
	ptr_struct->is_whbf_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 160;
	ptr_struct->is_hbf_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 208;
	ptr_struct->enable_by_sl_mask_hbf = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->whbf_granularity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 240;
	ptr_struct->enable_by_vl_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->sl_vl_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 272;
	ptr_struct->enable_by_vl_mask_hbf = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void adaptive_routing_info_print(const struct adaptive_routing_info *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== adaptive_routing_info ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e                    : " UH_FMT "\n", ptr_struct->e);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_arn_sup           : " UH_FMT "\n", ptr_struct->is_arn_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_frn_sup           : " UH_FMT "\n", ptr_struct->is_frn_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_fr_sup            : " UH_FMT "\n", ptr_struct->is_fr_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fr_enabled           : " UH_FMT "\n", ptr_struct->fr_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rn_xmit_enabled      : " UH_FMT "\n", ptr_struct->rn_xmit_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_ar_trials_supported : " UH_FMT "\n", ptr_struct->is_ar_trials_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sub_grps_active      : " UH_FMT "\n", ptr_struct->sub_grps_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_table_copy_sup : " UH_FMT "\n", ptr_struct->group_table_copy_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "direction_num_sup    : " UH_FMT "\n", ptr_struct->direction_num_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_fallback          : " UH_FMT "\n", ptr_struct->no_fallback);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is4_mode             : " UH_FMT "\n", ptr_struct->is4_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "glb_groups           : " UH_FMT "\n", ptr_struct->glb_groups);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "by_sl_cap            : " UH_FMT "\n", ptr_struct->by_sl_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "by_sl_en             : " UH_FMT "\n", ptr_struct->by_sl_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "by_transp_cap        : " UH_FMT "\n", ptr_struct->by_transp_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dyn_cap_calc_sup     : " UH_FMT "\n", ptr_struct->dyn_cap_calc_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_cap            : " UH_FMT "\n", ptr_struct->group_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_top            : " UH_FMT "\n", ptr_struct->group_top);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_table_cap      : " UH_FMT "\n", ptr_struct->group_table_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "string_width_cap     : " UH_FMT "\n", ptr_struct->string_width_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar_version_cap       : " UH_FMT "\n", ptr_struct->ar_version_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rn_version_cap       : " UH_FMT "\n", ptr_struct->rn_version_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sub_grps_supported   : " UH_FMT "\n", ptr_struct->sub_grps_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_by_sl_mask    : " UH_FMT "\n", ptr_struct->enable_by_sl_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "by_transport_disable : " UH_FMT "\n", ptr_struct->by_transport_disable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ageing_time_value    : " U32H_FMT "\n", ptr_struct->ageing_time_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pfrn_enabled         : " UH_FMT "\n", ptr_struct->pfrn_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "by_vl_en             : " UH_FMT "\n", ptr_struct->by_vl_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "whbf_en              : " UH_FMT "\n", ptr_struct->whbf_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "by_sl_hbf_en         : " UH_FMT "\n", ptr_struct->by_sl_hbf_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_pfrn_supported    : " UH_FMT "\n", ptr_struct->is_pfrn_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "by_vl_cap            : " UH_FMT "\n", ptr_struct->by_vl_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_bth_dqp_hash_supported : " UH_FMT "\n", ptr_struct->is_bth_dqp_hash_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_dceth_hash_supported : " UH_FMT "\n", ptr_struct->is_dceth_hash_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_symmetric_hash_supported : " UH_FMT "\n", ptr_struct->is_symmetric_hash_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_whbf_supported    : " UH_FMT "\n", ptr_struct->is_whbf_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_hbf_supported     : " UH_FMT "\n", ptr_struct->is_hbf_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_by_sl_mask_hbf : " UH_FMT "\n", ptr_struct->enable_by_sl_mask_hbf);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "whbf_granularity     : " UH_FMT "\n", ptr_struct->whbf_granularity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_by_vl_mask    : " UH_FMT "\n", ptr_struct->enable_by_vl_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_vl_mode           : " UH_FMT "\n", ptr_struct->sl_vl_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_by_vl_mask_hbf : " UH_FMT "\n", ptr_struct->enable_by_vl_mask_hbf);

}

int adaptive_routing_info_size(void)
{
	 return 36;
}

void adaptive_routing_info_dump(const struct adaptive_routing_info *ptr_struct, FILE* file)
{
	adaptive_routing_info_print(ptr_struct, file, 0);
}

void anycast_lid_block_pack(const struct anycast_lid_block *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->anycast_lid);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->properties);

}

void anycast_lid_block_unpack(struct anycast_lid_block *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	ptr_struct->anycast_lid = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 0;
	ptr_struct->properties = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void anycast_lid_block_print(const struct anycast_lid_block *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== anycast_lid_block ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "anycast_lid          : " UH_FMT "\n", ptr_struct->anycast_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "properties           : " UH_FMT "\n", ptr_struct->properties);

}

int anycast_lid_block_size(void)
{
	 return 4;
}

void anycast_lid_block_dump(const struct anycast_lid_block *ptr_struct, FILE* file)
{
	anycast_lid_block_print(ptr_struct, file, 0);
}

void child_qp_pack(const struct child_qp *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->child_qpn);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->child_index);

}

void child_qp_unpack(struct child_qp *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->child_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 0;
	ptr_struct->child_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void child_qp_print(const struct child_qp *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== child_qp ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "child_qpn            : " UH_FMT "\n", ptr_struct->child_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "child_index          : " UH_FMT "\n", ptr_struct->child_index);

}

int child_qp_size(void)
{
	 return 4;
}

void child_qp_dump(const struct child_qp *ptr_struct, FILE* file)
{
	child_qp_print(ptr_struct, file, 0);
}

void child_qpn_pack(const struct child_qpn *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->child_qpn);

}

void child_qpn_unpack(struct child_qpn *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->child_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void child_qpn_print(const struct child_qpn *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== child_qpn ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "child_qpn            : " UH_FMT "\n", ptr_struct->child_qpn);

}

int child_qpn_size(void)
{
	 return 4;
}

void child_qpn_dump(const struct child_qpn *ptr_struct, FILE* file)
{
	child_qpn_print(ptr_struct, file, 0);
}

void end_port_plane_filter_entry_pack(const struct end_port_plane_filter_entry *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->lid);

}

void end_port_plane_filter_entry_unpack(struct end_port_plane_filter_entry *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	ptr_struct->lid = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

}

void end_port_plane_filter_entry_print(const struct end_port_plane_filter_entry *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== end_port_plane_filter_entry ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid                  : " UH_FMT "\n", ptr_struct->lid);

}

int end_port_plane_filter_entry_size(void)
{
	 return 4;
}

void end_port_plane_filter_entry_dump(const struct end_port_plane_filter_entry *ptr_struct, FILE* file)
{
	end_port_plane_filter_entry_print(ptr_struct, file, 0);
}

void group_weights_pack(const struct group_weights *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sg2_weight);

	offset = 17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sg1_weight);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sg0_weight);

}

void group_weights_unpack(struct group_weights *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->sg2_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 17;
	ptr_struct->sg1_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 9;
	ptr_struct->sg0_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

}

void group_weights_print(const struct group_weights *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== group_weights ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sg2_weight           : " UH_FMT "\n", ptr_struct->sg2_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sg1_weight           : " UH_FMT "\n", ptr_struct->sg1_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sg0_weight           : " UH_FMT "\n", ptr_struct->sg0_weight);

}

int group_weights_size(void)
{
	 return 4;
}

void group_weights_dump(const struct group_weights *ptr_struct, FILE* file)
{
	group_weights_print(ptr_struct, file, 0);
}

void ib_ar_lft_block_element_pack(const struct ib_ar_lft_block_element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->GroupNumber);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TableNumber);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->Reserved);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->LidState);

}

void ib_ar_lft_block_element_unpack(struct ib_ar_lft_block_element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->GroupNumber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->TableNumber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 2;
	ptr_struct->Reserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->LidState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void ib_ar_lft_block_element_print(const struct ib_ar_lft_block_element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_ar_lft_block_element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GroupNumber          : " UH_FMT "\n", ptr_struct->GroupNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TableNumber          : " UH_FMT "\n", ptr_struct->TableNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidState             : " UH_FMT "\n", ptr_struct->LidState);

}

int ib_ar_lft_block_element_size(void)
{
	 return 2;
}

void ib_ar_lft_block_element_dump(const struct ib_ar_lft_block_element *ptr_struct, FILE* file)
{
	ib_ar_lft_block_element_print(ptr_struct, file, 0);
}

void ib_ar_lft_block_element_sx_pack(const struct ib_ar_lft_block_element_sx *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->GroupNumber);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved_1);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DefaultPort);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TableNumber);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->Reserved_2);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->LidState);

}

void ib_ar_lft_block_element_sx_unpack(struct ib_ar_lft_block_element_sx *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->GroupNumber = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 16;
	ptr_struct->Reserved_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->DefaultPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->TableNumber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 2;
	ptr_struct->Reserved_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->LidState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void ib_ar_lft_block_element_sx_print(const struct ib_ar_lft_block_element_sx *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_ar_lft_block_element_sx ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GroupNumber          : " UH_FMT "\n", ptr_struct->GroupNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved_1           : " UH_FMT "\n", ptr_struct->Reserved_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DefaultPort          : " UH_FMT "\n", ptr_struct->DefaultPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TableNumber          : " UH_FMT "\n", ptr_struct->TableNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved_2           : " UH_FMT "\n", ptr_struct->Reserved_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidState             : " UH_FMT "\n", ptr_struct->LidState);

}

int ib_ar_lft_block_element_sx_size(void)
{
	 return 4;
}

void ib_ar_lft_block_element_sx_dump(const struct ib_ar_lft_block_element_sx *ptr_struct, FILE* file)
{
	ib_ar_lft_block_element_sx_print(ptr_struct, file, 0);
}

void ib_description_mode_pack(const struct ib_description_mode *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->NumOfLFTables);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->LFTableSize);

}

void ib_description_mode_unpack(struct ib_description_mode *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	ptr_struct->NumOfLFTables = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 2;
	ptr_struct->LFTableSize = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void ib_description_mode_print(const struct ib_description_mode *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_description_mode ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NumOfLFTables        : " UH_FMT "\n", ptr_struct->NumOfLFTables);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LFTableSize          : " UH_FMT "\n", ptr_struct->LFTableSize);

}

int ib_description_mode_size(void)
{
	 return 2;
}

void ib_description_mode_dump(const struct ib_description_mode *ptr_struct, FILE* file)
{
	ib_description_mode_print(ptr_struct, file, 0);
}

void ib_extended_node_info_pack(const struct ib_extended_node_info *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->sl2vl_cap);

	offset = 22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sl2vl_act);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_pcie);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_oob);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->node_type_extended);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AnycastLidCap);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AnycastLIDTop);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->asic_max_planes);

}

void ib_extended_node_info_unpack(struct ib_extended_node_info *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->sl2vl_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 22;
	ptr_struct->sl2vl_act = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 12;
	ptr_struct->num_pcie = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 4;
	ptr_struct->num_oob = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 120;
	ptr_struct->node_type_extended = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->AnycastLidCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->AnycastLIDTop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->asic_max_planes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void ib_extended_node_info_print(const struct ib_extended_node_info *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_extended_node_info ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl2vl_cap            : " UH_FMT "\n", ptr_struct->sl2vl_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl2vl_act            : " UH_FMT "\n", ptr_struct->sl2vl_act);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pcie             : " UH_FMT "\n", ptr_struct->num_pcie);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_oob              : " UH_FMT "\n", ptr_struct->num_oob);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_type_extended   : " UH_FMT "\n", ptr_struct->node_type_extended);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AnycastLidCap        : " UH_FMT "\n", ptr_struct->AnycastLidCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AnycastLIDTop        : " UH_FMT "\n", ptr_struct->AnycastLIDTop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "asic_max_planes      : " UH_FMT "\n", ptr_struct->asic_max_planes);

}

int ib_extended_node_info_size(void)
{
	 return 20;
}

void ib_extended_node_info_dump(const struct ib_extended_node_info *ptr_struct, FILE* file)
{
	ib_extended_node_info_print(ptr_struct, file, 0);
}

void ib_lft_def_pack(const struct ib_lft_def *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->FDB_LID_Offset);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->FDB_LID_Space);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->FDB_Table_IX);

}

void ib_lft_def_unpack(struct ib_lft_def *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->FDB_LID_Offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 8;
	ptr_struct->FDB_LID_Space = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->FDB_Table_IX = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void ib_lft_def_print(const struct ib_lft_def *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_lft_def ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDB_LID_Offset       : " UH_FMT "\n", ptr_struct->FDB_LID_Offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDB_LID_Space        : " UH_FMT "\n", ptr_struct->FDB_LID_Space);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDB_Table_IX         : " UH_FMT "\n", ptr_struct->FDB_Table_IX);

}

int ib_lft_def_size(void)
{
	 return 4;
}

void ib_lft_def_dump(const struct ib_lft_def *ptr_struct, FILE* file)
{
	ib_lft_def_print(ptr_struct, file, 0);
}

void ib_port_sl_to_plft_pack(const struct ib_port_sl_to_plft *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL3);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL2);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL1);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL0);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL7);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL6);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL5);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL4);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL11);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL10);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL9);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL8);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL15);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL14);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL13);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL12);

}

void ib_port_sl_to_plft_unpack(struct ib_port_sl_to_plft *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->PLFTToPortSL3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->PLFTToPortSL2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->PLFTToPortSL1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->PLFTToPortSL0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->PLFTToPortSL7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->PLFTToPortSL6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->PLFTToPortSL5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->PLFTToPortSL4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->PLFTToPortSL11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->PLFTToPortSL10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->PLFTToPortSL9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->PLFTToPortSL8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->PLFTToPortSL15 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->PLFTToPortSL14 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->PLFTToPortSL13 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->PLFTToPortSL12 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void ib_port_sl_to_plft_print(const struct ib_port_sl_to_plft *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_port_sl_to_plft ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL3        : " UH_FMT "\n", ptr_struct->PLFTToPortSL3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL2        : " UH_FMT "\n", ptr_struct->PLFTToPortSL2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL1        : " UH_FMT "\n", ptr_struct->PLFTToPortSL1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL0        : " UH_FMT "\n", ptr_struct->PLFTToPortSL0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL7        : " UH_FMT "\n", ptr_struct->PLFTToPortSL7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL6        : " UH_FMT "\n", ptr_struct->PLFTToPortSL6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL5        : " UH_FMT "\n", ptr_struct->PLFTToPortSL5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL4        : " UH_FMT "\n", ptr_struct->PLFTToPortSL4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL11       : " UH_FMT "\n", ptr_struct->PLFTToPortSL11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL10       : " UH_FMT "\n", ptr_struct->PLFTToPortSL10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL9        : " UH_FMT "\n", ptr_struct->PLFTToPortSL9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL8        : " UH_FMT "\n", ptr_struct->PLFTToPortSL8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL15       : " UH_FMT "\n", ptr_struct->PLFTToPortSL15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL14       : " UH_FMT "\n", ptr_struct->PLFTToPortSL14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL13       : " UH_FMT "\n", ptr_struct->PLFTToPortSL13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL12       : " UH_FMT "\n", ptr_struct->PLFTToPortSL12);

}

int ib_port_sl_to_plft_size(void)
{
	 return 16;
}

void ib_port_sl_to_plft_dump(const struct ib_port_sl_to_plft *ptr_struct, FILE* file)
{
	ib_port_sl_to_plft_print(ptr_struct, file, 0);
}

void ib_private_lft_map_pack(const struct ib_private_lft_map *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Port_MaskEn);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->LFT_TopEn);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(32, 32, i, 320, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->FDB_Port_Group_Mask[i]);
	}

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LFT_Top);

}

void ib_private_lft_map_unpack(struct ib_private_lft_map *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->Port_MaskEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->LFT_TopEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(32, 32, i, 320, 1);
	ptr_struct->FDB_Port_Group_Mask[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 304;
	ptr_struct->LFT_Top = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void ib_private_lft_map_print(const struct ib_private_lft_map *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_private_lft_map ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Port_MaskEn          : " UH_FMT "\n", ptr_struct->Port_MaskEn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LFT_TopEn            : " UH_FMT "\n", ptr_struct->LFT_TopEn);

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDB_Port_Group_Mask_%03d : " U32H_FMT "\n", i, ptr_struct->FDB_Port_Group_Mask[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LFT_Top              : " UH_FMT "\n", ptr_struct->LFT_Top);

}

int ib_private_lft_map_size(void)
{
	 return 40;
}

void ib_private_lft_map_dump(const struct ib_private_lft_map *ptr_struct, FILE* file)
{
	ib_private_lft_map_print(ptr_struct, file, 0);
}

void ipv4_record_pack(const struct ipv4_record *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ipv4);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->netmask);

}

void ipv4_record_unpack(struct ipv4_record *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->ipv4 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->netmask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void ipv4_record_print(const struct ipv4_record *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ipv4_record ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipv4                 : " U32H_FMT "\n", ptr_struct->ipv4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "netmask              : " U32H_FMT "\n", ptr_struct->netmask);

}

int ipv4_record_size(void)
{
	 return 8;
}

void ipv4_record_dump(const struct ipv4_record *ptr_struct, FILE* file)
{
	ipv4_record_print(ptr_struct, file, 0);
}

void ipv6_record_pack(const struct ipv6_record *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 256, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ipv6[i]);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 256, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->netmask[i]);
	}

}

void ipv6_record_unpack(struct ipv6_record *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 256, 1);
	ptr_struct->ipv6[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 256, 1);
	ptr_struct->netmask[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void ipv6_record_print(const struct ipv6_record *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ipv6_record ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipv6_%03d            : " UH_FMT "\n", i, ptr_struct->ipv6[i]);
	}

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "netmask_%03d         : " UH_FMT "\n", i, ptr_struct->netmask[i]);
	}

}

int ipv6_record_size(void)
{
	 return 32;
}

void ipv6_record_dump(const struct ipv6_record *ptr_struct, FILE* file)
{
	ipv6_record_print(ptr_struct, file, 0);
}

void qp_record_pack(const struct qp_record *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->qp_state);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

}

void qp_record_unpack(struct qp_record *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 4;
	ptr_struct->qp_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void qp_record_print(const struct qp_record *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== qp_record ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : " UH_FMT "\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : " UH_FMT "\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

}

int qp_record_size(void)
{
	 return 8;
}

void qp_record_dump(const struct qp_record *ptr_struct, FILE* file)
{
	qp_record_print(ptr_struct, file, 0);
}

void qpn_pack(const struct qpn *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

}

void qpn_unpack(struct qpn *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void qpn_print(const struct qpn *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== qpn ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : " UH_FMT "\n", ptr_struct->qpn);

}

int qpn_size(void)
{
	 return 4;
}

void qpn_dump(const struct qpn *ptr_struct, FILE* file)
{
	qpn_print(ptr_struct, file, 0);
}

void rn_gen_by_sub_group_prio_element_pack(const struct rn_gen_by_sub_group_prio_element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->gen_arn);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->gen_frn);

}

void rn_gen_by_sub_group_prio_element_unpack(struct rn_gen_by_sub_group_prio_element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->gen_arn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->gen_frn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void rn_gen_by_sub_group_prio_element_print(const struct rn_gen_by_sub_group_prio_element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_gen_by_sub_group_prio_element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen_arn              : " UH_FMT "\n", ptr_struct->gen_arn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen_frn              : " UH_FMT "\n", ptr_struct->gen_frn);

}

int rn_gen_by_sub_group_prio_element_size(void)
{
	 return 4;
}

void rn_gen_by_sub_group_prio_element_dump(const struct rn_gen_by_sub_group_prio_element *ptr_struct, FILE* file)
{
	rn_gen_by_sub_group_prio_element_print(ptr_struct, file, 0);
}

void rn_gen_by_sub_group_priority_element_pack(const struct rn_gen_by_sub_group_priority_element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->gen_arn);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->gen_frn);

}

void rn_gen_by_sub_group_priority_element_unpack(struct rn_gen_by_sub_group_priority_element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->gen_arn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->gen_frn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void rn_gen_by_sub_group_priority_element_print(const struct rn_gen_by_sub_group_priority_element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_gen_by_sub_group_priority_element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen_arn              : " UH_FMT "\n", ptr_struct->gen_arn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen_frn              : " UH_FMT "\n", ptr_struct->gen_frn);

}

int rn_gen_by_sub_group_priority_element_size(void)
{
	 return 4;
}

void rn_gen_by_sub_group_priority_element_dump(const struct rn_gen_by_sub_group_priority_element *ptr_struct, FILE* file)
{
	rn_gen_by_sub_group_priority_element_print(ptr_struct, file, 0);
}

void rn_gen_string_element_pack(const struct rn_gen_string_element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->rn_gen_string);

}

void rn_gen_string_element_unpack(struct rn_gen_string_element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	ptr_struct->rn_gen_string = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

}

void rn_gen_string_element_print(const struct rn_gen_string_element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_gen_string_element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rn_gen_string        : " UH_FMT "\n", ptr_struct->rn_gen_string);

}

int rn_gen_string_element_size(void)
{
	 return 2;
}

void rn_gen_string_element_dump(const struct rn_gen_string_element *ptr_struct, FILE* file)
{
	rn_gen_string_element_print(ptr_struct, file, 0);
}

void rn_rcv_string_element_pack(const struct rn_rcv_string_element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->decision);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->plft_id);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->string2string);

}

void rn_rcv_string_element_unpack(struct rn_rcv_string_element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->decision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->plft_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1;
	ptr_struct->string2string = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

}

void rn_rcv_string_element_print(const struct rn_rcv_string_element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_rcv_string_element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "decision             : " UH_FMT "\n", ptr_struct->decision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plft_id              : " UH_FMT "\n", ptr_struct->plft_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "string2string        : " UH_FMT "\n", ptr_struct->string2string);

}

int rn_rcv_string_element_size(void)
{
	 return 4;
}

void rn_rcv_string_element_dump(const struct rn_rcv_string_element *ptr_struct, FILE* file)
{
	rn_rcv_string_element_print(ptr_struct, file, 0);
}

void rn_sub_group_direction_tbl_pack(const struct rn_sub_group_direction_tbl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->direction_of_sub_group[i]);
	}

}

void rn_sub_group_direction_tbl_unpack(struct rn_sub_group_direction_tbl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	ptr_struct->direction_of_sub_group[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void rn_sub_group_direction_tbl_print(const struct rn_sub_group_direction_tbl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_sub_group_direction_tbl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "direction_of_sub_group_%03d : " UH_FMT "\n", i, ptr_struct->direction_of_sub_group[i]);
	}

}

int rn_sub_group_direction_tbl_size(void)
{
	 return 64;
}

void rn_sub_group_direction_tbl_dump(const struct rn_sub_group_direction_tbl *ptr_struct, FILE* file)
{
	rn_sub_group_direction_tbl_print(ptr_struct, file, 0);
}

void rn_xmit_port_mask_pack(const struct rn_xmit_port_mask *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->element[i]);
	}

}

void rn_xmit_port_mask_unpack(struct rn_xmit_port_mask *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(28, 4, i, 512, 1);
	ptr_struct->element[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);
	}

}

void rn_xmit_port_mask_print(const struct rn_xmit_port_mask *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_xmit_port_mask ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "element_%03d         : " UH_FMT "\n", i, ptr_struct->element[i]);
	}

}

int rn_xmit_port_mask_size(void)
{
	 return 64;
}

void rn_xmit_port_mask_dump(const struct rn_xmit_port_mask *ptr_struct, FILE* file)
{
	rn_xmit_port_mask_print(ptr_struct, file, 0);
}

void uint64bit_pack(const struct uint64bit *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->High);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Low);

}

void uint64bit_unpack(struct uint64bit *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->High = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->Low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void uint64bit_print(const struct uint64bit *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== uint64bit ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "High                 : " U32H_FMT "\n", ptr_struct->High);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Low                  : " U32H_FMT "\n", ptr_struct->Low);

}

int uint64bit_size(void)
{
	 return 8;
}

void uint64bit_dump(const struct uint64bit *ptr_struct, FILE* file)
{
	uint64bit_print(ptr_struct, file, 0);
}

void AM_AMKeyInfo_pack(const struct AM_AMKeyInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	uint64bit_pack(&(ptr_struct->am_key), ptr_buff + offset/8);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->am_key_lease_period);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->am_key_protect_bit);

}

void AM_AMKeyInfo_unpack(struct AM_AMKeyInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	uint64bit_unpack(&(ptr_struct->am_key), ptr_buff + offset/8);

	offset = 80;
	ptr_struct->am_key_lease_period = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->am_key_protect_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void AM_AMKeyInfo_print(const struct AM_AMKeyInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_AMKeyInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "am_key:\n");
	uint64bit_print(&(ptr_struct->am_key), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "am_key_lease_period  : " UH_FMT "\n", ptr_struct->am_key_lease_period);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "am_key_protect_bit   : " UH_FMT "\n", ptr_struct->am_key_protect_bit);

}

int AM_AMKeyInfo_size(void)
{
	 return 12;
}

void AM_AMKeyInfo_dump(const struct AM_AMKeyInfo *ptr_struct, FILE* file)
{
	AM_AMKeyInfo_print(ptr_struct, file, 0);
}

void AM_MulticastPrivateLFT_pack(const struct AM_MulticastPrivateLFT *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->disable_lbf_mask);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->set_disable_lbf_mask);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->inconsistent_lbf_cfg_mask);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(32, 256, i, 1056, 1);
	UINT256_pack(&(ptr_struct->port_mask[i]), ptr_buff + offset/8);
	}

}

void AM_MulticastPrivateLFT_unpack(struct AM_MulticastPrivateLFT *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->disable_lbf_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->set_disable_lbf_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 12;
	ptr_struct->inconsistent_lbf_cfg_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(32, 256, i, 1056, 1);
	UINT256_unpack(&(ptr_struct->port_mask[i]), ptr_buff + offset/8);
	}

}

void AM_MulticastPrivateLFT_print(const struct AM_MulticastPrivateLFT *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_MulticastPrivateLFT ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disable_lbf_mask     : " UH_FMT "\n", ptr_struct->disable_lbf_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_disable_lbf_mask : " UH_FMT "\n", ptr_struct->set_disable_lbf_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inconsistent_lbf_cfg_mask : " UH_FMT "\n", ptr_struct->inconsistent_lbf_cfg_mask);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_mask_%03d:\n", i);
	UINT256_print(&(ptr_struct->port_mask[i]), file, indent_level + 1);
	}

}

int AM_MulticastPrivateLFT_size(void)
{
	 return 132;
}

void AM_MulticastPrivateLFT_dump(const struct AM_MulticastPrivateLFT *ptr_struct, FILE* file)
{
	AM_MulticastPrivateLFT_print(ptr_struct, file, 0);
}

void AM_PerformanceCounters_pack(const struct AM_PerformanceCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->counter_select);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->counter_select2);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->packet_sent);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ack_packet_sent);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->retry_packet_sent);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rnr_event);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->timeout_event);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->oos_nack_rcv);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rnr_nack_rcv);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->packet_discard_transport);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->packet_discard_sharp);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->aeth_syndrome_ack_packet);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hba_sharp_lookup);

	offset = 768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hba_received_pkts);

	offset = 832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hba_received_bytes);

	offset = 896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hba_sent_ack_packets);

	offset = 960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rcds_sent_packets);

	offset = 1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hba_sent_ack_bytes);

	offset = 1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rcds_send_bytes);

	offset = 1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hba_multi_packet_message_dropped_pkts);

	offset = 1216;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hba_multi_packet_message_dropped_bytes);

}

void AM_PerformanceCounters_unpack(struct AM_PerformanceCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->counter_select = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->counter_select2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->packet_sent = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->ack_packet_sent = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->retry_packet_sent = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->rnr_event = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->timeout_event = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 384;
	ptr_struct->oos_nack_rcv = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 448;
	ptr_struct->rnr_nack_rcv = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 512;
	ptr_struct->packet_discard_transport = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 576;
	ptr_struct->packet_discard_sharp = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 640;
	ptr_struct->aeth_syndrome_ack_packet = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 704;
	ptr_struct->hba_sharp_lookup = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 768;
	ptr_struct->hba_received_pkts = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 832;
	ptr_struct->hba_received_bytes = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 896;
	ptr_struct->hba_sent_ack_packets = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 960;
	ptr_struct->rcds_sent_packets = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1024;
	ptr_struct->hba_sent_ack_bytes = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1088;
	ptr_struct->rcds_send_bytes = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1152;
	ptr_struct->hba_multi_packet_message_dropped_pkts = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1216;
	ptr_struct->hba_multi_packet_message_dropped_bytes = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void AM_PerformanceCounters_print(const struct AM_PerformanceCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_PerformanceCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_select       : " UH_FMT "\n", ptr_struct->counter_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_select2      : " UH_FMT "\n", ptr_struct->counter_select2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_sent          : " U64H_FMT "\n", ptr_struct->packet_sent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_packet_sent      : " U64H_FMT "\n", ptr_struct->ack_packet_sent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "retry_packet_sent    : " U64H_FMT "\n", ptr_struct->retry_packet_sent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_event            : " U64H_FMT "\n", ptr_struct->rnr_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timeout_event        : " U64H_FMT "\n", ptr_struct->timeout_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "oos_nack_rcv         : " U64H_FMT "\n", ptr_struct->oos_nack_rcv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_nack_rcv         : " U64H_FMT "\n", ptr_struct->rnr_nack_rcv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_discard_transport : " U64H_FMT "\n", ptr_struct->packet_discard_transport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_discard_sharp : " U64H_FMT "\n", ptr_struct->packet_discard_sharp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aeth_syndrome_ack_packet : " U64H_FMT "\n", ptr_struct->aeth_syndrome_ack_packet);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_sharp_lookup     : " U64H_FMT "\n", ptr_struct->hba_sharp_lookup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_received_pkts    : " U64H_FMT "\n", ptr_struct->hba_received_pkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_received_bytes   : " U64H_FMT "\n", ptr_struct->hba_received_bytes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_sent_ack_packets : " U64H_FMT "\n", ptr_struct->hba_sent_ack_packets);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcds_sent_packets    : " U64H_FMT "\n", ptr_struct->rcds_sent_packets);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_sent_ack_bytes   : " U64H_FMT "\n", ptr_struct->hba_sent_ack_bytes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcds_send_bytes      : " U64H_FMT "\n", ptr_struct->rcds_send_bytes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_multi_packet_message_dropped_pkts : " U64H_FMT "\n", ptr_struct->hba_multi_packet_message_dropped_pkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hba_multi_packet_message_dropped_bytes : " U64H_FMT "\n", ptr_struct->hba_multi_packet_message_dropped_bytes);

}

int AM_PerformanceCounters_size(void)
{
	 return 160;
}

void AM_PerformanceCounters_dump(const struct AM_PerformanceCounters *ptr_struct, FILE* file)
{
	AM_PerformanceCounters_print(ptr_struct, file, 0);
}

void AM_QPAllocation_pack(const struct AM_QPAllocation *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->num_of_qps);

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 1152, 1);
	qpn_pack(&(ptr_struct->qpn[i]), ptr_buff + offset/8);
	}

}

void AM_QPAllocation_unpack(struct AM_QPAllocation *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 4;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 58;
	ptr_struct->num_of_qps = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 1152, 1);
	qpn_unpack(&(ptr_struct->qpn[i]), ptr_buff + offset/8);
	}

}

void AM_QPAllocation_print(const struct AM_QPAllocation *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_QPAllocation ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : " UH_FMT "\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_qps           : " UH_FMT "\n", ptr_struct->num_of_qps);

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn_%03d:\n", i);
	qpn_print(&(ptr_struct->qpn[i]), file, indent_level + 1);
	}

}

int AM_QPAllocation_size(void)
{
	 return 144;
}

void AM_QPAllocation_dump(const struct AM_QPAllocation *ptr_struct, FILE* file)
{
	AM_QPAllocation_print(ptr_struct, file, 0);
}

void AM_QPDatabase_pack(const struct AM_QPDatabase *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->op);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->record_locator);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_rec);

	for (i = 0; i < 22; i++) {
	offset = adb2c_calc_array_field_address(128, 64, i, 1536, 1);
	qp_record_pack(&(ptr_struct->qp_record[i]), ptr_buff + offset/8);
	}

}

void AM_QPDatabase_unpack(struct AM_QPDatabase *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 2;
	ptr_struct->op = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 32;
	ptr_struct->record_locator = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->num_rec = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 22; i++) {
	offset = adb2c_calc_array_field_address(128, 64, i, 1536, 1);
	qp_record_unpack(&(ptr_struct->qp_record[i]), ptr_buff + offset/8);
	}

}

void AM_QPDatabase_print(const struct AM_QPDatabase *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_QPDatabase ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "op                   : " UH_FMT "\n", ptr_struct->op);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "record_locator       : " U32H_FMT "\n", ptr_struct->record_locator);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_rec              : " UH_FMT "\n", ptr_struct->num_rec);

	for (i = 0; i < 22; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_record_%03d:\n", i);
	qp_record_print(&(ptr_struct->qp_record[i]), file, indent_level + 1);
	}

}

int AM_QPDatabase_size(void)
{
	 return 192;
}

void AM_QPDatabase_dump(const struct AM_QPDatabase *ptr_struct, FILE* file)
{
	AM_QPDatabase_print(ptr_struct, file, 0);
}

void AM_QuotaConfig_pack(const struct AM_QuotaConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->endianness);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->r);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->job_is_reproducible);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->calc_bfloat19_en);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->calc_fp19_en);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->prevent_lock);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_ost);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->max_buffer);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_groups);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->ud_qpn);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_qps);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->key);

}

void AM_QuotaConfig_unpack(struct AM_QuotaConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 4;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1;
	ptr_struct->endianness = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->r = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 39;
	ptr_struct->job_is_reproducible = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 34;
	ptr_struct->calc_bfloat19_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 33;
	ptr_struct->calc_fp19_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->prevent_lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 80;
	ptr_struct->max_ost = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 136;
	ptr_struct->max_buffer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 208;
	ptr_struct->max_groups = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 296;
	ptr_struct->ud_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 336;
	ptr_struct->max_qps = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void AM_QuotaConfig_print(const struct AM_QuotaConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_QuotaConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : " UH_FMT "\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "endianness           : " UH_FMT "\n", ptr_struct->endianness);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "r                    : " UH_FMT "\n", ptr_struct->r);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_is_reproducible  : " UH_FMT "\n", ptr_struct->job_is_reproducible);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "calc_bfloat19_en     : " UH_FMT "\n", ptr_struct->calc_bfloat19_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "calc_fp19_en         : " UH_FMT "\n", ptr_struct->calc_fp19_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prevent_lock         : " UH_FMT "\n", ptr_struct->prevent_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_ost              : " UH_FMT "\n", ptr_struct->max_ost);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_buffer           : " UH_FMT "\n", ptr_struct->max_buffer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_groups           : " UH_FMT "\n", ptr_struct->max_groups);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ud_qpn               : " UH_FMT "\n", ptr_struct->ud_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_qps              : " UH_FMT "\n", ptr_struct->max_qps);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "key                  : " U64H_FMT "\n", ptr_struct->key);

}

int AM_QuotaConfig_size(void)
{
	 return 52;
}

void AM_QuotaConfig_dump(const struct AM_QuotaConfig *ptr_struct, FILE* file)
{
	AM_QuotaConfig_print(ptr_struct, file, 0);
}

void AM_TrapAMKeyViolation_pack(const struct AM_TrapAMKeyViolation *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->attribute_id);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->method);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->attribute_modifier);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

	offset = 103;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->multiple_violation);

	offset = 128;
	uint64bit_pack(&(ptr_struct->am_key), ptr_buff + offset/8);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(192, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(320, 32, i, 448, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->padding[i]);
	}

}

void AM_TrapAMKeyViolation_unpack(struct AM_TrapAMKeyViolation *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->attribute_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->method = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->attribute_modifier = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 104;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 103;
	ptr_struct->multiple_violation = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 128;
	uint64bit_unpack(&(ptr_struct->am_key), ptr_buff + offset/8);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(192, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(320, 32, i, 448, 1);
	ptr_struct->padding[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void AM_TrapAMKeyViolation_print(const struct AM_TrapAMKeyViolation *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TrapAMKeyViolation ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid                  : " UH_FMT "\n", ptr_struct->lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "attribute_id         : " UH_FMT "\n", ptr_struct->attribute_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "method               : " UH_FMT "\n", ptr_struct->method);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "attribute_modifier   : " U32H_FMT "\n", ptr_struct->attribute_modifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "multiple_violation   : " UH_FMT "\n", ptr_struct->multiple_violation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "am_key:\n");
	uint64bit_print(&(ptr_struct->am_key), file, indent_level + 1);

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid[i]), file, indent_level + 1);
	}

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "padding_%03d         : " U32H_FMT "\n", i, ptr_struct->padding[i]);
	}

}

int AM_TrapAMKeyViolation_size(void)
{
	 return 56;
}

void AM_TrapAMKeyViolation_dump(const struct AM_TrapAMKeyViolation *ptr_struct, FILE* file)
{
	AM_TrapAMKeyViolation_print(ptr_struct, file, 0);
}

void AM_TrapQPAllocationTime_pack(const struct AM_TrapQPAllocationTime *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_valid);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->notice_count);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->notice_toggle);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid1);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->job_id);

	offset = 160;
	GID_Block_Element_pack(&(ptr_struct->gid1), ptr_buff + offset/8);

	for (i = 0; i < 5; i++) {
	offset = adb2c_calc_array_field_address(288, 32, i, 448, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->padding[i]);
	}

}

void AM_TrapQPAllocationTime_unpack(struct AM_TrapQPAllocationTime *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->data_valid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->notice_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->notice_toggle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->lid1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->job_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 160;
	GID_Block_Element_unpack(&(ptr_struct->gid1), ptr_buff + offset/8);

	for (i = 0; i < 5; i++) {
	offset = adb2c_calc_array_field_address(288, 32, i, 448, 1);
	ptr_struct->padding[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void AM_TrapQPAllocationTime_print(const struct AM_TrapQPAllocationTime *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TrapQPAllocationTime ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_valid           : " UH_FMT "\n", ptr_struct->data_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_count         : " UH_FMT "\n", ptr_struct->notice_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_toggle        : " UH_FMT "\n", ptr_struct->notice_toggle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid1                 : " UH_FMT "\n", ptr_struct->lid1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid1:\n");
	GID_Block_Element_print(&(ptr_struct->gid1), file, indent_level + 1);

	for (i = 0; i < 5; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "padding_%03d         : " U32H_FMT "\n", i, ptr_struct->padding[i]);
	}

}

int AM_TrapQPAllocationTime_size(void)
{
	 return 56;
}

void AM_TrapQPAllocationTime_dump(const struct AM_TrapQPAllocationTime *ptr_struct, FILE* file)
{
	AM_TrapQPAllocationTime_print(ptr_struct, file, 0);
}

void AM_TrapQPAllocationTime_V2_pack(const struct AM_TrapQPAllocationTime_V2 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_valid);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->notice_count);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->notice_toggle);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid1);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

	offset = 160;
	GID_Block_Element_pack(&(ptr_struct->gid1), ptr_buff + offset/8);

	for (i = 0; i < 5; i++) {
	offset = adb2c_calc_array_field_address(288, 32, i, 448, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->padding[i]);
	}

}

void AM_TrapQPAllocationTime_V2_unpack(struct AM_TrapQPAllocationTime_V2 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->data_valid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->notice_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->notice_toggle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->lid1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 160;
	GID_Block_Element_unpack(&(ptr_struct->gid1), ptr_buff + offset/8);

	for (i = 0; i < 5; i++) {
	offset = adb2c_calc_array_field_address(288, 32, i, 448, 1);
	ptr_struct->padding[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void AM_TrapQPAllocationTime_V2_print(const struct AM_TrapQPAllocationTime_V2 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TrapQPAllocationTime_V2 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_valid           : " UH_FMT "\n", ptr_struct->data_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_count         : " UH_FMT "\n", ptr_struct->notice_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_toggle        : " UH_FMT "\n", ptr_struct->notice_toggle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid1                 : " UH_FMT "\n", ptr_struct->lid1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid1:\n");
	GID_Block_Element_print(&(ptr_struct->gid1), file, indent_level + 1);

	for (i = 0; i < 5; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "padding_%03d         : " U32H_FMT "\n", i, ptr_struct->padding[i]);
	}

}

int AM_TrapQPAllocationTime_V2_size(void)
{
	 return 56;
}

void AM_TrapQPAllocationTime_V2_dump(const struct AM_TrapQPAllocationTime_V2 *ptr_struct, FILE* file)
{
	AM_TrapQPAllocationTime_V2_print(ptr_struct, file, 0);
}

void AM_TrapQPError_pack(const struct AM_TrapQPError *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_valid);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->notice_count);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->notice_toggle);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid2);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid1);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->job_id);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp1);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->syndrom);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp2);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid1[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(288, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid2[i]), ptr_buff + offset/8);
	}

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->padding);

}

void AM_TrapQPError_unpack(struct AM_TrapQPError *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->data_valid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->notice_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->notice_toggle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->lid2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->lid1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->job_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->qp1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 96;
	ptr_struct->syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->qp2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid1[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(288, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid2[i]), ptr_buff + offset/8);
	}

	offset = 416;
	ptr_struct->padding = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void AM_TrapQPError_print(const struct AM_TrapQPError *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TrapQPError ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_valid           : " UH_FMT "\n", ptr_struct->data_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_count         : " UH_FMT "\n", ptr_struct->notice_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_toggle        : " UH_FMT "\n", ptr_struct->notice_toggle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid2                 : " UH_FMT "\n", ptr_struct->lid2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid1                 : " UH_FMT "\n", ptr_struct->lid1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp1                  : " UH_FMT "\n", ptr_struct->qp1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrom              : " UH_FMT "\n", ptr_struct->syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp2                  : " UH_FMT "\n", ptr_struct->qp2);

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid1_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid1[i]), file, indent_level + 1);
	}

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid2_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid2[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "padding              : " U32H_FMT "\n", ptr_struct->padding);

}

int AM_TrapQPError_size(void)
{
	 return 56;
}

void AM_TrapQPError_dump(const struct AM_TrapQPError *ptr_struct, FILE* file)
{
	AM_TrapQPError_print(ptr_struct, file, 0);
}

void AM_TrapQPError_V2_pack(const struct AM_TrapQPError_V2 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_valid);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->notice_count);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->notice_toggle);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid2);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid1);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp1);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->syndrom);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp2);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid1[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(288, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid2[i]), ptr_buff + offset/8);
	}

	offset = 424;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

}

void AM_TrapQPError_V2_unpack(struct AM_TrapQPError_V2 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->data_valid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->notice_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->notice_toggle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->lid2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->lid1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 104;
	ptr_struct->qp1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 96;
	ptr_struct->syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->qp2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid1[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(288, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid2[i]), ptr_buff + offset/8);
	}

	offset = 424;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void AM_TrapQPError_V2_print(const struct AM_TrapQPError_V2 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TrapQPError_V2 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_valid           : " UH_FMT "\n", ptr_struct->data_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_count         : " UH_FMT "\n", ptr_struct->notice_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_toggle        : " UH_FMT "\n", ptr_struct->notice_toggle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid2                 : " UH_FMT "\n", ptr_struct->lid2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid1                 : " UH_FMT "\n", ptr_struct->lid1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp1                  : " UH_FMT "\n", ptr_struct->qp1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrom              : " UH_FMT "\n", ptr_struct->syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp2                  : " UH_FMT "\n", ptr_struct->qp2);

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid1_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid1[i]), file, indent_level + 1);
	}

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid2_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid2[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

}

int AM_TrapQPError_V2_size(void)
{
	 return 56;
}

void AM_TrapQPError_V2_dump(const struct AM_TrapQPError_V2 *ptr_struct, FILE* file)
{
	AM_TrapQPError_V2_print(ptr_struct, file, 0);
}

void AM_TrapSharpError_pack(const struct AM_TrapSharpError *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_valid);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->notice_count);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->notice_toggle);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->syndrom);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->an_lid);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->job_id);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->group_num);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->an_gid[i]), ptr_buff + offset/8);
	}

}

void AM_TrapSharpError_unpack(struct AM_TrapSharpError *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->data_valid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->notice_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->notice_toggle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->an_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->job_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 112;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->group_num = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->an_gid[i]), ptr_buff + offset/8);
	}

}

void AM_TrapSharpError_print(const struct AM_TrapSharpError *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TrapSharpError ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_valid           : " UH_FMT "\n", ptr_struct->data_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_count         : " UH_FMT "\n", ptr_struct->notice_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_toggle        : " UH_FMT "\n", ptr_struct->notice_toggle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrom              : " UH_FMT "\n", ptr_struct->syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_lid               : " UH_FMT "\n", ptr_struct->an_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_num            : " U32H_FMT "\n", ptr_struct->group_num);

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_gid_%03d:\n", i);
	uint64bit_print(&(ptr_struct->an_gid[i]), file, indent_level + 1);
	}

}

int AM_TrapSharpError_size(void)
{
	 return 56;
}

void AM_TrapSharpError_dump(const struct AM_TrapSharpError *ptr_struct, FILE* file)
{
	AM_TrapSharpError_print(ptr_struct, file, 0);
}

void AM_TrapSharpInvalidRequest_pack(const struct AM_TrapSharpInvalidRequest *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_valid);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->notice_count);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->notice_toggle);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid2);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid1);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->job_id);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp1);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->syndrom);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp2);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid1[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(288, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid2[i]), ptr_buff + offset/8);
	}

	offset = 424;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->group_id);

}

void AM_TrapSharpInvalidRequest_unpack(struct AM_TrapSharpInvalidRequest *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->data_valid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->notice_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->notice_toggle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->lid2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->lid1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->job_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->qp1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 96;
	ptr_struct->syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->qp2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid1[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(288, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid2[i]), ptr_buff + offset/8);
	}

	offset = 424;
	ptr_struct->group_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void AM_TrapSharpInvalidRequest_print(const struct AM_TrapSharpInvalidRequest *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TrapSharpInvalidRequest ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_valid           : " UH_FMT "\n", ptr_struct->data_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_count         : " UH_FMT "\n", ptr_struct->notice_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_toggle        : " UH_FMT "\n", ptr_struct->notice_toggle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid2                 : " UH_FMT "\n", ptr_struct->lid2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid1                 : " UH_FMT "\n", ptr_struct->lid1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id               : " UH_FMT "\n", ptr_struct->job_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp1                  : " UH_FMT "\n", ptr_struct->qp1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrom              : " UH_FMT "\n", ptr_struct->syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp2                  : " UH_FMT "\n", ptr_struct->qp2);

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid1_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid1[i]), file, indent_level + 1);
	}

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid2_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid2[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_id             : " UH_FMT "\n", ptr_struct->group_id);

}

int AM_TrapSharpInvalidRequest_size(void)
{
	 return 56;
}

void AM_TrapSharpInvalidRequest_dump(const struct AM_TrapSharpInvalidRequest *ptr_struct, FILE* file)
{
	AM_TrapSharpInvalidRequest_print(ptr_struct, file, 0);
}

void AM_TrapSharpInvalidRequest_V2_pack(const struct AM_TrapSharpInvalidRequest_V2 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_valid);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->notice_count);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->notice_toggle);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid2);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid1);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->job_id_lo);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp1);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->syndrom);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp2);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->job_id_hi);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid1[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(288, 64, i, 448, 1);
	uint64bit_pack(&(ptr_struct->gid2[i]), ptr_buff + offset/8);
	}

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->group_num);

}

void AM_TrapSharpInvalidRequest_V2_unpack(struct AM_TrapSharpInvalidRequest_V2 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->data_valid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->notice_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->notice_toggle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->lid2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->lid1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->job_id_lo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 104;
	ptr_struct->qp1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 96;
	ptr_struct->syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->qp2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 128;
	ptr_struct->job_id_hi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(160, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid1[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(288, 64, i, 448, 1);
	uint64bit_unpack(&(ptr_struct->gid2[i]), ptr_buff + offset/8);
	}

	offset = 416;
	ptr_struct->group_num = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void AM_TrapSharpInvalidRequest_V2_print(const struct AM_TrapSharpInvalidRequest_V2 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TrapSharpInvalidRequest_V2 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_valid           : " UH_FMT "\n", ptr_struct->data_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_count         : " UH_FMT "\n", ptr_struct->notice_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "notice_toggle        : " UH_FMT "\n", ptr_struct->notice_toggle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid2                 : " UH_FMT "\n", ptr_struct->lid2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid1                 : " UH_FMT "\n", ptr_struct->lid1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id_lo            : " UH_FMT "\n", ptr_struct->job_id_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp1                  : " UH_FMT "\n", ptr_struct->qp1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrom              : " UH_FMT "\n", ptr_struct->syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp2                  : " UH_FMT "\n", ptr_struct->qp2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "job_id_hi            : " UH_FMT "\n", ptr_struct->job_id_hi);

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid1_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid1[i]), file, indent_level + 1);
	}

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid2_%03d:\n", i);
	uint64bit_print(&(ptr_struct->gid2[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_num            : " U32H_FMT "\n", ptr_struct->group_num);

}

int AM_TrapSharpInvalidRequest_V2_size(void)
{
	 return 56;
}

void AM_TrapSharpInvalidRequest_V2_dump(const struct AM_TrapSharpInvalidRequest_V2 *ptr_struct, FILE* file)
{
	AM_TrapSharpInvalidRequest_V2_print(ptr_struct, file, 0);
}

void AM_TreeConfig_pack(const struct AM_TreeConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tree_id);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tree_state);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->small_data_tree_id);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->log_max_streaming_op);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->streaming_lock_mode);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tree_mode);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->parent_qpn);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_of_children);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->record_locator);

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 1536, 1);
	child_qp_pack(&(ptr_struct->child_qp[i]), ptr_buff + offset/8);
	}

}

void AM_TreeConfig_unpack(struct AM_TreeConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 4;
	ptr_struct->tree_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->small_data_tree_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 44;
	ptr_struct->log_max_streaming_op = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 36;
	ptr_struct->streaming_lock_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->tree_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 72;
	ptr_struct->parent_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 120;
	ptr_struct->num_of_children = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->record_locator = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 1536, 1);
	child_qp_unpack(&(ptr_struct->child_qp[i]), ptr_buff + offset/8);
	}

}

void AM_TreeConfig_print(const struct AM_TreeConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AM_TreeConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_id              : " UH_FMT "\n", ptr_struct->tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_state           : " UH_FMT "\n", ptr_struct->tree_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : " UH_FMT "\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "small_data_tree_id   : " UH_FMT "\n", ptr_struct->small_data_tree_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_streaming_op : " UH_FMT "\n", ptr_struct->log_max_streaming_op);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "streaming_lock_mode  : " UH_FMT "\n", ptr_struct->streaming_lock_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tree_mode            : " UH_FMT "\n", ptr_struct->tree_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parent_qpn           : " UH_FMT "\n", ptr_struct->parent_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_children      : " UH_FMT "\n", ptr_struct->num_of_children);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "record_locator       : " UH_FMT "\n", ptr_struct->record_locator);

	for (i = 0; i < 44; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "child_qp_%03d:\n", i);
	child_qp_print(&(ptr_struct->child_qp[i]), file, indent_level + 1);
	}

}

int AM_TreeConfig_size(void)
{
	 return 192;
}

void AM_TreeConfig_dump(const struct AM_TreeConfig *ptr_struct, FILE* file)
{
	AM_TreeConfig_print(ptr_struct, file, 0);
}

void CACongestionEntryList_pack(const struct CACongestionEntryList *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1024, 1);
	CACongestionEntryListElement_pack(&(ptr_struct->CACongestionEntryListElement[i]), ptr_buff + offset/8);
	}

}

void CACongestionEntryList_unpack(struct CACongestionEntryList *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1024, 1);
	CACongestionEntryListElement_unpack(&(ptr_struct->CACongestionEntryListElement[i]), ptr_buff + offset/8);
	}

}

void CACongestionEntryList_print(const struct CACongestionEntryList *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CACongestionEntryList ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CACongestionEntryListElement_%03d:\n", i);
	CACongestionEntryListElement_print(&(ptr_struct->CACongestionEntryListElement[i]), file, indent_level + 1);
	}

}

int CACongestionEntryList_size(void)
{
	 return 128;
}

void CACongestionEntryList_dump(const struct CACongestionEntryList *ptr_struct, FILE* file)
{
	CACongestionEntryList_print(ptr_struct, file, 0);
}

void CCTI_Entry_List_pack(const struct CCTI_Entry_List *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 1024, 1);
	CCTI_Entry_ListElement_pack(&(ptr_struct->CCTI_Entry_ListElement[i]), ptr_buff + offset/8);
	}

}

void CCTI_Entry_List_unpack(struct CCTI_Entry_List *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 1024, 1);
	CCTI_Entry_ListElement_unpack(&(ptr_struct->CCTI_Entry_ListElement[i]), ptr_buff + offset/8);
	}

}

void CCTI_Entry_List_print(const struct CCTI_Entry_List *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CCTI_Entry_List ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CCTI_Entry_ListElement_%03d:\n", i);
	CCTI_Entry_ListElement_print(&(ptr_struct->CCTI_Entry_ListElement[i]), file, indent_level + 1);
	}

}

int CCTI_Entry_List_size(void)
{
	 return 128;
}

void CCTI_Entry_List_dump(const struct CCTI_Entry_List *ptr_struct, FILE* file)
{
	CCTI_Entry_List_print(ptr_struct, file, 0);
}

void CC_CongestionHCAAlgoConfigInfo_pack(const struct CC_CongestionHCAAlgoConfigInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	CC_CongestionHCAAlgoConfigInfoElement_pack(&(ptr_struct->info[i]), ptr_buff + offset/8);
	}

}

void CC_CongestionHCAAlgoConfigInfo_unpack(struct CC_CongestionHCAAlgoConfigInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	CC_CongestionHCAAlgoConfigInfoElement_unpack(&(ptr_struct->info[i]), ptr_buff + offset/8);
	}

}

void CC_CongestionHCAAlgoConfigInfo_print(const struct CC_CongestionHCAAlgoConfigInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCAAlgoConfigInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "info_%03d:\n", i);
	CC_CongestionHCAAlgoConfigInfoElement_print(&(ptr_struct->info[i]), file, indent_level + 1);
	}

}

int CC_CongestionHCAAlgoConfigInfo_size(void)
{
	 return 64;
}

void CC_CongestionHCAAlgoConfigInfo_dump(const struct CC_CongestionHCAAlgoConfigInfo *ptr_struct, FILE* file)
{
	CC_CongestionHCAAlgoConfigInfo_print(ptr_struct, file, 0);
}

void CC_CongestionHCAStatisticsQuery_pack(const struct CC_CongestionHCAStatisticsQuery *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clear);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->cnp_ignored);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->cnp_handled);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->marked_packets);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->cnp_sent);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->timestamp);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->accumulators_period);

}

void CC_CongestionHCAStatisticsQuery_unpack(struct CC_CongestionHCAStatisticsQuery *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->clear = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->cnp_ignored = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->cnp_handled = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->marked_packets = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->cnp_sent = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->timestamp = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 352;
	ptr_struct->accumulators_period = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void CC_CongestionHCAStatisticsQuery_print(const struct CC_CongestionHCAStatisticsQuery *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionHCAStatisticsQuery ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clear                : " UH_FMT "\n", ptr_struct->clear);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnp_ignored          : " U64H_FMT "\n", ptr_struct->cnp_ignored);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnp_handled          : " U64H_FMT "\n", ptr_struct->cnp_handled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "marked_packets       : " U64H_FMT "\n", ptr_struct->marked_packets);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnp_sent             : " U64H_FMT "\n", ptr_struct->cnp_sent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp            : " U64H_FMT "\n", ptr_struct->timestamp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "accumulators_period  : " U32H_FMT "\n", ptr_struct->accumulators_period);

}

int CC_CongestionHCAStatisticsQuery_size(void)
{
	 return 48;
}

void CC_CongestionHCAStatisticsQuery_dump(const struct CC_CongestionHCAStatisticsQuery *ptr_struct, FILE* file)
{
	CC_CongestionHCAStatisticsQuery_print(ptr_struct, file, 0);
}

void CC_CongestionKeyInfo_pack(const struct CC_CongestionKeyInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->CC_Key);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CC_KeyLeasePeriod);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->CC_KeyProtectBit);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CC_KeyViolations);

}

void CC_CongestionKeyInfo_unpack(struct CC_CongestionKeyInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->CC_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->CC_KeyLeasePeriod = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->CC_KeyProtectBit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 96;
	ptr_struct->CC_KeyViolations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CC_CongestionKeyInfo_print(const struct CC_CongestionKeyInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionKeyInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_Key               : " U64H_FMT "\n", ptr_struct->CC_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_KeyLeasePeriod    : " UH_FMT "\n", ptr_struct->CC_KeyLeasePeriod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_KeyProtectBit     : " UH_FMT "\n", ptr_struct->CC_KeyProtectBit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_KeyViolations     : " UH_FMT "\n", ptr_struct->CC_KeyViolations);

}

int CC_CongestionKeyInfo_size(void)
{
	 return 16;
}

void CC_CongestionKeyInfo_dump(const struct CC_CongestionKeyInfo *ptr_struct, FILE* file)
{
	CC_CongestionKeyInfo_print(ptr_struct, file, 0);
}

void CC_EnhancedCongestionInfo_pack(const struct CC_EnhancedCongestionInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ver1);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ver0);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->CC_Capability_Mask);

}

void CC_EnhancedCongestionInfo_unpack(struct CC_EnhancedCongestionInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 1;
	ptr_struct->ver1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->ver0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->CC_Capability_Mask = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void CC_EnhancedCongestionInfo_print(const struct CC_EnhancedCongestionInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_EnhancedCongestionInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ver1                 : " UH_FMT "\n", ptr_struct->ver1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ver0                 : " UH_FMT "\n", ptr_struct->ver0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_Capability_Mask   : " U64H_FMT "\n", ptr_struct->CC_Capability_Mask);

}

int CC_EnhancedCongestionInfo_size(void)
{
	 return 16;
}

void CC_EnhancedCongestionInfo_dump(const struct CC_EnhancedCongestionInfo *ptr_struct, FILE* file)
{
	CC_EnhancedCongestionInfo_print(ptr_struct, file, 0);
}

void CC_KeyViolation_pack(const struct CC_KeyViolation *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Method);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SourceLID);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ArrtibuteID);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->AttributeModifier);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->QP);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->CC_Key);

	offset = 192;
	GID_Block_Element_pack(&(ptr_struct->SourceGID), ptr_buff + offset/8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(344, 8, i, 448, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Padding[i]);
	}

}

void CC_KeyViolation_unpack(struct CC_KeyViolation *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->Method = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->SourceLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->ArrtibuteID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->AttributeModifier = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->QP = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 128;
	ptr_struct->CC_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	GID_Block_Element_unpack(&(ptr_struct->SourceGID), ptr_buff + offset/8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(344, 8, i, 448, 1);
	ptr_struct->Padding[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void CC_KeyViolation_print(const struct CC_KeyViolation *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_KeyViolation ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Method               : " UH_FMT "\n", ptr_struct->Method);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SourceLID            : " UH_FMT "\n", ptr_struct->SourceLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ArrtibuteID          : " UH_FMT "\n", ptr_struct->ArrtibuteID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AttributeModifier    : " U32H_FMT "\n", ptr_struct->AttributeModifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "QP                   : " UH_FMT "\n", ptr_struct->QP);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_Key               : " U64H_FMT "\n", ptr_struct->CC_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SourceGID:\n");
	GID_Block_Element_print(&(ptr_struct->SourceGID), file, indent_level + 1);

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Padding_%03d         : " UH_FMT "\n", i, ptr_struct->Padding[i]);
	}

}

int CC_KeyViolation_size(void)
{
	 return 56;
}

void CC_KeyViolation_dump(const struct CC_KeyViolation *ptr_struct, FILE* file)
{
	CC_KeyViolation_print(ptr_struct, file, 0);
}

void CC_SwitchCongestionSetting_pack(const struct CC_SwitchCongestionSetting *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	CC_SwitchCongestionSetting_Control_Map_pack(&(ptr_struct->Control_Map), ptr_buff + offset/8);

	offset = 32;
	UINT256_pack(&(ptr_struct->Victim_Mask), ptr_buff + offset/8);

	offset = 288;
	UINT256_pack(&(ptr_struct->Credit_Mask), ptr_buff + offset/8);

	offset = 560;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->CS_Threshold);

	offset = 552;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Packet_Size);

	offset = 544;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Threshold);

	offset = 592;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Marking_Rate);

	offset = 576;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CS_ReturnDelay);

}

void CC_SwitchCongestionSetting_unpack(struct CC_SwitchCongestionSetting *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	CC_SwitchCongestionSetting_Control_Map_unpack(&(ptr_struct->Control_Map), ptr_buff + offset/8);

	offset = 32;
	UINT256_unpack(&(ptr_struct->Victim_Mask), ptr_buff + offset/8);

	offset = 288;
	UINT256_unpack(&(ptr_struct->Credit_Mask), ptr_buff + offset/8);

	offset = 560;
	ptr_struct->CS_Threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 552;
	ptr_struct->Packet_Size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 544;
	ptr_struct->Threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 592;
	ptr_struct->Marking_Rate = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 576;
	ptr_struct->CS_ReturnDelay = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CC_SwitchCongestionSetting_print(const struct CC_SwitchCongestionSetting *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_SwitchCongestionSetting ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Control_Map:\n");
	CC_SwitchCongestionSetting_Control_Map_print(&(ptr_struct->Control_Map), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Victim_Mask:\n");
	UINT256_print(&(ptr_struct->Victim_Mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Credit_Mask:\n");
	UINT256_print(&(ptr_struct->Credit_Mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CS_Threshold         : " UH_FMT "\n", ptr_struct->CS_Threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Packet_Size          : " UH_FMT "\n", ptr_struct->Packet_Size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Threshold            : " UH_FMT "\n", ptr_struct->Threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Marking_Rate         : " UH_FMT "\n", ptr_struct->Marking_Rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CS_ReturnDelay       : " UH_FMT "\n", ptr_struct->CS_ReturnDelay);

}

int CC_SwitchCongestionSetting_size(void)
{
	 return 76;
}

void CC_SwitchCongestionSetting_dump(const struct CC_SwitchCongestionSetting *ptr_struct, FILE* file)
{
	CC_SwitchCongestionSetting_print(ptr_struct, file, 0);
}

void CC_SwitchPortCongestionSetting_pack(const struct CC_SwitchPortCongestionSetting *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	SwitchPortCongestionSettingElement_pack(&(ptr_struct->SwitchPortCongestionSettingElement[i]), ptr_buff + offset/8);
	}

}

void CC_SwitchPortCongestionSetting_unpack(struct CC_SwitchPortCongestionSetting *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	SwitchPortCongestionSettingElement_unpack(&(ptr_struct->SwitchPortCongestionSettingElement[i]), ptr_buff + offset/8);
	}

}

void CC_SwitchPortCongestionSetting_print(const struct CC_SwitchPortCongestionSetting *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_SwitchPortCongestionSetting ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SwitchPortCongestionSettingElement_%03d:\n", i);
	SwitchPortCongestionSettingElement_print(&(ptr_struct->SwitchPortCongestionSettingElement[i]), file, indent_level + 1);
	}

}

int CC_SwitchPortCongestionSetting_size(void)
{
	 return 128;
}

void CC_SwitchPortCongestionSetting_dump(const struct CC_SwitchPortCongestionSetting *ptr_struct, FILE* file)
{
	CC_SwitchPortCongestionSetting_print(ptr_struct, file, 0);
}

void Class_C_KeyInfo_pack(const struct Class_C_KeyInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->Key);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->KeyLeasePeriod);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->KeyProtectBit);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->NodeKeyViolations);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->KeyViolations);

}

void Class_C_KeyInfo_unpack(struct Class_C_KeyInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->KeyLeasePeriod = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->KeyProtectBit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 112;
	ptr_struct->NodeKeyViolations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->KeyViolations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void Class_C_KeyInfo_print(const struct Class_C_KeyInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== Class_C_KeyInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Key                  : " U64H_FMT "\n", ptr_struct->Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "KeyLeasePeriod       : " UH_FMT "\n", ptr_struct->KeyLeasePeriod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "KeyProtectBit        : " UH_FMT "\n", ptr_struct->KeyProtectBit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NodeKeyViolations    : " UH_FMT "\n", ptr_struct->NodeKeyViolations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "KeyViolations        : " UH_FMT "\n", ptr_struct->KeyViolations);

}

int Class_C_KeyInfo_size(void)
{
	 return 224;
}

void Class_C_KeyInfo_dump(const struct Class_C_KeyInfo *ptr_struct, FILE* file)
{
	Class_C_KeyInfo_print(ptr_struct, file, 0);
}

void CongestionEntryListSwitch_pack(const struct CongestionEntryListSwitch *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 15; i++) {
	offset = adb2c_calc_array_field_address(0, 96, i, 1440, 1);
	CongestionEntryListSwitchElement_pack(&(ptr_struct->CongestionEntryListSwitchElement[i]), ptr_buff + offset/8);
	}

}

void CongestionEntryListSwitch_unpack(struct CongestionEntryListSwitch *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 15; i++) {
	offset = adb2c_calc_array_field_address(0, 96, i, 1440, 1);
	CongestionEntryListSwitchElement_unpack(&(ptr_struct->CongestionEntryListSwitchElement[i]), ptr_buff + offset/8);
	}

}

void CongestionEntryListSwitch_print(const struct CongestionEntryListSwitch *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CongestionEntryListSwitch ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 15; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CongestionEntryListSwitchElement_%03d:\n", i);
	CongestionEntryListSwitchElement_print(&(ptr_struct->CongestionEntryListSwitchElement[i]), file, indent_level + 1);
	}

}

int CongestionEntryListSwitch_size(void)
{
	 return 180;
}

void CongestionEntryListSwitch_dump(const struct CongestionEntryListSwitch *ptr_struct, FILE* file)
{
	CongestionEntryListSwitch_print(ptr_struct, file, 0);
}

void CongestionLogEventListCA_pack(const struct CongestionLogEventListCA *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 13; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 1664, 1);
	CongestionLogEventListCAElement_pack(&(ptr_struct->CongestionLogEventListCAElement[i]), ptr_buff + offset/8);
	}

}

void CongestionLogEventListCA_unpack(struct CongestionLogEventListCA *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 13; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 1664, 1);
	CongestionLogEventListCAElement_unpack(&(ptr_struct->CongestionLogEventListCAElement[i]), ptr_buff + offset/8);
	}

}

void CongestionLogEventListCA_print(const struct CongestionLogEventListCA *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CongestionLogEventListCA ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 13; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CongestionLogEventListCAElement_%03d:\n", i);
	CongestionLogEventListCAElement_print(&(ptr_struct->CongestionLogEventListCAElement[i]), file, indent_level + 1);
	}

}

int CongestionLogEventListCA_size(void)
{
	 return 208;
}

void CongestionLogEventListCA_dump(const struct CongestionLogEventListCA *ptr_struct, FILE* file)
{
	CongestionLogEventListCA_print(ptr_struct, file, 0);
}

void DD_set_pack(const union DD_set *ptr_struct, u_int8_t* ptr_buff)
{
	DataBuffer_pack(&(ptr_struct->gen_set), ptr_buff);
}

void DD_set_unpack(union DD_set *ptr_struct, const u_int8_t* ptr_buff)
{
	DataBuffer_unpack(&(ptr_struct->gen_set), ptr_buff);
}

void DD_set_print(const union DD_set *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DD_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TransportErrorsAndFlowsV2:\n");
	VS_DC_TransportErrorsAndFlowsV2_print(&(ptr_struct->TransportErrorsAndFlowsV2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Page1LatestVersion:\n");
	VS_DC_Page1LatestVersion_print(&(ptr_struct->Page1LatestVersion), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Page255LatestVersion:\n");
	VS_DC_Page255LatestVersion_print(&(ptr_struct->Page255LatestVersion), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen_set:\n");
	DataBuffer_print(&(ptr_struct->gen_set), file, indent_level + 1);

}

int DD_set_size(void)
{
	 return 216;
}

void DD_set_dump(const union DD_set *ptr_struct, FILE* file)
{
	DD_set_print(ptr_struct, file, 0);
}

void FWInfo_Block_Element_pack(const struct FWInfo_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SubMinor);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Minor);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Major);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->secure_fw);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->signed_fw);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->debug_fw);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dev_fw);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->BuildID);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Year);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Day);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Month);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Hour);

	offset = 128;
	PSID_Block_Element_pack(&(ptr_struct->PSID), ptr_buff + offset/8);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->INI_File_Version);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Extended_Major);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Extended_Minor);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Extended_SubMinor);

	offset = 400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->isfu_major);

	offset = 446;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->life_cycle);

	offset = 445;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sec_boot);

}

void FWInfo_Block_Element_unpack(struct FWInfo_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->SubMinor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->Minor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->Major = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 7;
	ptr_struct->secure_fw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 6;
	ptr_struct->signed_fw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 5;
	ptr_struct->debug_fw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 4;
	ptr_struct->dev_fw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->BuildID = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->Year = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->Day = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->Month = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->Hour = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	PSID_Block_Element_unpack(&(ptr_struct->PSID), ptr_buff + offset/8);

	offset = 256;
	ptr_struct->INI_File_Version = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->Extended_Major = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->Extended_Minor = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->Extended_SubMinor = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 400;
	ptr_struct->isfu_major = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 446;
	ptr_struct->life_cycle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 445;
	ptr_struct->sec_boot = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void FWInfo_Block_Element_print(const struct FWInfo_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== FWInfo_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubMinor             : " UH_FMT "\n", ptr_struct->SubMinor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Minor                : " UH_FMT "\n", ptr_struct->Minor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Major                : " UH_FMT "\n", ptr_struct->Major);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "secure_fw            : " UH_FMT "\n", ptr_struct->secure_fw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signed_fw            : " UH_FMT "\n", ptr_struct->signed_fw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "debug_fw             : " UH_FMT "\n", ptr_struct->debug_fw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dev_fw               : " UH_FMT "\n", ptr_struct->dev_fw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BuildID              : " U32H_FMT "\n", ptr_struct->BuildID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Year                 : " UH_FMT "\n", ptr_struct->Year);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Day                  : " UH_FMT "\n", ptr_struct->Day);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Month                : " UH_FMT "\n", ptr_struct->Month);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Hour                 : " UH_FMT "\n", ptr_struct->Hour);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PSID:\n");
	PSID_Block_Element_print(&(ptr_struct->PSID), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "INI_File_Version     : " U32H_FMT "\n", ptr_struct->INI_File_Version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Extended_Major       : " U32H_FMT "\n", ptr_struct->Extended_Major);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Extended_Minor       : " U32H_FMT "\n", ptr_struct->Extended_Minor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Extended_SubMinor    : " U32H_FMT "\n", ptr_struct->Extended_SubMinor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "isfu_major           : " UH_FMT "\n", ptr_struct->isfu_major);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_cycle           : " UH_FMT "\n", ptr_struct->life_cycle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sec_boot             : " UH_FMT "\n", ptr_struct->sec_boot);

}

int FWInfo_Block_Element_size(void)
{
	 return 64;
}

void FWInfo_Block_Element_dump(const struct FWInfo_Block_Element *ptr_struct, FILE* file)
{
	FWInfo_Block_Element_print(ptr_struct, file, 0);
}

void GMP_AccessRegister_pack(const struct GMP_AccessRegister *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->reg_current_rev);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->reg_backward_rev);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->block);

	offset = 32;
	acc_register_gmp_pack(&(ptr_struct->reg), ptr_buff + offset/8);

}

void GMP_AccessRegister_unpack(struct GMP_AccessRegister *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->reg_current_rev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->reg_backward_rev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 12;
	ptr_struct->block = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	acc_register_gmp_unpack(&(ptr_struct->reg), ptr_buff + offset/8);

}

void GMP_AccessRegister_print(const struct GMP_AccessRegister *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== GMP_AccessRegister ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg_current_rev      : " UH_FMT "\n", ptr_struct->reg_current_rev);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg_backward_rev     : " UH_FMT "\n", ptr_struct->reg_backward_rev);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "block                : " UH_FMT "\n", ptr_struct->block);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg:\n");
	acc_register_gmp_print(&(ptr_struct->reg), file, indent_level + 1);

}

int GMP_AccessRegister_size(void)
{
	 return 224;
}

void GMP_AccessRegister_dump(const struct GMP_AccessRegister *ptr_struct, FILE* file)
{
	GMP_AccessRegister_print(ptr_struct, file, 0);
}

void GUID_Block_Element_pack(const struct GUID_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 512, 1);
	uint64bit_pack(&(ptr_struct->GUID[i]), ptr_buff + offset/8);
	}

}

void GUID_Block_Element_unpack(struct GUID_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 512, 1);
	uint64bit_unpack(&(ptr_struct->GUID[i]), ptr_buff + offset/8);
	}

}

void GUID_Block_Element_print(const struct GUID_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== GUID_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GUID_%03d:\n", i);
	uint64bit_print(&(ptr_struct->GUID[i]), file, indent_level + 1);
	}

}

int GUID_Block_Element_size(void)
{
	 return 64;
}

void GUID_Block_Element_dump(const struct GUID_Block_Element *ptr_struct, FILE* file)
{
	GUID_Block_Element_print(ptr_struct, file, 0);
}

void IB_AtomicAckETH_pack(const struct IB_AtomicAckETH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->OrigRemDt);

}

void IB_AtomicAckETH_unpack(struct IB_AtomicAckETH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->OrigRemDt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void IB_AtomicAckETH_print(const struct IB_AtomicAckETH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_AtomicAckETH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OrigRemDt            : " U64H_FMT "\n", ptr_struct->OrigRemDt);

}

int IB_AtomicAckETH_size(void)
{
	 return 8;
}

void IB_AtomicAckETH_dump(const struct IB_AtomicAckETH *ptr_struct, FILE* file)
{
	IB_AtomicAckETH_print(ptr_struct, file, 0);
}

void IB_AtomicETH_pack(const struct IB_AtomicETH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->VA);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->R_Key);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SwapDt);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->CmpDt);

}

void IB_AtomicETH_unpack(struct IB_AtomicETH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->VA = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->R_Key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->SwapDt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->CmpDt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void IB_AtomicETH_print(const struct IB_AtomicETH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_AtomicETH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VA                   : " U64H_FMT "\n", ptr_struct->VA);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "R_Key                : " U32H_FMT "\n", ptr_struct->R_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SwapDt               : " U64H_FMT "\n", ptr_struct->SwapDt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CmpDt                : " U64H_FMT "\n", ptr_struct->CmpDt);

}

int IB_AtomicETH_size(void)
{
	 return 28;
}

void IB_AtomicETH_dump(const struct IB_AtomicETH *ptr_struct, FILE* file)
{
	IB_AtomicETH_print(ptr_struct, file, 0);
}

void IB_BTH_pack(const struct IB_BTH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	P_Key_Block_Element_pack(&(ptr_struct->P_Key), ptr_buff + offset/8);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TVer);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PadCnt);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->MigReq);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SE);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->OpCode);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->DestQP);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Rsv8);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->PSN);

	offset = 65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->Rsv7);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->AckReq);

}

void IB_BTH_unpack(struct IB_BTH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	P_Key_Block_Element_unpack(&(ptr_struct->P_Key), ptr_buff + offset/8);

	offset = 12;
	ptr_struct->TVer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 10;
	ptr_struct->PadCnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 9;
	ptr_struct->MigReq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->SE = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->OpCode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->DestQP = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 32;
	ptr_struct->Rsv8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->PSN = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 65;
	ptr_struct->Rsv7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 64;
	ptr_struct->AckReq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void IB_BTH_print(const struct IB_BTH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_BTH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "P_Key:\n");
	P_Key_Block_Element_print(&(ptr_struct->P_Key), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TVer                 : " UH_FMT "\n", ptr_struct->TVer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PadCnt               : " UH_FMT "\n", ptr_struct->PadCnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MigReq               : " UH_FMT "\n", ptr_struct->MigReq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SE                   : " UH_FMT "\n", ptr_struct->SE);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OpCode               : " UH_FMT "\n", ptr_struct->OpCode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DestQP               : " UH_FMT "\n", ptr_struct->DestQP);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsv8                 : " UH_FMT "\n", ptr_struct->Rsv8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PSN                  : " UH_FMT "\n", ptr_struct->PSN);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsv7                 : " UH_FMT "\n", ptr_struct->Rsv7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AckReq               : " UH_FMT "\n", ptr_struct->AckReq);

}

int IB_BTH_size(void)
{
	 return 12;
}

void IB_BTH_dump(const struct IB_BTH *ptr_struct, FILE* file)
{
	IB_BTH_print(ptr_struct, file, 0);
}

void IB_BTH_CNP_pack(const struct IB_BTH_CNP *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	P_Key_Block_Element_pack(&(ptr_struct->P_Key), ptr_buff + offset/8);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TVer);

	offset = 10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PadCnt);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->MigReq);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->SE);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->OpCode);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->DestQP);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->Rsv6);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Becn);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Fecn);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->PSN);

	offset = 65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->Rsv7);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->AckReq);

}

void IB_BTH_CNP_unpack(struct IB_BTH_CNP *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	P_Key_Block_Element_unpack(&(ptr_struct->P_Key), ptr_buff + offset/8);

	offset = 12;
	ptr_struct->TVer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 10;
	ptr_struct->PadCnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 9;
	ptr_struct->MigReq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->SE = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->OpCode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->DestQP = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 34;
	ptr_struct->Rsv6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 33;
	ptr_struct->Becn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->Fecn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 72;
	ptr_struct->PSN = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 65;
	ptr_struct->Rsv7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 64;
	ptr_struct->AckReq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void IB_BTH_CNP_print(const struct IB_BTH_CNP *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_BTH_CNP ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "P_Key:\n");
	P_Key_Block_Element_print(&(ptr_struct->P_Key), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TVer                 : " UH_FMT "\n", ptr_struct->TVer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PadCnt               : " UH_FMT "\n", ptr_struct->PadCnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MigReq               : " UH_FMT "\n", ptr_struct->MigReq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SE                   : " UH_FMT "\n", ptr_struct->SE);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OpCode               : " UH_FMT "\n", ptr_struct->OpCode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DestQP               : " UH_FMT "\n", ptr_struct->DestQP);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsv6                 : " UH_FMT "\n", ptr_struct->Rsv6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Becn                 : " UH_FMT "\n", ptr_struct->Becn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Fecn                 : " UH_FMT "\n", ptr_struct->Fecn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PSN                  : " UH_FMT "\n", ptr_struct->PSN);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rsv7                 : " UH_FMT "\n", ptr_struct->Rsv7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AckReq               : " UH_FMT "\n", ptr_struct->AckReq);

}

int IB_BTH_CNP_size(void)
{
	 return 12;
}

void IB_BTH_CNP_dump(const struct IB_BTH_CNP *ptr_struct, FILE* file)
{
	IB_BTH_CNP_print(ptr_struct, file, 0);
}

void IB_ClassPortInfo_pack(const struct IB_ClassPortInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CapMsk);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ClassVersion);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->BaseVersion);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->RespTimeValue);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 27, (u_int32_t)ptr_struct->CapMsk2);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(64, 64, i, 576, 1);
	uint64bit_pack(&(ptr_struct->RedirectGID[i]), ptr_buff + offset/8);
	}

	offset = 204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->RedirectFL);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->RedirectSL);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->RedirectTC);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->RedirectPKey);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->RedirectLID);

	offset = 264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->RedirectQP);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->RedirectQKey);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(320, 32, i, 576, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TrapGID[i]);
	}

	offset = 460;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->TrapFL);

	offset = 456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TrapSL);

	offset = 448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TrapTC);

	offset = 496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->TrapPKey);

	offset = 480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->TrapLID);

	offset = 520;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->TrapQP);

	offset = 512;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TrapHL);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TrapQKey);

}

void IB_ClassPortInfo_unpack(struct IB_ClassPortInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->CapMsk = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->ClassVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->BaseVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 59;
	ptr_struct->RespTimeValue = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 32;
	ptr_struct->CapMsk2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 27);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(64, 64, i, 576, 1);
	uint64bit_unpack(&(ptr_struct->RedirectGID[i]), ptr_buff + offset/8);
	}

	offset = 204;
	ptr_struct->RedirectFL = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 200;
	ptr_struct->RedirectSL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->RedirectTC = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->RedirectPKey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->RedirectLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 264;
	ptr_struct->RedirectQP = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 288;
	ptr_struct->RedirectQKey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(320, 32, i, 576, 1);
	ptr_struct->TrapGID[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 460;
	ptr_struct->TrapFL = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 456;
	ptr_struct->TrapSL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->TrapTC = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 496;
	ptr_struct->TrapPKey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 480;
	ptr_struct->TrapLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 520;
	ptr_struct->TrapQP = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 512;
	ptr_struct->TrapHL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 544;
	ptr_struct->TrapQKey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void IB_ClassPortInfo_print(const struct IB_ClassPortInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_ClassPortInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CapMsk               : " UH_FMT "\n", ptr_struct->CapMsk);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClassVersion         : " UH_FMT "\n", ptr_struct->ClassVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BaseVersion          : " UH_FMT "\n", ptr_struct->BaseVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RespTimeValue        : " UH_FMT "\n", ptr_struct->RespTimeValue);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CapMsk2              : " UH_FMT "\n", ptr_struct->CapMsk2);

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RedirectGID_%03d:\n", i);
	uint64bit_print(&(ptr_struct->RedirectGID[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RedirectFL           : " UH_FMT "\n", ptr_struct->RedirectFL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RedirectSL           : " UH_FMT "\n", ptr_struct->RedirectSL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RedirectTC           : " UH_FMT "\n", ptr_struct->RedirectTC);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RedirectPKey         : " UH_FMT "\n", ptr_struct->RedirectPKey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RedirectLID          : " UH_FMT "\n", ptr_struct->RedirectLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RedirectQP           : " UH_FMT "\n", ptr_struct->RedirectQP);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RedirectQKey         : " U32H_FMT "\n", ptr_struct->RedirectQKey);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapGID_%03d         : " U32H_FMT "\n", i, ptr_struct->TrapGID[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapFL               : " UH_FMT "\n", ptr_struct->TrapFL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapSL               : " UH_FMT "\n", ptr_struct->TrapSL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapTC               : " UH_FMT "\n", ptr_struct->TrapTC);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapPKey             : " UH_FMT "\n", ptr_struct->TrapPKey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapLID              : " UH_FMT "\n", ptr_struct->TrapLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapQP               : " UH_FMT "\n", ptr_struct->TrapQP);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapHL               : " UH_FMT "\n", ptr_struct->TrapHL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapQKey             : " U32H_FMT "\n", ptr_struct->TrapQKey);

}

int IB_ClassPortInfo_size(void)
{
	 return 72;
}

void IB_ClassPortInfo_dump(const struct IB_ClassPortInfo *ptr_struct, FILE* file)
{
	IB_ClassPortInfo_print(ptr_struct, file, 0);
}

void IB_GRH_pack(const struct IB_GRH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->FlowLabel);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TClass);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->IPVer);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HopLmt);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NxtHdr);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PayLen);

	offset = 64;
	GID_Block_Element_pack(&(ptr_struct->SGID), ptr_buff + offset/8);

	offset = 192;
	GID_Block_Element_pack(&(ptr_struct->DGID), ptr_buff + offset/8);

}

void IB_GRH_unpack(struct IB_GRH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	ptr_struct->FlowLabel = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 4;
	ptr_struct->TClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->IPVer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->HopLmt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->NxtHdr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->PayLen = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	GID_Block_Element_unpack(&(ptr_struct->SGID), ptr_buff + offset/8);

	offset = 192;
	GID_Block_Element_unpack(&(ptr_struct->DGID), ptr_buff + offset/8);

}

void IB_GRH_print(const struct IB_GRH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_GRH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FlowLabel            : " UH_FMT "\n", ptr_struct->FlowLabel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TClass               : " UH_FMT "\n", ptr_struct->TClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IPVer                : " UH_FMT "\n", ptr_struct->IPVer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HopLmt               : " UH_FMT "\n", ptr_struct->HopLmt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NxtHdr               : " UH_FMT "\n", ptr_struct->NxtHdr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PayLen               : " UH_FMT "\n", ptr_struct->PayLen);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SGID:\n");
	GID_Block_Element_print(&(ptr_struct->SGID), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DGID:\n");
	GID_Block_Element_print(&(ptr_struct->DGID), file, indent_level + 1);

}

int IB_GRH_size(void)
{
	 return 40;
}

void IB_GRH_dump(const struct IB_GRH *ptr_struct, FILE* file)
{
	IB_GRH_print(ptr_struct, file, 0);
}

void IB_RETH_pack(const struct IB_RETH *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->VA);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->R_Key);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->DMALen);

}

void IB_RETH_unpack(struct IB_RETH *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->VA = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->R_Key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->DMALen = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void IB_RETH_print(const struct IB_RETH *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== IB_RETH ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VA                   : " U64H_FMT "\n", ptr_struct->VA);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "R_Key                : " U32H_FMT "\n", ptr_struct->R_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DMALen               : " U32H_FMT "\n", ptr_struct->DMALen);

}

int IB_RETH_size(void)
{
	 return 16;
}

void IB_RETH_dump(const struct IB_RETH *ptr_struct, FILE* file)
{
	IB_RETH_print(ptr_struct, file, 0);
}

void MAD_Header_Common_pack(const struct MAD_Header_Common *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Method);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ClassVersion);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MgmtClass);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->BaseVersion);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ClassSpecific);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Status);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->TID_Block_Element);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->AdditionalStatus);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->AttributeID);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->AttributeModifier);

}

void MAD_Header_Common_unpack(struct MAD_Header_Common *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->Method = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->ClassVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->MgmtClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->BaseVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ClassSpecific = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->Status = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->TID_Block_Element = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->AdditionalStatus = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->AttributeID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->AttributeModifier = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void MAD_Header_Common_print(const struct MAD_Header_Common *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_Header_Common ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Method               : " UH_FMT "\n", ptr_struct->Method);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClassVersion         : " UH_FMT "\n", ptr_struct->ClassVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MgmtClass            : " UH_FMT "\n", ptr_struct->MgmtClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BaseVersion          : " UH_FMT "\n", ptr_struct->BaseVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClassSpecific        : " UH_FMT "\n", ptr_struct->ClassSpecific);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Status               : " UH_FMT "\n", ptr_struct->Status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TID_Block_Element    : " U64H_FMT "\n", ptr_struct->TID_Block_Element);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdditionalStatus     : " UH_FMT "\n", ptr_struct->AdditionalStatus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AttributeID          : " UH_FMT "\n", ptr_struct->AttributeID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AttributeModifier    : " U32H_FMT "\n", ptr_struct->AttributeModifier);

}

int MAD_Header_Common_size(void)
{
	 return 24;
}

void MAD_Header_Common_dump(const struct MAD_Header_Common *ptr_struct, FILE* file)
{
	MAD_Header_Common_print(ptr_struct, file, 0);
}

void MAD_Header_Common_With_RMPP_pack(const struct MAD_Header_Common_With_RMPP *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Method);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ClassVersion);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MgmtClass);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->BaseVersion);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ClassSpecific);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Status);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->TID_Block_Element);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->AdditionalStatus);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->AttributeID);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->AttributeModifier);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->RMPPStatus);

	offset = 212;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->RMPPFlags);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->RRespTime);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->RMPPType);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->RMPPVersion);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Data1);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Data2);

}

void MAD_Header_Common_With_RMPP_unpack(struct MAD_Header_Common_With_RMPP *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->Method = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->ClassVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->MgmtClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->BaseVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ClassSpecific = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->Status = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->TID_Block_Element = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->AdditionalStatus = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->AttributeID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->AttributeModifier = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 216;
	ptr_struct->RMPPStatus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 212;
	ptr_struct->RMPPFlags = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 208;
	ptr_struct->RRespTime = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 200;
	ptr_struct->RMPPType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->RMPPVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->Data1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->Data2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void MAD_Header_Common_With_RMPP_print(const struct MAD_Header_Common_With_RMPP *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_Header_Common_With_RMPP ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Method               : " UH_FMT "\n", ptr_struct->Method);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClassVersion         : " UH_FMT "\n", ptr_struct->ClassVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MgmtClass            : " UH_FMT "\n", ptr_struct->MgmtClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BaseVersion          : " UH_FMT "\n", ptr_struct->BaseVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClassSpecific        : " UH_FMT "\n", ptr_struct->ClassSpecific);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Status               : " UH_FMT "\n", ptr_struct->Status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TID_Block_Element    : " U64H_FMT "\n", ptr_struct->TID_Block_Element);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdditionalStatus     : " UH_FMT "\n", ptr_struct->AdditionalStatus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AttributeID          : " UH_FMT "\n", ptr_struct->AttributeID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AttributeModifier    : " U32H_FMT "\n", ptr_struct->AttributeModifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RMPPStatus           : " UH_FMT "\n", ptr_struct->RMPPStatus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RMPPFlags            : " UH_FMT "\n", ptr_struct->RMPPFlags);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RRespTime            : " UH_FMT "\n", ptr_struct->RRespTime);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RMPPType             : %s (" UH_FMT ")\n", (ptr_struct->RMPPType == 0 ? ("NOT_RMPP_PKT") : ((ptr_struct->RMPPType == 1 ? ("DATA_PKT") : ((ptr_struct->RMPPType == 2 ? ("ACK_PKT") : ((ptr_struct->RMPPType == 3 ? ("STOP_PKT") : ((ptr_struct->RMPPType == 4 ? ("ABORT_PKT") : ("unknown")))))))))), ptr_struct->RMPPType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RMPPVersion          : " UH_FMT "\n", ptr_struct->RMPPVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data1                : " U32H_FMT "\n", ptr_struct->Data1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data2                : " U32H_FMT "\n", ptr_struct->Data2);

}

int MAD_Header_Common_With_RMPP_size(void)
{
	 return 36;
}

void MAD_Header_Common_With_RMPP_dump(const struct MAD_Header_Common_With_RMPP *ptr_struct, FILE* file)
{
	MAD_Header_Common_With_RMPP_print(ptr_struct, file, 0);
}

void MAD_Header_SMP_Direct_Routed_pack(const struct MAD_Header_SMP_Direct_Routed *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Method);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ClassVersion);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MgmtClass);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->BaseVersion);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HopCounter);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HopPointer);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->Status);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->D);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->TID_Block_Element);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->AdditionalStatus);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->AttributeID);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->AttributeModifier);

}

void MAD_Header_SMP_Direct_Routed_unpack(struct MAD_Header_SMP_Direct_Routed *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->Method = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->ClassVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->MgmtClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->BaseVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->HopCounter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->HopPointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 33;
	ptr_struct->Status = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 32;
	ptr_struct->D = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->TID_Block_Element = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->AdditionalStatus = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->AttributeID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->AttributeModifier = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void MAD_Header_SMP_Direct_Routed_print(const struct MAD_Header_SMP_Direct_Routed *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_Header_SMP_Direct_Routed ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Method               : " UH_FMT "\n", ptr_struct->Method);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClassVersion         : " UH_FMT "\n", ptr_struct->ClassVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MgmtClass            : " UH_FMT "\n", ptr_struct->MgmtClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BaseVersion          : " UH_FMT "\n", ptr_struct->BaseVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HopCounter           : " UH_FMT "\n", ptr_struct->HopCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HopPointer           : " UH_FMT "\n", ptr_struct->HopPointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Status               : " UH_FMT "\n", ptr_struct->Status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "D                    : " UH_FMT "\n", ptr_struct->D);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TID_Block_Element    : " U64H_FMT "\n", ptr_struct->TID_Block_Element);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdditionalStatus     : " UH_FMT "\n", ptr_struct->AdditionalStatus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AttributeID          : " UH_FMT "\n", ptr_struct->AttributeID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AttributeModifier    : " U32H_FMT "\n", ptr_struct->AttributeModifier);

}

int MAD_Header_SMP_Direct_Routed_size(void)
{
	 return 24;
}

void MAD_Header_SMP_Direct_Routed_dump(const struct MAD_Header_SMP_Direct_Routed *ptr_struct, FILE* file)
{
	MAD_Header_SMP_Direct_Routed_print(ptr_struct, file, 0);
}

void NVLReductionCounters_pack(const struct NVLReductionCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->port_select);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lean_pipe_select);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mlid);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->counter_select);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->incoming_good_mc_read_req_pkt);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->incoming_good_mc_read_req_data);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->incoming_good_mc_write_req_pkt);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->incoming_good_mc_write_req_data);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->incoming_good_mc_read_resp_pkt);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->incoming_good_mc_read_resp_data);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->incoming_good_mc_write_resp_pkt);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->incoming_good_mc_write_resp_data);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->generated_mc_read_resp_pkt);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->generated_mc_read_resp_data);

	offset = 768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->generated_mc_write_resp_pkt);

	offset = 832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->generated_mc_write_resp_data);

	offset = 896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->dropped_pkt);

	offset = 960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->trapped_pkt);

	offset = 1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->nvl_reduction_errors);

	offset = 1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->nvl_reduction_penalty_box_errors);

	offset = 1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_nvr_local_alm_id_allocations);

	offset = 1216;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_nvr_global_alm_id_allocations);

}

void NVLReductionCounters_unpack(struct NVLReductionCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->port_select = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 12;
	ptr_struct->lean_pipe_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->mlid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->counter_select = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->incoming_good_mc_read_req_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->incoming_good_mc_read_req_data = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->incoming_good_mc_write_req_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->incoming_good_mc_write_req_data = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 384;
	ptr_struct->incoming_good_mc_read_resp_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 448;
	ptr_struct->incoming_good_mc_read_resp_data = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 512;
	ptr_struct->incoming_good_mc_write_resp_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 576;
	ptr_struct->incoming_good_mc_write_resp_data = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 640;
	ptr_struct->generated_mc_read_resp_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 704;
	ptr_struct->generated_mc_read_resp_data = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 768;
	ptr_struct->generated_mc_write_resp_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 832;
	ptr_struct->generated_mc_write_resp_data = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 896;
	ptr_struct->dropped_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 960;
	ptr_struct->trapped_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1024;
	ptr_struct->nvl_reduction_errors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1088;
	ptr_struct->nvl_reduction_penalty_box_errors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1152;
	ptr_struct->port_nvr_local_alm_id_allocations = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1216;
	ptr_struct->port_nvr_global_alm_id_allocations = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void NVLReductionCounters_print(const struct NVLReductionCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NVLReductionCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_select          : " UH_FMT "\n", ptr_struct->port_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lean_pipe_select     : " UH_FMT "\n", ptr_struct->lean_pipe_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlid                 : " UH_FMT "\n", ptr_struct->mlid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_select       : " U32H_FMT "\n", ptr_struct->counter_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "incoming_good_mc_read_req_pkt : " U64H_FMT "\n", ptr_struct->incoming_good_mc_read_req_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "incoming_good_mc_read_req_data : " U64H_FMT "\n", ptr_struct->incoming_good_mc_read_req_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "incoming_good_mc_write_req_pkt : " U64H_FMT "\n", ptr_struct->incoming_good_mc_write_req_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "incoming_good_mc_write_req_data : " U64H_FMT "\n", ptr_struct->incoming_good_mc_write_req_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "incoming_good_mc_read_resp_pkt : " U64H_FMT "\n", ptr_struct->incoming_good_mc_read_resp_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "incoming_good_mc_read_resp_data : " U64H_FMT "\n", ptr_struct->incoming_good_mc_read_resp_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "incoming_good_mc_write_resp_pkt : " U64H_FMT "\n", ptr_struct->incoming_good_mc_write_resp_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "incoming_good_mc_write_resp_data : " U64H_FMT "\n", ptr_struct->incoming_good_mc_write_resp_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "generated_mc_read_resp_pkt : " U64H_FMT "\n", ptr_struct->generated_mc_read_resp_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "generated_mc_read_resp_data : " U64H_FMT "\n", ptr_struct->generated_mc_read_resp_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "generated_mc_write_resp_pkt : " U64H_FMT "\n", ptr_struct->generated_mc_write_resp_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "generated_mc_write_resp_data : " U64H_FMT "\n", ptr_struct->generated_mc_write_resp_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dropped_pkt          : " U64H_FMT "\n", ptr_struct->dropped_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trapped_pkt          : " U64H_FMT "\n", ptr_struct->trapped_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nvl_reduction_errors : " U64H_FMT "\n", ptr_struct->nvl_reduction_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nvl_reduction_penalty_box_errors : " U64H_FMT "\n", ptr_struct->nvl_reduction_penalty_box_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_nvr_local_alm_id_allocations : " U64H_FMT "\n", ptr_struct->port_nvr_local_alm_id_allocations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_nvr_global_alm_id_allocations : " U64H_FMT "\n", ptr_struct->port_nvr_global_alm_id_allocations);

}

int NVLReductionCounters_size(void)
{
	 return 164;
}

void NVLReductionCounters_dump(const struct NVLReductionCounters *ptr_struct, FILE* file)
{
	NVLReductionCounters_print(ptr_struct, file, 0);
}

void NextHopRecord_pack(const struct NextHopRecord *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubnetPrefix);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Pkey);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Weight);

}

void NextHopRecord_unpack(struct NextHopRecord *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->SubnetPrefix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->Pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->Weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void NextHopRecord_print(const struct NextHopRecord *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NextHopRecord ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubnetPrefix         : " U64H_FMT "\n", ptr_struct->SubnetPrefix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Pkey                 : " UH_FMT "\n", ptr_struct->Pkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Weight               : " UH_FMT "\n", ptr_struct->Weight);

}

int NextHopRecord_size(void)
{
	 return 16;
}

void NextHopRecord_dump(const struct NextHopRecord *ptr_struct, FILE* file)
{
	NextHopRecord_print(ptr_struct, file, 0);
}

void PM_PortCounters_pack(const struct PM_PortCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	PortCounters_Mask_Block_Element_pack(&(ptr_struct->CounterSelect), ptr_buff + offset/8);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved0);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkDownedCounter);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkErrorRecoveryCounter);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SymbolErrorCounter);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortRcvRemotePhysicalErrors);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortRcvErrors);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortXmitDiscards);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortRcvSwitchRelayErrors);

	offset = 156;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ExcessiveBufferOverrunErrors);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LocalLinkIntegrityErrors);

	offset = 144;
	PortCounters_Mask2_Block_Element_pack(&(ptr_struct->CounterSelect2), ptr_buff + offset/8);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortRcvConstraintErrors);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortXmitConstraintErrors);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->VL15Dropped);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Reserved2);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortXmitData);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortRcvData);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortXmitPkts);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortRcvPkts);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortXmitWait);

}

void PM_PortCounters_unpack(struct PM_PortCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	PortCounters_Mask_Block_Element_unpack(&(ptr_struct->CounterSelect), ptr_buff + offset/8);

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->Reserved0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->LinkDownedCounter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->LinkErrorRecoveryCounter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->SymbolErrorCounter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->PortRcvRemotePhysicalErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->PortRcvErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->PortXmitDiscards = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->PortRcvSwitchRelayErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 156;
	ptr_struct->ExcessiveBufferOverrunErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 152;
	ptr_struct->LocalLinkIntegrityErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 144;
	PortCounters_Mask2_Block_Element_unpack(&(ptr_struct->CounterSelect2), ptr_buff + offset/8);

	offset = 136;
	ptr_struct->PortRcvConstraintErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->PortXmitConstraintErrors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->VL15Dropped = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->Reserved2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->PortXmitData = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->PortRcvData = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->PortXmitPkts = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->PortRcvPkts = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->PortXmitWait = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void PM_PortCounters_print(const struct PM_PortCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect:\n");
	PortCounters_Mask_Block_Element_print(&(ptr_struct->CounterSelect), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved0            : " UH_FMT "\n", ptr_struct->Reserved0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkDownedCounter    : " UH_FMT "\n", ptr_struct->LinkDownedCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkErrorRecoveryCounter : " UH_FMT "\n", ptr_struct->LinkErrorRecoveryCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SymbolErrorCounter   : " UH_FMT "\n", ptr_struct->SymbolErrorCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvRemotePhysicalErrors : " UH_FMT "\n", ptr_struct->PortRcvRemotePhysicalErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvErrors        : " UH_FMT "\n", ptr_struct->PortRcvErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDiscards     : " UH_FMT "\n", ptr_struct->PortXmitDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvSwitchRelayErrors : " UH_FMT "\n", ptr_struct->PortRcvSwitchRelayErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ExcessiveBufferOverrunErrors : " UH_FMT "\n", ptr_struct->ExcessiveBufferOverrunErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LocalLinkIntegrityErrors : " UH_FMT "\n", ptr_struct->LocalLinkIntegrityErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect2:\n");
	PortCounters_Mask2_Block_Element_print(&(ptr_struct->CounterSelect2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvConstraintErrors : " UH_FMT "\n", ptr_struct->PortRcvConstraintErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitConstraintErrors : " UH_FMT "\n", ptr_struct->PortXmitConstraintErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL15Dropped          : " UH_FMT "\n", ptr_struct->VL15Dropped);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved2            : " UH_FMT "\n", ptr_struct->Reserved2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitData         : " U32H_FMT "\n", ptr_struct->PortXmitData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvData          : " U32H_FMT "\n", ptr_struct->PortRcvData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitPkts         : " U32H_FMT "\n", ptr_struct->PortXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvPkts          : " U32H_FMT "\n", ptr_struct->PortRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitWait         : " U32H_FMT "\n", ptr_struct->PortXmitWait);

}

int PM_PortCounters_size(void)
{
	 return 44;
}

void PM_PortCounters_dump(const struct PM_PortCounters *ptr_struct, FILE* file)
{
	PM_PortCounters_print(ptr_struct, file, 0);
}

void PM_PortCountersExtended_pack(const struct PM_PortCountersExtended *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	PortCountersExtended_Mask_Block_Element_pack(&(ptr_struct->CounterSelect), ptr_buff + offset/8);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved0);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->CounterSelect2);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortXmitData);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvData);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortXmitPkts);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvPkts);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortUniCastXmitPkts);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortUniCastRcvPkts);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortMultiCastXmitPkts);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortMultiCastRcvPkts);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SymbolErrorCounter);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->LinkErrorRecoveryCounter);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->LinkDownedCounter);

	offset = 768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvErrors);

	offset = 832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvRemotePhysicalErrors);

	offset = 896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvSwitchRelayErrors);

	offset = 960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortXmitDiscards);

	offset = 1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortXmitConstraintErrors);

	offset = 1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvConstraintErrors);

	offset = 1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->LocalLinkIntegrityErrors);

	offset = 1216;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ExcessiveBufferOverrunErrors);

	offset = 1280;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->VL15Dropped);

	offset = 1344;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortXmitWait);

	offset = 1408;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->QP1Dropped);

}

void PM_PortCountersExtended_unpack(struct PM_PortCountersExtended *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	PortCountersExtended_Mask_Block_Element_unpack(&(ptr_struct->CounterSelect), ptr_buff + offset/8);

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->Reserved0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->CounterSelect2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->PortXmitData = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->PortRcvData = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->PortXmitPkts = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->PortRcvPkts = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->PortUniCastXmitPkts = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 384;
	ptr_struct->PortUniCastRcvPkts = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 448;
	ptr_struct->PortMultiCastXmitPkts = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 512;
	ptr_struct->PortMultiCastRcvPkts = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 576;
	ptr_struct->SymbolErrorCounter = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 640;
	ptr_struct->LinkErrorRecoveryCounter = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 704;
	ptr_struct->LinkDownedCounter = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 768;
	ptr_struct->PortRcvErrors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 832;
	ptr_struct->PortRcvRemotePhysicalErrors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 896;
	ptr_struct->PortRcvSwitchRelayErrors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 960;
	ptr_struct->PortXmitDiscards = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1024;
	ptr_struct->PortXmitConstraintErrors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1088;
	ptr_struct->PortRcvConstraintErrors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1152;
	ptr_struct->LocalLinkIntegrityErrors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1216;
	ptr_struct->ExcessiveBufferOverrunErrors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1280;
	ptr_struct->VL15Dropped = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1344;
	ptr_struct->PortXmitWait = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1408;
	ptr_struct->QP1Dropped = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void PM_PortCountersExtended_print(const struct PM_PortCountersExtended *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortCountersExtended ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect:\n");
	PortCountersExtended_Mask_Block_Element_print(&(ptr_struct->CounterSelect), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved0            : " UH_FMT "\n", ptr_struct->Reserved0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect2       : " U32H_FMT "\n", ptr_struct->CounterSelect2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitData         : " U64H_FMT "\n", ptr_struct->PortXmitData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvData          : " U64H_FMT "\n", ptr_struct->PortRcvData);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitPkts         : " U64H_FMT "\n", ptr_struct->PortXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvPkts          : " U64H_FMT "\n", ptr_struct->PortRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortUniCastXmitPkts  : " U64H_FMT "\n", ptr_struct->PortUniCastXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortUniCastRcvPkts   : " U64H_FMT "\n", ptr_struct->PortUniCastRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMultiCastXmitPkts : " U64H_FMT "\n", ptr_struct->PortMultiCastXmitPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMultiCastRcvPkts : " U64H_FMT "\n", ptr_struct->PortMultiCastRcvPkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SymbolErrorCounter   : " U64H_FMT "\n", ptr_struct->SymbolErrorCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkErrorRecoveryCounter : " U64H_FMT "\n", ptr_struct->LinkErrorRecoveryCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkDownedCounter    : " U64H_FMT "\n", ptr_struct->LinkDownedCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvErrors        : " U64H_FMT "\n", ptr_struct->PortRcvErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvRemotePhysicalErrors : " U64H_FMT "\n", ptr_struct->PortRcvRemotePhysicalErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvSwitchRelayErrors : " U64H_FMT "\n", ptr_struct->PortRcvSwitchRelayErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitDiscards     : " U64H_FMT "\n", ptr_struct->PortXmitDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitConstraintErrors : " U64H_FMT "\n", ptr_struct->PortXmitConstraintErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvConstraintErrors : " U64H_FMT "\n", ptr_struct->PortRcvConstraintErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LocalLinkIntegrityErrors : " U64H_FMT "\n", ptr_struct->LocalLinkIntegrityErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ExcessiveBufferOverrunErrors : " U64H_FMT "\n", ptr_struct->ExcessiveBufferOverrunErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL15Dropped          : " U64H_FMT "\n", ptr_struct->VL15Dropped);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitWait         : " U64H_FMT "\n", ptr_struct->PortXmitWait);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "QP1Dropped           : " U64H_FMT "\n", ptr_struct->QP1Dropped);

}

int PM_PortCountersExtended_size(void)
{
	 return 184;
}

void PM_PortCountersExtended_dump(const struct PM_PortCountersExtended *ptr_struct, FILE* file)
{
	PM_PortCountersExtended_print(ptr_struct, file, 0);
}

void PM_PortExtendedSpeedsCounters_pack(const struct PM_PortExtendedSpeedsCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->CounterSelect);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->UnknownBlockCounter);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SyncHeaderErrorCounter);

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(176, 16, i, 1120, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ErrorDetectionCounterLane[i]);
	}

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(352, 32, i, 1120, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->FECCorrectableBlockCountrLane[i]);
	}

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(736, 32, i, 1120, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->FECUncorrectableBlockCounterLane[i]);
	}

}

void PM_PortExtendedSpeedsCounters_unpack(struct PM_PortExtendedSpeedsCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->CounterSelect = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->UnknownBlockCounter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->SyncHeaderErrorCounter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(176, 16, i, 1120, 1);
	ptr_struct->ErrorDetectionCounterLane[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(352, 32, i, 1120, 1);
	ptr_struct->FECCorrectableBlockCountrLane[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(736, 32, i, 1120, 1);
	ptr_struct->FECUncorrectableBlockCounterLane[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void PM_PortExtendedSpeedsCounters_print(const struct PM_PortExtendedSpeedsCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortExtendedSpeedsCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect        : " U64H_FMT "\n", ptr_struct->CounterSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "UnknownBlockCounter  : " UH_FMT "\n", ptr_struct->UnknownBlockCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SyncHeaderErrorCounter : " UH_FMT "\n", ptr_struct->SyncHeaderErrorCounter);

	for (i = 0; i < 12; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ErrorDetectionCounterLane_%03d : " UH_FMT "\n", i, ptr_struct->ErrorDetectionCounterLane[i]);
	}

	for (i = 0; i < 12; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FECCorrectableBlockCountrLane_%03d : " U32H_FMT "\n", i, ptr_struct->FECCorrectableBlockCountrLane[i]);
	}

	for (i = 0; i < 12; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FECUncorrectableBlockCounterLane_%03d : " U32H_FMT "\n", i, ptr_struct->FECUncorrectableBlockCounterLane[i]);
	}

}

int PM_PortExtendedSpeedsCounters_size(void)
{
	 return 140;
}

void PM_PortExtendedSpeedsCounters_dump(const struct PM_PortExtendedSpeedsCounters *ptr_struct, FILE* file)
{
	PM_PortExtendedSpeedsCounters_print(ptr_struct, file, 0);
}

void PM_PortExtendedSpeedsRSFECCounters_pack(const struct PM_PortExtendedSpeedsRSFECCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->CounterSelect);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->UnknownBlockCounter);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SyncHeaderErrorCounter);

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(352, 32, i, 1216, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->FECCorrectedSymbolCounterLane[i]);
	}

	offset = 1120;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortFECCorrectableBlockCounter);

	offset = 1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortFECUncorrectableBlockCounter);

	offset = 1184;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortFECCorrectedSymbolCounter);

}

void PM_PortExtendedSpeedsRSFECCounters_unpack(struct PM_PortExtendedSpeedsRSFECCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->CounterSelect = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->UnknownBlockCounter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->SyncHeaderErrorCounter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(352, 32, i, 1216, 1);
	ptr_struct->FECCorrectedSymbolCounterLane[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 1120;
	ptr_struct->PortFECCorrectableBlockCounter = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1152;
	ptr_struct->PortFECUncorrectableBlockCounter = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1184;
	ptr_struct->PortFECCorrectedSymbolCounter = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void PM_PortExtendedSpeedsRSFECCounters_print(const struct PM_PortExtendedSpeedsRSFECCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortExtendedSpeedsRSFECCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect        : " U64H_FMT "\n", ptr_struct->CounterSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "UnknownBlockCounter  : " UH_FMT "\n", ptr_struct->UnknownBlockCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SyncHeaderErrorCounter : " UH_FMT "\n", ptr_struct->SyncHeaderErrorCounter);

	for (i = 0; i < 12; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FECCorrectedSymbolCounterLane_%03d : " U32H_FMT "\n", i, ptr_struct->FECCorrectedSymbolCounterLane[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortFECCorrectableBlockCounter : " U32H_FMT "\n", ptr_struct->PortFECCorrectableBlockCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortFECUncorrectableBlockCounter : " U32H_FMT "\n", ptr_struct->PortFECUncorrectableBlockCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortFECCorrectedSymbolCounter : " U32H_FMT "\n", ptr_struct->PortFECCorrectedSymbolCounter);

}

int PM_PortExtendedSpeedsRSFECCounters_size(void)
{
	 return 152;
}

void PM_PortExtendedSpeedsRSFECCounters_dump(const struct PM_PortExtendedSpeedsRSFECCounters *ptr_struct, FILE* file)
{
	PM_PortExtendedSpeedsRSFECCounters_print(ptr_struct, file, 0);
}

void PM_PortRcvErrorDetails_pack(const struct PM_PortRcvErrorDetails *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	PortRcvErrorDetails_Mask_Block_Element_pack(&(ptr_struct->CounterSelect), ptr_buff + offset/8);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortMalformedPacketErrors);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortLocalPhysicalErrors);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortDLIDMappingErrors);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortBufferOverrunErrors);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortLoopingErrors);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortVLMappingErrors);

}

void PM_PortRcvErrorDetails_unpack(struct PM_PortRcvErrorDetails *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	PortRcvErrorDetails_Mask_Block_Element_unpack(&(ptr_struct->CounterSelect), ptr_buff + offset/8);

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->Reserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->PortMalformedPacketErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->PortLocalPhysicalErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->PortDLIDMappingErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->PortBufferOverrunErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->PortLoopingErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->PortVLMappingErrors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void PM_PortRcvErrorDetails_print(const struct PM_PortRcvErrorDetails *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortRcvErrorDetails ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect:\n");
	PortRcvErrorDetails_Mask_Block_Element_print(&(ptr_struct->CounterSelect), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMalformedPacketErrors : " UH_FMT "\n", ptr_struct->PortMalformedPacketErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortLocalPhysicalErrors : " UH_FMT "\n", ptr_struct->PortLocalPhysicalErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortDLIDMappingErrors : " UH_FMT "\n", ptr_struct->PortDLIDMappingErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortBufferOverrunErrors : " UH_FMT "\n", ptr_struct->PortBufferOverrunErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortLoopingErrors    : " UH_FMT "\n", ptr_struct->PortLoopingErrors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortVLMappingErrors  : " UH_FMT "\n", ptr_struct->PortVLMappingErrors);

}

int PM_PortRcvErrorDetails_size(void)
{
	 return 64;
}

void PM_PortRcvErrorDetails_dump(const struct PM_PortRcvErrorDetails *ptr_struct, FILE* file)
{
	PM_PortRcvErrorDetails_print(ptr_struct, file, 0);
}

void PM_PortSamplesControl_pack(const struct PM_PortSamplesControl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->CounterWidth);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Tick);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->OpCode);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 27, (u_int32_t)ptr_struct->CounterMasks1to9);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->CounterMask0);

	offset = 94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->SampleStatus);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SampleMechanisms);

	offset = 65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->CounterMasks10to14);

	offset = 96;
	PortSampleControlOptionMask_pack(&(ptr_struct->PortSampleControlOptionMask), ptr_buff + offset/8);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->VendorMask);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SampleStart);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SampleInterval);

	for (i = 0; i < 15; i++) {
	offset = adb2c_calc_array_field_address(288, 16, i, 832, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CounterSelect[i]);
	}

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Tag);

}

void PM_PortSamplesControl_unpack(struct PM_PortSamplesControl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->CounterWidth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 16;
	ptr_struct->Tick = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->OpCode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 37;
	ptr_struct->CounterMasks1to9 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 27);

	offset = 34;
	ptr_struct->CounterMask0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 94;
	ptr_struct->SampleStatus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 80;
	ptr_struct->SampleMechanisms = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 65;
	ptr_struct->CounterMasks10to14 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 96;
	PortSampleControlOptionMask_unpack(&(ptr_struct->PortSampleControlOptionMask), ptr_buff + offset/8);

	offset = 160;
	ptr_struct->VendorMask = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->SampleStart = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->SampleInterval = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 15; i++) {
	offset = adb2c_calc_array_field_address(288, 16, i, 832, 1);
	ptr_struct->CounterSelect[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	offset = 288;
	ptr_struct->Tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void PM_PortSamplesControl_print(const struct PM_PortSamplesControl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortSamplesControl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterWidth         : " UH_FMT "\n", ptr_struct->CounterWidth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Tick                 : " UH_FMT "\n", ptr_struct->Tick);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OpCode               : " UH_FMT "\n", ptr_struct->OpCode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterMasks1to9     : " UH_FMT "\n", ptr_struct->CounterMasks1to9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterMask0         : " UH_FMT "\n", ptr_struct->CounterMask0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SampleStatus         : %s (" UH_FMT ")\n", (ptr_struct->SampleStatus == 0 ? ("SAMPLE_COMPLETE") : ((ptr_struct->SampleStatus == 1 ? ("SAMPLE_START") : ((ptr_struct->SampleStatus == 2 ? ("SAMPLE_UNDERWAY") : ((ptr_struct->SampleStatus == 3 ? ("RESERVED") : ("unknown")))))))), ptr_struct->SampleStatus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SampleMechanisms     : " UH_FMT "\n", ptr_struct->SampleMechanisms);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterMasks10to14   : " UH_FMT "\n", ptr_struct->CounterMasks10to14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSampleControlOptionMask:\n");
	PortSampleControlOptionMask_print(&(ptr_struct->PortSampleControlOptionMask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorMask           : " U64H_FMT "\n", ptr_struct->VendorMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SampleStart          : " U32H_FMT "\n", ptr_struct->SampleStart);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SampleInterval       : " U32H_FMT "\n", ptr_struct->SampleInterval);

	for (i = 0; i < 15; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect_%03d   : " UH_FMT "\n", i, ptr_struct->CounterSelect[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Tag                  : " UH_FMT "\n", ptr_struct->Tag);

}

int PM_PortSamplesControl_size(void)
{
	 return 104;
}

void PM_PortSamplesControl_dump(const struct PM_PortSamplesControl *ptr_struct, FILE* file)
{
	PM_PortSamplesControl_print(ptr_struct, file, 0);
}

void PM_PortXmitDiscardDetails_pack(const struct PM_PortXmitDiscardDetails *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	PortXmitDiscardDetails_Mask_Block_Element_pack(&(ptr_struct->CounterSelect), ptr_buff + offset/8);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortNeighborMTUDiscards);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortInactiveDiscards);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortSwHOQLifetimeLimitDiscards);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortSwLifetimeLimitDiscards);

}

void PM_PortXmitDiscardDetails_unpack(struct PM_PortXmitDiscardDetails *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	PortXmitDiscardDetails_Mask_Block_Element_unpack(&(ptr_struct->CounterSelect), ptr_buff + offset/8);

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->Reserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->PortNeighborMTUDiscards = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->PortInactiveDiscards = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->PortSwHOQLifetimeLimitDiscards = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->PortSwLifetimeLimitDiscards = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void PM_PortXmitDiscardDetails_print(const struct PM_PortXmitDiscardDetails *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortXmitDiscardDetails ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect:\n");
	PortXmitDiscardDetails_Mask_Block_Element_print(&(ptr_struct->CounterSelect), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortNeighborMTUDiscards : " UH_FMT "\n", ptr_struct->PortNeighborMTUDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortInactiveDiscards : " UH_FMT "\n", ptr_struct->PortInactiveDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSwHOQLifetimeLimitDiscards : " UH_FMT "\n", ptr_struct->PortSwHOQLifetimeLimitDiscards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSwLifetimeLimitDiscards : " UH_FMT "\n", ptr_struct->PortSwLifetimeLimitDiscards);

}

int PM_PortXmitDiscardDetails_size(void)
{
	 return 64;
}

void PM_PortXmitDiscardDetails_dump(const struct PM_PortXmitDiscardDetails *ptr_struct, FILE* file)
{
	PM_PortXmitDiscardDetails_print(ptr_struct, file, 0);
}

void RDMNoticeDataDetails_pack(const union RDMNoticeDataDetails *ptr_struct, u_int8_t* ptr_buff)
{
	RDMRawNoticeDataDetails_pack(&(ptr_struct->RawData), ptr_buff);
}

void RDMNoticeDataDetails_unpack(union RDMNoticeDataDetails *ptr_struct, const u_int8_t* ptr_buff)
{
	RDMRawNoticeDataDetails_unpack(&(ptr_struct->RawData), ptr_buff);
}

void RDMNoticeDataDetails_print(const union RDMNoticeDataDetails *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RDMNoticeDataDetails ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PenaltyBoxChangeTrap:\n");
	PenaltyBoxChangeTrap_print(&(ptr_struct->PenaltyBoxChangeTrap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RawData:\n");
	RDMRawNoticeDataDetails_print(&(ptr_struct->RawData), file, indent_level + 1);

}

int RDMNoticeDataDetails_size(void)
{
	 return 56;
}

void RDMNoticeDataDetails_dump(const union RDMNoticeDataDetails *ptr_struct, FILE* file)
{
	RDMNoticeDataDetails_print(ptr_struct, file, 0);
}

void RawData_PM_PortRcvXmitCntrsSl64_pack(const struct RawData_PM_PortRcvXmitCntrsSl64 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->reserved);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(32, 64, i, 1056, 1);
	uint64bit_pack(&(ptr_struct->DataVLSL64[i]), ptr_buff + offset/8);
	}

}

void RawData_PM_PortRcvXmitCntrsSl64_unpack(struct RawData_PM_PortRcvXmitCntrsSl64 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->reserved = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(32, 64, i, 1056, 1);
	uint64bit_unpack(&(ptr_struct->DataVLSL64[i]), ptr_buff + offset/8);
	}

}

void RawData_PM_PortRcvXmitCntrsSl64_print(const struct RawData_PM_PortRcvXmitCntrsSl64 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RawData_PM_PortRcvXmitCntrsSl64 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved             : " U32H_FMT "\n", ptr_struct->reserved);

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DataVLSL64_%03d:\n", i);
	uint64bit_print(&(ptr_struct->DataVLSL64[i]), file, indent_level + 1);
	}

}

int RawData_PM_PortRcvXmitCntrsSl64_size(void)
{
	 return 132;
}

void RawData_PM_PortRcvXmitCntrsSl64_dump(const struct RawData_PM_PortRcvXmitCntrsSl64 *ptr_struct, FILE* file)
{
	RawData_PM_PortRcvXmitCntrsSl64_print(ptr_struct, file, 0);
}

void RawData_PM_PortRcvXmitCntrsVl64_pack(const struct RawData_PM_PortRcvXmitCntrsVl64 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1024, 1);
	uint64bit_pack(&(ptr_struct->DataVLSL64[i]), ptr_buff + offset/8);
	}

}

void RawData_PM_PortRcvXmitCntrsVl64_unpack(struct RawData_PM_PortRcvXmitCntrsVl64 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1024, 1);
	uint64bit_unpack(&(ptr_struct->DataVLSL64[i]), ptr_buff + offset/8);
	}

}

void RawData_PM_PortRcvXmitCntrsVl64_print(const struct RawData_PM_PortRcvXmitCntrsVl64 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RawData_PM_PortRcvXmitCntrsVl64 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DataVLSL64_%03d:\n", i);
	uint64bit_print(&(ptr_struct->DataVLSL64[i]), file, indent_level + 1);
	}

}

int RawData_PM_PortRcvXmitCntrsVl64_size(void)
{
	 return 128;
}

void RawData_PM_PortRcvXmitCntrsVl64_dump(const struct RawData_PM_PortRcvXmitCntrsVl64 *ptr_struct, FILE* file)
{
	RawData_PM_PortRcvXmitCntrsVl64_print(ptr_struct, file, 0);
}

void SA_MCMMemberRecord_pack(const struct SA_MCMMemberRecord *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	GID_Block_Element_pack(&(ptr_struct->MGID), ptr_buff + offset/8);

	offset = 128;
	GID_Block_Element_pack(&(ptr_struct->PortGID), ptr_buff + offset/8);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Q_key);

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TClass);

	offset = 306;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->MTU);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->MTUSelector);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MLID);

	offset = 346;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->PacketLifeTime);

	offset = 344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PacketLifeTimeSelector);

	offset = 338;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->Rate);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->RateSelector);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->P_Key);

	offset = 376;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HopLimit);

	offset = 356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->FlowLabel);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SL);

	offset = 393;
	adb2c_push_bits_to_buff(ptr_buff, offset, 23, (u_int32_t)ptr_struct->Reserved);

	offset = 392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ProxyJoin);

	offset = 388;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->JoinState);

	offset = 384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Scope);

}

void SA_MCMMemberRecord_unpack(struct SA_MCMMemberRecord *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	GID_Block_Element_unpack(&(ptr_struct->MGID), ptr_buff + offset/8);

	offset = 128;
	GID_Block_Element_unpack(&(ptr_struct->PortGID), ptr_buff + offset/8);

	offset = 256;
	ptr_struct->Q_key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 312;
	ptr_struct->TClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 306;
	ptr_struct->MTU = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 304;
	ptr_struct->MTUSelector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 288;
	ptr_struct->MLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 346;
	ptr_struct->PacketLifeTime = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 344;
	ptr_struct->PacketLifeTimeSelector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 338;
	ptr_struct->Rate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 336;
	ptr_struct->RateSelector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 320;
	ptr_struct->P_Key = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 376;
	ptr_struct->HopLimit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 356;
	ptr_struct->FlowLabel = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 352;
	ptr_struct->SL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 393;
	ptr_struct->Reserved = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 23);

	offset = 392;
	ptr_struct->ProxyJoin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 388;
	ptr_struct->JoinState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->Scope = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void SA_MCMMemberRecord_print(const struct SA_MCMMemberRecord *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SA_MCMMemberRecord ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MGID:\n");
	GID_Block_Element_print(&(ptr_struct->MGID), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortGID:\n");
	GID_Block_Element_print(&(ptr_struct->PortGID), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Q_key                : " U32H_FMT "\n", ptr_struct->Q_key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TClass               : " UH_FMT "\n", ptr_struct->TClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MTU                  : " UH_FMT "\n", ptr_struct->MTU);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MTUSelector          : " UH_FMT "\n", ptr_struct->MTUSelector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MLID                 : " UH_FMT "\n", ptr_struct->MLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PacketLifeTime       : " UH_FMT "\n", ptr_struct->PacketLifeTime);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PacketLifeTimeSelector : " UH_FMT "\n", ptr_struct->PacketLifeTimeSelector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Rate                 : " UH_FMT "\n", ptr_struct->Rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RateSelector         : " UH_FMT "\n", ptr_struct->RateSelector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "P_Key                : " UH_FMT "\n", ptr_struct->P_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HopLimit             : " UH_FMT "\n", ptr_struct->HopLimit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FlowLabel            : " UH_FMT "\n", ptr_struct->FlowLabel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SL                   : " UH_FMT "\n", ptr_struct->SL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ProxyJoin            : " UH_FMT "\n", ptr_struct->ProxyJoin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "JoinState            : " UH_FMT "\n", ptr_struct->JoinState);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Scope                : " UH_FMT "\n", ptr_struct->Scope);

}

int SA_MCMMemberRecord_size(void)
{
	 return 52;
}

void SA_MCMMemberRecord_dump(const struct SA_MCMMemberRecord *ptr_struct, FILE* file)
{
	SA_MCMMemberRecord_print(ptr_struct, file, 0);
}

void SMP_AccessRegister_pack(const struct SMP_AccessRegister *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->status);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dr);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->len_op);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->type_op);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_op);

	offset = 49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->method);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->r);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->register_id);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tid_hi);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tid_lo);

	offset = 133;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->len_reg);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->type_reg);

	offset = 160;
	acc_register_pack(&(ptr_struct->reg), ptr_buff + offset/8);

}

void SMP_AccessRegister_unpack(struct SMP_AccessRegister *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 17;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 16;
	ptr_struct->dr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 5;
	ptr_struct->len_op = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 0;
	ptr_struct->type_op = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 56;
	ptr_struct->class_op = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 49;
	ptr_struct->method = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 48;
	ptr_struct->r = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->register_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->tid_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->tid_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 133;
	ptr_struct->len_reg = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 128;
	ptr_struct->type_reg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 160;
	acc_register_unpack(&(ptr_struct->reg), ptr_buff + offset/8);

}

void SMP_AccessRegister_print(const struct SMP_AccessRegister *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_AccessRegister ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dr                   : " UH_FMT "\n", ptr_struct->dr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "len_op               : " UH_FMT "\n", ptr_struct->len_op);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type_op              : " UH_FMT "\n", ptr_struct->type_op);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_op             : " UH_FMT "\n", ptr_struct->class_op);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "method               : " UH_FMT "\n", ptr_struct->method);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "r                    : " UH_FMT "\n", ptr_struct->r);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "register_id          : " UH_FMT "\n", ptr_struct->register_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tid_hi               : " U32H_FMT "\n", ptr_struct->tid_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tid_lo               : " U32H_FMT "\n", ptr_struct->tid_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "len_reg              : " UH_FMT "\n", ptr_struct->len_reg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type_reg             : " UH_FMT "\n", ptr_struct->type_reg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg:\n");
	acc_register_print(&(ptr_struct->reg), file, indent_level + 1);

}

int SMP_AccessRegister_size(void)
{
	 return 64;
}

void SMP_AccessRegister_dump(const struct SMP_AccessRegister *ptr_struct, FILE* file)
{
	SMP_AccessRegister_print(ptr_struct, file, 0);
}

void SMP_AdjSiteLocalSubnTbl_pack(const struct SMP_AdjSiteLocalSubnTbl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 512, 1);
	AdjSiteLocalSubnetRecord_pack(&(ptr_struct->Record[i]), ptr_buff + offset/8);
	}

}

void SMP_AdjSiteLocalSubnTbl_unpack(struct SMP_AdjSiteLocalSubnTbl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 512, 1);
	AdjSiteLocalSubnetRecord_unpack(&(ptr_struct->Record[i]), ptr_buff + offset/8);
	}

}

void SMP_AdjSiteLocalSubnTbl_print(const struct SMP_AdjSiteLocalSubnTbl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_AdjSiteLocalSubnTbl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Record_%03d:\n", i);
	AdjSiteLocalSubnetRecord_print(&(ptr_struct->Record[i]), file, indent_level + 1);
	}

}

int SMP_AdjSiteLocalSubnTbl_size(void)
{
	 return 64;
}

void SMP_AdjSiteLocalSubnTbl_dump(const struct SMP_AdjSiteLocalSubnTbl *ptr_struct, FILE* file)
{
	SMP_AdjSiteLocalSubnTbl_print(ptr_struct, file, 0);
}

void SMP_AdjSubnetsRouterLIDInfoTable_pack(const struct SMP_AdjSubnetsRouterLIDInfoTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 512, 1);
	AdjSubnetRouterLIDRecord_pack(&(ptr_struct->Record[i]), ptr_buff + offset/8);
	}

}

void SMP_AdjSubnetsRouterLIDInfoTable_unpack(struct SMP_AdjSubnetsRouterLIDInfoTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 512, 1);
	AdjSubnetRouterLIDRecord_unpack(&(ptr_struct->Record[i]), ptr_buff + offset/8);
	}

}

void SMP_AdjSubnetsRouterLIDInfoTable_print(const struct SMP_AdjSubnetsRouterLIDInfoTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_AdjSubnetsRouterLIDInfoTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Record_%03d:\n", i);
	AdjSubnetRouterLIDRecord_print(&(ptr_struct->Record[i]), file, indent_level + 1);
	}

}

int SMP_AdjSubnetsRouterLIDInfoTable_size(void)
{
	 return 64;
}

void SMP_AdjSubnetsRouterLIDInfoTable_dump(const struct SMP_AdjSubnetsRouterLIDInfoTable *ptr_struct, FILE* file)
{
	SMP_AdjSubnetsRouterLIDInfoTable_print(ptr_struct, file, 0);
}

void SMP_AnycastLIDInfo_pack(const struct SMP_AnycastLIDInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	anycast_lid_block_pack(&(ptr_struct->block[i]), ptr_buff + offset/8);
	}

}

void SMP_AnycastLIDInfo_unpack(struct SMP_AnycastLIDInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	anycast_lid_block_unpack(&(ptr_struct->block[i]), ptr_buff + offset/8);
	}

}

void SMP_AnycastLIDInfo_print(const struct SMP_AnycastLIDInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_AnycastLIDInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "block_%03d:\n", i);
	anycast_lid_block_print(&(ptr_struct->block[i]), file, indent_level + 1);
	}

}

int SMP_AnycastLIDInfo_size(void)
{
	 return 64;
}

void SMP_AnycastLIDInfo_dump(const struct SMP_AnycastLIDInfo *ptr_struct, FILE* file)
{
	SMP_AnycastLIDInfo_print(ptr_struct, file, 0);
}

void SMP_ContainAndDrainInfo_pack(const struct SMP_ContainAndDrainInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	CDInfo_Block_pack(&(ptr_struct->blocks[i]), ptr_buff + offset/8);
	}

}

void SMP_ContainAndDrainInfo_unpack(struct SMP_ContainAndDrainInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	CDInfo_Block_unpack(&(ptr_struct->blocks[i]), ptr_buff + offset/8);
	}

}

void SMP_ContainAndDrainInfo_print(const struct SMP_ContainAndDrainInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ContainAndDrainInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "blocks_%03d:\n", i);
	CDInfo_Block_print(&(ptr_struct->blocks[i]), file, indent_level + 1);
	}

}

int SMP_ContainAndDrainInfo_size(void)
{
	 return 64;
}

void SMP_ContainAndDrainInfo_dump(const struct SMP_ContainAndDrainInfo *ptr_struct, FILE* file)
{
	SMP_ContainAndDrainInfo_print(ptr_struct, file, 0);
}

void SMP_ContainAndDrainPortState_pack(const struct SMP_ContainAndDrainPortState *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	CDPortState_Block_pack(&(ptr_struct->blocks[i]), ptr_buff + offset/8);
	}

}

void SMP_ContainAndDrainPortState_unpack(struct SMP_ContainAndDrainPortState *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 512, 1);
	CDPortState_Block_unpack(&(ptr_struct->blocks[i]), ptr_buff + offset/8);
	}

}

void SMP_ContainAndDrainPortState_print(const struct SMP_ContainAndDrainPortState *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ContainAndDrainPortState ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "blocks_%03d:\n", i);
	CDPortState_Block_print(&(ptr_struct->blocks[i]), file, indent_level + 1);
	}

}

int SMP_ContainAndDrainPortState_size(void)
{
	 return 64;
}

void SMP_ContainAndDrainPortState_dump(const struct SMP_ContainAndDrainPortState *ptr_struct, FILE* file)
{
	SMP_ContainAndDrainPortState_print(ptr_struct, file, 0);
}

void SMP_EndPortPlaneFilterConfig_pack(const struct SMP_EndPortPlaneFilterConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 64;
	end_port_plane_filter_entry_pack(&(ptr_struct->end_port_plane_filter_entry_0), ptr_buff + offset/8);

	offset = 96;
	end_port_plane_filter_entry_pack(&(ptr_struct->end_port_plane_filter_entry_1), ptr_buff + offset/8);

	offset = 128;
	end_port_plane_filter_entry_pack(&(ptr_struct->end_port_plane_filter_entry_2), ptr_buff + offset/8);

	offset = 160;
	end_port_plane_filter_entry_pack(&(ptr_struct->end_port_plane_filter_entry_3), ptr_buff + offset/8);

}

void SMP_EndPortPlaneFilterConfig_unpack(struct SMP_EndPortPlaneFilterConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 64;
	end_port_plane_filter_entry_unpack(&(ptr_struct->end_port_plane_filter_entry_0), ptr_buff + offset/8);

	offset = 96;
	end_port_plane_filter_entry_unpack(&(ptr_struct->end_port_plane_filter_entry_1), ptr_buff + offset/8);

	offset = 128;
	end_port_plane_filter_entry_unpack(&(ptr_struct->end_port_plane_filter_entry_2), ptr_buff + offset/8);

	offset = 160;
	end_port_plane_filter_entry_unpack(&(ptr_struct->end_port_plane_filter_entry_3), ptr_buff + offset/8);

}

void SMP_EndPortPlaneFilterConfig_print(const struct SMP_EndPortPlaneFilterConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_EndPortPlaneFilterConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "end_port_plane_filter_entry_0:\n");
	end_port_plane_filter_entry_print(&(ptr_struct->end_port_plane_filter_entry_0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "end_port_plane_filter_entry_1:\n");
	end_port_plane_filter_entry_print(&(ptr_struct->end_port_plane_filter_entry_1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "end_port_plane_filter_entry_2:\n");
	end_port_plane_filter_entry_print(&(ptr_struct->end_port_plane_filter_entry_2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "end_port_plane_filter_entry_3:\n");
	end_port_plane_filter_entry_print(&(ptr_struct->end_port_plane_filter_entry_3), file, indent_level + 1);

}

int SMP_EndPortPlaneFilterConfig_size(void)
{
	 return 64;
}

void SMP_EndPortPlaneFilterConfig_dump(const struct SMP_EndPortPlaneFilterConfig *ptr_struct, FILE* file)
{
	SMP_EndPortPlaneFilterConfig_print(ptr_struct, file, 0);
}

void SMP_HierarchyInfo_pack(const struct SMP_HierarchyInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->TemplateGUID);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved2);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved1);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ActiveLevels);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MaxActiveIndex);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MaxSupportedIndex);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level0Data);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level1Data);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level2Data);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level3Data);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level4Data);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level5Data);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level6Data);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level7Data);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level8Data);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level9Data);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level10Data);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level11Data);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Level12Data);

}

void SMP_HierarchyInfo_unpack(struct SMP_HierarchyInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->TemplateGUID = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->Reserved2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 84;
	ptr_struct->Reserved1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->ActiveLevels = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 72;
	ptr_struct->MaxActiveIndex = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->MaxSupportedIndex = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->Level0Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->Level1Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->Level2Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->Level3Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->Level4Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->Level5Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->Level6Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->Level7Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->Level8Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->Level9Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->Level10Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->Level11Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->Level12Data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void SMP_HierarchyInfo_print(const struct SMP_HierarchyInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_HierarchyInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TemplateGUID         : " U64H_FMT "\n", ptr_struct->TemplateGUID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved2            : " UH_FMT "\n", ptr_struct->Reserved2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved1            : " UH_FMT "\n", ptr_struct->Reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ActiveLevels         : " UH_FMT "\n", ptr_struct->ActiveLevels);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MaxActiveIndex       : " UH_FMT "\n", ptr_struct->MaxActiveIndex);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MaxSupportedIndex    : " UH_FMT "\n", ptr_struct->MaxSupportedIndex);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level0Data           : " U32H_FMT "\n", ptr_struct->Level0Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level1Data           : " U32H_FMT "\n", ptr_struct->Level1Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level2Data           : " U32H_FMT "\n", ptr_struct->Level2Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level3Data           : " U32H_FMT "\n", ptr_struct->Level3Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level4Data           : " U32H_FMT "\n", ptr_struct->Level4Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level5Data           : " U32H_FMT "\n", ptr_struct->Level5Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level6Data           : " U32H_FMT "\n", ptr_struct->Level6Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level7Data           : " U32H_FMT "\n", ptr_struct->Level7Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level8Data           : " U32H_FMT "\n", ptr_struct->Level8Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level9Data           : " U32H_FMT "\n", ptr_struct->Level9Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level10Data          : " U32H_FMT "\n", ptr_struct->Level10Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level11Data          : " U32H_FMT "\n", ptr_struct->Level11Data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Level12Data          : " U32H_FMT "\n", ptr_struct->Level12Data);

}

int SMP_HierarchyInfo_size(void)
{
	 return 64;
}

void SMP_HierarchyInfo_dump(const struct SMP_HierarchyInfo *ptr_struct, FILE* file)
{
	SMP_HierarchyInfo_print(ptr_struct, file, 0);
}

void SMP_NVLHBFConfig_pack(const struct SMP_NVLHBFConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hash_type);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->packet_hash_bitmask);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->seed);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->fields_enable);

}

void SMP_NVLHBFConfig_unpack(struct SMP_NVLHBFConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->hash_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->packet_hash_bitmask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->seed = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->fields_enable = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void SMP_NVLHBFConfig_print(const struct SMP_NVLHBFConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_NVLHBFConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hash_type            : " UH_FMT "\n", ptr_struct->hash_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_hash_bitmask  : " UH_FMT "\n", ptr_struct->packet_hash_bitmask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "seed                 : " U32H_FMT "\n", ptr_struct->seed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fields_enable        : " U64H_FMT "\n", ptr_struct->fields_enable);

}

int SMP_NVLHBFConfig_size(void)
{
	 return 64;
}

void SMP_NVLHBFConfig_dump(const struct SMP_NVLHBFConfig *ptr_struct, FILE* file)
{
	SMP_NVLHBFConfig_print(ptr_struct, file, 0);
}

void SMP_NodeInfo_pack(const struct SMP_NodeInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NumPorts);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NodeType);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ClassVersion);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->BaseVersion);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SystemImageGUID);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->NodeGUID);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortGUID);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DeviceID);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PartitionCap);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->revision);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->VendorID);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LocalPortNum);

}

void SMP_NodeInfo_unpack(struct SMP_NodeInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->NumPorts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->NodeType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->ClassVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->BaseVersion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->SystemImageGUID = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->NodeGUID = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->PortGUID = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->DeviceID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->PartitionCap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->revision = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 296;
	ptr_struct->VendorID = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 288;
	ptr_struct->LocalPortNum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void SMP_NodeInfo_print(const struct SMP_NodeInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_NodeInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NumPorts             : " UH_FMT "\n", ptr_struct->NumPorts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NodeType             : " UH_FMT "\n", ptr_struct->NodeType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClassVersion         : " UH_FMT "\n", ptr_struct->ClassVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BaseVersion          : " UH_FMT "\n", ptr_struct->BaseVersion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SystemImageGUID      : " U64H_FMT "\n", ptr_struct->SystemImageGUID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NodeGUID             : " U64H_FMT "\n", ptr_struct->NodeGUID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortGUID             : " U64H_FMT "\n", ptr_struct->PortGUID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DeviceID             : " UH_FMT "\n", ptr_struct->DeviceID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PartitionCap         : " UH_FMT "\n", ptr_struct->PartitionCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "revision             : " U32H_FMT "\n", ptr_struct->revision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorID             : " UH_FMT "\n", ptr_struct->VendorID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LocalPortNum         : " UH_FMT "\n", ptr_struct->LocalPortNum);

}

int SMP_NodeInfo_size(void)
{
	 return 40;
}

void SMP_NodeInfo_dump(const struct SMP_NodeInfo *ptr_struct, FILE* file)
{
	SMP_NodeInfo_print(ptr_struct, file, 0);
}

void SMP_PKeyTable_pack(const struct SMP_PKeyTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	P_Key_Block_Element_pack(&(ptr_struct->PKey_Entry[i]), ptr_buff + offset/8);
	}

}

void SMP_PKeyTable_unpack(struct SMP_PKeyTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	P_Key_Block_Element_unpack(&(ptr_struct->PKey_Entry[i]), ptr_buff + offset/8);
	}

}

void SMP_PKeyTable_print(const struct SMP_PKeyTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_PKeyTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PKey_Entry_%03d:\n", i);
	P_Key_Block_Element_print(&(ptr_struct->PKey_Entry[i]), file, indent_level + 1);
	}

}

int SMP_PKeyTable_size(void)
{
	 return 64;
}

void SMP_PKeyTable_dump(const struct SMP_PKeyTable *ptr_struct, FILE* file)
{
	SMP_PKeyTable_print(ptr_struct, file, 0);
}

void SMP_PortInfo_pack(const struct SMP_PortInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->MKey);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->GIDPrfx);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MSMLID);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LID);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->CapMsk);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->M_KeyLeasePeriod);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagCode);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkWidthActv);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkWidthSup);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkWidthEn);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LocalPortNum);

	offset = 284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LinkSpeedEn);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LinkSpeedActv);

	offset = 277;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->LMC);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->MKeyProtBits);

	offset = 268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LinkDownDefState);

	offset = 264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortPhyState);

	offset = 260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->PortState);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LinkSpeedSup);

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VLArbHighCap);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VLHighLimit);

	offset = 300;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->InitType);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VLCap);

	offset = 292;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->MSMSL);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->NMTU);

	offset = 351;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->FilterRawOutb);

	offset = 350;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->FilterRawInb);

	offset = 349;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PartEnfOutb);

	offset = 348;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->PartEnfInb);

	offset = 344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->OpVLs);

	offset = 339;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->HoQLife);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->VLStallCnt);

	offset = 332;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->MTUCap);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->InitTypeReply);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VLArbLowCap);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PKeyViolations);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MKeyViolations);

	offset = 411;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->SubnTmo);

	offset = 409;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->MulticastPKeyTrapSuppressionEnabled);

	offset = 408;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ClientReregister);

	offset = 400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->GUIDCap);

	offset = 384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->QKeyViolations);

	offset = 432;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MaxCreditHint);

	offset = 428;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->OverrunErrs);

	offset = 424;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LocalPhyError);

	offset = 419;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->RespTimeValue);

	offset = 456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->LinkRoundTripLatency);

	offset = 453;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->LinkSpeedExtEn2);

	offset = 451;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->LinkSpeedExtSup2);

	offset = 449;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->LinkSpeedExtActv2);

	offset = 507;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->LinkSpeedExtEn);

	offset = 500;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LinkSpeedExtSup);

	offset = 496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->LinkSpeedExtActv);

	offset = 480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CapMsk2);

}

void SMP_PortInfo_unpack(struct SMP_PortInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->MKey = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->GIDPrfx = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->MSMLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->LID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->CapMsk = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 208;
	ptr_struct->M_KeyLeasePeriod = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->DiagCode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 248;
	ptr_struct->LinkWidthActv = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->LinkWidthSup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 232;
	ptr_struct->LinkWidthEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->LocalPortNum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 284;
	ptr_struct->LinkSpeedEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 280;
	ptr_struct->LinkSpeedActv = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 277;
	ptr_struct->LMC = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 272;
	ptr_struct->MKeyProtBits = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 268;
	ptr_struct->LinkDownDefState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 264;
	ptr_struct->PortPhyState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 260;
	ptr_struct->PortState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->LinkSpeedSup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 312;
	ptr_struct->VLArbHighCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 304;
	ptr_struct->VLHighLimit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 300;
	ptr_struct->InitType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 296;
	ptr_struct->VLCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 292;
	ptr_struct->MSMSL = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->NMTU = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 351;
	ptr_struct->FilterRawOutb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 350;
	ptr_struct->FilterRawInb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 349;
	ptr_struct->PartEnfOutb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 348;
	ptr_struct->PartEnfInb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 344;
	ptr_struct->OpVLs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 339;
	ptr_struct->HoQLife = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 336;
	ptr_struct->VLStallCnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 332;
	ptr_struct->MTUCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 328;
	ptr_struct->InitTypeReply = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->VLArbLowCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 368;
	ptr_struct->PKeyViolations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->MKeyViolations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 411;
	ptr_struct->SubnTmo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 409;
	ptr_struct->MulticastPKeyTrapSuppressionEnabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 408;
	ptr_struct->ClientReregister = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 400;
	ptr_struct->GUIDCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 384;
	ptr_struct->QKeyViolations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 432;
	ptr_struct->MaxCreditHint = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 428;
	ptr_struct->OverrunErrs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 424;
	ptr_struct->LocalPhyError = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 419;
	ptr_struct->RespTimeValue = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 456;
	ptr_struct->LinkRoundTripLatency = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 453;
	ptr_struct->LinkSpeedExtEn2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 451;
	ptr_struct->LinkSpeedExtSup2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 449;
	ptr_struct->LinkSpeedExtActv2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 507;
	ptr_struct->LinkSpeedExtEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 500;
	ptr_struct->LinkSpeedExtSup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 496;
	ptr_struct->LinkSpeedExtActv = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->CapMsk2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void SMP_PortInfo_print(const struct SMP_PortInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_PortInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MKey                 : " U64H_FMT "\n", ptr_struct->MKey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GIDPrfx              : " U64H_FMT "\n", ptr_struct->GIDPrfx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MSMLID               : " UH_FMT "\n", ptr_struct->MSMLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LID                  : " UH_FMT "\n", ptr_struct->LID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CapMsk               : " U32H_FMT "\n", ptr_struct->CapMsk);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "M_KeyLeasePeriod     : " UH_FMT "\n", ptr_struct->M_KeyLeasePeriod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagCode             : " UH_FMT "\n", ptr_struct->DiagCode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkWidthActv        : " UH_FMT "\n", ptr_struct->LinkWidthActv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkWidthSup         : " UH_FMT "\n", ptr_struct->LinkWidthSup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkWidthEn          : " UH_FMT "\n", ptr_struct->LinkWidthEn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LocalPortNum         : " UH_FMT "\n", ptr_struct->LocalPortNum);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedEn          : " UH_FMT "\n", ptr_struct->LinkSpeedEn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedActv        : " UH_FMT "\n", ptr_struct->LinkSpeedActv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LMC                  : " UH_FMT "\n", ptr_struct->LMC);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MKeyProtBits         : " UH_FMT "\n", ptr_struct->MKeyProtBits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkDownDefState     : %s (" UH_FMT ")\n", (ptr_struct->LinkDownDefState == 0 ? ("NO_STATE") : ((ptr_struct->LinkDownDefState == 1 ? ("SLEEP") : ((ptr_struct->LinkDownDefState == 2 ? ("POLLING") : ("unknown")))))), ptr_struct->LinkDownDefState);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortPhyState         : %s (" UH_FMT ")\n", (ptr_struct->PortPhyState == 0 ? ("NO_STATE") : ((ptr_struct->PortPhyState == 1 ? ("SLEEP") : ((ptr_struct->PortPhyState == 2 ? ("POLLING") : ((ptr_struct->PortPhyState == 3 ? ("DISABLED") : ((ptr_struct->PortPhyState == 4 ? ("PORT_CONFIGURATION_TRAINING") : ((ptr_struct->PortPhyState == 5 ? ("LINK_UP") : ((ptr_struct->PortPhyState == 6 ? ("LINK_ERROR_RECOVERY") : ((ptr_struct->PortPhyState == 7 ? ("PHY_TEST") : ("unknown")))))))))))))))), ptr_struct->PortPhyState);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortState            : %s (" UH_FMT ")\n", (ptr_struct->PortState == 0 ? ("NO_STATE") : ((ptr_struct->PortState == 1 ? ("DOWN") : ((ptr_struct->PortState == 2 ? ("INIT") : ((ptr_struct->PortState == 3 ? ("ARMED") : ((ptr_struct->PortState == 4 ? ("ACTIVE") : ("unknown")))))))))), ptr_struct->PortState);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedSup         : " UH_FMT "\n", ptr_struct->LinkSpeedSup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VLArbHighCap         : " UH_FMT "\n", ptr_struct->VLArbHighCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VLHighLimit          : " UH_FMT "\n", ptr_struct->VLHighLimit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "InitType             : " UH_FMT "\n", ptr_struct->InitType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VLCap                : " UH_FMT "\n", ptr_struct->VLCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MSMSL                : " UH_FMT "\n", ptr_struct->MSMSL);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NMTU                 : " UH_FMT "\n", ptr_struct->NMTU);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FilterRawOutb        : " UH_FMT "\n", ptr_struct->FilterRawOutb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FilterRawInb         : " UH_FMT "\n", ptr_struct->FilterRawInb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PartEnfOutb          : " UH_FMT "\n", ptr_struct->PartEnfOutb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PartEnfInb           : " UH_FMT "\n", ptr_struct->PartEnfInb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OpVLs                : " UH_FMT "\n", ptr_struct->OpVLs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HoQLife              : " UH_FMT "\n", ptr_struct->HoQLife);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VLStallCnt           : " UH_FMT "\n", ptr_struct->VLStallCnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MTUCap               : " UH_FMT "\n", ptr_struct->MTUCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "InitTypeReply        : " UH_FMT "\n", ptr_struct->InitTypeReply);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VLArbLowCap          : " UH_FMT "\n", ptr_struct->VLArbLowCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PKeyViolations       : " UH_FMT "\n", ptr_struct->PKeyViolations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MKeyViolations       : " UH_FMT "\n", ptr_struct->MKeyViolations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubnTmo              : " UH_FMT "\n", ptr_struct->SubnTmo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MulticastPKeyTrapSuppressionEnabled : " UH_FMT "\n", ptr_struct->MulticastPKeyTrapSuppressionEnabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClientReregister     : " UH_FMT "\n", ptr_struct->ClientReregister);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GUIDCap              : " UH_FMT "\n", ptr_struct->GUIDCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "QKeyViolations       : " UH_FMT "\n", ptr_struct->QKeyViolations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MaxCreditHint        : " UH_FMT "\n", ptr_struct->MaxCreditHint);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OverrunErrs          : " UH_FMT "\n", ptr_struct->OverrunErrs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LocalPhyError        : " UH_FMT "\n", ptr_struct->LocalPhyError);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RespTimeValue        : " UH_FMT "\n", ptr_struct->RespTimeValue);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkRoundTripLatency : " UH_FMT "\n", ptr_struct->LinkRoundTripLatency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedExtEn2      : " UH_FMT "\n", ptr_struct->LinkSpeedExtEn2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedExtSup2     : " UH_FMT "\n", ptr_struct->LinkSpeedExtSup2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedExtActv2    : " UH_FMT "\n", ptr_struct->LinkSpeedExtActv2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedExtEn       : " UH_FMT "\n", ptr_struct->LinkSpeedExtEn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedExtSup      : " UH_FMT "\n", ptr_struct->LinkSpeedExtSup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkSpeedExtActv     : " UH_FMT "\n", ptr_struct->LinkSpeedExtActv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CapMsk2              : " UH_FMT "\n", ptr_struct->CapMsk2);

}

int SMP_PortInfo_size(void)
{
	 return 64;
}

void SMP_PortInfo_dump(const struct SMP_PortInfo *ptr_struct, FILE* file)
{
	SMP_PortInfo_print(ptr_struct, file, 0);
}

void SMP_QosConfigSL_pack(const struct SMP_QosConfigSL *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	BandwidthPerSL_pack(&(ptr_struct->BandwidthPerSL[i]), ptr_buff + offset/8);
	}

}

void SMP_QosConfigSL_unpack(struct SMP_QosConfigSL *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	BandwidthPerSL_unpack(&(ptr_struct->BandwidthPerSL[i]), ptr_buff + offset/8);
	}

}

void SMP_QosConfigSL_print(const struct SMP_QosConfigSL *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_QosConfigSL ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BandwidthPerSL_%03d:\n", i);
	BandwidthPerSL_print(&(ptr_struct->BandwidthPerSL[i]), file, indent_level + 1);
	}

}

int SMP_QosConfigSL_size(void)
{
	 return 64;
}

void SMP_QosConfigSL_dump(const struct SMP_QosConfigSL *ptr_struct, FILE* file)
{
	SMP_QosConfigSL_print(ptr_struct, file, 0);
}

void SMP_QosConfigVL_pack(const struct SMP_QosConfigVL *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 15; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	VLConfigBlock_pack(&(ptr_struct->VLConfigBlock[i]), ptr_buff + offset/8);
	}

}

void SMP_QosConfigVL_unpack(struct SMP_QosConfigVL *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 15; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	VLConfigBlock_unpack(&(ptr_struct->VLConfigBlock[i]), ptr_buff + offset/8);
	}

}

void SMP_QosConfigVL_print(const struct SMP_QosConfigVL *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_QosConfigVL ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 15; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VLConfigBlock_%03d:\n", i);
	VLConfigBlock_print(&(ptr_struct->VLConfigBlock[i]), file, indent_level + 1);
	}

}

int SMP_QosConfigVL_size(void)
{
	 return 64;
}

void SMP_QosConfigVL_dump(const struct SMP_QosConfigVL *ptr_struct, FILE* file)
{
	SMP_QosConfigVL_print(ptr_struct, file, 0);
}

void SMP_RandomForwardingTable_pack(const struct SMP_RandomForwardingTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	LID_Port_Block_Element_pack(&(ptr_struct->LID_Port_Block_Element[i]), ptr_buff + offset/8);
	}

}

void SMP_RandomForwardingTable_unpack(struct SMP_RandomForwardingTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	LID_Port_Block_Element_unpack(&(ptr_struct->LID_Port_Block_Element[i]), ptr_buff + offset/8);
	}

}

void SMP_RandomForwardingTable_print(const struct SMP_RandomForwardingTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_RandomForwardingTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LID_Port_Block_Element_%03d:\n", i);
	LID_Port_Block_Element_print(&(ptr_struct->LID_Port_Block_Element[i]), file, indent_level + 1);
	}

}

int SMP_RandomForwardingTable_size(void)
{
	 return 64;
}

void SMP_RandomForwardingTable_dump(const struct SMP_RandomForwardingTable *ptr_struct, FILE* file)
{
	SMP_RandomForwardingTable_print(ptr_struct, file, 0);
}

void SMP_SMInfo_pack(const struct SMP_SMInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->GUID);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->Sm_Key);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ActCount);

	offset = 164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SmState);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Priority);

}

void SMP_SMInfo_unpack(struct SMP_SMInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->GUID = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->Sm_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->ActCount = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 164;
	ptr_struct->SmState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->Priority = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void SMP_SMInfo_print(const struct SMP_SMInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_SMInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GUID                 : " U64H_FMT "\n", ptr_struct->GUID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Sm_Key               : " U64H_FMT "\n", ptr_struct->Sm_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ActCount             : " U32H_FMT "\n", ptr_struct->ActCount);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SmState              : %s (" UH_FMT ")\n", (ptr_struct->SmState == 0 ? ("NOT_ACTIVE") : ((ptr_struct->SmState == 1 ? ("DISCOVERING") : ((ptr_struct->SmState == 2 ? ("STANDBY") : ((ptr_struct->SmState == 3 ? ("MASTER") : ("unknown")))))))), ptr_struct->SmState);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Priority             : " UH_FMT "\n", ptr_struct->Priority);

}

int SMP_SMInfo_size(void)
{
	 return 24;
}

void SMP_SMInfo_dump(const struct SMP_SMInfo *ptr_struct, FILE* file)
{
	SMP_SMInfo_print(ptr_struct, file, 0);
}

void SMP_VLArbitrationTable_pack(const struct SMP_VLArbitrationTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	VL_Weight_Block_Element_pack(&(ptr_struct->VLArb[i]), ptr_buff + offset/8);
	}

}

void SMP_VLArbitrationTable_unpack(struct SMP_VLArbitrationTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	VL_Weight_Block_Element_unpack(&(ptr_struct->VLArb[i]), ptr_buff + offset/8);
	}

}

void SMP_VLArbitrationTable_print(const struct SMP_VLArbitrationTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_VLArbitrationTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VLArb_%03d:\n", i);
	VL_Weight_Block_Element_print(&(ptr_struct->VLArb[i]), file, indent_level + 1);
	}

}

int SMP_VLArbitrationTable_size(void)
{
	 return 64;
}

void SMP_VLArbitrationTable_dump(const struct SMP_VLArbitrationTable *ptr_struct, FILE* file)
{
	SMP_VLArbitrationTable_print(ptr_struct, file, 0);
}

void SMP_VNodeInfo_pack(const struct SMP_VNodeInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vnum_ports);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vlocal_port_num);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vpartition_cap);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->vnode_guid);

}

void SMP_VNodeInfo_unpack(struct SMP_VNodeInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->vnum_ports = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->vlocal_port_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->vpartition_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->vnode_guid = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void SMP_VNodeInfo_print(const struct SMP_VNodeInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_VNodeInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vnum_ports           : " UH_FMT "\n", ptr_struct->vnum_ports);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vlocal_port_num      : " UH_FMT "\n", ptr_struct->vlocal_port_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpartition_cap       : " UH_FMT "\n", ptr_struct->vpartition_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vnode_guid           : " U64H_FMT "\n", ptr_struct->vnode_guid);

}

int SMP_VNodeInfo_size(void)
{
	 return 64;
}

void SMP_VNodeInfo_dump(const struct SMP_VNodeInfo *ptr_struct, FILE* file)
{
	SMP_VNodeInfo_print(ptr_struct, file, 0);
}

void SMP_VPortInfo_pack(const struct SMP_VPortInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vport_capability_mask);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vguid_cap);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lid_required);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vport_client_reregister);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vport_state);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qkey_violations);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey_violations);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid_by_vport_idx);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vport_lid);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->vport_guid);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->vport_profile);

}

void SMP_VPortInfo_unpack(struct SMP_VPortInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->vport_capability_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->vguid_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 5;
	ptr_struct->lid_required = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 4;
	ptr_struct->vport_client_reregister = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->vport_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->qkey_violations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->pkey_violations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->lid_by_vport_idx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->vport_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->vport_guid = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->vport_profile = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void SMP_VPortInfo_print(const struct SMP_VPortInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_VPortInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_capability_mask : " UH_FMT "\n", ptr_struct->vport_capability_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vguid_cap            : " UH_FMT "\n", ptr_struct->vguid_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid_required         : " UH_FMT "\n", ptr_struct->lid_required);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_client_reregister : " UH_FMT "\n", ptr_struct->vport_client_reregister);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_state          : " UH_FMT "\n", ptr_struct->vport_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey_violations      : " UH_FMT "\n", ptr_struct->qkey_violations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_violations      : " UH_FMT "\n", ptr_struct->pkey_violations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid_by_vport_idx     : " UH_FMT "\n", ptr_struct->lid_by_vport_idx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_lid            : " UH_FMT "\n", ptr_struct->vport_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_guid           : " U64H_FMT "\n", ptr_struct->vport_guid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_profile        : " U64H_FMT "\n", ptr_struct->vport_profile);

}

int SMP_VPortInfo_size(void)
{
	 return 64;
}

void SMP_VPortInfo_dump(const struct SMP_VPortInfo *ptr_struct, FILE* file)
{
	SMP_VPortInfo_print(ptr_struct, file, 0);
}

void UINT128_pack(const struct UINT128 *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->High);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->Low);

}

void UINT128_unpack(struct UINT128 *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->High = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->Low = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void UINT128_print(const struct UINT128 *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== UINT128 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "High                 : " U64H_FMT "\n", ptr_struct->High);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Low                  : " U64H_FMT "\n", ptr_struct->Low);

}

int UINT128_size(void)
{
	 return 16;
}

void UINT128_dump(const struct UINT128 *ptr_struct, FILE* file)
{
	UINT128_print(ptr_struct, file, 0);
}

void VPortGUID_Block_Element_pack(const struct VPortGUID_Block_Element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->GUID[i]);
	}

}

void VPortGUID_Block_Element_unpack(struct VPortGUID_Block_Element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 512, 1);
	ptr_struct->GUID[i] = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);
	}

}

void VPortGUID_Block_Element_print(const struct VPortGUID_Block_Element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VPortGUID_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GUID_%03d            : " U64H_FMT "\n", i, ptr_struct->GUID[i]);
	}

}

int VPortGUID_Block_Element_size(void)
{
	 return 64;
}

void VPortGUID_Block_Element_dump(const struct VPortGUID_Block_Element *ptr_struct, FILE* file)
{
	VPortGUID_Block_Element_print(ptr_struct, file, 0);
}

void VS_CreditWatchdogTimeoutCounters_pack(const struct VS_CreditWatchdogTimeoutCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CounterSelect);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(32, 64, i, 1152, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->credit_watchdog_timeout_per_vl[i]);
	}

	offset = 992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->total_port_credit_watchdog_timeout);

}

void VS_CreditWatchdogTimeoutCounters_unpack(struct VS_CreditWatchdogTimeoutCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->CounterSelect = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(32, 64, i, 1152, 1);
	ptr_struct->credit_watchdog_timeout_per_vl[i] = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);
	}

	offset = 992;
	ptr_struct->total_port_credit_watchdog_timeout = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void VS_CreditWatchdogTimeoutCounters_print(const struct VS_CreditWatchdogTimeoutCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_CreditWatchdogTimeoutCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CounterSelect        : " UH_FMT "\n", ptr_struct->CounterSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "credit_watchdog_timeout_per_vl_%03d : " U64H_FMT "\n", i, ptr_struct->credit_watchdog_timeout_per_vl[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "total_port_credit_watchdog_timeout : " U64H_FMT "\n", ptr_struct->total_port_credit_watchdog_timeout);

}

int VS_CreditWatchdogTimeoutCounters_size(void)
{
	 return 144;
}

void VS_CreditWatchdogTimeoutCounters_dump(const struct VS_CreditWatchdogTimeoutCounters *ptr_struct, FILE* file)
{
	VS_CreditWatchdogTimeoutCounters_print(ptr_struct, file, 0);
}

void VS_Encapsulation_RemoteSPANGlobalUD_pack(const struct VS_Encapsulation_RemoteSPANGlobalUD *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dlid);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dpa);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->slid);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->swid);

	offset = 124;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset = 192;
	GID_Block_Element_pack(&(ptr_struct->sgid), ptr_buff + offset/8);

	offset = 320;
	GID_Block_Element_pack(&(ptr_struct->dgid), ptr_buff + offset/8);

	offset = 464;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey);

	offset = 457;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m);

	offset = 456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->se);

	offset = 488;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->dest_qp);

	offset = 520;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->psn_init_val);

	offset = 513;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ar);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->qkey);

	offset = 584;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->src_qp);

}

void VS_Encapsulation_RemoteSPANGlobalUD_unpack(struct VS_Encapsulation_RemoteSPANGlobalUD *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->dlid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 14;
	ptr_struct->dpa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->slid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 40;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->swid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 124;
	ptr_struct->vl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 140;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 132;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 184;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	GID_Block_Element_unpack(&(ptr_struct->sgid), ptr_buff + offset/8);

	offset = 320;
	GID_Block_Element_unpack(&(ptr_struct->dgid), ptr_buff + offset/8);

	offset = 464;
	ptr_struct->pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 457;
	ptr_struct->m = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 456;
	ptr_struct->se = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 488;
	ptr_struct->dest_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 520;
	ptr_struct->psn_init_val = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 513;
	ptr_struct->ar = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 544;
	ptr_struct->qkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 584;
	ptr_struct->src_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void VS_Encapsulation_RemoteSPANGlobalUD_print(const struct VS_Encapsulation_RemoteSPANGlobalUD *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_Encapsulation_RemoteSPANGlobalUD ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dlid                 : " UH_FMT "\n", ptr_struct->dlid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dpa                  : " UH_FMT "\n", ptr_struct->dpa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : " UH_FMT "\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slid                 : " UH_FMT "\n", ptr_struct->slid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swid                 : " UH_FMT "\n", ptr_struct->swid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl                   : " UH_FMT "\n", ptr_struct->vl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : " UH_FMT "\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : " UH_FMT "\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : " UH_FMT "\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sgid:\n");
	GID_Block_Element_print(&(ptr_struct->sgid), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dgid:\n");
	GID_Block_Element_print(&(ptr_struct->dgid), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey                 : " UH_FMT "\n", ptr_struct->pkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m                    : " UH_FMT "\n", ptr_struct->m);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "se                   : " UH_FMT "\n", ptr_struct->se);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dest_qp              : " UH_FMT "\n", ptr_struct->dest_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psn_init_val         : " UH_FMT "\n", ptr_struct->psn_init_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar                   : " UH_FMT "\n", ptr_struct->ar);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey                 : " U32H_FMT "\n", ptr_struct->qkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "src_qp               : " UH_FMT "\n", ptr_struct->src_qp);

}

int VS_Encapsulation_RemoteSPANGlobalUD_size(void)
{
	 return 80;
}

void VS_Encapsulation_RemoteSPANGlobalUD_dump(const struct VS_Encapsulation_RemoteSPANGlobalUD *ptr_struct, FILE* file)
{
	VS_Encapsulation_RemoteSPANGlobalUD_print(ptr_struct, file, 0);
}

void VS_PerformanceHistogramBufferData_pack(const struct VS_PerformanceHistogramBufferData *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->histogram_type);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->min_sampled);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->max_sampled);

	for (i = 0; i < 10; i++) {
	offset = adb2c_calc_array_field_address(192, 64, i, 832, 1);
	uint64bit_pack(&(ptr_struct->bin[i]), ptr_buff + offset/8);
	}

}

void VS_PerformanceHistogramBufferData_unpack(struct VS_PerformanceHistogramBufferData *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 32;
	ptr_struct->histogram_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 64;
	ptr_struct->min_sampled = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->max_sampled = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 10; i++) {
	offset = adb2c_calc_array_field_address(192, 64, i, 832, 1);
	uint64bit_unpack(&(ptr_struct->bin[i]), ptr_buff + offset/8);
	}

}

void VS_PerformanceHistogramBufferData_print(const struct VS_PerformanceHistogramBufferData *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_PerformanceHistogramBufferData ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "histogram_type       : " UH_FMT "\n", ptr_struct->histogram_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_sampled          : " U64H_FMT "\n", ptr_struct->min_sampled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_sampled          : " U64H_FMT "\n", ptr_struct->max_sampled);

	for (i = 0; i < 10; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bin_%03d:\n", i);
	uint64bit_print(&(ptr_struct->bin[i]), file, indent_level + 1);
	}

}

int VS_PerformanceHistogramBufferData_size(void)
{
	 return 104;
}

void VS_PerformanceHistogramBufferData_dump(const struct VS_PerformanceHistogramBufferData *ptr_struct, FILE* file)
{
	VS_PerformanceHistogramBufferData_print(ptr_struct, file, 0);
}

void VS_PerformanceHistogramPortsData_pack(const struct VS_PerformanceHistogramPortsData *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->histogram_type);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->min_sampled);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->max_sampled);

	for (i = 0; i < 10; i++) {
	offset = adb2c_calc_array_field_address(192, 64, i, 832, 1);
	uint64bit_pack(&(ptr_struct->bin[i]), ptr_buff + offset/8);
	}

}

void VS_PerformanceHistogramPortsData_unpack(struct VS_PerformanceHistogramPortsData *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 32;
	ptr_struct->histogram_type = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->min_sampled = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->max_sampled = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 10; i++) {
	offset = adb2c_calc_array_field_address(192, 64, i, 832, 1);
	uint64bit_unpack(&(ptr_struct->bin[i]), ptr_buff + offset/8);
	}

}

void VS_PerformanceHistogramPortsData_print(const struct VS_PerformanceHistogramPortsData *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_PerformanceHistogramPortsData ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "histogram_type       : " UH_FMT "\n", ptr_struct->histogram_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_sampled          : " U64H_FMT "\n", ptr_struct->min_sampled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_sampled          : " U64H_FMT "\n", ptr_struct->max_sampled);

	for (i = 0; i < 10; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bin_%03d:\n", i);
	uint64bit_print(&(ptr_struct->bin[i]), file, indent_level + 1);
	}

}

int VS_PerformanceHistogramPortsData_size(void)
{
	 return 104;
}

void VS_PerformanceHistogramPortsData_dump(const struct VS_PerformanceHistogramPortsData *ptr_struct, FILE* file)
{
	VS_PerformanceHistogramPortsData_print(ptr_struct, file, 0);
}

void VS_PortGeneralCounters_pack(const struct VS_PortGeneralCounters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->port_select);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capablity_mask);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->counter_select);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_icrc_error);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->tx_parity_error);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->contain_n_drain_xmit_discards);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->contain_n_drain_rcv_discards);

}

void VS_PortGeneralCounters_unpack(struct VS_PortGeneralCounters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->port_select = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->capablity_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->counter_select = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->rx_icrc_error = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->tx_parity_error = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->contain_n_drain_xmit_discards = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->contain_n_drain_rcv_discards = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void VS_PortGeneralCounters_print(const struct VS_PortGeneralCounters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_PortGeneralCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_select          : " UH_FMT "\n", ptr_struct->port_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capablity_mask       : " U32H_FMT "\n", ptr_struct->capablity_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_select       : " U32H_FMT "\n", ptr_struct->counter_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_icrc_error        : " U64H_FMT "\n", ptr_struct->rx_icrc_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_parity_error      : " U64H_FMT "\n", ptr_struct->tx_parity_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "contain_n_drain_xmit_discards : " U64H_FMT "\n", ptr_struct->contain_n_drain_xmit_discards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "contain_n_drain_rcv_discards : " U64H_FMT "\n", ptr_struct->contain_n_drain_rcv_discards);

}

int VS_PortGeneralCounters_size(void)
{
	 return 48;
}

void VS_PortGeneralCounters_dump(const struct VS_PortGeneralCounters *ptr_struct, FILE* file)
{
	VS_PortGeneralCounters_print(ptr_struct, file, 0);
}

void VS_SwitchNetworkInfo_pack(const struct VS_SwitchNetworkInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(64, 64, i, 1344, 1);
	ipv4_record_pack(&(ptr_struct->ipv4_record_arr[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(320, 256, i, 1344, 1);
	ipv6_record_pack(&(ptr_struct->ipv6_record_arr[i]), ptr_buff + offset/8);
	}

}

void VS_SwitchNetworkInfo_unpack(struct VS_SwitchNetworkInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(64, 64, i, 1344, 1);
	ipv4_record_unpack(&(ptr_struct->ipv4_record_arr[i]), ptr_buff + offset/8);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(320, 256, i, 1344, 1);
	ipv6_record_unpack(&(ptr_struct->ipv6_record_arr[i]), ptr_buff + offset/8);
	}

}

void VS_SwitchNetworkInfo_print(const struct VS_SwitchNetworkInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_SwitchNetworkInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipv4_record_arr_%03d:\n", i);
	ipv4_record_print(&(ptr_struct->ipv4_record_arr[i]), file, indent_level + 1);
	}

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipv6_record_arr_%03d:\n", i);
	ipv6_record_print(&(ptr_struct->ipv6_record_arr[i]), file, indent_level + 1);
	}

}

int VS_SwitchNetworkInfo_size(void)
{
	 return 168;
}

void VS_SwitchNetworkInfo_dump(const struct VS_SwitchNetworkInfo *ptr_struct, FILE* file)
{
	VS_SwitchNetworkInfo_print(ptr_struct, file, 0);
}

void VendorSpec_PortLLRStatistics_pack(const struct VendorSpec_PortLLRStatistics *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Reserved1);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved2);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvCells);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvCellForRetry);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortRcvRetry);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortXmitCells);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortXmitRetryCells);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortXmitRetry);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortSymbolError);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortErrorDetectionCounterLane0);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortErrorDetectionCounterLane1);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortErrorDetectionCounterLane2);

	offset = 672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PortErrorDetectionCounterLane3);

	offset = 752;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MaxRetransmissionRate);

}

void VendorSpec_PortLLRStatistics_unpack(struct VendorSpec_PortLLRStatistics *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->Reserved1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->Reserved2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->PortRcvCells = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->PortRcvCellForRetry = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->PortRcvRetry = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->PortXmitCells = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->PortXmitRetryCells = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 352;
	ptr_struct->PortXmitRetry = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 416;
	ptr_struct->PortSymbolError = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 480;
	ptr_struct->PortErrorDetectionCounterLane0 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 544;
	ptr_struct->PortErrorDetectionCounterLane1 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 608;
	ptr_struct->PortErrorDetectionCounterLane2 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 672;
	ptr_struct->PortErrorDetectionCounterLane3 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 752;
	ptr_struct->MaxRetransmissionRate = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void VendorSpec_PortLLRStatistics_print(const struct VendorSpec_PortLLRStatistics *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VendorSpec_PortLLRStatistics ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved1            : " UH_FMT "\n", ptr_struct->Reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved2            : " UH_FMT "\n", ptr_struct->Reserved2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvCells         : " U64H_FMT "\n", ptr_struct->PortRcvCells);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvCellForRetry  : " U64H_FMT "\n", ptr_struct->PortRcvCellForRetry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortRcvRetry         : " U64H_FMT "\n", ptr_struct->PortRcvRetry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitCells        : " U64H_FMT "\n", ptr_struct->PortXmitCells);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitRetryCells   : " U64H_FMT "\n", ptr_struct->PortXmitRetryCells);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortXmitRetry        : " U64H_FMT "\n", ptr_struct->PortXmitRetry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSymbolError      : " U64H_FMT "\n", ptr_struct->PortSymbolError);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortErrorDetectionCounterLane0 : " U64H_FMT "\n", ptr_struct->PortErrorDetectionCounterLane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortErrorDetectionCounterLane1 : " U64H_FMT "\n", ptr_struct->PortErrorDetectionCounterLane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortErrorDetectionCounterLane2 : " U64H_FMT "\n", ptr_struct->PortErrorDetectionCounterLane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortErrorDetectionCounterLane3 : " U64H_FMT "\n", ptr_struct->PortErrorDetectionCounterLane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MaxRetransmissionRate : " UH_FMT "\n", ptr_struct->MaxRetransmissionRate);

}

int VendorSpec_PortLLRStatistics_size(void)
{
	 return 96;
}

void VendorSpec_PortLLRStatistics_dump(const struct VendorSpec_PortLLRStatistics *ptr_struct, FILE* file)
{
	VendorSpec_PortLLRStatistics_print(ptr_struct, file, 0);
}

void adaptive_routing_group_table_copy_pack(const struct adaptive_routing_group_table_copy *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	adaptive_routing_group_table_copy_element_pack(&(ptr_struct->element[i]), ptr_buff + offset/8);
	}

}

void adaptive_routing_group_table_copy_unpack(struct adaptive_routing_group_table_copy *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	adaptive_routing_group_table_copy_element_unpack(&(ptr_struct->element[i]), ptr_buff + offset/8);
	}

}

void adaptive_routing_group_table_copy_print(const struct adaptive_routing_group_table_copy *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== adaptive_routing_group_table_copy ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "element_%03d:\n", i);
	adaptive_routing_group_table_copy_element_print(&(ptr_struct->element[i]), file, indent_level + 1);
	}

}

int adaptive_routing_group_table_copy_size(void)
{
	 return 64;
}

void adaptive_routing_group_table_copy_dump(const struct adaptive_routing_group_table_copy *ptr_struct, FILE* file)
{
	adaptive_routing_group_table_copy_print(ptr_struct, file, 0);
}

void hbf_config_pack(const struct hbf_config *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->seed_type);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hash_type);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->seed);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->fields_enable);

}

void hbf_config_unpack(struct hbf_config *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 6;
	ptr_struct->seed_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->hash_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->seed = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->fields_enable = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void hbf_config_print(const struct hbf_config *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== hbf_config ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "seed_type            : " UH_FMT "\n", ptr_struct->seed_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hash_type            : " UH_FMT "\n", ptr_struct->hash_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "seed                 : " U32H_FMT "\n", ptr_struct->seed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fields_enable        : " U64H_FMT "\n", ptr_struct->fields_enable);

}

int hbf_config_size(void)
{
	 return 20;
}

void hbf_config_dump(const struct hbf_config *ptr_struct, FILE* file)
{
	hbf_config_print(ptr_struct, file, 0);
}

void ib_ar_linear_forwarding_table_pack(const struct ib_ar_linear_forwarding_table *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	ib_ar_lft_block_element_pack(&(ptr_struct->LidEntry[i]), ptr_buff + offset/8);
	}

}

void ib_ar_linear_forwarding_table_unpack(struct ib_ar_linear_forwarding_table *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	ib_ar_lft_block_element_unpack(&(ptr_struct->LidEntry[i]), ptr_buff + offset/8);
	}

}

void ib_ar_linear_forwarding_table_print(const struct ib_ar_linear_forwarding_table *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_ar_linear_forwarding_table ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidEntry_%03d:\n", i);
	ib_ar_lft_block_element_print(&(ptr_struct->LidEntry[i]), file, indent_level + 1);
	}

}

int ib_ar_linear_forwarding_table_size(void)
{
	 return 64;
}

void ib_ar_linear_forwarding_table_dump(const struct ib_ar_linear_forwarding_table *ptr_struct, FILE* file)
{
	ib_ar_linear_forwarding_table_print(ptr_struct, file, 0);
}

void ib_ar_linear_forwarding_table_sx_pack(const struct ib_ar_linear_forwarding_table_sx *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ib_ar_lft_block_element_sx_pack(&(ptr_struct->LidEntry[i]), ptr_buff + offset/8);
	}

}

void ib_ar_linear_forwarding_table_sx_unpack(struct ib_ar_linear_forwarding_table_sx *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ib_ar_lft_block_element_sx_unpack(&(ptr_struct->LidEntry[i]), ptr_buff + offset/8);
	}

}

void ib_ar_linear_forwarding_table_sx_print(const struct ib_ar_linear_forwarding_table_sx *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_ar_linear_forwarding_table_sx ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidEntry_%03d:\n", i);
	ib_ar_lft_block_element_sx_print(&(ptr_struct->LidEntry[i]), file, indent_level + 1);
	}

}

int ib_ar_linear_forwarding_table_sx_size(void)
{
	 return 64;
}

void ib_ar_linear_forwarding_table_sx_dump(const struct ib_ar_linear_forwarding_table_sx *ptr_struct, FILE* file)
{
	ib_ar_linear_forwarding_table_sx_print(ptr_struct, file, 0);
}

void ib_port_sl_to_private_lft_map_pack(const struct ib_port_sl_to_private_lft_map *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 512, 1);
	ib_port_sl_to_plft_pack(&(ptr_struct->PortSLToPLFT[i]), ptr_buff + offset/8);
	}

}

void ib_port_sl_to_private_lft_map_unpack(struct ib_port_sl_to_private_lft_map *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 512, 1);
	ib_port_sl_to_plft_unpack(&(ptr_struct->PortSLToPLFT[i]), ptr_buff + offset/8);
	}

}

void ib_port_sl_to_private_lft_map_print(const struct ib_port_sl_to_private_lft_map *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_port_sl_to_private_lft_map ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSLToPLFT_%03d:\n", i);
	ib_port_sl_to_plft_print(&(ptr_struct->PortSLToPLFT[i]), file, indent_level + 1);
	}

}

int ib_port_sl_to_private_lft_map_size(void)
{
	 return 64;
}

void ib_port_sl_to_private_lft_map_dump(const struct ib_port_sl_to_private_lft_map *ptr_struct, FILE* file)
{
	ib_port_sl_to_private_lft_map_print(ptr_struct, file, 0);
}

void ib_portgroup_block_element_pack(const struct ib_portgroup_block_element *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubGroup_3);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubGroup_2);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubGroup_1);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubGroup_0);

}

void ib_portgroup_block_element_unpack(struct ib_portgroup_block_element *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->SubGroup_3 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->SubGroup_2 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->SubGroup_1 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->SubGroup_0 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void ib_portgroup_block_element_print(const struct ib_portgroup_block_element *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_portgroup_block_element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubGroup_3           : " U64H_FMT "\n", ptr_struct->SubGroup_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubGroup_2           : " U64H_FMT "\n", ptr_struct->SubGroup_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubGroup_1           : " U64H_FMT "\n", ptr_struct->SubGroup_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubGroup_0           : " U64H_FMT "\n", ptr_struct->SubGroup_0);

}

int ib_portgroup_block_element_size(void)
{
	 return 32;
}

void ib_portgroup_block_element_dump(const struct ib_portgroup_block_element *ptr_struct, FILE* file)
{
	ib_portgroup_block_element_print(ptr_struct, file, 0);
}

void ib_private_lft_def_pack(const struct ib_private_lft_def *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ib_lft_def_pack(&(ptr_struct->LFT[i]), ptr_buff + offset/8);
	}

}

void ib_private_lft_def_unpack(struct ib_private_lft_def *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ib_lft_def_unpack(&(ptr_struct->LFT[i]), ptr_buff + offset/8);
	}

}

void ib_private_lft_def_print(const struct ib_private_lft_def *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_private_lft_def ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LFT_%03d:\n", i);
	ib_lft_def_print(&(ptr_struct->LFT[i]), file, indent_level + 1);
	}

}

int ib_private_lft_def_size(void)
{
	 return 64;
}

void ib_private_lft_def_dump(const struct ib_private_lft_def *ptr_struct, FILE* file)
{
	ib_private_lft_def_print(ptr_struct, file, 0);
}

void ib_private_lft_info_pack(const struct ib_private_lft_info *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->Active_Mode);

	offset = 21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ModeCap);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NumPLFTs);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->NoFallback);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(48, 16, i, 512, 1);
	ib_description_mode_pack(&(ptr_struct->Description_Mode[i]), ptr_buff + offset/8);
	}

}

void ib_private_lft_info_unpack(struct ib_private_lft_info *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->Active_Mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 21;
	ptr_struct->ModeCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 8;
	ptr_struct->NumPLFTs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 7;
	ptr_struct->NoFallback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(48, 16, i, 512, 1);
	ib_description_mode_unpack(&(ptr_struct->Description_Mode[i]), ptr_buff + offset/8);
	}

}

void ib_private_lft_info_print(const struct ib_private_lft_info *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_private_lft_info ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Active_Mode          : " UH_FMT "\n", ptr_struct->Active_Mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ModeCap              : " UH_FMT "\n", ptr_struct->ModeCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NumPLFTs             : " UH_FMT "\n", ptr_struct->NumPLFTs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NoFallback           : " UH_FMT "\n", ptr_struct->NoFallback);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Description_Mode_%03d:\n", i);
	ib_description_mode_print(&(ptr_struct->Description_Mode[i]), file, indent_level + 1);
	}

}

int ib_private_lft_info_size(void)
{
	 return 64;
}

void ib_private_lft_info_dump(const struct ib_private_lft_info *ptr_struct, FILE* file)
{
	ib_private_lft_info_print(ptr_struct, file, 0);
}

void neighbor_record_pack(const struct neighbor_record *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->node_type);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->key);

}

void neighbor_record_unpack(struct neighbor_record *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->node_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 64;
	ptr_struct->key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void neighbor_record_print(const struct neighbor_record *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== neighbor_record ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid                  : " UH_FMT "\n", ptr_struct->lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_type            : " UH_FMT "\n", ptr_struct->node_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "key                  : " U64H_FMT "\n", ptr_struct->key);

}

int neighbor_record_size(void)
{
	 return 16;
}

void neighbor_record_dump(const struct neighbor_record *ptr_struct, FILE* file)
{
	neighbor_record_print(ptr_struct, file, 0);
}

void port_rn_counters_pack(const struct port_rn_counters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->counter_select);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_select);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_rcv_rn_pkt);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_xmit_rn_pkt);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_rcv_rn_error);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_rcv_switch_relay_rn_error);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_ar_trials);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pfrn_received_packet);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pfrn_received_error);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pfrn_xmit_packet);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pfrn_start_packet);

}

void port_rn_counters_unpack(struct port_rn_counters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->counter_select = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->port_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->port_rcv_rn_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->port_xmit_rn_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->port_rcv_rn_error = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->port_rcv_switch_relay_rn_error = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->port_ar_trials = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 352;
	ptr_struct->pfrn_received_packet = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->pfrn_received_error = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->pfrn_xmit_packet = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->pfrn_start_packet = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void port_rn_counters_print(const struct port_rn_counters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== port_rn_counters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_select       : " UH_FMT "\n", ptr_struct->counter_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_select          : " UH_FMT "\n", ptr_struct->port_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_rn_pkt      : " U64H_FMT "\n", ptr_struct->port_rcv_rn_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_rn_pkt     : " U64H_FMT "\n", ptr_struct->port_xmit_rn_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_rn_error    : " U64H_FMT "\n", ptr_struct->port_rcv_rn_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_switch_relay_rn_error : " U64H_FMT "\n", ptr_struct->port_rcv_switch_relay_rn_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_ar_trials       : " U64H_FMT "\n", ptr_struct->port_ar_trials);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pfrn_received_packet : " U32H_FMT "\n", ptr_struct->pfrn_received_packet);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pfrn_received_error  : " U32H_FMT "\n", ptr_struct->pfrn_received_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pfrn_xmit_packet     : " U32H_FMT "\n", ptr_struct->pfrn_xmit_packet);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pfrn_start_packet    : " U32H_FMT "\n", ptr_struct->pfrn_start_packet);

}

int port_rn_counters_size(void)
{
	 return 192;
}

void port_rn_counters_dump(const struct port_rn_counters *ptr_struct, FILE* file)
{
	port_rn_counters_print(ptr_struct, file, 0);
}

void port_routing_decision_counters_pack(const struct port_routing_decision_counters *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->counter_select);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_select);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_static);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_hbf);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_ar);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_hbf_fallback_local);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_hbf_fallback_remote);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_hbf_sg0);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_hbf_sg1);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_hbf_sg2);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_ar_sg0);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_ar_sg1);

	offset = 672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rx_pkt_forwarding_ar_sg2);

}

void port_routing_decision_counters_unpack(struct port_routing_decision_counters *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->counter_select = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->port_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->rx_pkt_forwarding_static = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->rx_pkt_forwarding_hbf = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->rx_pkt_forwarding_ar = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->rx_pkt_hbf_fallback_local = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->rx_pkt_hbf_fallback_remote = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 352;
	ptr_struct->rx_pkt_forwarding_hbf_sg0 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 416;
	ptr_struct->rx_pkt_forwarding_hbf_sg1 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 480;
	ptr_struct->rx_pkt_forwarding_hbf_sg2 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 544;
	ptr_struct->rx_pkt_forwarding_ar_sg0 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 608;
	ptr_struct->rx_pkt_forwarding_ar_sg1 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 672;
	ptr_struct->rx_pkt_forwarding_ar_sg2 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void port_routing_decision_counters_print(const struct port_routing_decision_counters *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== port_routing_decision_counters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_select       : " UH_FMT "\n", ptr_struct->counter_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_select          : " UH_FMT "\n", ptr_struct->port_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_static : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_static);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_hbf : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_hbf);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_ar : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_ar);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_hbf_fallback_local : " U64H_FMT "\n", ptr_struct->rx_pkt_hbf_fallback_local);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_hbf_fallback_remote : " U64H_FMT "\n", ptr_struct->rx_pkt_hbf_fallback_remote);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_hbf_sg0 : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_hbf_sg0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_hbf_sg1 : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_hbf_sg1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_hbf_sg2 : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_hbf_sg2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_ar_sg0 : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_ar_sg0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_ar_sg1 : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_ar_sg1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pkt_forwarding_ar_sg2 : " U64H_FMT "\n", ptr_struct->rx_pkt_forwarding_ar_sg2);

}

int port_routing_decision_counters_size(void)
{
	 return 92;
}

void port_routing_decision_counters_dump(const struct port_routing_decision_counters *ptr_struct, FILE* file)
{
	port_routing_decision_counters_print(ptr_struct, file, 0);
}

void rn_gen_by_sub_group_prio_pack(const struct rn_gen_by_sub_group_prio *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	rn_gen_by_sub_group_prio_element_pack(&(ptr_struct->element[i]), ptr_buff + offset/8);
	}

}

void rn_gen_by_sub_group_prio_unpack(struct rn_gen_by_sub_group_prio *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	rn_gen_by_sub_group_prio_element_unpack(&(ptr_struct->element[i]), ptr_buff + offset/8);
	}

}

void rn_gen_by_sub_group_prio_print(const struct rn_gen_by_sub_group_prio *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_gen_by_sub_group_prio ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "element_%03d:\n", i);
	rn_gen_by_sub_group_prio_element_print(&(ptr_struct->element[i]), file, indent_level + 1);
	}

}

int rn_gen_by_sub_group_prio_size(void)
{
	 return 64;
}

void rn_gen_by_sub_group_prio_dump(const struct rn_gen_by_sub_group_prio *ptr_struct, FILE* file)
{
	rn_gen_by_sub_group_prio_print(ptr_struct, file, 0);
}

void rn_gen_by_sub_group_priority_pack(const struct rn_gen_by_sub_group_priority *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	rn_gen_by_sub_group_priority_element_pack(&(ptr_struct->sub_group_priority_element[i]), ptr_buff + offset/8);
	}

}

void rn_gen_by_sub_group_priority_unpack(struct rn_gen_by_sub_group_priority *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	rn_gen_by_sub_group_priority_element_unpack(&(ptr_struct->sub_group_priority_element[i]), ptr_buff + offset/8);
	}

}

void rn_gen_by_sub_group_priority_print(const struct rn_gen_by_sub_group_priority *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_gen_by_sub_group_priority ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sub_group_priority_element_%03d:\n", i);
	rn_gen_by_sub_group_priority_element_print(&(ptr_struct->sub_group_priority_element[i]), file, indent_level + 1);
	}

}

int rn_gen_by_sub_group_priority_size(void)
{
	 return 64;
}

void rn_gen_by_sub_group_priority_dump(const struct rn_gen_by_sub_group_priority *ptr_struct, FILE* file)
{
	rn_gen_by_sub_group_priority_print(ptr_struct, file, 0);
}

void rn_gen_string_tbl_pack(const struct rn_gen_string_tbl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	rn_gen_string_element_pack(&(ptr_struct->element[i]), ptr_buff + offset/8);
	}

}

void rn_gen_string_tbl_unpack(struct rn_gen_string_tbl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	rn_gen_string_element_unpack(&(ptr_struct->element[i]), ptr_buff + offset/8);
	}

}

void rn_gen_string_tbl_print(const struct rn_gen_string_tbl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_gen_string_tbl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "element_%03d:\n", i);
	rn_gen_string_element_print(&(ptr_struct->element[i]), file, indent_level + 1);
	}

}

int rn_gen_string_tbl_size(void)
{
	 return 64;
}

void rn_gen_string_tbl_dump(const struct rn_gen_string_tbl *ptr_struct, FILE* file)
{
	rn_gen_string_tbl_print(ptr_struct, file, 0);
}

void rn_rcv_string_pack(const struct rn_rcv_string *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	rn_rcv_string_element_pack(&(ptr_struct->element[i]), ptr_buff + offset/8);
	}

}

void rn_rcv_string_unpack(struct rn_rcv_string *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	rn_rcv_string_element_unpack(&(ptr_struct->element[i]), ptr_buff + offset/8);
	}

}

void rn_rcv_string_print(const struct rn_rcv_string *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== rn_rcv_string ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "element_%03d:\n", i);
	rn_rcv_string_element_print(&(ptr_struct->element[i]), file, indent_level + 1);
	}

}

int rn_rcv_string_size(void)
{
	 return 64;
}

void rn_rcv_string_dump(const struct rn_rcv_string *ptr_struct, FILE* file)
{
	rn_rcv_string_print(ptr_struct, file, 0);
}

void whbf_config_pack(const struct whbf_config *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	group_weights_pack(&(ptr_struct->group_weights_arr[i]), ptr_buff + offset/8);
	}

}

void whbf_config_unpack(struct whbf_config *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	group_weights_unpack(&(ptr_struct->group_weights_arr[i]), ptr_buff + offset/8);
	}

}

void whbf_config_print(const struct whbf_config *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== whbf_config ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_weights_arr_%03d:\n", i);
	group_weights_print(&(ptr_struct->group_weights_arr[i]), file, indent_level + 1);
	}

}

int whbf_config_size(void)
{
	 return 64;
}

void whbf_config_dump(const struct whbf_config *ptr_struct, FILE* file)
{
	whbf_config_print(ptr_struct, file, 0);
}

void CC_CACongestionSetting_pack(const struct CC_CACongestionSetting *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Control_Map);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Port_Control);

	offset = 32;
	CACongestionEntryList_pack(&(ptr_struct->CACongestionEntryList), ptr_buff + offset/8);

}

void CC_CACongestionSetting_unpack(struct CC_CACongestionSetting *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->Control_Map = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->Port_Control = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	CACongestionEntryList_unpack(&(ptr_struct->CACongestionEntryList), ptr_buff + offset/8);

}

void CC_CACongestionSetting_print(const struct CC_CACongestionSetting *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CACongestionSetting ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Control_Map          : " UH_FMT "\n", ptr_struct->Control_Map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Port_Control         : " UH_FMT "\n", ptr_struct->Port_Control);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CACongestionEntryList:\n");
	CACongestionEntryList_print(&(ptr_struct->CACongestionEntryList), file, indent_level + 1);

}

int CC_CACongestionSetting_size(void)
{
	 return 132;
}

void CC_CACongestionSetting_dump(const struct CC_CACongestionSetting *ptr_struct, FILE* file)
{
	CC_CACongestionSetting_print(ptr_struct, file, 0);
}

void CC_CongestionControlTable_pack(const struct CC_CongestionControlTable *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->CCTI_Limit);

	offset = 32;
	CCTI_Entry_List_pack(&(ptr_struct->CCTI_Entry_List), ptr_buff + offset/8);

}

void CC_CongestionControlTable_unpack(struct CC_CongestionControlTable *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->CCTI_Limit = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	CCTI_Entry_List_unpack(&(ptr_struct->CCTI_Entry_List), ptr_buff + offset/8);

}

void CC_CongestionControlTable_print(const struct CC_CongestionControlTable *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionControlTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CCTI_Limit           : " UH_FMT "\n", ptr_struct->CCTI_Limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CCTI_Entry_List:\n");
	CCTI_Entry_List_print(&(ptr_struct->CCTI_Entry_List), file, indent_level + 1);

}

int CC_CongestionControlTable_size(void)
{
	 return 132;
}

void CC_CongestionControlTable_dump(const struct CC_CongestionControlTable *ptr_struct, FILE* file)
{
	CC_CongestionControlTable_print(ptr_struct, file, 0);
}

void CC_CongestionLogCA_pack(const struct CC_CongestionLogCA *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ThresholdEventCounter);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->CongestionFlags);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LogType);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ThresholdCongestionEventMap);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->CurrentTimeStamp);

	offset = 96;
	CongestionLogEventListCA_pack(&(ptr_struct->CongestionLogEvent), ptr_buff + offset/8);

}

void CC_CongestionLogCA_unpack(struct CC_CongestionLogCA *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->ThresholdEventCounter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->CongestionFlags = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->LogType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->ThresholdCongestionEventMap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->CurrentTimeStamp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	CongestionLogEventListCA_unpack(&(ptr_struct->CongestionLogEvent), ptr_buff + offset/8);

}

void CC_CongestionLogCA_print(const struct CC_CongestionLogCA *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionLogCA ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ThresholdEventCounter : " UH_FMT "\n", ptr_struct->ThresholdEventCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CongestionFlags      : " UH_FMT "\n", ptr_struct->CongestionFlags);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LogType              : " UH_FMT "\n", ptr_struct->LogType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ThresholdCongestionEventMap : " UH_FMT "\n", ptr_struct->ThresholdCongestionEventMap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CurrentTimeStamp     : " U32H_FMT "\n", ptr_struct->CurrentTimeStamp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CongestionLogEvent:\n");
	CongestionLogEventListCA_print(&(ptr_struct->CongestionLogEvent), file, indent_level + 1);

}

int CC_CongestionLogCA_size(void)
{
	 return 220;
}

void CC_CongestionLogCA_dump(const struct CC_CongestionLogCA *ptr_struct, FILE* file)
{
	CC_CongestionLogCA_print(ptr_struct, file, 0);
}

void CC_CongestionLogSwitch_pack(const struct CC_CongestionLogSwitch *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LogEventsCounter);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->CongestionFlags);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LogType);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->CurrentTimeStamp);

	offset = 64;
	UINT256_pack(&(ptr_struct->PortMap), ptr_buff + offset/8);

	offset = 320;
	CongestionEntryListSwitch_pack(&(ptr_struct->CongestionEntryList), ptr_buff + offset/8);

}

void CC_CongestionLogSwitch_unpack(struct CC_CongestionLogSwitch *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->LogEventsCounter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->CongestionFlags = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->LogType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->CurrentTimeStamp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	UINT256_unpack(&(ptr_struct->PortMap), ptr_buff + offset/8);

	offset = 320;
	CongestionEntryListSwitch_unpack(&(ptr_struct->CongestionEntryList), ptr_buff + offset/8);

}

void CC_CongestionLogSwitch_print(const struct CC_CongestionLogSwitch *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_CongestionLogSwitch ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LogEventsCounter     : " UH_FMT "\n", ptr_struct->LogEventsCounter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CongestionFlags      : " UH_FMT "\n", ptr_struct->CongestionFlags);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LogType              : " UH_FMT "\n", ptr_struct->LogType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CurrentTimeStamp     : " U32H_FMT "\n", ptr_struct->CurrentTimeStamp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMap:\n");
	UINT256_print(&(ptr_struct->PortMap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CongestionEntryList:\n");
	CongestionEntryListSwitch_print(&(ptr_struct->CongestionEntryList), file, indent_level + 1);

}

int CC_CongestionLogSwitch_size(void)
{
	 return 220;
}

void CC_CongestionLogSwitch_dump(const struct CC_CongestionLogSwitch *ptr_struct, FILE* file)
{
	CC_CongestionLogSwitch_print(ptr_struct, file, 0);
}

void CC_Notice_pack(const struct CC_Notice *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->ProducerType_VendorID);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->Type);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->IsGeneric);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->IssuerLID);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->TrapNumber);

	offset = 64;
	CC_KeyViolation_pack(&(ptr_struct->CC_KeyViolation), ptr_buff + offset/8);

	offset = 512;
	GID_Block_Element_pack(&(ptr_struct->IssuerGID), ptr_buff + offset/8);

}

void CC_Notice_unpack(struct CC_Notice *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->ProducerType_VendorID = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 1;
	ptr_struct->Type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 0;
	ptr_struct->IsGeneric = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->IssuerLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->TrapNumber = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	CC_KeyViolation_unpack(&(ptr_struct->CC_KeyViolation), ptr_buff + offset/8);

	offset = 512;
	GID_Block_Element_unpack(&(ptr_struct->IssuerGID), ptr_buff + offset/8);

}

void CC_Notice_print(const struct CC_Notice *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CC_Notice ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ProducerType_VendorID : " UH_FMT "\n", ptr_struct->ProducerType_VendorID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Type                 : " UH_FMT "\n", ptr_struct->Type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IsGeneric            : " UH_FMT "\n", ptr_struct->IsGeneric);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IssuerLID            : " UH_FMT "\n", ptr_struct->IssuerLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapNumber           : " UH_FMT "\n", ptr_struct->TrapNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_KeyViolation:\n");
	CC_KeyViolation_print(&(ptr_struct->CC_KeyViolation), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IssuerGID:\n");
	GID_Block_Element_print(&(ptr_struct->IssuerGID), file, indent_level + 1);

}

int CC_Notice_size(void)
{
	 return 80;
}

void CC_Notice_dump(const struct CC_Notice *ptr_struct, FILE* file)
{
	CC_Notice_print(ptr_struct, file, 0);
}

void MAD_AggregationManagement_pack(const struct MAD_AggregationManagement *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_pack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->am_key);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(256, 32, i, 2048, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved_Dword[i]);
	}

	offset = 512;
	AggregationManagement_MAD_Data_Block_Element_pack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void MAD_AggregationManagement_unpack(struct MAD_AggregationManagement *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_unpack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	ptr_struct->am_key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(256, 32, i, 2048, 1);
	ptr_struct->Reserved_Dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 512;
	AggregationManagement_MAD_Data_Block_Element_unpack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void MAD_AggregationManagement_print(const struct MAD_AggregationManagement *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_AggregationManagement ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common:\n");
	MAD_Header_Common_print(&(ptr_struct->MAD_Header_Common), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "am_key               : " U64H_FMT "\n", ptr_struct->am_key);

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved_Dword_%03d  : " U32H_FMT "\n", i, ptr_struct->Reserved_Dword[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data:\n");
	AggregationManagement_MAD_Data_Block_Element_print(&(ptr_struct->Data), file, indent_level + 1);

}

int MAD_AggregationManagement_size(void)
{
	 return 256;
}

void MAD_AggregationManagement_dump(const struct MAD_AggregationManagement *ptr_struct, FILE* file)
{
	MAD_AggregationManagement_print(ptr_struct, file, 0);
}

void MAD_Class_C_pack(const struct MAD_Class_C *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_pack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->N2N_Key);

	offset = 256;
	Class_C_Data_Block_Element_pack(&(ptr_struct->Class_C_Data), ptr_buff + offset/8);

}

void MAD_Class_C_unpack(struct MAD_Class_C *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_unpack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	ptr_struct->N2N_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	Class_C_Data_Block_Element_unpack(&(ptr_struct->Class_C_Data), ptr_buff + offset/8);

}

void MAD_Class_C_print(const struct MAD_Class_C *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_Class_C ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common:\n");
	MAD_Header_Common_print(&(ptr_struct->MAD_Header_Common), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "N2N_Key              : " U64H_FMT "\n", ptr_struct->N2N_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Class_C_Data:\n");
	Class_C_Data_Block_Element_print(&(ptr_struct->Class_C_Data), file, indent_level + 1);

}

int MAD_Class_C_size(void)
{
	 return 256;
}

void MAD_Class_C_dump(const struct MAD_Class_C *ptr_struct, FILE* file)
{
	MAD_Class_C_print(ptr_struct, file, 0);
}

void MAD_Class_RDM_pack(const struct MAD_Class_RDM *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_pack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->VS_Key);

	offset = 256;
	Class_RDM_Data_Block_Element_pack(&(ptr_struct->Class_RDM_Data), ptr_buff + offset/8);

}

void MAD_Class_RDM_unpack(struct MAD_Class_RDM *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_unpack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	ptr_struct->VS_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	Class_RDM_Data_Block_Element_unpack(&(ptr_struct->Class_RDM_Data), ptr_buff + offset/8);

}

void MAD_Class_RDM_print(const struct MAD_Class_RDM *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_Class_RDM ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common:\n");
	MAD_Header_Common_print(&(ptr_struct->MAD_Header_Common), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_Key               : " U64H_FMT "\n", ptr_struct->VS_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Class_RDM_Data:\n");
	Class_RDM_Data_Block_Element_print(&(ptr_struct->Class_RDM_Data), file, indent_level + 1);

}

int MAD_Class_RDM_size(void)
{
	 return 256;
}

void MAD_Class_RDM_dump(const struct MAD_Class_RDM *ptr_struct, FILE* file)
{
	MAD_Class_RDM_print(ptr_struct, file, 0);
}

void MAD_CongestionControl_pack(const struct MAD_CongestionControl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_pack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->CC_Key);

	offset = 256;
	CC_Log_Data_Block_Element_pack(&(ptr_struct->CC_LogData), ptr_buff + offset/8);

	offset = 512;
	CC_Mgt_Data_Block_Element_pack(&(ptr_struct->CC_MgtData), ptr_buff + offset/8);

}

void MAD_CongestionControl_unpack(struct MAD_CongestionControl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_unpack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	ptr_struct->CC_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	CC_Log_Data_Block_Element_unpack(&(ptr_struct->CC_LogData), ptr_buff + offset/8);

	offset = 512;
	CC_Mgt_Data_Block_Element_unpack(&(ptr_struct->CC_MgtData), ptr_buff + offset/8);

}

void MAD_CongestionControl_print(const struct MAD_CongestionControl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_CongestionControl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common:\n");
	MAD_Header_Common_print(&(ptr_struct->MAD_Header_Common), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_Key               : " U64H_FMT "\n", ptr_struct->CC_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_LogData:\n");
	CC_Log_Data_Block_Element_print(&(ptr_struct->CC_LogData), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_MgtData:\n");
	CC_Mgt_Data_Block_Element_print(&(ptr_struct->CC_MgtData), file, indent_level + 1);

}

int MAD_CongestionControl_size(void)
{
	 return 256;
}

void MAD_CongestionControl_dump(const struct MAD_CongestionControl *ptr_struct, FILE* file)
{
	MAD_CongestionControl_print(ptr_struct, file, 0);
}

void MAD_PerformanceManagement_pack(const struct MAD_PerformanceManagement *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_pack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->PM_Key);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(256, 32, i, 2048, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved_Dword[i]);
	}

	offset = 512;
	PerfManagement_MAD_Data_Block_Element_pack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void MAD_PerformanceManagement_unpack(struct MAD_PerformanceManagement *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_unpack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	ptr_struct->PM_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(256, 32, i, 2048, 1);
	ptr_struct->Reserved_Dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 512;
	PerfManagement_MAD_Data_Block_Element_unpack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void MAD_PerformanceManagement_print(const struct MAD_PerformanceManagement *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_PerformanceManagement ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common:\n");
	MAD_Header_Common_print(&(ptr_struct->MAD_Header_Common), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_Key               : " U64H_FMT "\n", ptr_struct->PM_Key);

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved_Dword_%03d  : " U32H_FMT "\n", i, ptr_struct->Reserved_Dword[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data:\n");
	PerfManagement_MAD_Data_Block_Element_print(&(ptr_struct->Data), file, indent_level + 1);

}

int MAD_PerformanceManagement_size(void)
{
	 return 256;
}

void MAD_PerformanceManagement_dump(const struct MAD_PerformanceManagement *ptr_struct, FILE* file)
{
	MAD_PerformanceManagement_print(ptr_struct, file, 0);
}

void MAD_SMP_Direct_Routed_pack(const struct MAD_SMP_Direct_Routed *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_SMP_Direct_Routed_pack(&(ptr_struct->MAD_Header_SMP_Direct_Routed), ptr_buff + offset/8);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->M_Key);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DrDLID);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DrSLID);

	for (i = 0; i < 7; i++) {
	offset = adb2c_calc_array_field_address(288, 32, i, 2048, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved[i]);
	}

	offset = 512;
	SMP_MAD_Data_Block_Element_pack(&(ptr_struct->Data), ptr_buff + offset/8);

	offset = 1024;
	DirRPath_Block_Element_pack(&(ptr_struct->InitPath), ptr_buff + offset/8);

	offset = 1536;
	DirRPath_Block_Element_pack(&(ptr_struct->RetPath), ptr_buff + offset/8);

}

void MAD_SMP_Direct_Routed_unpack(struct MAD_SMP_Direct_Routed *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_SMP_Direct_Routed_unpack(&(ptr_struct->MAD_Header_SMP_Direct_Routed), ptr_buff + offset/8);

	offset = 192;
	ptr_struct->M_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 272;
	ptr_struct->DrDLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->DrSLID = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 7; i++) {
	offset = adb2c_calc_array_field_address(288, 32, i, 2048, 1);
	ptr_struct->Reserved[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 512;
	SMP_MAD_Data_Block_Element_unpack(&(ptr_struct->Data), ptr_buff + offset/8);

	offset = 1024;
	DirRPath_Block_Element_unpack(&(ptr_struct->InitPath), ptr_buff + offset/8);

	offset = 1536;
	DirRPath_Block_Element_unpack(&(ptr_struct->RetPath), ptr_buff + offset/8);

}

void MAD_SMP_Direct_Routed_print(const struct MAD_SMP_Direct_Routed *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_SMP_Direct_Routed ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_SMP_Direct_Routed:\n");
	MAD_Header_SMP_Direct_Routed_print(&(ptr_struct->MAD_Header_SMP_Direct_Routed), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "M_Key                : " U64H_FMT "\n", ptr_struct->M_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DrDLID               : " UH_FMT "\n", ptr_struct->DrDLID);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DrSLID               : " UH_FMT "\n", ptr_struct->DrSLID);

	for (i = 0; i < 7; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved_%03d        : " U32H_FMT "\n", i, ptr_struct->Reserved[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data:\n");
	SMP_MAD_Data_Block_Element_print(&(ptr_struct->Data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "InitPath:\n");
	DirRPath_Block_Element_print(&(ptr_struct->InitPath), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RetPath:\n");
	DirRPath_Block_Element_print(&(ptr_struct->RetPath), file, indent_level + 1);

}

int MAD_SMP_Direct_Routed_size(void)
{
	 return 256;
}

void MAD_SMP_Direct_Routed_dump(const struct MAD_SMP_Direct_Routed *ptr_struct, FILE* file)
{
	MAD_SMP_Direct_Routed_print(ptr_struct, file, 0);
}

void MAD_SMP_LID_Routed_pack(const struct MAD_SMP_LID_Routed *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_pack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->M_Key);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(256, 32, i, 2048, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved1[i]);
	}

	offset = 512;
	SMP_MAD_Data_Block_Element_pack(&(ptr_struct->Data), ptr_buff + offset/8);

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(1024, 32, i, 2048, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved2[i]);
	}

}

void MAD_SMP_LID_Routed_unpack(struct MAD_SMP_LID_Routed *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_unpack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	ptr_struct->M_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(256, 32, i, 2048, 1);
	ptr_struct->Reserved1[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 512;
	SMP_MAD_Data_Block_Element_unpack(&(ptr_struct->Data), ptr_buff + offset/8);

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(1024, 32, i, 2048, 1);
	ptr_struct->Reserved2[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void MAD_SMP_LID_Routed_print(const struct MAD_SMP_LID_Routed *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_SMP_LID_Routed ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common:\n");
	MAD_Header_Common_print(&(ptr_struct->MAD_Header_Common), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "M_Key                : " U64H_FMT "\n", ptr_struct->M_Key);

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved1_%03d       : " U32H_FMT "\n", i, ptr_struct->Reserved1[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data:\n");
	SMP_MAD_Data_Block_Element_print(&(ptr_struct->Data), file, indent_level + 1);

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved2_%03d       : " U32H_FMT "\n", i, ptr_struct->Reserved2[i]);
	}

}

int MAD_SMP_LID_Routed_size(void)
{
	 return 256;
}

void MAD_SMP_LID_Routed_dump(const struct MAD_SMP_LID_Routed *ptr_struct, FILE* file)
{
	MAD_SMP_LID_Routed_print(ptr_struct, file, 0);
}

void MAD_SubnetAdministartion_pack(const struct MAD_SubnetAdministartion *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_With_RMPP_pack(&(ptr_struct->MAD_Header_Common_With_RMPP), ptr_buff + offset/8);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->Sm_Key);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Reserved);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->AttributeOffset);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ComponentMask);

	offset = 448;
	SubnetAdministartion_MAD_Data_Block_Element_pack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void MAD_SubnetAdministartion_unpack(struct MAD_SubnetAdministartion *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_With_RMPP_unpack(&(ptr_struct->MAD_Header_Common_With_RMPP), ptr_buff + offset/8);

	offset = 288;
	ptr_struct->Sm_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 368;
	ptr_struct->Reserved = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->AttributeOffset = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 384;
	ptr_struct->ComponentMask = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 448;
	SubnetAdministartion_MAD_Data_Block_Element_unpack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void MAD_SubnetAdministartion_print(const struct MAD_SubnetAdministartion *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_SubnetAdministartion ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common_With_RMPP:\n");
	MAD_Header_Common_With_RMPP_print(&(ptr_struct->MAD_Header_Common_With_RMPP), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Sm_Key               : " U64H_FMT "\n", ptr_struct->Sm_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AttributeOffset      : " UH_FMT "\n", ptr_struct->AttributeOffset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ComponentMask        : " U64H_FMT "\n", ptr_struct->ComponentMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data:\n");
	SubnetAdministartion_MAD_Data_Block_Element_print(&(ptr_struct->Data), file, indent_level + 1);

}

int MAD_SubnetAdministartion_size(void)
{
	 return 256;
}

void MAD_SubnetAdministartion_dump(const struct MAD_SubnetAdministartion *ptr_struct, FILE* file)
{
	MAD_SubnetAdministartion_print(ptr_struct, file, 0);
}

void MAD_VendorSpec_pack(const struct MAD_VendorSpec *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_pack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->VS_Key);

	offset = 256;
	VendorSpecific_MAD_Data_Block_Element_pack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void MAD_VendorSpec_unpack(struct MAD_VendorSpec *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	MAD_Header_Common_unpack(&(ptr_struct->MAD_Header_Common), ptr_buff + offset/8);

	offset = 192;
	ptr_struct->VS_Key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	VendorSpecific_MAD_Data_Block_Element_unpack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void MAD_VendorSpec_print(const struct MAD_VendorSpec *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== MAD_VendorSpec ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common:\n");
	MAD_Header_Common_print(&(ptr_struct->MAD_Header_Common), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_Key               : " U64H_FMT "\n", ptr_struct->VS_Key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data:\n");
	VendorSpecific_MAD_Data_Block_Element_print(&(ptr_struct->Data), file, indent_level + 1);

}

int MAD_VendorSpec_size(void)
{
	 return 256;
}

void MAD_VendorSpec_dump(const struct MAD_VendorSpec *ptr_struct, FILE* file)
{
	MAD_VendorSpec_print(ptr_struct, file, 0);
}

void NeighborsInfo_pack(const struct NeighborsInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 14; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 1792, 1);
	neighbor_record_pack(&(ptr_struct->Neighbors[i]), ptr_buff + offset/8);
	}

}

void NeighborsInfo_unpack(struct NeighborsInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 14; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 1792, 1);
	neighbor_record_unpack(&(ptr_struct->Neighbors[i]), ptr_buff + offset/8);
	}

}

void NeighborsInfo_print(const struct NeighborsInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NeighborsInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 14; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Neighbors_%03d:\n", i);
	neighbor_record_print(&(ptr_struct->Neighbors[i]), file, indent_level + 1);
	}

}

int NeighborsInfo_size(void)
{
	 return 224;
}

void NeighborsInfo_dump(const struct NeighborsInfo *ptr_struct, FILE* file)
{
	NeighborsInfo_print(ptr_struct, file, 0);
}

void NoticeDataDetails_pack(const union NoticeDataDetails *ptr_struct, u_int8_t* ptr_buff)
{
	RawNoticeDataDetails_pack(&(ptr_struct->RawData), ptr_buff);
}

void NoticeDataDetails_unpack(union NoticeDataDetails *ptr_struct, const u_int8_t* ptr_buff)
{
	RawNoticeDataDetails_unpack(&(ptr_struct->RawData), ptr_buff);
}

void NoticeDataDetails_print(const union NoticeDataDetails *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== NoticeDataDetails ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapQPError:\n");
	AM_TrapQPError_print(&(ptr_struct->TrapQPError), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapQPError_V2:\n");
	AM_TrapQPError_V2_print(&(ptr_struct->TrapQPError_V2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapQPAllocationTime:\n");
	AM_TrapQPAllocationTime_print(&(ptr_struct->TrapQPAllocationTime), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapQPAllocationTime_V2:\n");
	AM_TrapQPAllocationTime_V2_print(&(ptr_struct->TrapQPAllocationTime_V2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapSharpInvalidRequest:\n");
	AM_TrapSharpInvalidRequest_print(&(ptr_struct->TrapSharpInvalidRequest), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapSharpInvalidRequest_V2:\n");
	AM_TrapSharpInvalidRequest_V2_print(&(ptr_struct->TrapSharpInvalidRequest_V2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapSharpError:\n");
	AM_TrapSharpError_print(&(ptr_struct->TrapSharpError), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TrapAMKeyViolation:\n");
	AM_TrapAMKeyViolation_print(&(ptr_struct->TrapAMKeyViolation), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RawData:\n");
	RawNoticeDataDetails_print(&(ptr_struct->RawData), file, indent_level + 1);

}

int NoticeDataDetails_size(void)
{
	 return 56;
}

void NoticeDataDetails_dump(const union NoticeDataDetails *ptr_struct, FILE* file)
{
	NoticeDataDetails_print(ptr_struct, file, 0);
}

void PM_PortRcvXmitCntrsSlVlData_pack(const union PM_PortRcvXmitCntrsSlVlData *ptr_struct, u_int8_t* ptr_buff)
{
	RawData_PM_PortRcvXmitCntrsSlVl_pack(&(ptr_struct->RawData_8x132_array), ptr_buff);
}

void PM_PortRcvXmitCntrsSlVlData_unpack(union PM_PortRcvXmitCntrsSlVlData *ptr_struct, const u_int8_t* ptr_buff)
{
	RawData_PM_PortRcvXmitCntrsSlVl_unpack(&(ptr_struct->RawData_8x132_array), ptr_buff);
}

void PM_PortRcvXmitCntrsSlVlData_print(const union PM_PortRcvXmitCntrsSlVlData *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortRcvXmitCntrsSlVlData ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Cntrs16Bit:\n");
	RawData_PM_PortRcvXmitCntrsSlVl16_print(&(ptr_struct->Cntrs16Bit), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Cntrs32Bit:\n");
	RawData_PM_PortRcvXmitCntrsSlVl32_print(&(ptr_struct->Cntrs32Bit), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CntrsVL64Bit:\n");
	RawData_PM_PortRcvXmitCntrsVl64_print(&(ptr_struct->CntrsVL64Bit), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CntrsSL64Bit:\n");
	RawData_PM_PortRcvXmitCntrsSl64_print(&(ptr_struct->CntrsSL64Bit), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RawData_8x132_array:\n");
	RawData_PM_PortRcvXmitCntrsSlVl_print(&(ptr_struct->RawData_8x132_array), file, indent_level + 1);

}

int PM_PortRcvXmitCntrsSlVlData_size(void)
{
	 return 132;
}

void PM_PortRcvXmitCntrsSlVlData_dump(const union PM_PortRcvXmitCntrsSlVlData *ptr_struct, FILE* file)
{
	PM_PortRcvXmitCntrsSlVlData_print(ptr_struct, file, 0);
}

void RDMNotice_pack(const struct RDMNotice *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->producer_type);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->type);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_generic);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->issuer_lid);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->trap_number);

	offset = 64;
	RDMNoticeDataDetails_pack(&(ptr_struct->data_details), ptr_buff + offset/8);

}

void RDMNotice_unpack(struct RDMNotice *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->producer_type = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 1;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 0;
	ptr_struct->is_generic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->issuer_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->trap_number = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	RDMNoticeDataDetails_unpack(&(ptr_struct->data_details), ptr_buff + offset/8);

}

void RDMNotice_print(const struct RDMNotice *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RDMNotice ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "producer_type        : " UH_FMT "\n", ptr_struct->producer_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : " UH_FMT "\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_generic           : " UH_FMT "\n", ptr_struct->is_generic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "issuer_lid           : " UH_FMT "\n", ptr_struct->issuer_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_number          : " UH_FMT "\n", ptr_struct->trap_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_details:\n");
	RDMNoticeDataDetails_print(&(ptr_struct->data_details), file, indent_level + 1);

}

int RDMNotice_size(void)
{
	 return 64;
}

void RDMNotice_dump(const struct RDMNotice *ptr_struct, FILE* file)
{
	RDMNotice_print(ptr_struct, file, 0);
}

void SMP_EntryPlaneFilterConfig_pack(const struct SMP_EntryPlaneFilterConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 128;
	UINT128_pack(&(ptr_struct->ingress_port_bitmask), ptr_buff + offset/8);

	offset = 256;
	UINT256_pack(&(ptr_struct->egress_port_bitmask), ptr_buff + offset/8);

}

void SMP_EntryPlaneFilterConfig_unpack(struct SMP_EntryPlaneFilterConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 128;
	UINT128_unpack(&(ptr_struct->ingress_port_bitmask), ptr_buff + offset/8);

	offset = 256;
	UINT256_unpack(&(ptr_struct->egress_port_bitmask), ptr_buff + offset/8);

}

void SMP_EntryPlaneFilterConfig_print(const struct SMP_EntryPlaneFilterConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_EntryPlaneFilterConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_port_bitmask:\n");
	UINT128_print(&(ptr_struct->ingress_port_bitmask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_port_bitmask:\n");
	UINT256_print(&(ptr_struct->egress_port_bitmask), file, indent_level + 1);

}

int SMP_EntryPlaneFilterConfig_size(void)
{
	 return 64;
}

void SMP_EntryPlaneFilterConfig_dump(const struct SMP_EntryPlaneFilterConfig *ptr_struct, FILE* file)
{
	SMP_EntryPlaneFilterConfig_print(ptr_struct, file, 0);
}

void SMP_GUIDInfo_pack(const struct SMP_GUIDInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	GUID_Block_Element_pack(&(ptr_struct->GUIDBlock), ptr_buff + offset/8);

}

void SMP_GUIDInfo_unpack(struct SMP_GUIDInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	GUID_Block_Element_unpack(&(ptr_struct->GUIDBlock), ptr_buff + offset/8);

}

void SMP_GUIDInfo_print(const struct SMP_GUIDInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_GUIDInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GUIDBlock:\n");
	GUID_Block_Element_print(&(ptr_struct->GUIDBlock), file, indent_level + 1);

}

int SMP_GUIDInfo_size(void)
{
	 return 64;
}

void SMP_GUIDInfo_dump(const struct SMP_GUIDInfo *ptr_struct, FILE* file)
{
	SMP_GUIDInfo_print(ptr_struct, file, 0);
}

void SMP_NextHopTbl_pack(const struct SMP_NextHopTbl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 512, 1);
	NextHopRecord_pack(&(ptr_struct->Record[i]), ptr_buff + offset/8);
	}

}

void SMP_NextHopTbl_unpack(struct SMP_NextHopTbl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 512, 1);
	NextHopRecord_unpack(&(ptr_struct->Record[i]), ptr_buff + offset/8);
	}

}

void SMP_NextHopTbl_print(const struct SMP_NextHopTbl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_NextHopTbl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Record_%03d:\n", i);
	NextHopRecord_print(&(ptr_struct->Record[i]), file, indent_level + 1);
	}

}

int SMP_NextHopTbl_size(void)
{
	 return 64;
}

void SMP_NextHopTbl_dump(const struct SMP_NextHopTbl *ptr_struct, FILE* file)
{
	SMP_NextHopTbl_print(ptr_struct, file, 0);
}

void SMP_RailFilterConfig_pack(const struct SMP_RailFilterConfig *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->VLMask);

	offset = 15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->MCEnable);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->UCEnable);

	offset = 32;
	UINT128_pack(&(ptr_struct->IngressPortMask), ptr_buff + offset/8);

	offset = 160;
	UINT256_pack(&(ptr_struct->EgressPortMask), ptr_buff + offset/8);

}

void SMP_RailFilterConfig_unpack(struct SMP_RailFilterConfig *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->VLMask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 15;
	ptr_struct->MCEnable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 14;
	ptr_struct->UCEnable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	UINT128_unpack(&(ptr_struct->IngressPortMask), ptr_buff + offset/8);

	offset = 160;
	UINT256_unpack(&(ptr_struct->EgressPortMask), ptr_buff + offset/8);

}

void SMP_RailFilterConfig_print(const struct SMP_RailFilterConfig *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_RailFilterConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VLMask               : " UH_FMT "\n", ptr_struct->VLMask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MCEnable             : " UH_FMT "\n", ptr_struct->MCEnable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "UCEnable             : " UH_FMT "\n", ptr_struct->UCEnable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IngressPortMask:\n");
	UINT128_print(&(ptr_struct->IngressPortMask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EgressPortMask:\n");
	UINT256_print(&(ptr_struct->EgressPortMask), file, indent_level + 1);

}

int SMP_RailFilterConfig_size(void)
{
	 return 64;
}

void SMP_RailFilterConfig_dump(const struct SMP_RailFilterConfig *ptr_struct, FILE* file)
{
	SMP_RailFilterConfig_print(ptr_struct, file, 0);
}

void SMP_VPortGUIDInfo_pack(const struct SMP_VPortGUIDInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	VPortGUID_Block_Element_pack(&(ptr_struct->GUIDBlock), ptr_buff + offset/8);

}

void SMP_VPortGUIDInfo_unpack(struct SMP_VPortGUIDInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	VPortGUID_Block_Element_unpack(&(ptr_struct->GUIDBlock), ptr_buff + offset/8);

}

void SMP_VPortGUIDInfo_print(const struct SMP_VPortGUIDInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_VPortGUIDInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GUIDBlock:\n");
	VPortGUID_Block_Element_print(&(ptr_struct->GUIDBlock), file, indent_level + 1);

}

int SMP_VPortGUIDInfo_size(void)
{
	 return 64;
}

void SMP_VPortGUIDInfo_dump(const struct SMP_VPortGUIDInfo *ptr_struct, FILE* file)
{
	SMP_VPortGUIDInfo_print(ptr_struct, file, 0);
}

void VS_DiagnosticData_pack(const struct VS_DiagnosticData *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->CurrentRevision);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->BackwardRevision);

	offset = 64;
	DD_set_pack(&(ptr_struct->data_set), ptr_buff + offset/8);

}

void VS_DiagnosticData_unpack(struct VS_DiagnosticData *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->CurrentRevision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->BackwardRevision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 64;
	DD_set_unpack(&(ptr_struct->data_set), ptr_buff + offset/8);

}

void VS_DiagnosticData_print(const struct VS_DiagnosticData *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_DiagnosticData ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CurrentRevision      : " UH_FMT "\n", ptr_struct->CurrentRevision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BackwardRevision     : " UH_FMT "\n", ptr_struct->BackwardRevision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_set:\n");
	DD_set_print(&(ptr_struct->data_set), file, indent_level + 1);

}

int VS_DiagnosticData_size(void)
{
	 return 224;
}

void VS_DiagnosticData_dump(const struct VS_DiagnosticData *ptr_struct, FILE* file)
{
	VS_DiagnosticData_print(ptr_struct, file, 0);
}

void VS_Encapsulation_pack(const union VS_Encapsulation *ptr_struct, u_int8_t* ptr_buff)
{
	VS_Encapsulation_RawData_pack(&(ptr_struct->raw), ptr_buff);
}

void VS_Encapsulation_unpack(union VS_Encapsulation *ptr_struct, const u_int8_t* ptr_buff)
{
	VS_Encapsulation_RawData_unpack(&(ptr_struct->raw), ptr_buff);
}

void VS_Encapsulation_print(const union VS_Encapsulation *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_Encapsulation ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_span:\n");
	VS_Encapsulation_LocalSPAN_print(&(ptr_struct->local_span), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_span_local_ud:\n");
	VS_Encapsulation_RemoteSPANLocalUD_print(&(ptr_struct->remote_span_local_ud), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_span_global_ud:\n");
	VS_Encapsulation_RemoteSPANGlobalUD_print(&(ptr_struct->remote_span_global_ud), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw:\n");
	VS_Encapsulation_RawData_print(&(ptr_struct->raw), file, indent_level + 1);

}

int VS_Encapsulation_size(void)
{
	 return 80;
}

void VS_Encapsulation_dump(const union VS_Encapsulation *ptr_struct, FILE* file)
{
	VS_Encapsulation_print(ptr_struct, file, 0);
}

void VendorSpec_GeneralInfo_pack(const struct VendorSpec_GeneralInfo *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	HWInfo_Block_Element_pack(&(ptr_struct->HWInfo), ptr_buff + offset/8);

	offset = 256;
	FWInfo_Block_Element_pack(&(ptr_struct->FWInfo), ptr_buff + offset/8);

	offset = 768;
	SWInfo_Block_Element_pack(&(ptr_struct->SWInfo), ptr_buff + offset/8);

	offset = 1024;
	GeneralInfoCapabilityMask_pack(&(ptr_struct->CapabilityMask), ptr_buff + offset/8);

}

void VendorSpec_GeneralInfo_unpack(struct VendorSpec_GeneralInfo *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	HWInfo_Block_Element_unpack(&(ptr_struct->HWInfo), ptr_buff + offset/8);

	offset = 256;
	FWInfo_Block_Element_unpack(&(ptr_struct->FWInfo), ptr_buff + offset/8);

	offset = 768;
	SWInfo_Block_Element_unpack(&(ptr_struct->SWInfo), ptr_buff + offset/8);

	offset = 1024;
	GeneralInfoCapabilityMask_unpack(&(ptr_struct->CapabilityMask), ptr_buff + offset/8);

}

void VendorSpec_GeneralInfo_print(const struct VendorSpec_GeneralInfo *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VendorSpec_GeneralInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HWInfo:\n");
	HWInfo_Block_Element_print(&(ptr_struct->HWInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FWInfo:\n");
	FWInfo_Block_Element_print(&(ptr_struct->FWInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SWInfo:\n");
	SWInfo_Block_Element_print(&(ptr_struct->SWInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CapabilityMask:\n");
	GeneralInfoCapabilityMask_print(&(ptr_struct->CapabilityMask), file, indent_level + 1);

}

int VendorSpec_GeneralInfo_size(void)
{
	 return 144;
}

void VendorSpec_GeneralInfo_dump(const struct VendorSpec_GeneralInfo *ptr_struct, FILE* file)
{
	VendorSpec_GeneralInfo_print(ptr_struct, file, 0);
}

void ib_ar_grp_table_pack(const struct ib_ar_grp_table *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(0, 256, i, 512, 1);
	ib_portgroup_block_element_pack(&(ptr_struct->Group[i]), ptr_buff + offset/8);
	}

}

void ib_ar_grp_table_unpack(struct ib_ar_grp_table *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(0, 256, i, 512, 1);
	ib_portgroup_block_element_unpack(&(ptr_struct->Group[i]), ptr_buff + offset/8);
	}

}

void ib_ar_grp_table_print(const struct ib_ar_grp_table *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ib_ar_grp_table ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Group_%03d:\n", i);
	ib_portgroup_block_element_print(&(ptr_struct->Group[i]), file, indent_level + 1);
	}

}

int ib_ar_grp_table_size(void)
{
	 return 64;
}

void ib_ar_grp_table_dump(const struct ib_ar_grp_table *ptr_struct, FILE* file)
{
	ib_ar_grp_table_print(ptr_struct, file, 0);
}

void CONGESTION_CONTOL_pack(const union CONGESTION_CONTOL *ptr_struct, u_int8_t* ptr_buff)
{
	CC_CongestionHCAAlgoCounters_pack(&(ptr_struct->CC_CongestionHCAAlgoCounters), ptr_buff);
}

void CONGESTION_CONTOL_unpack(union CONGESTION_CONTOL *ptr_struct, const u_int8_t* ptr_buff)
{
	CC_CongestionHCAAlgoCounters_unpack(&(ptr_struct->CC_CongestionHCAAlgoCounters), ptr_buff);
}

void CONGESTION_CONTOL_print(const union CONGESTION_CONTOL *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CONGESTION_CONTOL ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionInfo:\n");
	CC_CongestionInfo_print(&(ptr_struct->CC_CongestionInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionKeyInfo:\n");
	CC_CongestionKeyInfo_print(&(ptr_struct->CC_CongestionKeyInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionLogSwitch:\n");
	CC_CongestionLogSwitch_print(&(ptr_struct->CC_CongestionLogSwitch), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionLogCA:\n");
	CC_CongestionLogCA_print(&(ptr_struct->CC_CongestionLogCA), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_SwitchCongestionSetting:\n");
	CC_SwitchCongestionSetting_print(&(ptr_struct->CC_SwitchCongestionSetting), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_SwitchPortCongestionSetting:\n");
	CC_SwitchPortCongestionSetting_print(&(ptr_struct->CC_SwitchPortCongestionSetting), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CACongestionSetting:\n");
	CC_CACongestionSetting_print(&(ptr_struct->CC_CACongestionSetting), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionControlTable:\n");
	CC_CongestionControlTable_print(&(ptr_struct->CC_CongestionControlTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_TimeStamp:\n");
	CC_TimeStamp_print(&(ptr_struct->CC_TimeStamp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_Notice:\n");
	CC_Notice_print(&(ptr_struct->CC_Notice), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_EnhancedCongestionInfo:\n");
	CC_EnhancedCongestionInfo_print(&(ptr_struct->CC_EnhancedCongestionInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionSwitchGeneralSettings:\n");
	CC_CongestionSwitchGeneralSettings_print(&(ptr_struct->CC_CongestionSwitchGeneralSettings), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionPortProfileSettings:\n");
	CC_CongestionPortProfileSettings_print(&(ptr_struct->CC_CongestionPortProfileSettings), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionSLMappingSettings:\n");
	CC_CongestionSLMappingSettings_print(&(ptr_struct->CC_CongestionSLMappingSettings), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionHCAGeneralSettings:\n");
	CC_CongestionHCAGeneralSettings_print(&(ptr_struct->CC_CongestionHCAGeneralSettings), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionHCARPParameters:\n");
	CC_CongestionHCARPParameters_print(&(ptr_struct->CC_CongestionHCARPParameters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionHCANPParameters:\n");
	CC_CongestionHCANPParameters_print(&(ptr_struct->CC_CongestionHCANPParameters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionHCAStatisticsQuery:\n");
	CC_CongestionHCAStatisticsQuery_print(&(ptr_struct->CC_CongestionHCAStatisticsQuery), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionHCAAlgoConfig:\n");
	CC_CongestionHCAAlgoConfig_print(&(ptr_struct->CC_CongestionHCAAlgoConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionHCAAlgoConfigParams:\n");
	CC_CongestionHCAAlgoConfigParams_print(&(ptr_struct->CC_CongestionHCAAlgoConfigParams), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CC_CongestionHCAAlgoCounters:\n");
	CC_CongestionHCAAlgoCounters_print(&(ptr_struct->CC_CongestionHCAAlgoCounters), file, indent_level + 1);

}

int CONGESTION_CONTOL_size(void)
{
	 return 131072;
}

void CONGESTION_CONTOL_dump(const union CONGESTION_CONTOL *ptr_struct, FILE* file)
{
	CONGESTION_CONTOL_print(ptr_struct, file, 0);
}

void Notice_pack(const struct Notice *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->producer_type);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->type);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_generic);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->issuer_lid);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->trap_number);

	offset = 64;
	NoticeDataDetails_pack(&(ptr_struct->data_details), ptr_buff + offset/8);

}

void Notice_unpack(struct Notice *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->producer_type = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 1;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 0;
	ptr_struct->is_generic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->issuer_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->trap_number = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	NoticeDataDetails_unpack(&(ptr_struct->data_details), ptr_buff + offset/8);

}

void Notice_print(const struct Notice *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== Notice ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "producer_type        : " UH_FMT "\n", ptr_struct->producer_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : " UH_FMT "\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_generic           : " UH_FMT "\n", ptr_struct->is_generic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "issuer_lid           : " UH_FMT "\n", ptr_struct->issuer_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_number          : " UH_FMT "\n", ptr_struct->trap_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_details:\n");
	NoticeDataDetails_print(&(ptr_struct->data_details), file, indent_level + 1);

}

int Notice_size(void)
{
	 return 64;
}

void Notice_dump(const struct Notice *ptr_struct, FILE* file)
{
	Notice_print(ptr_struct, file, 0);
}

void PM_PortRcvXmitCntrsSlVl_pack(const struct PM_PortRcvXmitCntrsSlVl *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->counter_select);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_select);

	offset = 32;
	PM_PortRcvXmitCntrsSlVlData_pack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void PM_PortRcvXmitCntrsSlVl_unpack(struct PM_PortRcvXmitCntrsSlVl *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->counter_select = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->port_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	PM_PortRcvXmitCntrsSlVlData_unpack(&(ptr_struct->Data), ptr_buff + offset/8);

}

void PM_PortRcvXmitCntrsSlVl_print(const struct PM_PortRcvXmitCntrsSlVl *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PM_PortRcvXmitCntrsSlVl ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_select       : " UH_FMT "\n", ptr_struct->counter_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_select          : " UH_FMT "\n", ptr_struct->port_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Data:\n");
	PM_PortRcvXmitCntrsSlVlData_print(&(ptr_struct->Data), file, indent_level + 1);

}

int PM_PortRcvXmitCntrsSlVl_size(void)
{
	 return 136;
}

void PM_PortRcvXmitCntrsSlVl_dump(const struct PM_PortRcvXmitCntrsSlVl *ptr_struct, FILE* file)
{
	PM_PortRcvXmitCntrsSlVl_print(ptr_struct, file, 0);
}

void RDM_NVL_MADS_pack(const union RDM_NVL_MADS *ptr_struct, u_int8_t* ptr_buff)
{
	NVLReductionRoundingMode_pack(&(ptr_struct->NVLReductionRoundingMode), ptr_buff);
}

void RDM_NVL_MADS_unpack(union RDM_NVL_MADS *ptr_struct, const u_int8_t* ptr_buff)
{
	NVLReductionRoundingMode_unpack(&(ptr_struct->NVLReductionRoundingMode), ptr_buff);
}

void RDM_NVL_MADS_print(const union RDM_NVL_MADS *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== RDM_NVL_MADS ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NVLReductionInfo:\n");
	NVLReductionInfo_print(&(ptr_struct->NVLReductionInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NVLReductionPortInfo:\n");
	NVLReductionPortInfo_print(&(ptr_struct->NVLReductionPortInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NVLReductionProfilesConfig:\n");
	NVLReductionProfilesConfig_print(&(ptr_struct->NVLReductionProfilesConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NVLReductionForwardingTable:\n");
	NVLReductionForwardingTable_print(&(ptr_struct->NVLReductionForwardingTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NVLPenaltyBoxConfig:\n");
	NVLPenaltyBoxConfig_print(&(ptr_struct->NVLPenaltyBoxConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RDMNotice:\n");
	RDMNotice_print(&(ptr_struct->RDMNotice), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NVLReductionConfigureMLIDMonitors:\n");
	NVLReductionConfigureMLIDMonitors_print(&(ptr_struct->NVLReductionConfigureMLIDMonitors), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NVLReductionCounters:\n");
	NVLReductionCounters_print(&(ptr_struct->NVLReductionCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NVLReductionRoundingMode:\n");
	NVLReductionRoundingMode_print(&(ptr_struct->NVLReductionRoundingMode), file, indent_level + 1);

}

int RDM_NVL_MADS_size(void)
{
	 return 256;
}

void RDM_NVL_MADS_dump(const union RDM_NVL_MADS *ptr_struct, FILE* file)
{
	RDM_NVL_MADS_print(ptr_struct, file, 0);
}

void SMP_MADS_pack(const union SMP_MADS *ptr_struct, u_int8_t* ptr_buff)
{
	SMP_ContainAndDrainPortState_pack(&(ptr_struct->SMP_ContainAndDrainPortState), ptr_buff);
}

void SMP_MADS_unpack(union SMP_MADS *ptr_struct, const u_int8_t* ptr_buff)
{
	SMP_ContainAndDrainPortState_unpack(&(ptr_struct->SMP_ContainAndDrainPortState), ptr_buff);
}

void SMP_MADS_print(const union SMP_MADS *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_MADS ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_NodeDesc:\n");
	SMP_NodeDesc_print(&(ptr_struct->SMP_NodeDesc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_NodeInfo:\n");
	SMP_NodeInfo_print(&(ptr_struct->SMP_NodeInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_SwitchInfo:\n");
	SMP_SwitchInfo_print(&(ptr_struct->SMP_SwitchInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_GUIDInfo:\n");
	SMP_GUIDInfo_print(&(ptr_struct->SMP_GUIDInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_PortInfo:\n");
	SMP_PortInfo_print(&(ptr_struct->SMP_PortInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_PortInfoExtended:\n");
	SMP_PortInfoExtended_print(&(ptr_struct->SMP_PortInfoExtended), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_PKeyTable:\n");
	SMP_PKeyTable_print(&(ptr_struct->SMP_PKeyTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_SLToVLMappingTable:\n");
	SMP_SLToVLMappingTable_print(&(ptr_struct->SMP_SLToVLMappingTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_VLArbitrationTable:\n");
	SMP_VLArbitrationTable_print(&(ptr_struct->SMP_VLArbitrationTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_LinearForwardingTable:\n");
	SMP_LinearForwardingTable_print(&(ptr_struct->SMP_LinearForwardingTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_RandomForwardingTable:\n");
	SMP_RandomForwardingTable_print(&(ptr_struct->SMP_RandomForwardingTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_MulticastForwardingTable:\n");
	SMP_MulticastForwardingTable_print(&(ptr_struct->SMP_MulticastForwardingTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_SMInfo:\n");
	SMP_SMInfo_print(&(ptr_struct->SMP_SMInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ExtendedSwitchInfo:\n");
	SMP_ExtendedSwitchInfo_print(&(ptr_struct->SMP_ExtendedSwitchInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ChassisInfo:\n");
	SMP_ChassisInfo_print(&(ptr_struct->SMP_ChassisInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_LedInfo:\n");
	SMP_LedInfo_print(&(ptr_struct->SMP_LedInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_MlnxExtPortInfo:\n");
	SMP_MlnxExtPortInfo_print(&(ptr_struct->SMP_MlnxExtPortInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GeneralInfoCapabilityMask:\n");
	GeneralInfoCapabilityMask_print(&(ptr_struct->GeneralInfoCapabilityMask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_HierarchyInfo:\n");
	SMP_HierarchyInfo_print(&(ptr_struct->SMP_HierarchyInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "private_lft_info:\n");
	ib_private_lft_info_print(&(ptr_struct->private_lft_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "private_lft_map:\n");
	ib_private_lft_map_print(&(ptr_struct->private_lft_map), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "private_lft_def:\n");
	ib_private_lft_def_print(&(ptr_struct->private_lft_def), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_sl_to_private_lft_map:\n");
	ib_port_sl_to_private_lft_map_print(&(ptr_struct->port_sl_to_private_lft_map), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_node_info:\n");
	ib_extended_node_info_print(&(ptr_struct->extended_node_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar_info:\n");
	adaptive_routing_info_print(&(ptr_struct->ar_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar_linear_forwarding_table:\n");
	ib_ar_linear_forwarding_table_print(&(ptr_struct->ar_linear_forwarding_table), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar_linear_forwarding_table_sx:\n");
	ib_ar_linear_forwarding_table_sx_print(&(ptr_struct->ar_linear_forwarding_table_sx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar_group_table:\n");
	ib_ar_grp_table_print(&(ptr_struct->ar_group_table), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ar_group_table_copy:\n");
	adaptive_routing_group_table_copy_print(&(ptr_struct->ar_group_table_copy), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rn_sub_group_direction_tbl:\n");
	rn_sub_group_direction_tbl_print(&(ptr_struct->rn_sub_group_direction_tbl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rn_gen_string_tbl:\n");
	rn_gen_string_tbl_print(&(ptr_struct->rn_gen_string_tbl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rn_gen_by_sub_group_prio:\n");
	rn_gen_by_sub_group_prio_print(&(ptr_struct->rn_gen_by_sub_group_prio), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rn_rcv_string:\n");
	rn_rcv_string_print(&(ptr_struct->rn_rcv_string), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rn_xmit_port_mask:\n");
	rn_xmit_port_mask_print(&(ptr_struct->rn_xmit_port_mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_VPortState:\n");
	SMP_VPortState_print(&(ptr_struct->SMP_VPortState), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_VPortInfo:\n");
	SMP_VPortInfo_print(&(ptr_struct->SMP_VPortInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_VPortGUIDInfo:\n");
	SMP_VPortGUIDInfo_print(&(ptr_struct->SMP_VPortGUIDInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_VirtualizationInfo:\n");
	SMP_VirtualizationInfo_print(&(ptr_struct->SMP_VirtualizationInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_VNodeInfo:\n");
	SMP_VNodeInfo_print(&(ptr_struct->SMP_VNodeInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_RouterInfo:\n");
	SMP_RouterInfo_print(&(ptr_struct->SMP_RouterInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_AdjSiteLocalSubnTbl:\n");
	SMP_AdjSiteLocalSubnTbl_print(&(ptr_struct->SMP_AdjSiteLocalSubnTbl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_NextHopTbl:\n");
	SMP_NextHopTbl_print(&(ptr_struct->SMP_NextHopTbl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_SwitchPortStateTable:\n");
	SMP_SwitchPortStateTable_print(&(ptr_struct->SMP_SwitchPortStateTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_AdjSubnetsRouterLIDInfoTable:\n");
	SMP_AdjSubnetsRouterLIDInfoTable_print(&(ptr_struct->SMP_AdjSubnetsRouterLIDInfoTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_RouterLIDTable:\n");
	SMP_RouterLIDTable_print(&(ptr_struct->SMP_RouterLIDTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ARGroupToRouterLIDTable:\n");
	SMP_ARGroupToRouterLIDTable_print(&(ptr_struct->SMP_ARGroupToRouterLIDTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "WHBFConfig:\n");
	whbf_config_print(&(ptr_struct->WHBFConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HBFConfig:\n");
	hbf_config_print(&(ptr_struct->HBFConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_pFRNConfig:\n");
	SMP_pFRNConfig_print(&(ptr_struct->SMP_pFRNConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ProfilesConfig:\n");
	SMP_ProfilesConfig_print(&(ptr_struct->SMP_ProfilesConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_CreditWatchdogConfig:\n");
	SMP_CreditWatchdogConfig_print(&(ptr_struct->SMP_CreditWatchdogConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_BERConfig:\n");
	SMP_BERConfig_print(&(ptr_struct->SMP_BERConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_EntryPlaneFilterConfig:\n");
	SMP_EntryPlaneFilterConfig_print(&(ptr_struct->SMP_EntryPlaneFilterConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_EndPortPlaneFilterConfig:\n");
	SMP_EndPortPlaneFilterConfig_print(&(ptr_struct->SMP_EndPortPlaneFilterConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_AnycastLIDInfo:\n");
	SMP_AnycastLIDInfo_print(&(ptr_struct->SMP_AnycastLIDInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_RailFilterConfig:\n");
	SMP_RailFilterConfig_print(&(ptr_struct->SMP_RailFilterConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_NVLHBFConfig:\n");
	SMP_NVLHBFConfig_print(&(ptr_struct->SMP_NVLHBFConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_LinearForwardingTableSplit:\n");
	SMP_LinearForwardingTableSplit_print(&(ptr_struct->SMP_LinearForwardingTableSplit), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ContainAndDrainInfo:\n");
	SMP_ContainAndDrainInfo_print(&(ptr_struct->SMP_ContainAndDrainInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ContainAndDrainPortState:\n");
	SMP_ContainAndDrainPortState_print(&(ptr_struct->SMP_ContainAndDrainPortState), file, indent_level + 1);

}

int SMP_MADS_size(void)
{
	 return 131072;
}

void SMP_MADS_dump(const union SMP_MADS *ptr_struct, FILE* file)
{
	SMP_MADS_print(ptr_struct, file, 0);
}

void VS_MirroringAgent_pack(const struct VS_MirroringAgent *ptr_struct, u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->span_type);

	offset = 39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tr);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->be);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qos);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e);

	offset = 83;
	adb2c_push_bits_to_buff(ptr_buff, offset, 13, (u_int32_t)ptr_struct->truncation_size);

	offset = 128;
	VS_Encapsulation_pack(&(ptr_struct->encapsulation), ptr_buff + offset/8);

}

void VS_MirroringAgent_unpack(struct VS_MirroringAgent *ptr_struct, const u_int8_t* ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 60;
	ptr_struct->span_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 39;
	ptr_struct->tr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 38;
	ptr_struct->be = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 37;
	ptr_struct->qos = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->e = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 83;
	ptr_struct->truncation_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 13);

	offset = 128;
	VS_Encapsulation_unpack(&(ptr_struct->encapsulation), ptr_buff + offset/8);

}

void VS_MirroringAgent_print(const struct VS_MirroringAgent *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VS_MirroringAgent ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : " UH_FMT "\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "span_type            : " UH_FMT "\n", ptr_struct->span_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tr                   : " UH_FMT "\n", ptr_struct->tr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "be                   : " UH_FMT "\n", ptr_struct->be);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qos                  : " UH_FMT "\n", ptr_struct->qos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e                    : " UH_FMT "\n", ptr_struct->e);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "truncation_size      : " UH_FMT "\n", ptr_struct->truncation_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encapsulation:\n");
	VS_Encapsulation_print(&(ptr_struct->encapsulation), file, indent_level + 1);

}

int VS_MirroringAgent_size(void)
{
	 return 96;
}

void VS_MirroringAgent_dump(const struct VS_MirroringAgent *ptr_struct, FILE* file)
{
	VS_MirroringAgent_print(ptr_struct, file, 0);
}

void AGGREGATION_MADS_pack(const union AGGREGATION_MADS *ptr_struct, u_int8_t* ptr_buff)
{
	AM_MulticastPrivateLFT_pack(&(ptr_struct->AM_MulticastPrivateLFT), ptr_buff);
}

void AGGREGATION_MADS_unpack(union AGGREGATION_MADS *ptr_struct, const u_int8_t* ptr_buff)
{
	AM_MulticastPrivateLFT_unpack(&(ptr_struct->AM_MulticastPrivateLFT), ptr_buff);
}

void AGGREGATION_MADS_print(const union AGGREGATION_MADS *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== AGGREGATION_MADS ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_QPAllocation:\n");
	AM_QPAllocation_print(&(ptr_struct->AM_QPAllocation), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_AMKeyInfo:\n");
	AM_AMKeyInfo_print(&(ptr_struct->AM_AMKeyInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_ANInfo:\n");
	AM_ANInfo_print(&(ptr_struct->AM_ANInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "child_qp:\n");
	child_qp_print(&(ptr_struct->child_qp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_GroupJoin:\n");
	AM_GroupJoin_print(&(ptr_struct->AM_GroupJoin), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_QPCConfig:\n");
	AM_QPCConfig_print(&(ptr_struct->AM_QPCConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_QuotaConfig:\n");
	AM_QuotaConfig_print(&(ptr_struct->AM_QuotaConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_ResourceCleanup:\n");
	AM_ResourceCleanup_print(&(ptr_struct->AM_ResourceCleanup), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_ResourceCleanup_V2:\n");
	AM_ResourceCleanup_V2_print(&(ptr_struct->AM_ResourceCleanup_V2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_TreeConfig:\n");
	AM_TreeConfig_print(&(ptr_struct->AM_TreeConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_Notice:\n");
	Notice_print(&(ptr_struct->AM_Notice), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_PerformanceCounters:\n");
	AM_PerformanceCounters_print(&(ptr_struct->AM_PerformanceCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_ANActiveJobs:\n");
	AM_ANActiveJobs_print(&(ptr_struct->AM_ANActiveJobs), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_PortCreditResourcesAllocation:\n");
	AM_PortCreditResourcesAllocation_print(&(ptr_struct->AM_PortCreditResourcesAllocation), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_TreeToJobBind:\n");
	AM_TreeToJobBind_print(&(ptr_struct->AM_TreeToJobBind), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_ANSemaphoreInfo:\n");
	AM_ANSemaphoreInfo_print(&(ptr_struct->AM_ANSemaphoreInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_ANSATQPInfo:\n");
	AM_ANSATQPInfo_print(&(ptr_struct->AM_ANSATQPInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_record:\n");
	qp_record_print(&(ptr_struct->qp_record), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_QPDatabase:\n");
	AM_QPDatabase_print(&(ptr_struct->AM_QPDatabase), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AM_MulticastPrivateLFT:\n");
	AM_MulticastPrivateLFT_print(&(ptr_struct->AM_MulticastPrivateLFT), file, indent_level + 1);

}

int AGGREGATION_MADS_size(void)
{
	 return 256;
}

void AGGREGATION_MADS_dump(const union AGGREGATION_MADS *ptr_struct, FILE* file)
{
	AGGREGATION_MADS_print(ptr_struct, file, 0);
}

void PERFORMANCE_MADS_pack(const union PERFORMANCE_MADS *ptr_struct, u_int8_t* ptr_buff)
{
	PM_PortVLXmitFlowCtlUpdateErrors_pack(&(ptr_struct->PM_PortVLXmitFlowCtlUpdateErrors), ptr_buff);
}

void PERFORMANCE_MADS_unpack(union PERFORMANCE_MADS *ptr_struct, const u_int8_t* ptr_buff)
{
	PM_PortVLXmitFlowCtlUpdateErrors_unpack(&(ptr_struct->PM_PortVLXmitFlowCtlUpdateErrors), ptr_buff);
}

void PERFORMANCE_MADS_print(const union PERFORMANCE_MADS *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PERFORMANCE_MADS ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortCounters:\n");
	PM_PortCounters_print(&(ptr_struct->PM_PortCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortCountersExtended:\n");
	PM_PortCountersExtended_print(&(ptr_struct->PM_PortCountersExtended), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortXmitDiscardDetails:\n");
	PM_PortXmitDiscardDetails_print(&(ptr_struct->PM_PortXmitDiscardDetails), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortRcvErrorDetails:\n");
	PM_PortRcvErrorDetails_print(&(ptr_struct->PM_PortRcvErrorDetails), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortSamplesResult:\n");
	PM_PortSamplesResult_print(&(ptr_struct->PM_PortSamplesResult), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortSamplesControl:\n");
	PM_PortSamplesControl_print(&(ptr_struct->PM_PortSamplesControl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortExtendedSpeedsCounters:\n");
	PM_PortExtendedSpeedsCounters_print(&(ptr_struct->PM_PortExtendedSpeedsCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortExtendedSpeedsRSFECCounters:\n");
	PM_PortExtendedSpeedsRSFECCounters_print(&(ptr_struct->PM_PortExtendedSpeedsRSFECCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortRcvXmitCntrsSlVl:\n");
	PM_PortRcvXmitCntrsSlVl_print(&(ptr_struct->PM_PortRcvXmitCntrsSlVl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PM_PortVLXmitFlowCtlUpdateErrors:\n");
	PM_PortVLXmitFlowCtlUpdateErrors_print(&(ptr_struct->PM_PortVLXmitFlowCtlUpdateErrors), file, indent_level + 1);

}

int PERFORMANCE_MADS_size(void)
{
	 return 131072;
}

void PERFORMANCE_MADS_dump(const union PERFORMANCE_MADS *ptr_struct, FILE* file)
{
	PERFORMANCE_MADS_print(ptr_struct, file, 0);
}

void VENDOR_SPECS_pack(const union VENDOR_SPECS *ptr_struct, u_int8_t* ptr_buff)
{
	VS_PerformanceHistogramPortsData_pack(&(ptr_struct->VS_PerformanceHistogramPortsData), ptr_buff);
}

void VENDOR_SPECS_unpack(union VENDOR_SPECS *ptr_struct, const u_int8_t* ptr_buff)
{
	VS_PerformanceHistogramPortsData_unpack(&(ptr_struct->VS_PerformanceHistogramPortsData), ptr_buff);
}

void VENDOR_SPECS_print(const union VENDOR_SPECS *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VENDOR_SPECS ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorSpec_GeneralInfo:\n");
	VendorSpec_GeneralInfo_print(&(ptr_struct->VendorSpec_GeneralInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorSpec_PortLLRStatistics:\n");
	VendorSpec_PortLLRStatistics_print(&(ptr_struct->VendorSpec_PortLLRStatistics), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_DiagnosticData:\n");
	VS_DiagnosticData_print(&(ptr_struct->VS_DiagnosticData), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_AccessRegister:\n");
	SMP_AccessRegister_print(&(ptr_struct->SMP_AccessRegister), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GMP_AccessRegister:\n");
	GMP_AccessRegister_print(&(ptr_struct->GMP_AccessRegister), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_TempSensing:\n");
	SMP_TempSensing_print(&(ptr_struct->SMP_TempSensing), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_PortRNCounters:\n");
	port_rn_counters_print(&(ptr_struct->VS_PortRNCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_QosConfigSL:\n");
	SMP_QosConfigSL_print(&(ptr_struct->SMP_QosConfigSL), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_QosConfigVL:\n");
	SMP_QosConfigVL_print(&(ptr_struct->SMP_QosConfigVL), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_PortRoutingDecisionCounters:\n");
	port_routing_decision_counters_print(&(ptr_struct->VS_PortRoutingDecisionCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_SwitchNetworkInfo:\n");
	VS_SwitchNetworkInfo_print(&(ptr_struct->VS_SwitchNetworkInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_MirroringInfo:\n");
	VS_MirroringInfo_print(&(ptr_struct->VS_MirroringInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_MirroringAgent:\n");
	VS_MirroringAgent_print(&(ptr_struct->VS_MirroringAgent), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_MirroringGlobalTrigger:\n");
	VS_MirroringGlobalTrigger_print(&(ptr_struct->VS_MirroringGlobalTrigger), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_CongestionMirroring:\n");
	VS_CongestionMirroring_print(&(ptr_struct->VS_CongestionMirroring), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_CreditWatchdogTimeoutCounters:\n");
	VS_CreditWatchdogTimeoutCounters_print(&(ptr_struct->VS_CreditWatchdogTimeoutCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_FastRecoveryCounters:\n");
	VS_FastRecoveryCounters_print(&(ptr_struct->VS_FastRecoveryCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_PortGeneralCounters:\n");
	VS_PortGeneralCounters_print(&(ptr_struct->VS_PortGeneralCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_PerformanceHistogramInfo:\n");
	VS_PerformanceHistogramInfo_print(&(ptr_struct->VS_PerformanceHistogramInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_PerformanceHistogramBufferControl:\n");
	VS_PerformanceHistogramBufferControl_print(&(ptr_struct->VS_PerformanceHistogramBufferControl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_PerformanceHistogramBufferData:\n");
	VS_PerformanceHistogramBufferData_print(&(ptr_struct->VS_PerformanceHistogramBufferData), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_PerformanceHistogramPortsControl:\n");
	VS_PerformanceHistogramPortsControl_print(&(ptr_struct->VS_PerformanceHistogramPortsControl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VS_PerformanceHistogramPortsData:\n");
	VS_PerformanceHistogramPortsData_print(&(ptr_struct->VS_PerformanceHistogramPortsData), file, indent_level + 1);

}

int VENDOR_SPECS_size(void)
{
	 return 131072;
}

void VENDOR_SPECS_dump(const union VENDOR_SPECS *ptr_struct, FILE* file)
{
	VENDOR_SPECS_print(ptr_struct, file, 0);
}

void PACKETS_EXTERNAL_pack(const union PACKETS_EXTERNAL *ptr_struct, u_int8_t* ptr_buff)
{
	RDM_NVL_MADS_pack(&(ptr_struct->RDM_NVL_MADS), ptr_buff);
}

void PACKETS_EXTERNAL_unpack(union PACKETS_EXTERNAL *ptr_struct, const u_int8_t* ptr_buff)
{
	RDM_NVL_MADS_unpack(&(ptr_struct->RDM_NVL_MADS), ptr_buff);
}

void PACKETS_EXTERNAL_print(const union PACKETS_EXTERNAL *ptr_struct, FILE* file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PACKETS_EXTERNAL ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_LRH:\n");
	IB_LRH_print(&(ptr_struct->IB_LRH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_RWH:\n");
	IB_RWH_print(&(ptr_struct->IB_RWH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_GRH:\n");
	IB_GRH_print(&(ptr_struct->IB_GRH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_BTH:\n");
	IB_BTH_print(&(ptr_struct->IB_BTH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_BTH_CNP:\n");
	IB_BTH_CNP_print(&(ptr_struct->IB_BTH_CNP), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_RDETH:\n");
	IB_RDETH_print(&(ptr_struct->IB_RDETH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_DETH:\n");
	IB_DETH_print(&(ptr_struct->IB_DETH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_RETH:\n");
	IB_RETH_print(&(ptr_struct->IB_RETH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_AtomicETH:\n");
	IB_AtomicETH_print(&(ptr_struct->IB_AtomicETH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_AETH:\n");
	IB_AETH_print(&(ptr_struct->IB_AETH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_AtomicAckETH:\n");
	IB_AtomicAckETH_print(&(ptr_struct->IB_AtomicAckETH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_ImmDt:\n");
	IB_ImmDt_print(&(ptr_struct->IB_ImmDt), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_IETH:\n");
	IB_IETH_print(&(ptr_struct->IB_IETH), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ICRC:\n");
	ICRC_print(&(ptr_struct->ICRC), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VCRC:\n");
	VCRC_print(&(ptr_struct->VCRC), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common:\n");
	MAD_Header_Common_print(&(ptr_struct->MAD_Header_Common), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_Common_With_RMPP:\n");
	MAD_Header_Common_With_RMPP_print(&(ptr_struct->MAD_Header_Common_With_RMPP), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_Header_SMP_Direct_Routed:\n");
	MAD_Header_SMP_Direct_Routed_print(&(ptr_struct->MAD_Header_SMP_Direct_Routed), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_SMP_Direct_Routed:\n");
	MAD_SMP_Direct_Routed_print(&(ptr_struct->MAD_SMP_Direct_Routed), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_SMP_LID_Routed:\n");
	MAD_SMP_LID_Routed_print(&(ptr_struct->MAD_SMP_LID_Routed), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_PerformanceManagement:\n");
	MAD_PerformanceManagement_print(&(ptr_struct->MAD_PerformanceManagement), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_SubnetAdministartion:\n");
	MAD_SubnetAdministartion_print(&(ptr_struct->MAD_SubnetAdministartion), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SA_MCMMemberRecord:\n");
	SA_MCMMemberRecord_print(&(ptr_struct->SA_MCMMemberRecord), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_VendorSpec:\n");
	MAD_VendorSpec_print(&(ptr_struct->MAD_VendorSpec), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_CongestionControl:\n");
	MAD_CongestionControl_print(&(ptr_struct->MAD_CongestionControl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "IB_ClassPortInfo:\n");
	IB_ClassPortInfo_print(&(ptr_struct->IB_ClassPortInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_MADS:\n");
	SMP_MADS_print(&(ptr_struct->SMP_MADS), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PERFORMANCE_MADS:\n");
	PERFORMANCE_MADS_print(&(ptr_struct->PERFORMANCE_MADS), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AGGREGATION_MADS:\n");
	AGGREGATION_MADS_print(&(ptr_struct->AGGREGATION_MADS), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CONGESTION_CONTOL:\n");
	CONGESTION_CONTOL_print(&(ptr_struct->CONGESTION_CONTOL), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VENDOR_SPECS:\n");
	VENDOR_SPECS_print(&(ptr_struct->VENDOR_SPECS), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RDM_NVL_MADS:\n");
	RDM_NVL_MADS_print(&(ptr_struct->RDM_NVL_MADS), file, indent_level + 1);

}

int PACKETS_EXTERNAL_size(void)
{
	 return 16777216;
}

void PACKETS_EXTERNAL_dump(const union PACKETS_EXTERNAL *ptr_struct, FILE* file)
{
	PACKETS_EXTERNAL_print(ptr_struct, file, 0);
}

